module new_build
  logical :: newbuild_active = .true.

contains

  subroutine maincl_new(kaction,iprin,makerest)
  USE atomi
  USE General, only: cell,spacegr,celem,vetint,neutro,lo
  USE atom_type_util
  USE variables
  USE connect_mod
  USE molpnew
  USE unit_cell
  USE elements
  USE sinterface, only: fillatom
  USE BuildModule, only: tabdst,tabang
  USE rrestr
  implicit none
  integer, intent(in)                             :: kaction,iprin
  logical, intent(in)                             :: makerest
  type(atom_type), dimension(:), allocatable      :: atom
  integer                                         :: i,nat
  type(cell_type)                                 :: cellt
  logical                                         :: move
  type(restraint_type), dimension(:), allocatable :: restrd,restra
!
  call xyz_to_atom(atom,xyzs(:3,:nats),bfac,occr=xyzs(5,:),occh=occpch,nz=nz,lab=aLab,elem=celem)
  nat = numatoms(atom)
  atom%inte = vetint(:nat)
  do i=1,nat
     if (atom(i)%get_nz() < NZCONST .and. atom(i)%get_nz() /= 0) then
         !call atom(i)%set_specie_from_el(1,celem)
         call make_specie(atom,spacegr,celem,neutro)
         exit
     endif
  enddo
  nz(:nat) = atom(:)%get_nz()
  call atom_string(atom,celem)
  cellt = set_cell_type(cell)
  call calcola_occ(atom,spacegr,cellt)
  move = any(kblock(:nat) == 0)
  !call create_connectivity(atom,lconn,set_cell_type(cell),spacegr,check=makerest,move=move)  ! expo_new
  !call create_connectivity(atom,lconn,set_cell_type(cell),spacegr,check=makerest,angl=55.0,move=move)
  !call create_connectivity(atom,lconn,set_cell_type(cell),spacegr,move=move)   ! expo_noang
  call create_connectivity(atom,lconn,set_cell_type(cell),spacegr,   &
                           check=.true.,move=move,kpr=iprin)   ! expo_ang
  call bond_to_iconn(lconn,iconn)
  izpk(:numatoms(atom)) = (numelem(celem) - atom(:)%kscatt() + 1)*NZCONST
  call fillatom(atom)
!!!!Fill tabdst: lconn%n1,lconn%n2,teor. dist, current dist., or use conn_to_restraints
!!!!TODO: check atoms with unresonable distance
  if (numbonds(lconn) > 0 .and. makerest) then
      call conn_to_restraints(lconn,atom,cellt,RESDIST,restrd,TARG_BOND_TAB)
      do i=1,nrestraints(restrd)
         tabdst(1,i) = restrd(i)%na(1)
         tabdst(2,i) = restrd(i)%na(2)
         tabdst(3,i) = restrd(i)%targ
         tabdst(4,i) = restrd(i)%val
      enddo
      call conn_to_restraints(lconn,atom,cellt,RESANGLE,restra,TARG_BOND_TAB)
      do i=1,nrestraints(restra)
         tabang(1,i) = restra(i)%na(1)
         tabang(3,i) = restra(i)%na(2)
         tabang(5,i) = restra(i)%na(3)
         tabang(6,i) = restra(i)%targ
      enddo
      !if (nrestraints(restrd) + nrestraints(restra) > 0) then
      !    write(lo,*)'===============================CALL MAINCL FOR RESTRAINTS'
      !    call print_restraints(lo,restrd,RESDIST,atom,cellt,.false.)
      !    call print_restraints(lo,restra,RESANGLE,atom,cellt,.false.)
      !endif
  endif
!
  end subroutine maincl_new

end module new_build

  subroutine maincl(kaction,iprin)
  USE atomi
  USE General, only: vetint
  use new_build
  implicit none
  integer, intent(in) :: kaction,iprin
  integer :: i
  logical :: kpr = .false.
  if (newbuild_active) then
      if (kpr) then
          write(6,*)'===============================CALL MAINCL'
      endif
      call maincl_new(kaction,iprin,makerest=.false.)
      if (kpr) then
          write(6,*)'AT,izpk,nz,xyzs()'
          do i=1,nats
             write(6,'(i5,i5,i5,5f10.3,2x,a,f10.3)')i,izpk(i),nz(i),xyzs(:5,i),aLab(i),vetint(i)
          enddo
          write(6,*)'===============================CALL MAINCL'
      endif
  else
      call maincl_old(kaction,iprin)
  endif
  end subroutine maincl

  subroutine avvisolati(kaction,iprin,ncycle)
  use new_build
  integer, intent(in) :: kaction,iprin,ncycle

  if (newbuild_active) then
      call maincl_new(kaction,iprin,makerest=.true.)
  else
      call avvisolati_old(kaction,iprin,ncycle)
  endif

  end subroutine avvisolati
