MODULE importexport

implicit none

CONTAINS

   subroutine import_structure(filename,ftype,atom,bond,elem,cell,spg,gui,has_symmetry,mergecont,err)   !!!,at_infod,nsecd,sec_structd)
   USE atom_basic
   USE pdb_frm
   USE general, only: neutro
   USE spginfom
   USE gen_frm
   USE connect_mod
   USE errormod
   USE unit_cell
   USE errormod
   USE elements
    use trig_constants
!corr   USE ochemdb
!corr   USE variables, only: cryst
   character(len=*), intent(in)                                               :: filename
   integer, intent(in)                                                        :: ftype ! if 0 the file type is set from filename
   type(atom_type), dimension(:), allocatable, intent(inout)                  :: atom
   type(bond_type), dimension(:), allocatable, intent(inout)                  :: bond
   real, dimension(6), intent(inout)                                          :: cell
   type(element_type), dimension(:), allocatable, intent(inout)               :: elem
   type(spaceg_type), intent(inout)                                           :: spg
   logical, intent(in)                                                        :: gui
   logical, intent(in)                                                        :: has_symmetry
   logical, intent(in)                                                        :: mergecont
   type(error_type)                                                           :: err
!   type(cell_type) :: newcell
!    real, dimension(3,3) :: pmat
!    real, dimension(3,3) :: cmat,cmat_new,gnew
!    integer :: i
!corr   type(pdb_atom_info_type), dimension(:), allocatable, optional, intent(out) :: at_infod   ! additional info for pdb file
!corr   integer, intent(out), optional :: nsecd
!corr   type(secondary_struct_type), dimension(:), allocatable, optional, intent(out) :: sec_structd ! secondary structure from pdb
   type(cell_type) :: cellt
!
   cellt = set_cell_type(cell)
   call import_crystal(filename,ftype,atom,bond,elem,cellt,spg,has_symmetry,neutro,gui,err,mergecont)   !,at_infod,nsecd,sec_structd)
   if (.not.err%signal) then
       call action_after_import(filename,has_symmetry,elem,cellt,spg)
       !if (.not.err%warning) call make_d_in_laueclass(cryst(1))
       !if (.not.err%warning)     &
       !    call export_for_ochemdb(atom,bond,elem,cellt,spg,structurename,expand=.true.,ftype='DATS',lcharge=.true.,kpr=lo)
           !call export_for_ochemdb(atom,bond,elem,cellt,spg,structurename,expand=.true.,ftype='S',lcharge=.true.,kpr=lo)
                  !call make_test(atom,bond,elem,cellt,spg,filename)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!       pmat(1,:) = [-1,0,1]
!       pmat(2,:) = [ 0,1,0]
!       pmat(3,:) = [-1,0,0]
!       call cellt%write(0)
!       call cell_transform(cellt,pmat,newcell)
!       call newcell%write(0)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   endif
   end subroutine import_structure
 
!---------------------------------------------------------------------      

   subroutine action_after_import(filename,has_symmetry,elem,cellv,spg)
   USE Conteggi, only:npunti
   USE elements
   USE spginfom
   USE gen_frm
   USE general, only: alambda, neutro, cell, StructureName
   USE sinterface
   USE enable_amb
   USE view
   USE variables, only: cryst, dataset
   USE unit_cell
   USE datamod
   USE fileutil
   USE Molcom, only: jscreen
   use reflection_type_util
   use datasetmod, only: ndataset
   character(len=*), intent(in)                              :: filename
   logical, intent(in)                                       :: has_symmetry
   type(element_type), dimension(:), allocatable, intent(in) :: elem
   type(cell_type), intent(in)                               :: cellv
   type(spaceg_type), intent(in)                             :: spg
   integer                                                   :: filetype
   integer                                                   :: iflag
!
   if (.not.has_symmetry) then
        cell(:6) = cellv%get_par()
        call set_spaceg_new(spg) 
        call cryst(1)%set_symmetry(spg,cellv)
   endif
   call cryst(1)%set_scattering(elem)
   if (len_trim(StructureName) > 0) then
       call cryst(1)%set_name(StructureName)
   else
       call cryst(1)%set_name(file_rem_ext(file_get_name(filename)))
   endif
   if (npunti > 0) call abilita_tasti('structure',1)
!
!  Generate reflections for cif and pdb files and symmetry not speciefied by user (has_symmetry = .false.)
   filetype = code_fragfilen(filename)
   if (npunti > 0 .and. (.not.has_symmetry) .and. (filetype == CIF_FILE .or. filetype == PDB_FILE) .and. jscreen > 0) then
       call gener([alambda],iflag,.false.)
       call vedinew(1)
   endif
!
!  clear reflections from previous imported structure
   if (ndataset(dataset) == 0) call clear_reflections(cryst(1)%ref)
!
!  save distances for database in a file
   !if (.not.err%warning) call export_for_db(atom,legm,set_cell_type(cell),spacegr,elem,structurename)
   end subroutine action_after_import

!---------------------------------------------------------------------      
#if 0
   subroutine make_test(atom,legm,elem,cell,spg,fname)
   USE atom_type_util
   USE connect_mod
   USE elements
   USE pdfcalc
   USE contacts
!corr   USE molpnew
!corr   USE hydrogens
!corr   USE polyhedra
!corr   USE centroids
   USE molgraph
   USE qe_frm
   USE unit_cell
   USE General, only:spacegr,celem,neutro,structurename
   USE symmgrid
   USE crystal_phase
   USE variables, only: cryst,dataset
   USE cif_frm
   USE prognames, only: package_alt_name
   !USE testgrid
!corr   USE spginfom
!corr   USE crystal_frm
   USE bond_valence
   use fileutil
   use strutil
   use arrayutil
   use cryutil
!corr   USE bvtemp
!
   type(atom_type), dimension(:), allocatable, intent(inout) :: atom
   type(bond_type), dimension(:), allocatable, intent(inout) :: legm
   type(element_type), dimension(:), allocatable, intent(in) :: elem
   type(cell_type), intent(in)                               :: cell
   type(spaceg_type), intent(in)                             :: spg
   character(len=*), intent(in)                              :: fname
   type(crystal_phase_t) :: crystal
   type(file_handle) :: ff
!  test bond valence
!bv   type(bond_valence_t), dimension(size(elem),size(elem)) :: bvtab
!bv   real, dimension(:,:,:), allocatable :: asymtab
!bv   real :: val
!bv   integer :: i
   integer :: ndinfo,i,cn
  type(bond_info_t), dimension(:), allocatable :: dinfo
  real, dimension(:), allocatable :: bvs
!corr   integer                                                   :: ier
   type(atom_type), dimension(:), allocatable                :: atoms
   type(bond_type), dimension(:), allocatable                :: legms
   type(bond_type), dimension(:), allocatable                :: legmHview,legmshort
   logical :: hbond,shbond,lpacking,lsymm
   integer, dimension(2) :: kexpand
!corr   type(polyhedron_type), dimension(:), allocatable      :: poly
   integer :: npoly
!corr   type(centroid_type), dimension(:), allocatable :: centr
   integer :: ncentr
!  type(torsion_type), dimension(:), allocatable :: tors
!  logical :: chang
!  type(angle_type), dimension(:), allocatable :: angle
!  integer, dimension(size(atom)) :: veta
!  integer :: nd
   real :: mw,vol,dens
   integer :: z_val,z_cif
   integer :: nline,ier,iv
   character(len=500) :: line
   integer, dimension(:), allocatable :: ivet
   type(container_type), allocatable, dimension(:) :: sitea
   type(element_type), dimension(:), allocatable :: chform
   character(len=:), allocatable :: sform
!
   if (numatoms(atom) == 0) return
   call export_phase_cif(cryst,dataset(1),'prova.cif',.true.)
#if 0
!
!  test doc
   crystal = cryst(1)
   call crystal%set_atoms(atom)
   call crystal%make_symmetry_cell()
   call crystal%allocate_grid(cutoff=1.0)
   call crystal%fill_grid()
   call crystal%compute_doc(1.0)
   do i=1,crystal%natoms()
      write(0,*)crystal%at(i)%lab,crystal%at(i)%ocry
   enddo
!
!   test Z
    !call get_site(atom,sitea)
    !z_val = Z_value_old(atom,spacegr%nsymop)
    !z_val = Z_value(atom,spacegr%nsymop)
    z_val = Z_value(atom,spacegr%nsymop,chform)
    call ff%fopen(fname)   
    nline = 0
    call find_key_file(ff%handle(),'_cell_formula_units_Z',nline,line,ier)
    if (nline > 0 .and. ier == 0) then
        call cutst(line)
        call Getnum1(line,ivet=ivet,iv=iv)
        if (iv > 0) then
            z_cif = ivet(1)
            !write(0,*)'Zcif=',ivet(1)
            !write(0,*)'LINE=',trim(line)
            if (z_val == z_cif) then
                write(0,*)file_get_name(fname)//' Z=',z_val,z_cif,' RIGHT'
            else
                write(0,*)file_get_name(fname)//' Z=',z_val,z_cif,' WRONG'
            endif
        endif
    else
        write(0,*)'ZVAL=',z_val
    endif
    if (numelem(chform) > 0) then
        call chemical_formula(chform, sform, fform=2, ord=.true.,hide1=.true.,hidecharge=.true.)
        !write(0,*)'CHF=',chform%nw
        !write(0,*)'FORM=',sform
        call ff%rew()
        call find_key_file(ff%handle(),'_chemical_formula_sum',nline,line,ier)
        if (nline > 0 .and. ier == 0) then
            call cutst(line)
            write(0,'(a,a,a,a)')file_get_name(fname)//' FORM=',sform,'CIF=',trim(line)
        else
            write(0,'(a,a)')'FORM=',sform
        endif
    endif
#endif
    !stop
    !write(0,'(a,i10)',advance='no')'Z=',z_val
!   mw = molecular_weight(atom%ptab,atom%och*atom%ocry)
!   dens = density_value(mw,cell%volume(),spacegr%nsymop)
!   write(0,*)'MU=',linear_abs_coeff(atom,dens,1)/10
!   write(0,*)'MU=',linear_abs_coeff(atom,dens,2)/10
!
!  test for export with symmetry
   !call create_ciffile(cell=cell,atom=atom,progname=package_alt_name,    &
   !spg=spg,elem=elem,legm=legm,symm=.true.,filename='riet.cif')
!
!  test for qe file
   !call write_qe_file(trim(structurename)//'_qe.in',atom,cell,spacegr,structurename)
!
!   call compute_dist_matrix(atom,legm,path=.true.)
!
!  test symm
#if 0
   crystal = cryst(1)
   call crystal%set_atoms(atom)
   !call test_grid(crystal,atom,legm,cell,spacegr,elem)
   !call detect_spg(atom,cell)
!
!  test for pdf
   !call test_pdf(atom,set_cell_type(cell),spacegr,celem,neutro)
!
!  test bond valence
         write(0,*)'BV'
   call crystal%load_bvparam()
   call bvtable_check(crystal%elem,crystal%bvpar)
   call crystal%print_bvparam(0)
   call crystal%make_symmetry_cell()
   call crystal%allocate_grid(cutoff=crystal%bvs_cutoff())
   call crystal%fill_grid()
!c      write(0,*)'NAT=',crystal%natoms()
   allocate(bvs(crystal%natoms()))
   do i=1,crystal%natoms()
      call crystal%compute_bvs(i,bvs(i))
!c      write(70,*)'VAL=',crystal%at(i)%glab(),bvs(i)
!c      ndinfo = crystal%valence_atom(i)
!c      !write(0,*)'NB_'//crystal%at(i)%glab()//'=',ndinfo
!c      if (ndinfo > 0) then
!c          if (allocated(dinfo)) deallocate(dinfo)
!c          allocate(dinfo(ndinfo))
!c          call crystal%valence_atom_info(i,dinfo,bvs(i),cn)
!c          call print_bond_info(crystal%at,crystal%spg,dinfo,70)
!c          write(70,*)'NC_'//crystal%at(i)%glab()//'=',count(dinfo%dupl == 0),ndinfo
!c      endif
   enddo
#endif
!
!  test grow frag
   !call apply_symmetry(atom,atoms,legm,legms,infos,level=(/1.0,1.0,1.0/)-0.5,fitopt=2)
   !call grow_fragments(atom,atoms,legm,legms,infos,set_cell_type(cell),lsym=.true.,kexp=(/EXPAND_ALL,0/))
   !call grow_fragments(atom,atoms,legm,legms,infos,set_cell_type(cell),spacegr,lsym=.false.,kexp=(/EXPAND_ALL,0/))
   !call copy_atoms(atom,atoms)
   !call copy_bonds(legm,legms)
!
!  test bond perception
   !call bond_type_perception(atom,legm,cell)
   !call test_bond_perception(atom,legm,cell,structurename)
!
!  test hydrogens
   !call remove_atoms_from_list(atom,atom%ptab,H_at,legm=legm)  !remove H
   !call add_hydrogens(atom,legm,celem,set_cell_type(cell),spacegr,ier=ier)
!
!  test change bond distance
   !do i=1,numbonds(legm)
   !   call change_bond_distance(atom,legm,8,4.5, matrice_metrica(cell))
   !   call change_bond_distance(atom,legm,11,4.5, matrice_metrica(cell))
   !enddo
!
!  test for change angle
   !call bond_to_angle(legm,atom,angle)
   !call change_bond_angle(3,angle,atom,legm,170.,set_cell_type(cell))
!
!  test csys
   !write(0,'(1x,a,a,1x,a)')'CRY SYS: ',trim(cry_sys(spacegr%csys_code)), trim(cry_sys(csys_from_cell(cell)))
!
!  test for change torsion
   !call legm_to_tors(legm,atom,tors)
   !call change_torsion_angle(tors(10),atom,legm,150.,set_cell_type(cell),chang)
   !return
!
!  test centroids
   !call find_centroids(atom,legm,centr,ncentr)
!
!  test contacts
#if 0
   hbond = .false.; shbond = .true.; lpacking = .false.
   kexpand = [0,0]
   call find_contacts(atom,legm,cell,spg,legmHview,legmshort,atoms,legms,lpacking,kexpand,hbond,shbond)
   call copy_atoms(atom,atoms)
   call copy_bonds(legm,legms)
#endif
!
!  test polyhedra
   !lsymm = .false.
   !call find_polyhedra_sym(atom,legm,set_cell_type(cell),spacegr,atoms,legms,poly,npoly,lsym=lsymm)
!
!  test valence-bond
!
   end subroutine make_test
#endif
!----------------------------------------------------------------------------------------------------------------      

   subroutine export_info(filename,ftype,vet,atom,legm,legmc,adp_type)
   USE connect_mod
   USE fileutil
   USE atom_type_util
   USE general, only:spacegr,cell,celem
   USE unit_cell
   USE progtype, only: structure_info_type
   character(len=*), intent(in)                           :: filename
   type(atom_type), dimension(:), allocatable, intent(in) :: atom
   type(bond_type), dimension(:), allocatable, intent(in) :: legm
   integer, intent(in)                                    :: ftype ! che tipo di informazioni
   integer, dimension(:), intent(in)                      :: vet   ! quali informazioni
   integer, intent(in), optional                          :: adp_type ! adp type: 1 for B, 2 for U
   integer                                                :: j_in
   integer                                                :: ier
   type(angle_type), dimension(:), allocatable            :: angle
   type(torsion_type), dimension(:), allocatable          :: tors
   type(structure_info_type)                              :: info
   type(bond_type), dimension(:), allocatable, intent(in), optional :: legmc
   type(cell_type) :: cellt
!
!  Open file
   call get_unit(j_in)
   open(unit=j_in,file=filename,iostat=ier,status='unknown')
!
   if (ier == 0) then
       select case (ftype)
          case (1)    ! general info
            info = structure_info(atom,celem,set_cell_type(cell),spacegr,1)
            call print_structure_info(info,j_in)

          case (2)    ! atomi
            if (present(adp_type)) then
                call print_atoms_vet(atom,kpr=j_in,vet=vet,adp_type=adp_type,spg=spacegr)
            else
                call print_atoms_vet(atom,kpr=j_in,vet=vet,spg=spacegr)
            endif

          case (3)    ! legami
            call print_connect(atom%lab,bond=legm,kpri=j_in,vet=vet)

          case (4)    ! angoli
            cellt = set_cell_type(cell)
            call bond_to_angle(legm,atom,cellt%get_g(),angle)
            call print_connect(atom%lab,angle=angle,kpri=j_in,vet=vet)

          case (5)    ! torsioni
            call bonds_to_torsions(legm,atom,cellt,tors)
            call print_connect(atom%lab,tors=tors,kpri=j_in,vet=vet)
        
          case (7)
            call print_connect(atom%lab,bond=legmc,kpri=j_in,vet=vet)

       end select

       close (j_in)
   endif
!
   end subroutine export_info

!---------------------------------------------------------------------      

   function structure_info(atom,elem,cell,spg,icalc) result(info)
   USE unit_cell
   USE variables, only:ref
   USE reflection_type_util
   USE atom_type_util
   USE stat
   USE elements
   USE progtype, only: structure_info_type
   USE spginfom
   type(structure_info_type)                                 :: info
   type(atom_type), dimension(:), allocatable, intent(in)    :: atom
   type(element_type), dimension(:), allocatable, intent(in) :: elem
   type(cell_type), intent(in)                               :: cell
   type(spaceg_type), intent(in)                             :: spg
   integer, intent(in)                                       :: icalc
   integer                                                   :: i,ks
   real                                                      :: numat
   real, allocatable, dimension(:)                           :: vat
!
   info%nspec = numelem(elem)
   info%cell = cell%get_par()
   if (numatoms(atom) > 0) then
       allocate(vat(numelem(elem)),source=0.)
!
!      compute cell content from atoms
       info%vspec(:) = 0
       do i=1,numatoms(atom)
          ks = atom(i)%kscatt()
          if(ks == 0) cycle
          numat = atom(i)%och*atom(i)%ocry*spg%nsymop
          vat(ks) = vat(ks) + numat
       enddo
       do i=1,info%nspec
          info%zspec(i) = elem(i)%z 
          info%vspec(i) = nint(vat(i))
       enddo
   else
       do i=1,info%nspec
          info%vspec(i) = nint(elem(i)%nw)
          info%zspec(i) = elem(i)%z   
       enddo
   endif
   info%spaceg = trim(spg%symbol_xhm)
   if (spg%symcent == 1) then
       info%icent = 1
   else
       info%icent = 0
   endif
   info%nsymmstr = spg%nsymop
!
!  Se icalc = 0 non vengono riempite quelle informazioni che richiedono un calcolo
   if (icalc == 1) then
       info%cell_volume = cell%volume()
       if (numatoms(atom) > 0) then
           info%volume_per_atom = volume_per_atom(atom, spg%nsymop, info%cell_volume)
       else
           info%volume_per_atom = volume_per_atom(elem,info%cell_volume)
       endif
!corr       if (.not.allocated(ref)) call fillref(ref)
       if (numatoms(atom) > 0 .and. numrefl(ref) > 0) then
           call fcalcang(ref,atom,spg,elem)
           info%r_factor = Rvalue(ref%fo,ref%fc)
       else
           info%r_factor = 0.0
       endif
   endif
!
   end function structure_info

!---------------------------------------------------------------------      

   subroutine print_structure_info(info,kpr)
   USE General, only:StructureName,cell,spacegr,celem
   USE progtype, only: structure_info_type
   type(structure_info_type), intent(in) :: info
   integer, intent(in)                   :: kpr
   integer                               :: i
!
   write(kpr,'("Name                : ",a)')trim(StructureName)
   write(kpr,'("Cell Lengths        : ","a ",f0.5," b ",f0.5," c ",f0.5)')cell(1:3)
   write(kpr,'("Cell Angles         : ", "alpha ",f0.5," beta ",f0.5," gamma ",f0.5)')cell(4:6)
   if (info%icent == 1) then
       write(kpr,'("Space Group         : ",a)')trim(info%spaceg)//' (centrosymmetric)'
   else
       write(kpr,'("Space Group         : ",a)')trim(info%spaceg)//' (noncentrosymmetric)'
   endif
   call spacegr%prn_symop(2,kpr)
   write(kpr,'("Cell Volume         : ",f0.3)')info%cell_volume
   write(kpr,'("Cell Content        : ",18(a,1x,i0,1x))')(trim(celem(i)%lab),info%vspec(i),i=1,info%nspec)
   write(kpr,'("Volume per atom     : ",f0.3)')info%volume_per_atom
   write(kpr,'("R-Factor            : ",f0.2)')info%r_factor
!
   end subroutine print_structure_info

!---------------------------------------------------------------------      
   subroutine test_bond_perception(atom,legmv,cell,sname)
   USE fileutil
   USE atom_type_util
   USE atom_basic
   USE unit_cell
   USE connect_mod
   USE errormod
   type(atom_type), dimension(:), allocatable, intent(in) :: atom
   type(bond_type), dimension(:), allocatable, intent(in) :: legmv
   type(cell_type), intent(in)                            :: cell
   character(len=*), intent(in)                           :: sname
   type(bond_type), dimension(:), allocatable             :: legm,bonds
   type(file_handle)                                      :: fileh
   integer                                                :: ncorr,ordmol
   integer                                                :: i
   type(error_type) :: err
!
   call copy_bonds(legm,legmv)
   call bond_type_perception(atom,legm,cell)         ! create new bond order
   call read_molfile(trim(sname)//'.mol',bonds,err)  ! read correct bond order from mol file
!
!  Compare legm%ord with legmv%ord e save the result in a external file
   call fileh%fopen('result_bond.txt','w')
   if (fileh%good()) then
       ncorr = 0
       do i=1,numbonds(bonds)
          if (legm(i)%ord == 5) then
              ordmol = 4
          else
              ordmol = legm(i)%ord
          endif
          if (bonds(i)%ord /= ordmol) then
              ncorr = ncorr + 1
              write(fileh%handle(),'(a,a,i0,a,i0)')'legame sbagliato: ',    &
              trim(slabnum(atom(legm(i)%n1)%lab,legm(i)%n1))//'-'//trim(slabnum(atom(legm(i)%n2)%lab,legm(i)%n2))   &
              //' ord=', legm(i)%ord,' -> ordine corretto=',bonds(i)%ord
              write(0,'(a,a,i0,a,i0)')'legame sbagliato: ',    &
              trim(slabnum(atom(legm(i)%n1)%lab,legm(i)%n1))//'-'//trim(slabnum(atom(legm(i)%n2)%lab,legm(i)%n2))   &
              //' ord=', legm(i)%ord,' -> ordine corretto=',bonds(i)%ord
          endif
       enddo
       if (ncorr == 0) then
           write(fileh%handle(),'("No errors in the bond order!")')
           write(0,'("No errors in the bond order!")')
       endif
       call fileh%fclose()
   endif
   !stop   !uncomment for shell
   end subroutine test_bond_perception

!----------------------------------------------------------------------------------------------------

   subroutine read_molfile(filename,bonds,error)
!
!  Read bond order from a mol file
!
   USE fileutil
   USE errormod
   USE connect_mod
   USE strutil
   character(len=*), intent(in)                            :: filename
   type(bond_type), dimension(:), allocatable, intent(out) :: bonds
   type(error_type), intent(out)                           :: error
   type(file_handle)                                       :: ff
   integer                                                 :: i,j_in,errline,nat,nbonds,iv
   character(len=:), allocatable                           :: line
   character(len=6)                                        :: version
   integer, dimension(:), allocatable                      :: ivet
!
   call ff%fopen(filename)
   if (ff%fail()) then
       call error%set('Cannot open: '//trim(filename)//char(10)//'Message: '//trim(ff%err_msg()))
       return
   endif
   j_in = ff%handle()
!
!  Don't read header block
   if (ignore_lines(j_in,3,errline) /= 0) go to 10

   read(j_in,'(i3,i3,27x,a6)',err=10,end=10)nat,nbonds,version
!
   if (ignore_lines(j_in,nat,errline) /= 0) go to 10
!
   errline = 3+nat
   call new_bonds(bonds,nbonds)
   do i=1,nbonds
      errline = errline + 1
      if (.not.get_line(j_in,line)) go to 10
      call getnum1(line,ivet=ivet,iv=iv)
      bonds(i) = bond_type(ivet(1),ivet(2),ord=ivet(3))
   enddo
!
   return
!
10 call error%set('Error on reading line '//i_to_s(errline)//' of MDL MolFile')
!
   end subroutine read_molfile

!----------------------------------------------------------------------------------------------------

   subroutine write_reflection_table(table,vcol,kpri,ftype)
   USE strutil
   USE view, only: idph
   USE reflection_type_util, only: reflection_type
   type(reflection_type), intent(in), dimension(:) :: table  ! tabella dei riflessi
   integer, dimension(:), intent(in)               :: vcol   ! quali colonne stampare
   integer, intent(in)                             :: kpri
   integer, intent(in)                             :: ftype  ! 1 -> F; 2 -> F^2
   integer, dimension(size(vcol))                  :: ktype
!!mr   integer, parameter                              :: NCOL = 8
   integer, parameter                              :: NCOL = 9
   integer, dimension(NCOL)                        :: ival
   real, dimension(NCOL)                           :: rval
   character(len=20), dimension(7)                 :: sval
   integer                                         :: i
!
!  Titoli delle colonne
   ktype(:) = 3
   if (ftype == 1) then
       call set_row_list(vcol,ktype,sval=(/'n.      ','phase n.','h k l   ','2-theta ',    &
         'd       ','Fo      ','Fc      ','phase   ','m       '/),comm=.true.,kpr=kpri)
   else
       call set_row_list(vcol,ktype,sval=(/'n.      ','phase n.','h k l   ','2-theta ',    &
         'd       ','Fo^2    ','Fc^2    ','phase   ','m       '/),comm=.true.,kpr=kpri)
   endif
!
!  Scrivi la tabella dei riflessi
   ktype = (/1,1,3,25,25,23,23,1,1/)   ! formato delle colonne
   do i=1, size(table)
      ival(1) = i
      ival(2) = idph(i)
      write(sval(3),'(3(i0,1x))')table(i)%hkl(:)
      rval(4) = table(i)%tthd(1)
      rval(5) = table(i)%slaq
      rval(6) = table(i)%fo
      rval(7) = table(i)%fc
      ival(8) = table(i)%ph
      ival(9) = table(i)%m
      call set_row_list(vcol,ktype,ival,rval,sval,.false.,kpri)
   enddo
!
   end subroutine write_reflection_table

!-------------------------------------------------------------------------------------------------------  
#if 0
   subroutine make_d_in_laueclass(crystal)
   use crystal_phase
   use iso_fortran_env, only: ERROR_UNIT
   use prog_constants
   use counts
   use filereading
   use arrayutil
   use reflection_type_util
   type(crystal_phase_t), intent(inout) :: crystal
   character(len=:), allocatable        :: newspg
   type(error_type)                     :: err
   real, parameter                      :: RESMAX = 1.7
   real, dimension(:), allocatable      :: Icalc
!
!  Change space group in Laue
   if (crystal%spg%laue_code == 0) then
       write(ERROR_UNIT,'(a)') 'Laue class is not available!'
       return
   endif
   newspg = 'P '//crystal%spg%laue_class()
   call crystal%set_spg(newspg,err)
   if (err%signal) return
!
!  Generate reflections up to RESMAX resolution
   call crystal%make_reflections(0.5,thvalue(RESMAX,DEF_WAVE),[DEF_WAVE])
   if (crystal%numref() == 0) return
!
!  Compute intensities
   if (crystal%natoms() == 0) return
   call fcalcang(crystal%ref,crystal%at,crystal%spg,crystal%elem,anis=.true.)
   call crystal%LPcorr(RX_SOURCE,.false.,1)
   call new_array(Icalc,crystal%numref())
   Icalc(:) = crystal%ref%m*crystal%ref%lp(1)*crystal%ref%fc**2
   Icalc(:) = Icalc(:) / maxval(Icalc)
!
!  Write d on file
   call write_column(trim(crystal%cr_name)//'.txt',xcol1=dvalue(crystal%ref%tthd(1),DEF_WAVE), &
                     xcol2=Icalc,metad='#d in laue class '//newspg)
!
   end subroutine make_d_in_laueclass
#endif

END MODULE importexport

!corr   real function GetBondDistance(ispec1, ispec2)
!corr!
!corr!  Restituisce la distanza di legame date due specie
!corr!      
!corr   USE bondtmod
!corr   USE connect_mod
!corr   USE General, only: celem
!corr   implicit none
!corr   integer :: ispec1, ispec2
!corr   integer :: z1,z2
!corr!
!corr   if (ispec1 < 0) then
!corr       z1 = abs(ispec1)
!corr   else
!corr       z1 = celem(ispec1)%z
!corr   endif
!corr   if (ispec2 < 0) then
!corr       z2 = abs(ispec2)
!corr   else
!corr       z2 = celem(ispec2)%z
!corr   endif
!corr   GetBondDistance = bond_distanceZ(z1,z2)
!corr!
!corr   end function GetBondDistance


MODULE exportfiles

implicit none

integer                       :: nexportf    ! number of files to export
character(250), dimension(10) :: export_name ! name of file
logical, dimension(10)        :: is_export   ! se vero il file e stato gia esportato 

CONTAINS
   
   subroutine export_file(filename,ier)
   USE Atomi
   !USE General, only:nrefl,spacegr,celem,cell,StructureName,alambda
   USE General, only:nrefl,spacegr,celem,alambda
   USE reflection_type_util
   USE fileutil
   USE variables, only:atm, cryst
   USE importexport
   !USE atom_type_util
   USE strutil
   USE proginterface
   !USE unit_cell
   USE gen_frm
   character(len=*), intent(in)                     :: filename
   integer, intent(out)                             :: ier
   character(len=len_trim(filename))                :: ext
   type(reflection_type), dimension(:), allocatable :: reflb
   integer                                          :: nph
!
   ext = get_extension(filename)
   if (len_trim(ext) > 0) then
       select case (upper(trim(ext)))

          case ('HKL')      ! h k l   Fo^2 sigma in SHELX format
              if (nrefl > 0) then
                  allocate(reflb(nrefl))
                  call fillref(reflb)
                  call write_reflections(fname=filename,refl=reflb,code=2,title='#hkl,F(obs)^2,sigma in SHELX format')
              else
                  ier = 2
              endif

          case ('FC')       ! h k l  Fo   Fc  phase
              if (nrefl > 0) then
                  allocate(reflb(nrefl))
                  call fillref(reflb)
                  if (nats > 0) then
                      call fcalcang(reflb,atm,spacegr,celem)
                  else
                      reflb(:)%fc = 0
                  endif
                  call write_reflections(fname=filename,refl=reflb,code=4)
              else
                  ier = 2
              endif

          case ('INT')
              call intensity_file_for_database(filename,ier)

          case default
              nph = 1
              if (cryst(nph)%natoms() > 0) then
                  call export_structure(filename,cryst(nph)%at,cryst(nph)%cell,cryst(nph)%spg,cryst(nph)%elem, &
                                        ALL_FILES,cryst(nph)%cr_name,alambda,cryst(nph)%bond)
              endif
              !if (numatoms(atm) > 0) then
              !    call export_structure(filename,atm,set_cell_type(cell),spacegr,celem,ALL_FILES,StructureName,alambda,lconn)
              !endif
              
       end select
   endif
!
   end subroutine export_file

!-------------------------------------------------------------------------------------------------------  

   subroutine intensity_file_for_database(filename,ier)
   USE General, only:nrefl,lo,cell,spacegr,celem,neutro,nsyn,alambda
   USE patternref, only:thmin,thmax
   USE atom_type_util
   USE reflection_type_util
   USE variables, only:atm
   USE proginterface
   USE fileutil
   USE elements
   USE spginfom
   USE strutil
   USE ccryst, only: aniso_adp_is_ok, bequiv_from_beta
   USE unit_cell
   USE datamod
   use variables, only: dataset
   use datasetmod
   use filereading
   use counts
   use arrayutil
   character(len=*), intent(in)                     :: filename
   integer, intent(out)                             :: ier
   type(reflection_type), dimension(:), allocatable :: reflb
   integer                                          :: nat,nghost
   type(file_handle)                                :: fileh
   character(len=*), dimension(0:2), parameter      :: subf = ['inorganic    ','organic      ','metallorganic']
   character(len=:), allocatable                    :: sform
   real                                             :: mu, dens, vol
   integer                                          :: zval,i,ng
   integer, dimension(6)                            :: icell
   real                                             :: rapp_I,rapp_rho_v,rir
   type(cell_type)                                  :: cellt
   real, parameter                                  :: maxf_Cu_corundum = 340862.156  ! Calc. Intens. Corundum (from COD cif n. 1000017) b-iso=1.
   real, parameter                                  :: rho_vsq_Cu_corundum = 259079.140625 ! Calc. rho*vol*vol  Corundum  (from COD cif n. 1000017)
   integer, dimension(6)                            :: code
   type(element_type), dimension(:), allocatable    :: chform
   character(len=3)                                 :: adv
   integer                                          :: ierc,iflag
   integer, parameter                               :: MAXBISO = 100
   real, parameter                                  :: TTHETAMAX = 150
   integer, parameter                               :: NMAXREFLD = 500
   real, dimension(:), allocatable                  :: inte
   type(gref_type), dimension(:), allocatable       :: gref
   real                                             :: biso
   logical :: laue = .false.
   integer :: sortyp
!   
   icell(:) = 1
   ier = 0
   if (nrefl == 0) then
       if (alambda == 0) alambda = 1.54056
       if (ndataset(dataset) == 0) then
           thmin = 1.0; thmax = TTHETAMAX
       else
           thmin = dataset(1)%tmin; thmax = dataset(1)%tmax
       endif
       if (laue) then
           if (spacegr%laue_code == 0) return
           spacegr = init_spaceg_type('P '//spacegr%laue_class())
           thmax = thvalue(1.3,alambda)
       endif
       call gener([alambda],iflag,.false.)
   endif
   if (nrefl > 0) then
       nghost = numatomspec(atm,0)  ! this is the number of ghost atoms
       nat = numatoms(atm) - nghost
       if (nghost > 0) then
           adv = 'no'
           write(lo,'(a)',advance=adv)'BIG TROUBLE: some atoms with Z=0: '
           ng = 0
           do i=1,numatoms(atm)
              if (atm(i)%get_nz() == 0) then
                  ng = ng + 1
                  if (ng == nghost) then
                      adv = 'yes'
                      write(lo,'(a)',advance=adv)trim(atm(i)%lab)
                  else
                      write(lo,'(a)',advance=adv)trim(atm(i)%lab)//', '
                  endif
              endif
           enddo
           if (real(nghost) / nat > 0.7.and.nat> 10) nat = 0
       endif
       allocate(reflb(nrefl))
       call fillref(reflb)
       if (nat > 0) then
           cellt = set_cell_type(cell)
           call calcola_occ_new(atm,spacegr,cellt%get_g(),0.3)
!          check for adp
           do i=1,nat
              if (atm(i)%bij(1) > 0) then
                  biso = bequiv_from_beta(atm(i)%bij,cellt%get_g())
              else
                  biso = atm(i)%biso
              endif
              if (biso <= 0 .or. biso > MAXBISO) then
                  atm(i)%bij = 0
                  call set_biso(atm(i))
                  !write(0,*)'atom ',trim(atm(i)%lab),' set as iso, b=',atm(i)%biso
              endif
           enddo
           call fcalcang(reflb,atm,spacegr,celem,anis=.true.)
       else
           !ier = 1
           !return
           reflb%fc = 0; reflb%ph = 0;
       endif
       reflb(:)%lp(1) = lp_correction(reflb%tthd(1),neutro,.false.)
       call fileh%fopen(filename,ios='w')
       if (fileh%good()) then
           vol = cell_volume(cell)
           if (.not. spg_check_cell(spacegr,cell)) then
               write(lo,'(a)')'Cell dimensions and spacegroup are non consistent'
           endif
!
!          Generate groups and calculate intensities
           allocate(inte(nrefl))
           if (laue) then
               inte(:) = reflb%m*reflb%lp(1)*reflb%fc**2
           else
               reflb(:)%fwhm(1) = 1.0     
               call make_ref_groups(reflb,gref,0.00005)
               do i=1,size(gref)
                  inte(gref(i)%vref(1)) = gref(i)%Ic
                  if (gref(i)%code > 1) then 
                      inte(gref(i)%vref(2:)) = 0
                  endif
               enddo
           endif
!
           if (nat > 0) then
               dens = density_value(molecular_weight(atm%ptab,atm%och*atm%ocry),vol,spacegr%nsymop)
               mu = linear_abs_coeff(atm,dens,alambda)
!
               rapp_rho_v = (rho_vsq_Cu_corundum )/(vol*vol*dens)
               rapp_I = maxval(inte)/maxf_Cu_corundum
               write(6,'(a,f0.8)')'Rho_v2=     ',vol*vol*dens
               rir = rapp_rho_v * rapp_I
               !write(0,'(a,f0.3)')'RIR=   ',rir
!
               zval = Z_value(atm,spacegr%nsymop,chform)
               call chemical_formula(chform,sform,fform=2,ord=.true.,hide1=.true.,hidecharge=.true.)
!               
               write(fileh%handle(),'(1x,a,a)')'FORMULA: ',trim(sform)
               write(fileh%handle(),'(1x,a,a)')'SUBFILE: ',subf(is_organic(celem%z,nint(celem%nw)))
           else
               rir = 0
               dens = 0
               zval = 0
               mu = 0
               write(fileh%handle(),*) 'SUBFILE: undefined'
           endif
           if (spacegr%undef()) then
               spacegr%csys_code = csys_from_cell(cell)
           endif
           call spg_get_cell_code(spacegr,cell,code,ierc)
           do i=1,6
              if(code(i).ne.0) icell(i) = 0
           enddo
           write(fileh%handle(),'(1x,a,3(1x,f0.4),3(1x,f0.3))')    'CELL:    ',cell(1:6)
           write(fileh%handle(),'(1x,a,6i6)')    'WRITE CELL: ',icell(1:6)
           write(fileh%handle(),'(1x,a,a)')    'SPG:     ',trim(spacegr%symbol_xhm)
           if (spacegr%csys_code == CS_Trigonal) then
               if (uc_is_rhombohedral(cell,0.01)) then
                   write(fileh%handle(),'(1x,a,a)')    'CRY SYS: ',trim(cry_sys(spacegr%csys_code))//' (rhombohedral axes)'
               elseif (uc_is_hexagonal(cell,0.01)) then
                   write(fileh%handle(),'(1x,a,a)')    'CRY SYS: ',trim(cry_sys(spacegr%csys_code))//' (hexagonal axes)'
               endif
           else
               write(fileh%handle(),'(1x,a,a)')    'CRY SYS: ',trim(cry_sys(spacegr%csys_code))
           endif
           write(fileh%handle(),'(1x,a,f0.3)')   'VOLUME : ',vol
           write(fileh%handle(),'(1x,a,f0.3,a)') 'Density: ',dens,' g cm-3'
           write(fileh%handle(),'(1x,a,i5)')     'Z : ',zval
           write(fileh%handle(),'(1x,a,f0.3,a)') 'mu(CuKa):',mu,' cm-1'
           write(fileh%handle(),'(1x,a,i0)')   'NAtoms: ',nat
           write(fileh%handle(),'(1x,a,i0)')   'NReflections: ',nrefl
           write(fileh%handle(),'(1x,a,f0.3)')   'RIR     :',rir
           write(fileh%handle(),'(1x,a)') '----------------------------------------------------------------------------- '
           write(fileh%handle(),'(1x,a)') '  Remarks: Diffraction pattern calculated by EXPO from COD database cif file'
           write(fileh%handle(),'(1x,a)') '  Remarks: RIR calculated by EXPO     '
           write(fileh%handle(),'(1x,a)') '----------------------------------------------------------------------------- '
!
           if (laue) then
               sortyp = ORD_BY_2THETA
           else
               sortyp = ORD_BY_INT
           endif
           call write_reflections(jfile=fileh%handle(),refl=reflb,code=5,   &
                                  nref=min(NMAXREFLD,nrefl),intensity=inte,wave=alambda,sortby=sortyp)
           call fileh%fclose()
       endif
   else
       ier = 2
   endif

   end subroutine intensity_file_for_database

!-------------------------------------------------------------------------------------------------------  

   subroutine export_files()
   USE commandsmod
   USE fileutil
   integer :: ierrex
   integer :: i
!
   do i=1,ncommands(commands)
      if (commands(i)%code == EXPORT_CMD) then
          if (commands(i)%ndir > 0) then
              if (.not.extension_is(commands(i)%strdir(1),'int')) then
                  call export_file(commands(i)%strdir(1),ierrex)
              endif
          endif
      endif
   enddo
!
   end subroutine export_files

!-------------------------------------------------------------------------------------------------------  

   subroutine update_model_and_export(atom,legm,kmodel,id)
   USE connect_mod, only: bond_type
   USE atom_basic, only: atom_type
   USE sinterface
   type(atom_type), dimension(:), allocatable, intent(in) :: atom
   type(bond_type), dimension(:), allocatable, intent(in) :: legm
   integer, intent(in)                                    :: kmodel
   integer, intent(in)                                    :: id
!
   if (kmodel == 1) then
       call update_model(atom,legm,id)
       call export_files()
   endif
!
   end subroutine update_model_and_export

END MODULE exportfiles

   subroutine esportanew(iCod, filnam)
   USE Counts
   USE Conteggi
   USE reflection_type_util
   USE proginterface
   USE gen_frm
   USE variables, only: dataset,cryst
   USE General, only: is_extraction
   USE prog_constants
!
   implicit none
   integer                                          :: iCod
   character(len=256)                               :: filename
   character(len=256)                               :: filnam
   integer                                          :: Lung
   type(reflection_type), dimension(:), allocatable :: reflb
   integer                                          :: nExitCode
!
   filename = filnam(1:Lung(filnam))
   select case (iCod)
     case(16)       ! Powder Pattern
       if (npunti > 0) then
           if (allocated(dataset(1)%yc)) then
               call export_profile(filename,dataset(1)%x0,                     &
                    dataset(1)%y,dataset(1)%yc+dataset(1)%yb,dataset(1)%yb,    &
                    '#      2theta    yoss     ycalc    yback    ydiff')
           else
               call export_profile(filename,theta_int(:,7),theta_int(:,2),string='#      2theta    yoss')
           endif
       endif

      case (17)     ! Reflection File
       if (cryst(1)%numref() > 0) then
           call copy_ref(reflb,cryst(1)%ref)
           if (.not.is_extraction) reflb%fo = 0.0
           call write_reflections(fname=filename,refl=reflb,     &
           code=2,title='#hkl,F(obs)^2,sigma in SHELX format') ! hkl,Fo-squared
       else
           call MsgWinErr('ERROR','Reflections are not available!',ERR_WINDOW,nExitCode)
       endif
   end select
!
   return
   end
