#include "mrconfig.h"
//#include "forcomm1.h"
#include "forcomm2.h"
#include "callbacks.h"
#include "aliasx.h"

typedef char stringa20[20];

extern "C" void run_peaksearchwin_();


/* internally used functions */

void       c_disegna_interval       (int *val, int kdraw);
void on_cancel_clicked(GtkButton *button, gpointer data);
void on_search_peaks(GtkWidget *button, gpointer data);
void       end_polynomial           (GtkButton       *button,
                                        gpointer         user_data);
void       get_interval_selection   (GtkWidget *widget, gpointer data);

extern "C" void cflush_(void);

GtkWidget* create_Set_Search_Condition (float initsearch[]);
GtkWidget* create_polynomial (int coef,int n_int);

GtkWidget *new_search = NULL;
GtkWidget *polynomial = NULL;

static GtkWidget *spin_interval1;
static GtkWidget *spin_interval2;

static int pos_int = 0;

static float limite_infth, limite_supth;

long cc_nint(float fnumber)
{
    long inumber = 0;

    if (fnumber >= 0)
        inumber = (long) (fnumber + 0.5);
    else if(fnumber < 0)
        inumber = (long) (fnumber - 0.5);
  
    return inumber;
} 

float statomin, statomax;
static const int dimsearch = 5;
static float initsearch[dimsearch];
static float statosearch[dimsearch];
static float limite_inf;
static float limite_sup;
static int ultimo_intervallo;
int coef;
int val_interval=1;

extern plotok *cplotok;
extern int left_ruler;
extern int right_ruler;
extern int move_left_ruler;
extern int move_right_ruler;
extern GtkWidget *finestre[6];

void combo_changed(GtkWidget *combo, GCallback cb, gpointer cb_data)
{
#ifndef GTK_COMBO_BOX
      g_signal_connect_after(G_OBJECT(GTK_COMBO(combo)->list), "select-child",
               cb, cb_data);
#else
      g_signal_connect_after(G_OBJECT(combo), "changed", cb, cb_data);
#endif
}

void open_tb_profile(GtkWidget *item, gpointer data)
{
//corr     mostra_tb(item, data);
     if (cplotok->kprofile == 0)
         cplotok->kprofile = -1;
     else
         cplotok->kprofile = 0;
}

void cancel_tb_profile (GtkWidget *item, GdkEventButton *event, gpointer data)
{
     cplotok->kprofile = 0;
//corr     cancel_tb(item, event, data);
}

/*corr
void apply_background(GtkWidget *item, gpointer data)
{

    fortran_al_lavoro();
    if (cplotok->iriet == 1)
        val_interval = 1;
    c_calcola_background(&val_interval);
    fine_lavoro();
}
*/

void ok_tb_background (GtkWidget *item, GdkEventButton *event, gpointer data)
{
    GtkWidget *main_window = gtk_widget_get_toplevel(item);
    val_interval = 200;
    c_disegna_interval(&val_interval,2);
    nascondi_tb(main_window);
}

void save_position_left ()
{
     if (left_ruler < limite_inf || cplotok->iact_interval == 1)
     {
         left_ruler = cc_nint(limite_inf);
         cplotok->theta_left[cplotok->iact_interval]=limite_infth;
     }
     else
     cplotok->theta_left[cplotok->iact_interval]=(left_ruler - cplotok->xdispC[0])/cplotok->xscaleC[0];

     spin_button_set_value(spin_interval1,cplotok->theta_left[cplotok->iact_interval]);
// la modifica del valore dello spin invoca la funzione change_ruler_left 
}

void save_position_right ()
{
     if (right_ruler > limite_sup || cplotok->iact_interval == ultimo_intervallo)
     {
         right_ruler = cc_nint(limite_sup);
         cplotok->theta_right[cplotok->iact_interval]=limite_supth;
     }
     else
     cplotok->theta_right[cplotok->iact_interval]=(right_ruler - cplotok->xdispC[0])/cplotok->xscaleC[0];

     spin_button_set_value(spin_interval2,cplotok->theta_right[cplotok->iact_interval]);
// la modifica del valore dello spin invoca la funzione change_ruler_right
}

static int oldPos = -1;

void get_interval_selection_with_bars (GtkWidget *widget, gpointer user_data)
{
     int pos;
//     static int nvolte;

     pos = pos_int-1;
     if(oldPos == pos)
         return;
     oldPos = pos;
     if(pos != -1)
     {
        cplotok->iact_interval = pos;
///        g_print("GET_INTERVAL pos = %d\n",pos);
        spin_button_set_value(spin_interval1,cplotok->theta_left[pos]);
        spin_button_set_value(spin_interval2,cplotok->theta_right[pos]);
        if (pos == 1)
        {
            gtk_widget_set_sensitive(spin_interval1,FALSE);
            gtk_widget_set_sensitive(spin_interval2,TRUE);
        }
        else if (pos == ultimo_intervallo)
        {
            gtk_widget_set_sensitive(spin_interval1,TRUE);
            gtk_widget_set_sensitive(spin_interval2,FALSE);
        }
        else
        {
            gtk_widget_set_sensitive(spin_interval1,TRUE);
            gtk_widget_set_sensitive(spin_interval2,TRUE);
        }
     }
}

void change_ruler_left(GtkWidget *spin, gpointer user_data)
{

   if(!move_left_ruler) /*operazioni inutili se modifico gli intervalli col mouse*/
   {
     cplotok->theta_left[cplotok->iact_interval] = (float) spin_button_get_value(spin);
     left_ruler = (int) (cplotok->theta_left[cplotok->iact_interval]*cplotok->xscaleC[0] + cplotok->xdispC[0]);
   }
   redrawpattern(2);
   cflush_();
   show_vertical_ruler(right_ruler);
   show_vertical_ruler(left_ruler);
}


void change_ruler_right(GtkWidget *spin, gpointer user_data)
{

   if(!move_right_ruler) //operazioni inutili se modifico gli intervalli col mouse
   {
     cplotok->theta_right[cplotok->iact_interval] = (float)spin_button_get_value(spin);
     right_ruler = (int) (cplotok->theta_right[cplotok->iact_interval]*cplotok->xscaleC[0] + cplotok->xdispC[0]);
   }
   redrawpattern(2);
   cflush_();
   show_vertical_ruler(right_ruler);
   show_vertical_ruler(left_ruler);
}

void action_interval(GtkWidget *button, gpointer data)
{
    int action = GPOINTER_TO_INT(data);
    switch (action)
    {
    case 1:            // Apply
         c_setintervals(&action);
         break;
    case 2:            // Ok
    case 3:            // Cancel
         cplotok->kruler = 0;
         c_setintervals(&action);
         gtk_widget_destroy(gtk_widget_get_toplevel(button));
         break;
    }
    val_interval = 200;
    c_disegna_interval(&val_interval,2);
}

void create_setintervals(int n_interval)
{
   const char *intervals[12];
   intervals[0] = g_strdup("Single Peak");
   for(int i=1; i<n_interval+1;i++)
       intervals[i] = g_strdup_printf("interval %2d",i);

   GtkWidget *dlg = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(dlg), "Intervals");
   
   GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   GtkWidget *frame = FRAME_BOLD("Modify the intervals", MyBLUE, 1.1f);
   gtk_container_add (GTK_CONTAINER (vbox), frame);
   gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);
   GtkWidget *vbox1 =  vbox_new(FALSE, 10);
   gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);
   gtk_container_add (GTK_CONTAINER (frame), vbox1);

#ifdef IN_GTK3
   GtkWidget *align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_START, 0, 0);
#else
   GtkWidget *align = gtk_alignment_new(0.5, 0, 0, 0);
#endif
   gtk_box_pack_start (GTK_BOX (vbox1), align, FALSE, FALSE, 6);
   GtkWidget *comboint = create_combo(align, intervals, n_interval+1, 2, &pos_int);
   GtkWidget* hbox = hbox_new(FALSE, 10);
   gtk_container_set_border_width (GTK_CONTAINER (hbox), 10);
   gtk_widget_set_size_request(hbox,-1,90);
   gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 6);
   GtkWidget *label = gtk_label_new (" Two Theta min:");
   gtk_container_add (GTK_CONTAINER (hbox), label);

   spin_interval1 = spin_button_new_with_range(
        limite_infth, limite_supth, 0.05f);
   spin_button_set_value(spin_interval1, cplotok->theta_left[1]);
   gtk_container_add (GTK_CONTAINER (hbox), spin_interval1);
   set_width_chars(GTK_ENTRY(spin_interval1), 6);
   //gtk_widget_set_size_request(spin_interval1,70,20);
   gtk_widget_set_sensitive(spin_interval1,FALSE);

   label = gtk_label_new (" Two Theta max:");
   gtk_container_add (GTK_CONTAINER (hbox), label);
   spin_interval2 = spin_button_new_with_range(
        limite_infth, limite_supth, 0.05f);
//corr
   cplotok->iact_interval = 1;
//corr
   spin_button_set_value(spin_interval2, cplotok->theta_right[1]);
   gtk_container_add (GTK_CONTAINER (hbox), spin_interval2);
   //gtk_widget_set_size_request(spin_interval2,70,20);
   set_width_chars(GTK_ENTRY(spin_interval2), 6);
   
   combo_changed(comboint, G_CALLBACK(get_interval_selection_with_bars), NULL);
   g_signal_connect(G_OBJECT(spin_interval1), "value-changed",
       G_CALLBACK(change_ruler_left), GINT_TO_POINTER(1));
   g_signal_connect(G_OBJECT(spin_interval2), "value-changed",
       G_CALLBACK(change_ruler_right), GINT_TO_POINTER(2));

   GtkWidget *button = APPLY_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_interval), GINT_TO_POINTER(1));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 1);
   button = OK_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_interval), GINT_TO_POINTER(2));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 2);
   button = CANCEL_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_interval), GINT_TO_POINTER(3));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 3);
   g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
       G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
   gtk_widget_show_all(dlg);
}

void open_tb_intervals(GtkWidget *item, gpointer data)
{
     int n_interval = -1;

// forza la modalita' selezione
     gpointer button_sel = get_object(finestre[0], "selectionmode");
     obj_set_active(button_sel, TRUE);

     cplotok->kruler = 1;
     c_setintervals(&n_interval);
//
//   Definisci limiti inferiori e superiori in 2-theta e pixel
//
     limite_infth = cplotok->theta_left[1];
     limite_supth = cplotok->theta_right[n_interval];
     limite_inf = limite_infth*cplotok->xscaleC[0] + cplotok->xdispC[0];
     limite_sup = limite_supth*cplotok->xscaleC[0] + cplotok->xdispC[0];
//
//   Disegna rulers
//
     redrawpattern(1);
     int limite_sup1 = (int)(cplotok->theta_right[1]*cplotok->xscaleC[0] + cplotok->xdispC[0]);
     left_ruler = (int)limite_inf;
     right_ruler = limite_sup1;
     show_vertical_ruler(left_ruler);
     show_vertical_ruler(right_ruler);

     ultimo_intervallo = n_interval;

     create_setintervals(n_interval);
}

void action_range(GtkWidget *button, gpointer data)
{
    int action = GPOINTER_TO_INT(data);
    switch (action)
    {
    case 1:            // Apply
         c_set_range(&action);
         break;
    case 2:            // Ok
    case 3:            // Cancel
         cplotok->kruler = 0;
         c_set_range(&action);
         gtk_widget_destroy(gtk_widget_get_toplevel(button));
//corr         finestra_modale_chiusa2();
         break;
    }
}

void create_setrange()
{
   GtkWidget *dlg = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(dlg), "Range");
   
   GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   GtkWidget *frame = FRAME_BOLD("Set range", MyBLUE, 1.1f);
   gtk_container_add (GTK_CONTAINER (vbox), frame);
   gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);
   GtkWidget* hbox = hbox_new(FALSE, 10);
   gtk_container_set_border_width (GTK_CONTAINER (hbox), 10);
   gtk_widget_set_size_request(hbox,-1,90);
   gtk_container_add (GTK_CONTAINER (frame), hbox);
   GtkWidget *label_range1 = gtk_label_new (" Two Theta min:");
   gtk_container_add (GTK_CONTAINER (hbox), label_range1);

   spin_interval1 = spin_button_new_with_range(
        limite_infth, limite_supth, 0.05f);
   spin_button_set_value(spin_interval1, cplotok->theta_left[0]);
   gtk_container_add (GTK_CONTAINER (hbox), spin_interval1);
   //gtk_widget_set_size_request(spin_interval1,70,20);
   set_width_chars(GTK_ENTRY(spin_interval1), 6);

   GtkWidget *label_range2 = gtk_label_new (" Two Theta max:");
   gtk_container_add (GTK_CONTAINER (hbox), label_range2);
   spin_interval2 = spin_button_new_with_range(
        limite_infth, limite_supth, 0.05f);
   spin_button_set_value(spin_interval2, cplotok->theta_right[0]);
   gtk_container_add (GTK_CONTAINER (hbox), spin_interval2);
   //gtk_widget_set_size_request(spin_interval2,70,20);
   set_width_chars(GTK_ENTRY(spin_interval2), 6);
   g_signal_connect(G_OBJECT(spin_interval1), "value-changed",
       G_CALLBACK(change_ruler_left), GINT_TO_POINTER(1));
   g_signal_connect(G_OBJECT(spin_interval2), "value-changed",
       G_CALLBACK(change_ruler_right), GINT_TO_POINTER(2));
   
   GtkWidget *button = APPLY_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_range), GINT_TO_POINTER(1));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 1);
   button = OK_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_range), GINT_TO_POINTER(2));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 2);
   button = CANCEL_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_range), GINT_TO_POINTER(3));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 3);
   g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
       G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
//corr   finestra_modale_aperta2(dlg);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
   gtk_widget_show_all(dlg);
}

void open_tb_range(GtkWidget *item, gpointer data)
{
     int iact = 0;

// forza la modalita' selezione
     gpointer button_sel = get_object(finestre[0], "selectionmode");
     obj_set_active(button_sel, TRUE);

     cplotok->kruler = 1;
     cplotok->iact_interval = 0;
     ultimo_intervallo = 100;

     c_set_range(&iact);
//
//   Definisci limiti inferiori e superiori in 2-theta e pixel
//
     limite_infth = cplotok->theta_left[0];
     limite_supth = cplotok->theta_right[0];
     limite_inf = limite_infth*cplotok->xscaleC[0] + cplotok->xdispC[0];
     limite_sup = limite_supth*cplotok->xscaleC[0] + cplotok->xdispC[0];
//
//   Disegna rulers
//
     redrawpattern(1);
     left_ruler = (int)limite_inf;
     right_ruler = (int)limite_sup;
     show_vertical_ruler(left_ruler);
     show_vertical_ruler(right_ruler);

     create_setrange();
}

//void open_new_search(GtkWidget *item, char *string, guint cod)

void Set_Defaults_Search_Condition(GtkWidget *but, gpointer data)
{
     int iact=6;
     c_search_peaks(&iact,&statomin,&statomax,initsearch);
     for (int i=0; i<dimsearch; i++)
         statosearch[i] = initsearch[i];
     GtkWidget *dlg = gtk_widget_get_toplevel(but);

     GtkWidget *label = get_widget(dlg, "spinbutton1");
     int hnd = get_int(label, "hnd");
     g_signal_handler_block(G_OBJECT(label), hnd);
     spin_button_set_value(label, statosearch[0]);
     g_signal_handler_unblock(G_OBJECT(label), hnd);

     label = get_widget(dlg, "spinbutton2");
     hnd = get_int(label, "hnd");
     g_signal_handler_block(G_OBJECT(label), hnd);
     spin_button_set_value(label, statosearch[1]);
     g_signal_handler_unblock(G_OBJECT(label), hnd);
  
     label = get_widget(dlg, "spinbutton3");
     hnd = get_int(label, "hnd");
     g_signal_handler_block(G_OBJECT(label), hnd);
     spin_button_set_value(label, statosearch[2]);
     g_signal_handler_unblock(G_OBJECT(label), hnd);
  
     label = get_widget(dlg, "spinbutton4");
     hnd = get_int(label, "hnd");
     g_signal_handler_block(G_OBJECT(label), hnd);
     spin_button_set_value(label, statosearch[3]);
     g_signal_handler_unblock(G_OBJECT(label), hnd);
}

void open_new_search(gpointer item, gpointer data)
{
     int iact=1;
     int i;

     c_search_peaks(&iact,&statomin,&statomax,initsearch);
     for (i=0; i<dimsearch; i++)
         statosearch[i] = initsearch[i];
     new_search = create_Set_Search_Condition(initsearch);
     gtk_widget_show(new_search);
     gdk_window_raise(gtk_widget_get_window(new_search));
     finestra_modale_aperta2(new_search);
}

void peak_search(gpointer item, gpointer data)
{
     run_peaksearchwin_();
     if(get_widget(finestre[0], "peak_list_win") != NULL)
        peak_list(NULL, NULL);
}

void end_Set_Search_Condition  (GtkButton *button, gpointer data)
{
     int iact = GPOINTER_TO_INT(data);
     gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
     finestra_modale_chiusa2();
     if(iact == 0)
        c_search_peaks(&iact,&statomin,&statomax,statosearch);
}

GtkWidget*
create_Set_Search_Condition (float initsearch[])
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *table1;
  GtkWidget *label1;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *label2;
  GObject *spinbutton1_adj;
  GtkWidget *spinbutton1;
  GObject *spinbutton2_adj;
  GtkWidget *spinbutton2;
  GObject *spinbutton3_adj;
  GtkWidget *spinbutton3;
  GObject *spinbutton4_adj;
  GtkWidget *spinbutton4;
  GtkWidget *search_ok;
  GtkWidget *search_cancel;
  GtkWidget *search_def;

  window1 = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "Set Search Conditions");
  gtk_window_set_transient_for(GTK_WINDOW(window1), GTK_WINDOW(finestre[0]));
  gtk_window_set_position(GTK_WINDOW(window1), GTK_WIN_POS_CENTER_ON_PARENT);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));
  g_object_set_data (G_OBJECT (window1), "vbox1", vbox1);
  gtk_widget_show (vbox1);

  table1 = table_new (4, 2, FALSE);
  g_object_set_data (G_OBJECT (window1), "table1", table1);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (vbox1), table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 30);
  table_set_row_spacings (table1, 20);
  table_set_col_spacings (table1, 10);

  label1 = gtk_label_new ("Minimum 2-theta: ");
  g_object_set_data (G_OBJECT (window1), "label1", label1);
  gtk_widget_show (label1);
  table_attach_exp (table1, label1, 0, 1, 0, 1);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_RIGHT);
  set_alignment (label1, 1, 0.5);

  label3 = gtk_label_new ("% Int. Threshold:");
  g_object_set_data (G_OBJECT (window1), "label3", label3);
  gtk_widget_show (label3);
  table_attach_exp (table1, label3, 0, 1, 2, 3);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_RIGHT);
  set_alignment (label3, 1, 0.5);

  label4 = gtk_label_new ("Number of Peaks:");
  g_object_set_data (G_OBJECT (window1), "label4", label4);
  gtk_widget_show (label4);
  table_attach_exp (table1, label4, 0, 1, 3, 4);
  set_alignment (label4, 1, 0.5);

  label2 = gtk_label_new ("Maximum 2-theta:");
  g_object_set_data (G_OBJECT (window1), "label2", label2);
  gtk_widget_show (label2);
  table_attach_exp (table1, label2, 0, 1, 1, 2);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_RIGHT);
  set_alignment (label2, 1, 0.5);

  spinbutton1_adj = adj_new (initsearch[0], statomin, statomax, 1, 10);
  spinbutton1 = spin_button_new (GTK_ADJUSTMENT (spinbutton1_adj), 1, 2);
  g_object_set_data (G_OBJECT (window1), "spinbutton1", spinbutton1);
  gtk_widget_show (spinbutton1);
  table_attach_exp (table1, spinbutton1, 1, 2, 0, 1);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton1), 7);
  spin_button_set_numeric(spinbutton1,TRUE);
  int hnd = g_signal_connect(G_OBJECT(spinbutton1), "value-changed",
           G_CALLBACK(on_search_peaks), GINT_TO_POINTER(2));
  g_object_set_data (G_OBJECT (spinbutton1), "hnd", GINT_TO_POINTER(hnd));

  spinbutton2_adj = adj_new (initsearch[1], statomin, statomax, 1, 10);
  spinbutton2 = spin_button_new (GTK_ADJUSTMENT (spinbutton2_adj), 1, 2);
  g_object_set_data (G_OBJECT (window1), "spinbutton2", spinbutton2);
  gtk_widget_show (spinbutton2);
  table_attach_exp (table1, spinbutton2, 1, 2, 1, 2);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton2), 7);
  spin_button_set_numeric(spinbutton2,TRUE);
  hnd = g_signal_connect(G_OBJECT(spinbutton2), "value-changed",
           G_CALLBACK(on_search_peaks), GINT_TO_POINTER(3));
  g_object_set_data (G_OBJECT (spinbutton2), "hnd", GINT_TO_POINTER(hnd));

  spinbutton3_adj = adj_new (initsearch[2], 0, 99, 0.05, 10);
  spinbutton3 = spin_button_new (GTK_ADJUSTMENT (spinbutton3_adj), 1, 2);
  g_object_set_data (G_OBJECT (window1), "spinbutton3", spinbutton3);
  gtk_widget_show (spinbutton3);
  table_attach_exp (table1, spinbutton3, 1, 2, 2, 3);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton3), 7);
  spin_button_set_numeric(spinbutton3,TRUE);
  hnd = g_signal_connect(G_OBJECT(spinbutton3), "value-changed",
           G_CALLBACK(on_search_peaks), GINT_TO_POINTER(4));
  g_object_set_data (G_OBJECT (spinbutton3), "hnd", GINT_TO_POINTER(hnd));

  spinbutton4_adj = adj_new (initsearch[3], 0, initsearch[4], 1, 10);
  spinbutton4 = spin_button_new (GTK_ADJUSTMENT (spinbutton4_adj), 1, 0);
  g_object_set_data (G_OBJECT (window1), "spinbutton4", spinbutton4);
  gtk_widget_show (spinbutton4);
  table_attach_exp (table1, spinbutton4, 1, 2, 3, 4);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton4), 7);
  spin_button_set_numeric(spinbutton4,TRUE);
  hnd = g_signal_connect(G_OBJECT(spinbutton4), "value-changed",
           G_CALLBACK(on_search_peaks), GINT_TO_POINTER(5));
  g_object_set_data (G_OBJECT (spinbutton4), "hnd", GINT_TO_POINTER(hnd));

  search_ok = OK_button();
  g_object_set_data (G_OBJECT (window1), "search_ok", search_ok);
  gtk_widget_show (search_ok);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), search_ok, 1);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(search_ok)),
         GTK_BUTTONBOX_SPREAD);
  g_signal_connect (G_OBJECT (search_ok), "clicked",
                      G_CALLBACK (end_Set_Search_Condition),
                      GINT_TO_POINTER(1));

  search_def = DEFAULTS_button();
  g_object_set_data (G_OBJECT (window1), "search_def", search_def);
  gtk_widget_show (search_def);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), search_def, 3);
  g_signal_connect (G_OBJECT (search_def), "clicked",
                      G_CALLBACK (Set_Defaults_Search_Condition),
                      (gpointer) window1);

  search_cancel = CANCEL_button();
  g_object_set_data (G_OBJECT (window1), "search_cancel", search_cancel);
  gtk_widget_show (search_cancel);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), search_cancel, 2);

  g_signal_connect (G_OBJECT (search_cancel), "clicked",
                      G_CALLBACK (end_Set_Search_Condition),
                      GINT_TO_POINTER(0));

  g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
       G_CALLBACK(gtk_button_clicked), G_OBJECT(search_cancel));
  g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window1;
}

void open_polynomial(GtkWidget *item, gpointer data)
{
     int iact=1;
     int n_interval;

     val_interval = 1;
     c_salva_background(&iact, &n_interval);
     c_disegna_interval(&val_interval,2);

     c_polynomial(&iact, &coef, &val_interval);
     polynomial = create_polynomial(coef, n_interval);
     gtk_widget_show(polynomial);
     gdk_window_raise(gtk_widget_get_window(polynomial));
     finestra_modale_aperta2(polynomial);
}

GtkWidget* create_polynomial (int coef, int n_interval)
{
  GtkWidget *window1;
  GtkWidget *vbox1;
//corr  GtkWidget *hbox1;
  GtkWidget *label1;
  GtkWidget *spinbutton;
  GtkWidget *hbox2;
  GtkWidget *poly_ok;
  GtkWidget *poly_cancel;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  g_object_set_data (G_OBJECT (window1), "window1", window1);
  gtk_container_set_border_width (GTK_CONTAINER (window1), 10);
  gtk_window_set_title (GTK_WINDOW (window1), "Polynomial Coefficients");

  vbox1 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "vbox1", vbox1);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  GtkWidget *table = table_new(2, 2, FALSE);
  gtk_widget_show (table);
  gtk_box_pack_start (GTK_BOX (vbox1), table, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table), 20);
  table_set_row_spacings (table, 20);
  table_set_col_spacings (table, 10);

  label1 = gtk_label_new ("Number of Coefficients:");
  g_object_set_data (G_OBJECT (window1), "label1", label1);
  set_alignment(label1, 0, 0.5f);
  gtk_widget_show (label1);
  table_attach_exp(table, label1, 0, 1, 0, 1);

  spinbutton = SPIN_NEW (1, 11, coef, 1, 0);
  g_object_set_data (G_OBJECT (window1), "spinbutton", spinbutton);
  gtk_widget_show (spinbutton);
  table_attach_exp(table, spinbutton, 1, 2, 0, 1);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton), 4);
  spin_button_set_numeric(spinbutton,TRUE);

  label1 = gtk_label_new ("Select interval:");
  gtk_widget_show (label1);
  set_alignment(label1, 0, 0.5f);
  table_attach_exp(table, label1, 0, 1, 1, 2);

  const char *intervals[12];
  for(int i=0; i<n_interval+1;i++)
      intervals[i] = g_strdup_printf("interval %2d",i+1);

  GtkWidget *combo2 = create_combo(NULL, intervals, n_interval, val_interval, &val_interval, NULL, false);
  gtk_widget_show_all(get_widget(combo2, "parent"));
  g_object_set_data(G_OBJECT(window1),"intervals",get_widget(combo2, "entry"));
  combo_changed(combo2, G_CALLBACK(get_interval_selection), NULL);
  table_attach_exp(table, get_widget(combo2, "parent"), 1, 2, 1, 2);

  hbox2 = hbutton_box_new();
  g_object_set_data (G_OBJECT (window1), "hbox2", hbox2);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 10);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox2), GTK_BUTTONBOX_SPREAD);

  poly_ok = OK_button();
  g_object_set_data (G_OBJECT (window1), "poly_ok", poly_ok);
  gtk_widget_show (poly_ok);
  gtk_container_add (GTK_CONTAINER (hbox2), poly_ok);

  poly_cancel = CANCEL_button();
  g_object_set_data (G_OBJECT (window1), "poly_cancel", poly_cancel);
  gtk_widget_show (poly_cancel);
  gtk_container_add (GTK_CONTAINER (hbox2), poly_cancel);

  g_signal_connect (G_OBJECT (poly_cancel), "clicked",
                      G_CALLBACK (on_cancel_clicked),
                      NULL);
  g_signal_connect(G_OBJECT(poly_ok), "clicked", G_CALLBACK(end_polynomial),
                     GINT_TO_POINTER(1));

  return window1;
}

//   callbacks


void on_cancel_clicked  (GtkButton *button, gpointer data)
{
//corr    int iact = 2;
//corr    int n_interval;

//corr    c_salva_background(&iact,&n_interval);
    gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
    finestra_modale_chiusa2();
}

void on_search_peaks(GtkWidget *button, gpointer data)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(button);
   int iact = GPOINTER_TO_INT(data);
   GtkWidget *label = get_widget(dlg, "spinbutton1");
   statosearch[0] = (float)spin_button_get_value(label);

   label = get_widget(dlg, "spinbutton2");
   statosearch[1] = (float)spin_button_get_value(label);

   label = get_widget(dlg, "spinbutton3");
   statosearch[2] = (float)spin_button_get_value(label);

   label = get_widget(dlg, "spinbutton4");
   statosearch[3] = (float)spin_button_get_value(label);
   fortran_al_lavoro();
   c_search_peaks(&iact,&statomin,&statomax,statosearch);
   fine_lavoro();
   if((iact >= 2) && (iact <= 4))
   {
      label = get_widget(dlg, "spinbutton4");
      int hnd = get_int(label, "hnd");
      g_signal_handler_block(G_OBJECT(label), hnd);
      spin_button_set_value(label, statosearch[3]);
      g_signal_handler_unblock(G_OBJECT(label), hnd);
   }
   else if(iact == 5)
   {
      label = get_widget(dlg, "spinbutton3");
      int hnd = get_int(label, "hnd");
      g_signal_handler_block(G_OBJECT(label), hnd);
      spin_button_set_value(label, statosearch[2]);
      g_signal_handler_unblock(G_OBJECT(label), hnd);
   }
}

void end_polynomial (GtkButton *button, gpointer user_data)
{
   int iact=2;
   GtkWidget *label;

   label = get_widget(polynomial, "spinbutton");
   coef = spin_button_get_value_as_int(label);

   gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
   finestra_modale_chiusa2();

   fortran_al_lavoro();
   c_polynomial(&iact,&coef,&val_interval);
   fine_lavoro();
}

void get_interval_selection (GtkWidget *widget, gpointer data)
{
//     g_print("GET_COMBOSELECTION: %d\n", *val_interval);
   int iact = 1;
   c_disegna_interval(&val_interval,2);
   c_polynomial(&iact, &coef, &val_interval);
   GtkWidget *dlg = gtk_widget_get_toplevel(widget);
   GtkWidget *spin = get_widget(dlg, "spinbutton");
   spin_button_set_value(spin, coef);
}
