/********************************************************/
/*                    R E S T R A I N T S               */
/********************************************************/
#include "mrconfig.h"

//#include "forcomm2.h"
//#include "forcomm1.h"
#include "aliasx.h"
#include "cry.h"
#include <fstream>
extern Crystal *crys;

typedef struct {
                 int   index;
                 char *text;
               } FIXTEXT;

#if 0
typedef struct {
                 int   code;  // indica il tipo di restraint: 1=distanza,2=angolo,3=piano
                 int   nna;   // numero di atomi coinvolti nel restraint
                 int   *na;   // puntatori agli atomi coinvolti nel restraint
                 float val;   // valore corrente del restraint
                 float targ;  // valore target del restraint
                 float sigma; // deviazione standard
               } restraint_type;
#endif

typedef struct {
                 int  active;
                 char *type;
                 char *atoms;
                 char *current;
                 char *target;
                 char *esd;
                 int  posi;
               } restraint_info;

restraint_type *resv;
int nres;
float wqq[3];
static const char *wqq_label[] = {"on distances", "on angles", "on planes"};
static atom_type *atm;
extern _Dialogo *dialogo;
extern GtkWidget *finestre[6];

static GtkWidget *nrestraints_dlg = NULL;
static int nats;

/***********************************************************************/

enum {DIST, ANGLE, PLANE, DEL, ALL};

/******************************************************************************/
/*      R E S T R A I N T S       (nuova gestione)                            */
/******************************************************************************/
extern "C" int num_restraints_(int *j);
extern "C" void genera_lista_restraints_(int *code);
extern "C" void init_newrestraints_(float wqq[]);
extern "C" void get_restraints_from_c_(int *active, int *code, float *val, 
                                       float *targ, float *esd, int *nna, int na[]);
extern "C" void get_newrestraint_from_c_(int *active, int *code, float *val, 
                                       float *targ, float *esd, int *nna, int na[]);
extern "C" void get_resttodel_from_c_(int *which, int *active, int *code, float *val, 
                                       float *targ, float *esd, int *nna, int na[]);
extern "C" void  finishnewrestraints_(int *icod, float wqq[]);
extern "C" void  leggirestraints_(char *filnam, size_t idum);
extern "C" void  scrivirestraints_(char *filnam, float wqq[], size_t idum);
extern "C" void  passaweight_(float *w, int *which);

void DisegnaSelezione(int whichModel, int code, int n[]);

int *vetres = NULL;
static int CurrentRestr = -1;
static int RestrCode = -1;
//static int ifLabelsSav;
static const char *tmpRestrFile = "restraint_file.tmp";

static const char *tipo_res[] = {"Distance restraints",
                                 "Angle restraints", 
                                 "Plane restraints"};
enum
{
  COLUMN_FIXED,
  COLUMN_TYPE,
  COLUMN_ATOMS,
  COLUMN_CURRENT,
  COLUMN_TARGET,
  COLUMN_ESD,
  COLUMN_POSI,
  NUM_COLUMNS
};

GtkWidget *my_combo(GCallback cb, gpointer cb_data);
void my_combo_set_val(GtkWidget *combo, int val);
void fill_my_combo(GtkWidget *combo, const char *labels[],
                              int nlabels, int def_b);
GtkWidget *create_my_combo(const char *labels[], int nlabels, int def_b,
                           GCallback cb_func, gpointer data)
{
    GtkWidget *combo;

    combo = my_combo(cb_func, data);
    if(nlabels > 0)
       fill_my_combo(combo, labels, nlabels, def_b);
    return combo;
}

GList *get_selections_from_tog(GtkWidget *list)
{
    GtkTreeIter iter;
    gpointer data;
    gboolean fixed;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GList *rowsel = NULL;

    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    int i = 0;
    while (valid)
    {
       FIXTEXT *list_element = g_new0(FIXTEXT, 1);
       gtk_tree_model_get (model, &iter, 0, &fixed, 1, &data, -1);
       list_element->index = i + 1;
       list_element->text = (char *) data;
       if(fixed)
          rowsel = g_list_append(rowsel, (gpointer)list_element);
       valid = gtk_tree_model_iter_next (model, &iter);
       i++;
    }
    return rowsel;
}

std::string peek_atoms_from_list(GtkWidget *father, restraint_type *newr)
{
using namespace gtkext;
   int i;
   std::string return_string = "";
   char riga[16];
   GtkWidget *dlg = gtk_dialog_new();
   gtk_window_set_title (GTK_WINDOW (dlg), "Select atoms to define a plane");
   gtk_container_set_border_width(GTK_CONTAINER(gtk_dialog_get_content_area(GTK_DIALOG(dlg))), 10);
   gtk_widget_set_size_request(dlg, 350, 300);

   GtkWidget *list = createSelection(dlg, gtk_dialog_get_content_area(GTK_DIALOG(dlg)), "Atoms", "listaAtomi", 4, MyBLUE);
   set_selection_mode(list, GTK_SELECTION_NONE);
   for(i=0; i<nats; i++)
   {
       CopiaStringan(riga, sizeof(riga), atm[i].lab, 15);
       riga[15] = '\0';
       add_line_to_list(list, (gpointer) riga, 1);
   }

   GtkWidget *ok_button = OK_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), ok_button, GTK_RESPONSE_OK);

   GtkWidget *cancel_button = CANCEL_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), cancel_button, GTK_RESPONSE_CANCEL);
   gtk_button_box_set_layout(GTK_BUTTON_BOX (gtk_widget_get_parent(ok_button)),
          GTK_BUTTONBOX_SPREAD);
   gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(father));
   bool ok = false;
   gtk_widget_set_sensitive(father, FALSE);
   while(!ok)
   {
       ok = true;
       int response = gtk_dialog_run(GTK_DIALOG(dlg));
       if(response == GTK_RESPONSE_OK)
       {
//        GList *rowsel = NULL;
//        rowsel = get_selections(list);
          GList *rowsel = get_selections_from_tog(list);
          if( (rowsel == NULL)  || ( g_list_length(rowsel) < 3) )
          {
               gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
               dlg_errmsg(GTK_WINDOW(dlg), "You should select at least three atoms!");
               gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
               ok = false;
          }
          else
          {
               newr->code = PLANE + 1;
               newr->nna = (int) g_list_length(rowsel);
               newr->na  = g_new0(int, (int)g_list_length(rowsel));
               newr->val = 0.;
               newr->targ = 0.;
               newr->sigma = 0.001f;
               for(i=0; i<(int)g_list_length(rowsel); i++)
               {
//                 GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
//                 std::string str1 = (char *)get_selection_from_path(GTK_TREE_VIEW(list), path);
                   FIXTEXT *element = (FIXTEXT *)  g_list_nth_data (rowsel, i);
                   std::string str1 = element->text;
                   return_string.append(trim(str1));
                   if(i < (int)g_list_length(rowsel) -1)
                     return_string.append("-");
//                 int ind_at = gtk_tree_path_get_indices (path)[0];
//                 newr->na[i] = ind_at+1;
                   newr->na[i] = element->index;
               }
//             g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
               g_list_free (rowsel);
          }
       }
   }
   gtk_widget_destroy(dlg);
   gtk_widget_set_sensitive(father, TRUE);
   return return_string;
}

#if 0
static void aggiorna_label(GtkWidget *label)
{
    std::ifstream ifs;
    std::string label_text = "";
    ifs.open(tmpRestrFile, std::ios::in);
    if(ifs && ifs.is_open())
    {
       std::string line;
       while (std::getline(ifs, line)) 
       {
           label_text.append(line);
           label_text.append("\n");
       }
       ifs.close();
    }
    gtk_label_set_text(GTK_LABEL(label), label_text.c_str());
}

static void aggiorna_label(GtkWidget *label)
{
    std::stringstream label_text("");
    int nr[3] = {0, 0, 0};
    std::ifstream ifs;
    ifs.open(tmpRestrFile, std::ios::in);
    if(ifs && ifs.is_open())
    {
       std::string line;
       while (std::getline(ifs, line)) 
       {
           size_t ind = line.find(";");
           if(ind != std::string::npos)
           {
               int cod = atoi(line.substr(ind+1).c_str());
               nr[cod-1]++;
           }
       }
       ifs.close();
    }

    label_text << "Distance: " << nr[0] <<
                  "                    Angle: " << nr[1] << 
                  "                    Plane: " << nr[2];
    gtk_label_set_text(GTK_LABEL(label), label_text.str().c_str());
}
#endif

static void aggiorna_label(GtkWidget *label)
{
    std::stringstream label_text("");
    int nr[3];
    for(int j=1; j<=3; j++)
        nr[j-1] = num_restraints_(&j);

    label_text << "Distance: " << nr[0] <<
                  "                    Angle: " << nr[1] << 
                  "                    Plane: " << nr[2];
    gtk_label_set_text(GTK_LABEL(label), label_text.str().c_str());
}

static void PassaCurrentRestraint(int current, int active)
{
     vetres[current] = active;
     int code  = resv[current].code;
     float targ  = resv[current].targ;
     float sigma = resv[current].sigma;
     float val   = resv[current].val;
     int   nna   = resv[current].nna;
     int  *na    = g_new0(int, resv[current].nna);
     for(int i=0; i<nna; i++)
         na[i] = resv[current].na[i];
     get_restraints_from_c_(&active, &code, &val, &targ, &sigma, &nna, na);
     g_free(na);
}

static void get_wqq(GtkWidget *dlg)
{
     if(RestrCode >= 0)
     {
        GtkWidget *entry = get_widget(dlg, "weight");
        wqq[RestrCode] = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
     }
}

void set_global_toggle(gpointer list)
{
  GtkTreeViewColumn *col = gtk_tree_view_get_column(GTK_TREE_VIEW(list), COLUMN_FIXED);
  GtkWidget *tog = gtk_tree_view_column_get_widget(col);

  GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
  GtkTreeIter iter;
  gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
  gboolean result = valid;

  while (valid)
  {
     gboolean val;
     gtk_tree_model_get (model, &iter, COLUMN_FIXED, &val, -1);
     valid = gtk_tree_model_iter_next (model, &iter);
     result *= val;
  }
  int hnd = get_int(tog, "hnd");
  g_signal_handler_block(G_OBJECT(tog), hnd);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tog), result);
  g_signal_handler_unblock(G_OBJECT(tog), hnd);
}

static void active_toggled (GtkCellRendererToggle *cell,
	       gchar                 *path_str,
	       gpointer               data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreeIter  iter;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  gboolean fixed;

  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, COLUMN_FIXED, &fixed, 
                       COLUMN_POSI, &CurrentRestr, -1);
  CurrentRestr--;

  fixed ^= 1;

  //CurrentRestr = gtk_tree_path_get_indices (path)[0];
  if(CurrentRestr >= 0)
  {
     get_wqq(nrestraints_dlg);
     int active = fixed;
     vetres[CurrentRestr] = active;
     PassaCurrentRestraint(CurrentRestr, active);
  }

  gtk_list_store_set (GTK_LIST_STORE (model), &iter, COLUMN_FIXED, fixed, -1);

  gtk_tree_path_free (path);
  //19092016scrivirestraints_((char *)tmpRestrFile, wqq, strlen(tmpRestrFile));
  aggiorna_label(get_widget(nrestraints_dlg, "listact"));
  set_global_toggle(get_widget(nrestraints_dlg, "listaRestraints"));
}

static GtkTreeModel *create_restraints_model (void)
{
  GtkListStore *model;

  model = gtk_list_store_new (NUM_COLUMNS, G_TYPE_BOOLEAN, G_TYPE_STRING,
        G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT);

  return GTK_TREE_MODEL (model);
}
  
void fill_restraints_model(GtkWidget *list, restraint_type *resv_local)
{
  gint i, j;
  GtkListStore *model = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
  GtkTreeIter iter;

  for (i = 0; i < nres; i++)
    {
      gtk_list_store_append (model, &iter);

      std::string str1 (atm[resv_local[i].na[0]-1].lab, 15);
      std::string atoms_str = trim(str1);
      std::string type_str = get_nth_element(atm[resv_local[i].na[0]-1].ptab-1);
      
      for(j=1; j<resv_local[i].nna; j++)
      {
          atoms_str.append("-");
          type_str.append("-");
          std::string str2 (atm[resv_local[i].na[j]-1].lab, 15);
          atoms_str.append(trim(str2));
          type_str.append(get_nth_element(atm[resv_local[i].na[j]-1].ptab-1));
      }

      gtk_list_store_set (model, &iter,
                          COLUMN_FIXED,
                          vetres[i],
                          COLUMN_TYPE,
                          type_str.c_str(),
                          COLUMN_ATOMS,
                          atoms_str.c_str(),
                          COLUMN_CURRENT,
                          fToStr(resv_local[i].val, 3).c_str(),
                          COLUMN_TARGET,
                          fToStr(resv_local[i].targ, 3).c_str(),
                          COLUMN_ESD,
                          fToStr(resv_local[i].sigma, 3).c_str(),
                          COLUMN_POSI,
                          i+1,
                          -1);
    }
    get_wqq(nrestraints_dlg);
    //19092016scrivirestraints_((char *)tmpRestrFile, wqq, strlen(tmpRestrFile));
    GtkWidget *dlg = gtk_widget_get_toplevel(list);
    aggiorna_label(get_widget(dlg, "listact"));
}

static void cell_edited (GtkCellRendererText *cell,
             const gchar         *path_string,
             const gchar         *new_text,
             gpointer             data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
  GtkTreeIter iter;

  gint column = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (cell), "column"));

  gtk_tree_model_get_iter (model, &iter, path);

  switch (column)
  {
    case COLUMN_TARGET:
      {
        gint i;
        gchar *old_text;

        gtk_tree_model_get (model, &iter, column, &old_text,
              COLUMN_POSI, &i, -1);
        g_free (old_text);
        i--;

        //i = gtk_tree_path_get_indices (path)[0];
        resv[i].targ = (float) atof(new_text);
        gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                            fToStr(resv[i].targ, 3).c_str(), -1);
        PassaCurrentRestraint(i, vetres[i]);
      }
      break;
    case COLUMN_ESD:
      {
        gint i;
        gchar *old_text;

        gtk_tree_model_get (model, &iter, column, &old_text,
              COLUMN_POSI, &i, -1);
        g_free (old_text);
        i--;

        //i = gtk_tree_path_get_indices (path)[0];
        resv[i].sigma = (float) atof(new_text);
        gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                            fToStr(resv[i].sigma, 3).c_str(), -1);
        PassaCurrentRestraint(i, vetres[i]);
      }
      break;
  }

  get_wqq(nrestraints_dlg);
  //19092016scrivirestraints_((char *)tmpRestrFile, wqq, strlen(tmpRestrFile));
  //20092016aggiorna_label(get_widget(nrestraints_dlg, "listact"));

  gtk_tree_path_free (path);
}

void attiva_global_toggle(GtkTreeViewColumn *col, gpointer toggle)
{
  gboolean val = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle));
  val ^= 1;
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle), val);
}

void global_toggle(GtkToggleButton *but, gpointer list)
{
  GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
  GtkTreeIter iter;
  gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
  
  CurrentRestr = -1;
  while (valid)
  {
     gboolean val;
     gtk_tree_model_get (model, &iter, COLUMN_POSI, &CurrentRestr, -1);
     //CurrentRestr++;
     CurrentRestr--;
     val = gtk_toggle_button_get_active(but);
     gtk_list_store_set (GTK_LIST_STORE (model), &iter, COLUMN_FIXED, val, -1);
     get_wqq(nrestraints_dlg);
     vetres[CurrentRestr] = val;
     PassaCurrentRestraint(CurrentRestr, val);
     //19092016scrivirestraints_((char *)tmpRestrFile, wqq, strlen(tmpRestrFile));
     aggiorna_label(get_widget(nrestraints_dlg, "listact"));
     valid = gtk_tree_model_iter_next (model, &iter);
  }
}

bool sort_by_type ( restraint_info elem1, restraint_info elem2 )
{
   return (g_ascii_strcasecmp(elem1.type, elem2.type) < 0);
}

bool sort_by_typed ( restraint_info elem1, restraint_info elem2 )
{
   return (g_ascii_strcasecmp(elem1.type, elem2.type) > 0);
}

bool sort_by_atoms ( restraint_info elem1, restraint_info elem2 )
{
   return (g_ascii_strcasecmp(elem1.atoms, elem2.atoms) < 0);
}

bool sort_by_atomsd ( restraint_info elem1, restraint_info elem2 )
{
   return (g_ascii_strcasecmp(elem1.atoms, elem2.atoms) > 0);
}

bool sort_by_current ( restraint_info elem1, restraint_info elem2 )
{
   return (g_ascii_strcasecmp(elem1.current, elem2.current) < 0);
}

bool sort_by_currentd ( restraint_info elem1, restraint_info elem2 )
{
   return (g_ascii_strcasecmp(elem1.current, elem2.current) > 0);
}

bool sort_by_target ( restraint_info elem1, restraint_info elem2 )
{
   return (g_ascii_strcasecmp(elem1.target, elem2.target) < 0);
}

bool sort_by_targetd ( restraint_info elem1, restraint_info elem2 )
{
   return (g_ascii_strcasecmp(elem1.target, elem2.target) > 0);
}

bool sort_by_esd ( restraint_info elem1, restraint_info elem2 )
{
   return (g_ascii_strcasecmp(elem1.esd, elem2.esd) < 0);
}

bool sort_by_esdd ( restraint_info elem1, restraint_info elem2 )
{
   return (g_ascii_strcasecmp(elem1.esd, elem2.esd) > 0);
}

void OrdinaLista(std::vector<restraint_info> restr_vect,
                   GtkTreeModel *model, int ncol, int ordin)
{
    GtkTreeIter iter;
    GtkListStore *list_store = GTK_LIST_STORE(model);

    bool (*sort_by_col)(restraint_info, restraint_info);
    switch (ordin*(ncol+1))
    {
    case -COLUMN_TYPE-1:
         sort_by_col = sort_by_typed;
         break;
    case -COLUMN_ATOMS-1:
         sort_by_col = sort_by_atomsd;
         break;
    case -COLUMN_CURRENT-1:
         sort_by_col = sort_by_currentd;
         break;
    case -COLUMN_TARGET-1:
         sort_by_col = sort_by_targetd;
         break;
    case -COLUMN_ESD-1:
         sort_by_col = sort_by_esdd;
         break;
    case COLUMN_TYPE+1:
         sort_by_col = sort_by_type;
         break;
    default:
    case COLUMN_ATOMS+1:
         sort_by_col = sort_by_atoms;
         break;
    case COLUMN_CURRENT+1:
         sort_by_col = sort_by_current;
         break;
    case COLUMN_TARGET+1:
         sort_by_col = sort_by_target;
         break;
    case COLUMN_ESD+1:
         sort_by_col = sort_by_esd;
         break;
    }
    sort(restr_vect.begin(), restr_vect.end(), sort_by_col);
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    int k = 0;
    while(valid)
    {
       gtk_list_store_set (list_store, &iter,
           COLUMN_FIXED, restr_vect[k].active,
           COLUMN_TYPE, restr_vect[k].type,
           COLUMN_TYPE, restr_vect[k].type,
           COLUMN_ATOMS, restr_vect[k].atoms, 
           COLUMN_CURRENT, restr_vect[k].current,
           COLUMN_TARGET, restr_vect[k].target,
           COLUMN_ESD, restr_vect[k].esd,
           COLUMN_POSI, restr_vect[k].posi,
          -1);
       k++;
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}

static void sort_restraints_list(GtkWidget *column, gpointer data)
{
    std::vector<restraint_info> restr_vect;

    int ncol = GPOINTER_TO_INT(data);
    int ordin = get_int(column, "set_order");
    GtkWidget *treeview = get_widget(column, "father");
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    GtkTreeIter iter;
    g_object_set_data(G_OBJECT(treeview), "col_order", GINT_TO_POINTER(ncol));
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    while (valid)
    {
         restraint_info restr1;
         gtk_tree_model_get (model, &iter,COLUMN_FIXED, &restr1.active, 
                 COLUMN_TYPE, &restr1.type,
                 COLUMN_ATOMS, &restr1.atoms,
                 COLUMN_CURRENT, &restr1.current,
                 COLUMN_TARGET, &restr1.target,
                 COLUMN_ESD, &restr1.esd,
                 COLUMN_POSI, &restr1.posi, -1);
         valid = gtk_tree_model_iter_next (model, &iter);
         restr_vect.push_back(restr1);
    }
    if(ordin > 0)
       ordin = -1;
    else
       ordin = 1;
    g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(ordin));

    if(restr_vect.empty())
       return;
    std::vector<int>sel_vet;
    SaveSelection(treeview, COLUMN_POSI, sel_vet);

    OrdinaLista(restr_vect, model, ncol, ordin);
    restr_vect.clear();

    int num_elems = nres;
    RedoSelection(treeview, COLUMN_POSI, num_elems, sel_vet);
}

static void add_columns (GtkTreeView  *treeview,
             GtkTreeModel *restraints_model)
{
  GtkCellRenderer *renderer;

  renderer = gtk_cell_renderer_toggle_new ();
  g_signal_connect (renderer, "toggled",
		    G_CALLBACK (active_toggled), restraints_model);

  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Active", renderer,
                                               "active", COLUMN_FIXED,
                                               NULL);
  GtkTreeViewColumn *col = gtk_tree_view_get_column(GTK_TREE_VIEW(treeview), COLUMN_FIXED);
  gtk_tree_view_column_set_clickable(col, TRUE);
  GtkWidget *tog = gtk_check_button_new_with_label("Active");
  gtk_widget_show(tog);
  gtk_tree_view_column_set_widget(col, tog);
  int hnd = g_signal_connect(G_OBJECT(tog), "toggled",
        G_CALLBACK(global_toggle), (gpointer) treeview);
  g_object_set_data(G_OBJECT(tog), "hnd", GINT_TO_POINTER(hnd));
  g_signal_connect(G_OBJECT(col), "clicked", G_CALLBACK(attiva_global_toggle), 
         (gpointer) tog);

  renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", FALSE, NULL);
  g_signal_connect (renderer, "edited",
                    G_CALLBACK (cell_edited), restraints_model);
  g_object_set_data (G_OBJECT (renderer), "column", GINT_TO_POINTER (COLUMN_TYPE));
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Type", renderer,
                                               "text", COLUMN_TYPE,
                                               NULL);

  renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", FALSE, NULL);
  g_signal_connect (renderer, "edited",
                    G_CALLBACK (cell_edited), restraints_model);
  g_object_set_data (G_OBJECT (renderer), "column", GINT_TO_POINTER (COLUMN_ATOMS));
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Atoms", renderer,
                                               "text", COLUMN_ATOMS,
                                               NULL);

  renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", FALSE, NULL);
  g_signal_connect (renderer, "edited",
                    G_CALLBACK (cell_edited), restraints_model);
  g_object_set_data (G_OBJECT (renderer), "column", GINT_TO_POINTER (COLUMN_CURRENT));
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Current", renderer,
                                               "text", COLUMN_CURRENT,
                                               NULL);

  renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", TRUE, NULL);
  g_signal_connect (renderer, "edited",
                    G_CALLBACK (cell_edited), restraints_model);
  g_object_set_data (G_OBJECT (renderer), "column", GINT_TO_POINTER (COLUMN_TARGET));
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Target", renderer,
                                               "text", COLUMN_TARGET,
                                               NULL);

  renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", TRUE, NULL);
  g_object_set (renderer, "width-chars", 18, NULL);
  g_signal_connect (renderer, "edited",
                    G_CALLBACK (cell_edited), restraints_model);
  g_object_set_data (G_OBJECT (renderer), "column", GINT_TO_POINTER (COLUMN_ESD));
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "esd", renderer,
                                               "text", COLUMN_ESD,
                                               NULL);
  renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", FALSE, NULL);
  g_object_set_data (G_OBJECT (renderer), "column", GINT_TO_POINTER (COLUMN_POSI));
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "posi", renderer,
                                               "text", COLUMN_POSI,
                                               NULL);

  for(int i=1; i<NUM_COLUMNS; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(treeview), i);
      if(i < COLUMN_POSI)
      {
         gtk_tree_view_column_set_clickable(column, TRUE);
         g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(-1));
         g_object_set_data(G_OBJECT(column), "father", treeview);
         g_signal_connect(G_OBJECT(column), "clicked",
            G_CALLBACK(sort_restraints_list), GINT_TO_POINTER(i));
     }
      else
         gtk_tree_view_column_set_visible(column, FALSE);
  }

}

static void selected_restraint(GtkTreeSelection  *sele, gpointer data)
{
   GtkTreeIter iter;
   GtkTreeModel *model = (GtkTreeModel *) data;

   int current;

   if (gtk_tree_selection_get_selected (sele, &model, &iter))
   {
       gtk_tree_model_get (model, &iter, COLUMN_POSI, &current, -1);
       current--;
       int   code  = resv[current].code;
       int   nna   = resv[current].nna;
       int  *na    = g_new0(int, resv[current].nna);
       for(int i=0; i<nna; i++)
           na[i] = resv[current].na[i] - 1;
       if(code == 1)
          DisegnaSelezione(-1, code, na);
       else if(code == 2)
          DisegnaSelezione(-1, code, na);
       g_free(na);
   }
}

GtkWidget *create_restraints_list(GtkWidget *vbox)
{
   GtkWidget *treeview, *sw;
   GtkTreeModel *restraints_model;

   sw = gtk_scrolled_window_new (NULL, NULL);
   gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (sw),
                                           GTK_SHADOW_ETCHED_IN);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
                                      GTK_POLICY_AUTOMATIC,
                                      GTK_POLICY_AUTOMATIC);
   gtk_container_add (GTK_CONTAINER (vbox), sw);

   restraints_model = create_restraints_model ();
   treeview = gtk_tree_view_new_with_model (restraints_model);
   //gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview), FALSE);
   gtk_tree_selection_set_mode (gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview)),
                                   GTK_SELECTION_SINGLE);
   add_columns (GTK_TREE_VIEW (treeview), restraints_model);
   g_object_unref (restraints_model);
   gtk_container_add (GTK_CONTAINER (sw), treeview);
   GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
   int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_restraint), restraints_model);
   g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
   g_object_set_data(G_OBJECT(treeview), "hnd", GINT_TO_POINTER(hnd));

   gtk_widget_show_all(sw);
   return treeview;
}
void to_genera(int code, GtkWidget *dlg)
{
   GtkWidget *lista_r = get_widget(dlg, "listaRestraints");
   clear_list(lista_r);

   if (code > 0)
   {
      char string[35];
      RestrCode = code-1;
      GtkWidget *entry = get_widget(dlg, "weight");
      ScriviStringa(string, sizeof(string), "%.2f", wqq[code-1]);
      gtk_entry_set_text(GTK_ENTRY(entry), string);
      genera_lista_restraints_(&code);
      fill_restraints_model(lista_r, resv);
      entry = get_widget(dlg, "weight_label");
      ScriviStringa(string, sizeof(string), "Weight %s:", wqq_label[code-1]);
      gtk_label_set_text(GTK_LABEL(entry), string);
   }
}

void tr_changed(GtkWidget *combo, int tiporest)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(combo);
   int code = tiporest + 1;
   GtkWidget *entry = get_widget(dlg, "add_delete");
   GtkWidget *lista = get_widget(dlg, "listaRestraints");
   get_wqq(dlg);
   if(code <= 0)
      return;

   //19092016float w = wqq[code-1];
   //19092016passaweight_(&w, &code);
   GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(lista), COLUMN_TARGET);
   if(code > PLANE)
   {
      gtk_widget_show (entry);
      gtk_tree_view_column_set_visible(column, FALSE);
   }
   else
   {
      gtk_widget_hide (entry);
      gtk_tree_view_column_set_visible(column, TRUE);
   }
   to_genera(code, dlg);
   set_global_toggle(lista);
}

#if 0
#ifndef GTK_COMBO_BOX
void tipores_changed (GtkList *list, GtkWidget *widget1, GtkWidget *dlg)
{
     int code = gtk_list_child_position (list, widget1) + 1;
#else
void tipores_changed(GtkWidget *combo, GtkWidget *dlg)
{
     int code = gtk_combo_box_get_active(GTK_COMBO_BOX(combo)) + 1;
#endif
   GtkWidget *entry = get_widget(dlg, "add_delete");
   GtkWidget *lista = get_widget(dlg, "listaRestraints");
   get_wqq(dlg);
   if(code <= 0)
      return;

   float w = wqq[code-1];
   passaweight_(&w, &code);
   GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(lista), COLUMN_TARGET);
   if(code > PLANE)
   {
      gtk_widget_show (entry);
      gtk_tree_view_column_set_visible(column, FALSE);
   }
   else
   {
      gtk_widget_hide (entry);
      gtk_tree_view_column_set_visible(column, TRUE);
   }
   to_genera(code, dlg);
}
#endif

void FileToRestraints(GtkButton *button, gpointer data)
{
using namespace gtkext;
   GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
   const char *current_dir = g_get_current_dir();
   std::string fn = " ";
   fn = dlg_select_file(dlg, fn, eSELECT_TO_READ, "*.*");
   dir_set_current(current_dir);
   gchar *filename = g_new0(char, MaxLenFilename);
   if(!fn.empty())
   {
      int code = RestrCode + 1;
      ScriviStringa(filename, MaxLenFilename, "%s", fn.c_str());
	  size_t ll = MaxLenFilename;
      leggirestraints_(filename, ll);
      to_genera(code, dlg);
   }
}

void RestraintsToFile(GtkButton *button, gpointer data)
{
using namespace gtkext;
   GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
   const char *current_dir = g_get_current_dir();
   std::string fn = " ";
   fn = dlg_select_file(dlg, fn, eSELECT_TO_WRITE, "*.*");
   dir_set_current(current_dir);
   gchar *filename = g_new0(char, MaxLenFilename);
   if(!fn.empty())
   {
      get_wqq(dlg);
      ScriviStringa(filename, MaxLenFilename, "%s", fn.c_str());
      scrivirestraints_(filename, wqq, MaxLenFilename);
   }

}

void end_Newrestraints(GtkButton *button, gpointer data)
{
   GtkWidget *window;
   int exitC = GPOINTER_TO_INT(data);

   get_wqq(nrestraints_dlg);   //19092016

   close_dlg(button, GINT_TO_POINTER(1));
   Cancella(tmpRestrFile);
   finishnewrestraints_(&exitC,wqq);
   window = get_widget(finestre[0],"rietveld_window");
   gtk_widget_show(window);
//   dialogo->ifLabels = ifLabelsSav ;
//   GtkWidget *entry = get_widget(finestre[0], "LabTog");
//   if(entry != NULL)
//      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), dialogo->ifLabels);

}

void add_restraint(GtkButton *button, GtkWidget *dlg)
{
   restraint_type new_r;
   std::string stringa_atomi = peek_atoms_from_list(dlg, &new_r);
   if(!stringa_atomi.empty())
   {
//      g_print("Scelti: %s\n", stringa_atomi.c_str());
//      float w = wqq[PLANE];
      int active  = 1;
      int code    = new_r.code;
      float targ  = new_r.targ;
      float sigma = new_r.sigma;
      float val   = new_r.val;
      int   nna   = new_r.nna;
      int  *na    = g_new0(int, new_r.nna);
      for(int i=0; i<nna; i++)
          na[i] = new_r.na[i];
      get_newrestraint_from_c_(&active, &code, &val, &targ, &sigma, &nna, na);
      g_free(na);

      int cod1 = PLANE + 1;
      to_genera(cod1, dlg);
   }
}

void delete_restraint(GtkButton *button, GtkWidget *dlg)
{
using namespace gtkext;
   GtkWidget *list = get_widget(dlg, "listaRestraints");
   GtkTreeSelection *s = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
   int row = row_selected(s);
   if(row != -1)
   {
      int which = row + 1;
      int active = vetres[row];
      int code  = resv[row].code;
      float targ  = resv[row].targ;
      float sigma = resv[row].sigma;
      float val   = resv[row].val;
      int   nna   = resv[row].nna;
      int  *na    = g_new0(int, resv[row].nna);
      for(int i=0; i<nna; i++)
          na[i] = resv[row].na[i];
      get_resttodel_from_c_(&which, &active, &code, &val, &targ, &sigma, &nna, na);
      int cod1 = PLANE + 1;
      to_genera(cod1, dlg);
   }
   else
   {
      dlg_errmsg(GTK_WINDOW(dlg), "No restraint selected!");
   }
}

void weight_changed(GtkEntry *entry, GtkWidget *dlg)
{
     if(RestrCode <0)
        return;
     wqq[RestrCode] = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
  //19092016scrivirestraints_((char *)tmpRestrFile, wqq, strlen(tmpRestrFile));
  //20092016aggiorna_label(get_widget(dlg, "listact"));
}

GtkWidget* create_Newrestraints ()
{
  GtkWidget *restraints_window;
  GtkWidget *vbox;
  GtkWidget *hbox;
  GtkWidget *hbox1;
  GtkWidget *label;
  GtkWidget *frame;
  GtkWidget *combo;
  GtkWidget *button;
  GtkWidget *list;
  GtkWidget *align;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;
  GtkWidget *save_button;
  GtkWidget *open_button;
  GtkWidget *entry;

  restraints_window = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (restraints_window), 
                       "restraints_window", restraints_window);
  gtk_window_set_title (GTK_WINDOW (restraints_window), 
                        "Manage restraints");
  gtk_window_set_default_size (GTK_WINDOW (restraints_window), -1, 450);
  gtk_window_set_transient_for(GTK_WINDOW(restraints_window), GTK_WINDOW(finestre[0]));

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(restraints_window));

  frame = FRAME_NEW ("Select Restraint Type and weight", MyBLUE);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 6);

  hbox = hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER (frame), hbox);


#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
  align = gtk_alignment_new(0, 0.5, 0, 0);
#endif

  gtk_box_pack_start(GTK_BOX(hbox), align, FALSE, FALSE, 0);
  gtk_widget_show(align);
/*
  combo = create_my_combo(tipo_res, (int) sizeof(tipo_res)/sizeof(tipo_res[0]), 1,
                          G_CALLBACK(tipores_changed), restraints_window);
  g_object_set_data(G_OBJECT(restraints_window),"tipo_res",get_widget(combo, "entry"));
*/
  combo = MRcombo_new(tipo_res,  tr_changed, 0, 
             (int) sizeof(tipo_res)/sizeof(tipo_res[0]));

  g_object_set_data(G_OBJECT(restraints_window),"tipo_res",combo );
  gtk_widget_show(combo);
  gtk_container_add (GTK_CONTAINER (align), combo);
//  gtk_widget_set_size_request (combo, -1, 24);

#if 0
  GtkWidget *vbox2 = vbox_new(FALSE, 0);
  gtk_widget_show(vbox2);
  gtk_box_pack_start(GTK_BOX(hbox), vbox2, FALSE, FALSE, 10);
#endif

  label = gtk_label_new("Weight");
  gtk_widget_show(label);
  g_object_set_data (G_OBJECT (restraints_window), "weight_label", label);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 10);
//  gtk_box_pack_start(GTK_BOX(vbox2), label, FALSE, FALSE, 0);

  entry = gtk_entry_new ();
  g_object_set_data (G_OBJECT (restraints_window), "weight", entry);
  gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
//  gtk_box_pack_start(GTK_BOX(vbox2), entry, FALSE, FALSE, 0);
  gtk_widget_show (entry);
  gtk_entry_set_width_chars(GTK_ENTRY(entry), 10);
  g_signal_connect(G_OBJECT(entry), "activate", G_CALLBACK(weight_changed),
    restraints_window);

  hbox1 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start(GTK_BOX(hbox), hbox1, TRUE, TRUE, 5);
  g_object_set_data (G_OBJECT (restraints_window), "add_delete", hbox1);

  button = myimage_button("  _Add\n  Plane", "add.png");
  gtk_widget_show (button);
  gtk_box_pack_start(GTK_BOX(hbox1), button, FALSE, FALSE, 0);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(add_restraint),
                     restraints_window);

  button = myimage_button("_Delete\nPlane", "cancel.png");
  gtk_widget_show (button);
  gtk_box_pack_start(GTK_BOX(hbox1), button, FALSE, FALSE, 0);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(delete_restraint),
                     restraints_window);

//  hbox1 = hpaned_new();
//  gtk_widget_show(hbox1);
//  gtk_box_pack_start (GTK_BOX (vbox), hbox1, TRUE, TRUE, 0);

  frame = FRAME_NEW ("List of restraints", MyBLUE);
  gtk_widget_show (frame);
//  gtk_paned_pack1((GtkPaned *)hbox1, frame, TRUE, TRUE);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 6);

  list = create_restraints_list(frame);
  g_object_set_data (G_OBJECT (restraints_window), "listaRestraints", list);

  frame = FRAME_NEW ("Number of restraints", MyBLUE);
  gtk_widget_show (frame);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
  gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);

  label = gtk_label_new("");
  g_object_set_data (G_OBJECT (restraints_window), "listact", label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  set_alignment(label, 0., 0.5);
  set_margins (label, 4, 4, 4, 4);
  gtk_widget_show(label);
  gtk_container_add(GTK_CONTAINER(frame), label);

//  frame = FRAME_NEW ("Active restraints", MyBLUE);
//  gtk_widget_show (frame);
//  gtk_paned_pack2((GtkPaned *)hbox1, frame, TRUE, FALSE);
//  gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
//  gtk_paned_set_position (GTK_PANED (hbox1), 400);

//  GtkWidget *scrollwin = gtk_scrolled_window_new (NULL, NULL);
//  gtk_container_add(GTK_CONTAINER(frame), scrollwin);
//  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
//                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
//  gtk_widget_show (scrollwin);

//  label = gtk_label_new("");
//  g_object_set_data (G_OBJECT (restraints_window), "listact", label);
//  add_to_scrollwin(scrollwin, label);
//  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
//  set_alignment(label, 0., 0.);
//  gtk_widget_show(label);


  ok_button = OK_button();
  g_object_set_data (G_OBJECT (restraints_window), "ok_button",
                            ok_button);
  g_signal_connect(G_OBJECT(ok_button), "clicked", G_CALLBACK(end_Newrestraints),
                     GINT_TO_POINTER(1));
  gtk_dialog_add_action_widget (GTK_DIALOG(restraints_window), ok_button, 1);
  gtk_widget_show (ok_button);

  open_button = OPEN_button();
  g_object_set_data (G_OBJECT (restraints_window), "open_button",
                            open_button);
  g_signal_connect(G_OBJECT(open_button), "clicked", G_CALLBACK(FileToRestraints),NULL);
  gtk_box_pack_end (GTK_BOX (hbox), open_button, FALSE, FALSE, 0);
  gtk_widget_show (open_button);

  save_button = SAVE_button();
  g_object_set_data (G_OBJECT (restraints_window), "save_button",
                            save_button);
  g_signal_connect(G_OBJECT(save_button), "clicked", G_CALLBACK(RestraintsToFile),NULL);
  gtk_box_pack_end (GTK_BOX (hbox), save_button, FALSE, FALSE, 0);
  gtk_widget_show (save_button);

  cancel_button =  CANCEL_button();
  g_object_set_data (G_OBJECT (restraints_window), "cancel_button",
                            cancel_button);
  gtk_dialog_add_action_widget(GTK_DIALOG(restraints_window), cancel_button, 2);
  g_signal_connect(G_OBJECT(cancel_button), "clicked", G_CALLBACK(end_Newrestraints),
                     GINT_TO_POINTER(0));
  gtk_widget_show (cancel_button);

  gtk_button_box_set_layout(GTK_BUTTON_BOX (gtk_widget_get_parent(ok_button)), GTK_BUTTONBOX_SPREAD);
  g_signal_connect_swapped(G_OBJECT(restraints_window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(cancel_button)); 

  return restraints_window;
}

void Newrestraints (GtkWidget *widget, gpointer data)
{
   GtkWidget *window, *entry;

   int ph = GPOINTER_TO_INT(data);
   nats = crys[ph].GetNats();
   atm = crys[ph].GetAtoms();
   Cancella(tmpRestrFile);
   
   window = get_widget(finestre[0],"rietveld_window");
   gtk_widget_hide(window);

//   c_disegna_interval(NULL,1);

   if(nrestraints_dlg == NULL)
       nrestraints_dlg = create_Newrestraints();
   g_object_set_data(G_OBJECT(finestre[0]), "lsq_dlg", nrestraints_dlg);

/* inizializzazioni */

//corr   ifLabelsSav = dialogo->ifLabels;
//corr   dialogo->ifLabels = 1;
//corr   entry = get_widget(finestre[0], "LabTog");
//corr   if(entry != NULL)
//corr      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), dialogo->ifLabels);

   init_newrestraints_(wqq);
   entry = get_widget(nrestraints_dlg, "tipo_res");
//   gtk_entry_set_text(GTK_ENTRY(entry), tipo_res[0]);
   MRcombo_set_val(entry, 0, true);
   to_genera(1, nrestraints_dlg);

   GtkWidget *lista = get_widget(nrestraints_dlg, "listaRestraints");
   set_global_toggle(lista);
   GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(lista), COLUMN_TARGET);
   gtk_tree_view_column_set_visible(column, TRUE);

   gtk_widget_show (nrestraints_dlg);
   entry = get_widget(nrestraints_dlg, "add_delete");
   gtk_widget_hide (entry);
   gtk_widget_show (nrestraints_dlg);
   finestra_modale_aperta2(nrestraints_dlg);
}

extern "C"
{

void c_deallocate_res_()
{
    int i;
    {
       for(i=0; i<nres; i++)
           g_free(resv[i].na);
       g_free(resv);
       resv = NULL;
    }
    if(vetres)
    {
       g_free(vetres);
       vetres = NULL;
    }
}


void passa_nres_(int *nresl)
{
   nres = *nresl;
   if(nres)
      resv = g_new0(restraint_type, nres);
}

void put_info_rest_(int *i, int *code, float* targ, float *sigma, int *nna, int na[])
{
   int j, numna = *nna;

   resv[*i].code = *code;
   resv[*i].targ = *targ;
   resv[*i].sigma = *sigma;
   resv[*i].nna = numna;
   resv[*i].na = g_new0(int, numna);
   for(j=0; j<numna; j++)
       resv[*i].na[j] = na[j];
}

void put_info_newrest_(int *i, int *code, float* targ, float *sigma, float *val, int *nna, int na[])
{
   int j, numna = *nna;

   resv[*i].code = *code;
   resv[*i].targ = *targ;
   resv[*i].sigma = *sigma;
   resv[*i].val = *val;
   resv[*i].nna = numna;
   resv[*i].na = g_new0(int, numna);
   for(j=0; j<numna; j++)
       resv[*i].na[j] = na[j];
}

void passa_vetres_(int *numel, int localvet[])
{
   int n = *numel;
   if(n)
   {
      if(vetres)
         g_free(vetres);
      vetres = g_new0(int, n);
      for(int i=0; i<n; i++)
          vetres[i] = localvet[i];
   }
}

void prendi_nres_(int *nresl)
{
   *nresl = nres;
}

void get_info_rest1_(int *i, int *code, float* targ, float *sigma, int *nna)
{
   *code  = resv[*i].code;
   *targ  = resv[*i].targ;
   *sigma = resv[*i].sigma;
   *nna   =  resv[*i].nna;
}

void get_info_rest2_(int *i, int nna[])
{
   int j, numna = resv[*i].nna;

   for(j=0; j<numna; j++)
      nna[j] = resv[*i].na[j];
}

}
