      subroutine scr0()  
      USE General
      USE Molcom
      USE plotstyle
      USE fileutil
      USE strutil, only: time_string
      USE prognames
      USE variables, only: cryst
      USE crystal_phase
!
      implicit none
      common /scmess/MessH,Messages
      character *80 MessH,Messages(200)
      character *80 Messaggio
      character *256 str
      integer, parameter   :: NITEMSCRY = 10
      integer, parameter   :: NITEMSDATA = 10
      type(style_type), dimension(NITEMS)     :: styleg
      type(style_type), dimension(NITEMSCRY)  :: stylecryscfg
      type(style_type), dimension(NITEMSDATA) :: styledatacfg
      integer :: iz,i,nph
!
      if (kscreen.eq.0) return
      call GetStyleFromC(styleg,stylecryscfg,styledatacfg)
      style = styleg
!
      call stylecryst%load(stylecryscfg)
      do nph=1,numphase(cryst)
         cryst(nph)%style = stylecryst%get(nph)
      enddo
!
!!mr  styledatacfg(:) = style(STYLE_OBS) ! xRosi: commenta questa riga
      call styledata%load(styledatacfg)
!
!-- open the window
!
      ixv(1)=kscrx
      iyv(1)=kscry
      ixv(2)=0
      ixv(3)=0  
      MessH = package_alt_name//': '//trim(jobname)
      call OpenWindow(MessH, iz)
      if (iz.lt.0) then
         kscreen=0
         call manage_console(1)
         write(0,*)
         write(0,*) '*******************************************'
         write(0,*) '*    The Display cannot be accessed !!!   *'
         write(0,*) '*                                         *'
         write(0,*) '*  Program will go on without graphics    *'
         if (fname(INP_FILE)(1:1).eq.'.')
     *   write(0,*) '* only if a input file has been supplied  *'
         write(0,*) '*******************************************'
         write(0,*)
         call manage_console(2)
         return
      end if
      kscrx=ixv(1)
      kscry=iyv(1)
      FntPixWidth = ixv(2)
      FntPixHeight = iyv(2)
!corr      FntAscent = ixv(3)
!corr      FntDescent = iyv(3)
!corr      MaxScX = ixv(5)
!corr      MaxScY = iyv(5)

!corr      MaxColors = ixv(6)    ! corr-variabile non usata
!corr      ifLabels = ixv(7)
!corr      numSfum = MaxColors/16 - 2  ! corr-variabile non usata
! ---
      call AllocaColori()
! ---
      jscreen = 1
! ---
!     Set MessH for header and for scr2 
      MessH = 'At '//time_string()// ' '//
     *        package_alt_name //' starts on: '//
     *        file_rem_ext(fname(BIN_FILE))
!
      return
      end
!-----------------------------------------------------------------------
      subroutine scrper(line,iperc,nperc)
      USE General
      USE Molcom
!
      character line*(*)
!
      if (kscreen.eq.0) return

      lline = Lung(line)
      if (iperc.eq.0) then
        iz=0
        ind = 3
        call BarraDiStato(iz,ind,ix,iy,' ')              ! hide progress bar
      endif
c
      if (lline.gt.0) then
!corr          Message = ' '
!corr          Message(1:lline) = line(1:lline)
!corr          call PrintMess(line(1:lline))
        iz = 0
        ind = 4
        call BarraDiStato(iz,ind,ix,iy,line(1:lline))    ! write on  progress bar
      endif
c
      if (iperc.eq.0) then
          if (nperc.eq.0) then
              iz=0
              ind = 2
              call BarraDiStato(iz,ind,ix,iy,' ')         ! show progress bar
          endif
      else
           ix = iperc
           iy = nperc
           iz=5
           ind = 1
           call BarraDiStato(iz,ind,ix,iy,' ')            ! manage progress bar
      endif
!
!mr   call zflush
!
      return
      end
!-----------------------------------------------------------------------
      subroutine BeccaSt(ier,file1,file2,nome)
      USE General, only: fname,ext,INP_FILE,OUT_FILE,lo
      USE strutil, only: remc0
      USE fileutil
      USE iso_fortran_env
c
      implicit none
      integer, intent(out)          :: ier
      character(len=*), intent(out) :: file1,file2,nome
      character(len=len(file1))     :: bfile1
      integer :: opened1,opened2
      integer :: jsir,k,itype,ier1,ier2
      integer :: Lung,jop,jopen,iform,iTipo
      type(file_handle) :: finp
!
      opened1 = 0
      opened2 = 0
      nome = ' '
      ier = 0
!--
      call BeccaArg(file1,file2)
!--
      if (file1(1:7).eq.'newproj') then
          file2 = ' '
          return
      endif
!--
      if (file1(1:1).ne.' ') then
          call cBaseName(file1//char(0), bfile1)
          bfile1 = remc0(bfile1)
!
!         Set input file name
          jsir = index(bfile1,'.',back=.true.)
          if (jsir /= 0) then
              k = jsir - 1
              nome = bfile1(1:k)
          else
              nome = file1
              k = Lung(nome)
              file1 = nome(1:k) // ext(INP_FILE)
              k = Lung(bfile1)
              nome = bfile1(1:k)
          endif
!
!         Try open the input file
          call finp%fopen(file1)
          if (finp%good()) then
              call finp%fclose()
          else
              write(ERROR_UNIT,'(a)')' Cannot open: '//trim(file1)
     *        //char(10)//' Message: '//trim(finp%err_msg())
              ier = -2
          endif
!
!         Set output file name
          if (file2(1:1).eq.' ') then
              if (extension_is(file1,ext(OUT_FILE)(2:))) then !check if input has 'out' extension
                  file2 = trim(nome)//'_1'//ext(OUT_FILE)
              else
                  file2=trim(nome)//ext(OUT_FILE)
              endif
          end if
      endif
!--
      if (ier.lt.0) then
          return
      endif
!----
      itype = 0
      iform = 1
      if (file2(1:1).ne.' ') then
          jop = jopen(lo,file2,itype,iform,ier2)
          if (jop.lt.0) then
              ier = -1
              write(lo,500) ier2,file2(1:Lung(file2))
  500 format(' *** error ***  open error, code =',i5,' file is ',a)
          endif
      endif
! ---
      if (opened1.eq.1) then
          iTipo = 1            ! iTipo = 1 se file1=*.sir
                               ! iTipo = 2 se file1=*.bin
          call updSWRC(iTipo,file1,file2)
      endif
!
      fname(INP_FILE) = file1
      fname(OUT_FILE) = file2
!
      return
      end
!-----------------------------------------------------------------------
      subroutine BeccaArg(file1,file2)
      USE General
      USE Molcom
c
      character*(*) file1,file2
      character*256 argv
      common /SWareRC/ SWRC, HOMEdir, WorkingDirectory
      character *256 SWRC, HOMEdir, WorkingDirectory
      character*256 NewL, DISPLAY
      character*80 line
      character*256 args(3)                  !mr
      common /Args/ iargcc, args             !mr

!
      NumArgs = iargcc - 1
      if (NumArgs == 2) then
          file1 = args(2)(1:Lung(args(2)))
          file2 = args(3)(1:Lung(args(3)))
      else if (NumArgs == 1) then
          file1 = args(2)(1:Lung(args(2)))
          file2 = ' '
      else
          file1 = ' '
          file2 = ' '
      end if
      do i=1, NumArgs+1
         argv = args(i)
         if(i == 1) then
            exepath = args(1) // char (0)
         endif
         call PassaParametro(i, argv)
      enddo

!
!-- Get the value of exepath = sir2002.exe directory
!
      call fGetProgDir(exepath, i)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine updSWRC(iTipo,file1,file2)
      USE General
      USE Molcom
! --- iTipo = 1 se file1=*.sir
! --- iTipo = 2 se file1=*.bin
      common /SWareRC/ SWRC, HOMEdir, WorkingDirectory
      character *256 SWRC, HOMEdir, WorkingDirectory
      character *256 file1,file2,line
!
      if(iTipo.eq.1) then
         kTipo = index(file1, '.exp') - 1
      else
         kTipo = index(file1, '.bin') - 1
      endif
      itype=2
      iform=1
      jop=jopen(jrel,SWRC,itype,iform,ierr)
      if (jop.lt.0) then
          write(lo,500) ierr,SWRC(1:Lung(SWRC))
      else
          itype=1
          iform=1
          jop=jopen(jhost,' ',itype,iform,ierr)
          if (jop.lt.0) then
              write(lo,600) ierr,jhost
          else
            do 100 i=1,10000
               read(jrel,'(a)',err = 50, end = 200) line
   50          write(jhost,'(a)') line
  100       continue
  200       continue
            rewind jhost
            rewind jrel
!-Program version
            read(jhost,'(a)',err=205,end=400) line
  205       write(jrel,'(a)') line(1:Lung(line))
!-Home Directory
            read(jhost,'(a)',err=210,end=400) line
  210       write(jrel,'(a)') HOMEdir(1:Lung(HOMEdir))
!-Internet Browser
            read(jhost,'(a)',err=220,end=400) line
  220       write(jrel,'(a)') line(1:Lung(line))
!-PovRay
            read(jhost,'(a)',err=225,end=400) line
  225       write(jrel,'(a)') line(1:Lung(line))
!-Working directory & structure name
            call fGetPWD(WorkingDirectory,lstring,ier)
            read(jhost,'(a)',err=230,end=400) line
  230       write(jrel,'(a)') WorkingDirectory(1:lstring)
            read(jhost,'(a)',err=240,end=400) line
  240       write(jrel,'(a)') file1(1:kTipo)
!mr informa il C
            if(iTipo == 1) then
               call updateCfileinp(file1(1:Lung(file1)) // char(0))
            else
               call updateCfilebin(file1(1:Lung(file1)) // char(0))
            endif
!-Output file
            read(jhost,'(a)',err=250,end=400) line
  250       write(jrel,'(a)') file2(1:Lung(file2))
!-Fonts etc.
            do 300 i=1,10000
               read(jhost,'(a)',end = 400,err=260) line
  260          write(jrel,'(a)') line(1:Lung(line))
  300       continue
  400       continue
            close(jhost)
            close(jrel)
          endif
      endif
  500 format(' *** error ***  open error, code =',i5,' file is ',a)
  600 format(' *** error ***  open error, code =',i5,', unit # ',i5)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine updRecentProjects
      USE General
      USE Molcom
      USE plotstyle
      USE fileutil
c
      integer, parameter   :: NITEMSCRY = 10
      integer, parameter   :: NITEMSDATA = 10
      common /SWareRC/ SWRC, HOMEdir, WorkingDirectory
      character *256 SWRC, HOMEdir, WorkingDirectory
      common /RecentPr/ nRecentProjects, RecentProj(5)
      character *256 RecentProj
!
      character *80 WorkingDir,file1,file2
      character * 256 MostRecent, line
!
      return
      if (index(fname(BIN_FILE), 'ntreortmp') > 0) then
          return
      endif
      close(jhost)
      close(jrel)
!
      k = index(fname(BIN_FILE), '.bin')
      if (k.eq.1) then
          return
      endif
!
      itype=2
      iform=1
      jop=jopen(jrel,SWRC,itype,iform,ierr)
      if (jop.lt.0) then
          write(lo,500) ierr,SWRC(1:Lung(SWRC))
      else
          itype=1
          iform=1
          jop=jopen(jhost,' ',itype,iform,ierr)
          if (jop.lt.0) then
              write(lo,600) ierr,jhost
          else
              do i=1,10000
                 read(jrel,'(a)',end = 200) line
!!mr             if(i.ge.12.and.i.lt.(12+NITEMS)) then
!!mr                 j = STYLE_OBS + i - 12
!!mr                 read(line,*,err=101) style(j)
!!mr101                write(line,'(8i5)') style(j)
!!mr             endif
                 write(jhost,'(a)') line
              enddo
  200         continue
              rewind jhost
              rewind jrel
!
              do i=1,12+NITEMS+NITEMSCRY+NITEMSDATA-1
                 read(jhost,'(a)') line
                 write(jrel,'(a)') line(1:Lung(line))
                 if (i.eq.5) then
                     MostRecent = line(1:Lung(line)) //get_separ()//
     *                        fname(BIN_FILE)(1:Lung(fname(BIN_FILE)))
                 endif
              enddo
              kMost = Lung(MostRecent)
              write(jrel,'(a)') MostRecent(1:kMost)
              RecentProj(1)(1:kMost) = MostRecent(1:kMost)
              RecentProj(1)(kMost+1:kMost+1) = char(0)
              imr = 1
              do i = 1, 4
                 read(jhost,'(a)') line
                 lline = Lung(line)
                 if (line(1:lline).ne.MostRecent(1:kMost)) then
                     write(jrel,'(a)') line(1:lline)
                     imr = imr + 1
                     RecentProj(imr)(1:lline) = line(1:lline)
                     RecentProj(imr)(1+lline:1+lline) = char(0)
                 endif
              enddo
              if ((nRecentProjects.lt.5).and.(imr.eq.5)) then
                  nRecentProjects = nRecentProjects+1
              endif
              read(jhost,'(a)',end = 300) line
              if (imr.ne.5) then
                 lline = Lung(line)
                 write(jrel,'(a)') line(1:lline)
              endif
              do i=1,10000
                 read(jhost,'(a)',end = 300) line
                 lline = Lung(line)
                 write(jrel,'(a)') line(1:lline)
              enddo
  300         continue
              close(jhost)
              close(jrel)
          endif
          call UpdateMenu()
      endif
  500 format(' *** error ***  open error, code =',i5,' file is ',a)
  600 format(' *** error ***  open error, code =',i5,', unit # ',i5)
!
      return
      end
!-----------------------------------------------------------------------
! screen2002
!-----------------------------------------------------------------------
      subroutine svcard(nAddComm,ier)
!
!-- this subroutine save the command queue  (icomq)
!-- and the card reader (card)
!-- in the scratch file jrel
!
      USE General
!!!corr      common /charas/ beg,commen,allcom
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      character*80 name
!!!corr      character beg,commen,allcom(35)*14
!
*     write(lo,*) 'SVCARD   '
      ipd=ipdir
      nAddComm=0
      itype=1
      iform=2
      nlenn=512
      jop=jopen(jrel ,name,itype,iform,ier)
      if (jop.lt.0) go to 9000
!
      ico=icomat
   10 continue
      ico=ico+1
      write(jrel) (icomq(ico,j),j=1,2)
      icom =icomq(ico,1)
      if (icom.eq.0.or.icom.eq.7) go to 30
      icmx=icomq(ico,2)
      ic=0
   20 ic=ic+1
      if (ic.gt.icmx) go to 10
      ipd=ipd+1
      write(jrel) card(ipd)
      go to 20
!
   30 continue
      return
 9000 continue
      write(lo,9020) ier,jrel
 9020 format(' *** error ***  open error on scratch file jrel, code ='
     *,i5,',  channel =',i5)
      ier=-1
      return
      end
!-----------------------------------------------------------------------
      subroutine rscard(nAddComm,iPdire)
!
!-- this subroutine restore the command queue  (icomq)
!-- and the card reader (card)
!-- reading informations from the scratch file jrel
!
      USE General
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
!
*     write(lo,*) 'RSCARD   '
      rewind jrel
      ico=icomat
   10 continue
      icomat=icomat+1
      read(jrel) (icomq(icomat,j),j=1,2)
      icom =icomq(icomat,1)
      if (icom.eq.0.or.icom.eq.7) go to 30
      icmx=icomq(icomat,2)
      ic=0
   20 ic=ic+1
      if (ic.gt.icmx) go to 10
      ipdir=ipdir+1
      read(jrel) card(ipdir)
      go to 20
!
   30 continue
      icomat=ico-nAddComm
      ipdir=iPdire
!
      close (jrel)
      return
      end
!-----------------------------------------------------------------------
      subroutine OpenWarning(MsgW)
! ---
      USE General
      USE Molcom
! ---
      character*(*) MsgW
! ---
!
      if (kscreen.eq.0) return
!
      Inte = 'Warning'
      itempo = 6000
      call MsgWin (Inte, MsgW, WARN_WINDOW, itempo)
!
      return
      end
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
! screen_expo
!-----------------------------------------------------------------------
      subroutine scr2
      USE General
      USE Molcom
      USE commandsmod, only:allcom
      USE plotstyle
      USE comandiexpo
      implicit none
!corr      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
!corr      common /scmess/MessH,Messages
!corr      character *80 MessH,Messages(200)
      character str*80, strtmp*80
      integer :: i,j,k1p,k2p,iniz,limscr,nstep
      integer :: iccx,iccy,istx,isty,ivd,iz
      integer :: iys0,iysW,iysDyn,iysN,ixs,ixs0,iFill
!
      if (kscreen.eq.0) return
!
      iys0=0   !!!!90   ! crea problemi per kscry piccoli in scr2
      iysN=kscry-iys0
!
      k1p = index(fname(BIN_FILE),'.bin') - 1
      k2p = index(MessH,'starts on:') + 9
         !write(0,*)'MessH=',trim(MessH)
      strtmp = MessH(1:k2p) // ' ' // fname(BIN_FILE)(1:k1p)
      MessH = strtmp
!corr      icol0 = style(STYLE_BG)%colline
!corr      iniz = nstep
!corr      if (icomat.gt.1) then
!corr          j=icomq(icomat,1)
!corr          if (j.eq.6) then
!corr              iniz=1
!corr          endif
!corr      endif
! ---
      iccx = kscrx / 2
      iccy = kscry / 2
      istx = 8 * iccx / 10
corr      isty = 6 * iccy / 10
      isty = 7 * iccy / 10
! ---
      ivd = FntPixHeight * 1.4
      ixv(1) = iccx - istx
      ixv(2) = iccx + istx
      ixv(3) = iccx + istx
      ixv(4) = iccx - istx
      ixv(5) = iccx - istx
      iyv(1) = iccy - isty
      iyv(2) = iccy - isty
      iyv(3) = iccy + isty
      iyv(4) = iccy + isty
      iyv(5) = iccy - isty
      iz = 5
      iFill = 1
      call SetColor(style(STYLE_BG)%colline)
      call Poligono (iz, iFill)
!corr      icolor = color_LIGHTBLUE
      iz = 5
      iFill = 0
!corr      call SetColor(icolor)
      call SetColor(color_LIGHTBLUE)
      call Poligono (iz, iFill)
      !call zflush

      ixs = 1.5 * ixv(1)
      ixs0 = ixs
      iysW= iyv(1) + ivd
!
!-- draw the Header
!
!corr      iysDyn = iys0
      iysDyn = iyv(1) + ivd
!corr      icolor=color_LIGHTBLUE
!corr      call SetColor(icolor)
!corr      call SetColor(color_LIGHTBLUE)
      ixv(1) = float(iccx - istx) * 1.1
      call DrawLabelA(ixv(1), iysDyn, MessH)
!
!-- compute the number of commands to write
!
      limscr=iysN - ivd
      iniz=0
      do i=ipcom,1,-1
         iysDyn=iysDyn+ivd
         if (iysDyn.gt.limscr.and.iniz.eq.0) iniz=i+1
      enddo
      if (iniz.eq.0) iniz=1
      iysDyn=iysW
      do i=1,ipcom
         iz=14
         j=icomq(i,1)
         str=allcom(j)
         if (i.ge.iniz) then
             iysDyn=iysDyn+ivd
         endif
         iyv(1)=iysDyn
             !  write(*,'(2i6,a)')ixv(1),iyv(1),trim(str)
         if (i.eq.icomat) then
!corr             iyss = iysDyn
             call MettiPixmap("indica.png", ixs, iysDyn)
         else
             ixv(1)=ixs
         endif
         if (i.le.icomat) then
!corr             icolor=color_LIGHTBLUE
             strtmp = Messages(i)
!corr             izv = Lung(strtmp)
!corr             if (izv.gt.0) then
             if (len_trim(strtmp) > 0) then
                 write(str,'(a14,a)') allcom(j),trim(strtmp)
             endif
             call SetColor(color_LIGHTBLUE)
         else
!corr             icolor=color_LIGHTRED
             call SetColor(color_LIGHTRED)
         endif
!corr         call SetColor(icolor)
         if (i.ge.iniz) then
             call DrawLabelA(ixv(1), iyv(1), str)
         endif
      enddo
!
!corr      i=nstep
      nstep = 10
      ixv(1)=iccx - istx*nstep
      ixv(2)=iccx + istx*nstep
      ixv(3)=iccx + istx*nstep
      ixv(4)=iccx - istx*nstep
      ixv(5)=iccx - istx*nstep
      iyv(1)=iccy - isty*nstep
      iyv(2)=iccy - isty*nstep
      iyv(3)=iccy + isty*nstep
      iyv(4)=iccy + isty*nstep
      iyv(5)=iccy - isty*nstep
!corr      icolor = color_LIGHTBLUE
      iz=5
      iFill = 0
      call SetColor(color_LIGHTBLUE)
      call Poligono (iz, iFill)
!
      call zflush
!
      return
      end
c-----------------------------------------------------------------------
      subroutine scrf(numset,jstep,jab,kplot)
      USE Molcom
      USE General
      USE drawatoms
      USE messagemod
!
!-- plot the content of common /atom/
!
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      character *80 MessH,Messages(200)
      common /scmess/MessH,Messages
      common /appo/iVolta,pmax,nninv1,nninv2,kverbo,NumSteps,numsetmax
     *            ,numset0,imodmap
      common /writecyc/iprintcyc,nrefused
      common /newfou/newfourier
      character *120 line
      character aorb*1
!
      if (kscreen.eq.0) return
!
      call draw_xyzs(.true.)
      !call draw_xyzs()
!
      rfac=erre*100.0
      if (imodmap.eq.0) then
          rfaco=errem*100.0
          if (rfac.lt.rfaco) rfaco=rfac
          if (jab.eq.1) then
             aorb='A'
          else
             aorb='B'
          endif
          if (jstep.eq.1) then
             write(Message,10) numset,jstep,aorb,rfac
          else
             write(Message,22) numset,jstep,aorb,rfac,rfaco
          endif
   10 format('Set #',i4,'     Cycle ',i2,'(',a1,') R =',f7.2,
     *       '%                       ')
   20 format('Set #',i4,'     Cycle ',i2,'(',a1,') R =',f7.2,
     *       '%   (previous =',f7.2,'%)')
   22 format('Set #',i4,' Cycle ',i2,'(',a1,') R =',f7.2,
     *       '%   ( minimum =',f7.2,'%)')
      endif
      if (imodmap.eq.1) then
         if (iprintcyc.eq.0) then
             write(Message,8)rfac
  8   format(' E-map   R(F)=',f7.2,'%')
           else
             write(Message,9)iprintcyc,rfac
  9   format(' Fourier cycle #',i3,'   R(F)=',f7.2,'%')
         endif
      endif
      if (imodmap.eq.0) then
!corr         if (kkprog.eq.1) then
!corr            if (jrecyc.eq.100) then
!corr               rw0=rfaco
!corr               if (rfaco.gt.9999.0) then
!corr                  rw0 = 9999.0
!corr               endif
!corr            else
!corr               rw0=rfac
!corr            endif
!corr            rw1=rfac
!corr            rw2=rfaco
!corr            if (rfaco.gt.9999.0) then
!corr                rw2 = 9999.0
!corr            endif
!corr         else
            rw0=rfaco
            rw1=rfaco
            rw2=rfaco
!corr         endif
         if (newfourier.eq.0) then
!corr         if (jrest.eq.0) then
             write(Messages(icomat),30)  numset,rw0
!corr         else if (jrest.eq.1) then
!corr             write(Messages(icomat),30)  numset,rw1
!corr         else
!corr             write(Messages(icomat),30)  numset,rw2
!corr         endif
         endif
      endif
   30 format('Set#',i4,'  Final R =',f7.2,'%   ')
      if (iprintcyc.eq.10) then
          write(Message,18)rfac,iprintcyc
   18     format('  Final R =',f7.2,'%   ',' Cycle # ',i4)
      endif
      line = Message
      !call scrper(line,0,-1)
      call write_message(line,pos=2)
!
      return
      end
!-----------------------------------------------------------------------
!corr      subroutine scrend(line,lline)
      subroutine scrend(line)
      USE General
      USE Molcom
      USE PhaseModule 
      USE commandsmod, only:allcom
      USE plotstyle
      USE strutil, only: time_string
!
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /scmess/MessH,Messages
      common/ylimi/nfl,lfl,nlx,idummy(4)
      common /tempo/ nSecs,nSecsTot
      character *80 MessH,Messages(200)
      character str*80, strtmp*80, line*(*)
!
      iys0=0   !!!!90   ! crea problemi per kscry piccoli in scr2
      iysN=kscry-iys0
      nstep = 10
!
      nSecsPr = nSecs
!
!corr      call sirtime(str,icod)
      if (nSecs.lt.nSecsPr ) then
         nSecs = nSecs + 24 * 3600
      end if
      nSecsTot = nSecs - nSecsPr
!corr      if (icod.gt.0) then
!corr            Message(1:icod)=str(1:icod)
!corr            Message(icod+1:icod+lline)=line(1:lline)
!corr            lline=icod+lline
!corr            line(1:lline)=Message(1:lline)
!corr      endif
      line = 'At '//time_string()//' '//trim(line)
!
      if (jscreen.eq.0) return

      icol0 = style(STYLE_BG)%colline
! ---
      iccx = kscrx / 2
      iccy = kscry / 2
      istx = 8 * iccx / 10
      isty = 7 * iccy / 10
! ---
      ivd = FntPixHeight * 1.4
      ixv(1) = iccx - istx
      ixv(2) = iccx + istx
      ixv(3) = iccx + istx
      ixv(4) = iccx - istx
      ixv(5) = iccx - istx
      iyv(1) = iccy - isty
      iyv(2) = iccy - isty
      iyv(3) = iccy + isty
      iyv(4) = iccy + isty
      iyv(5) = iccy - isty
      ixs = 1.5 * ixv(1)
      ixs0 = ixs
      iysW= iyv(1) + ivd
      iz=5
      iFill = 1
      call SetColor(icol0)
      call Poligono(iz,iFill)
      icolor=10
      iz=5
      iFill = 0
      call SetColor(icolor)
      call Poligono (iz,iFill)
      call zflush
!
      icolor=color_LIGHTBLUE
      call SetColor(icolor)
      ind = 9
!
!-- draw the Header
!
      iysDyn=iysW
      ixv(1) = float(iccx - istx) * 1.1
      call DrawLabelA (ixv(1), iysDyn, MessH)
!
      ixv(1)=ixs
      ipup=0
      ipuf=0
      ipur=0
      ipun=0
      ipue=0
      ipui=0
      ipupa=0
!
!-- compute the number of commands to write
!
      limscr=iysN - ivd
      iniz=0
      do i=ipcom,1,-1
         iysDyn=iysDyn+ivd
         if (iysDyn.gt.limscr.and.iniz.eq.0) iniz=i+1
      enddo
      if (iniz.eq.0) iniz=1
      iysDyn=iysW
      do i=iniz,ipcom
         iz=14
         j=icomq(i,1)
         str=allcom(j)
         if (i.ge.iniz) then
             iysDyn=iysDyn+ivd
         endif
         iyv(1)=iysDyn
         strtmp = Messages(i)
         izv = Lung(strtmp)
         if (izv.gt.0) then
             write(str,'(a14,a)') allcom(j),strtmp(1:izv)
             iz=iz+izv
         endif
         if (i.ge.iniz) then
             call DrawLabelA (ixv(1), iyv(1), str)
         endif
      enddo
!
      i=nstep
      ixv(1)=iccx - istx*i
      ixv(2)=iccx + istx*i
      ixv(3)=iccx + istx*i
      ixv(4)=iccx - istx*i
      ixv(5)=iccx - istx*i
      iyv(1)=iccy - isty*i
      iyv(2)=iccy - isty*i
      iyv(3)=iccy + isty*i
      iyv(4)=iccy + isty*i
      iyv(5)=iccy - isty*i
      icolor=10
      icolor=color_LIGHTBLUE
      iz=5
      iFill = 0
      call SetColor(icolor)
      call Poligono (iz, iFill)
!
      call SetColor(icolor)
      ixv(1) = float(iccx - istx) * 1.1
      iysDyn=iysDyn+ivd
      iyv(1)=iysDyn
      aNumPix = LenInPix(line,2)
      call DrawLabelA (ixv(1), iyv(1), line)
      call zflush
!
      return
      end
!-----------------------------------------------------------------------
      subroutine lastplot() 
      USE Atomi
      USE General 
      USE Liste      
      USE Molcom
      USE Phasemodule, only:errem,jrest
      USE reflection_type_util
      USE stat, only:Rvalue
      USE drawatoms
      include 'buildcom.fi'
      type(reflection_type), allocatable, dimension(:) :: refl
!
      jrest=0
      rfac=-1.0
      erres = -9999
!
      if (kscreen.eq.0) return
!
      kaction = 4
      if(itutcefou.ne.0)ktutce=1
      if(iconn(1).eq.-1)iconn(1)=0
      call maincl(kaction,iprin)
      interp = 1
      call frm15e(nats,interp)
!
      if (jscreen > 0) call draw_xyzs(icon=iconn)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine upcard(nAddComm,line,lung,ier)
      USE General
      USE commandsmod
      USE RandomStaff, only: numtrialrando
c
c-- this subroutine update the command queue  (icomq)
c-- and the card reader (card)
c
!corr      common /labellare/distpp,distpl,natp,natp1(2),ilab,speclab,ialter
!corr      character*8 speclab(2)
      character linc*80,line*(*)
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
c
      call shift(line,lenp)
      if (lenp.eq.0) return
CANNA write(6,*) 'UPCARD   ',line(1:lenp)
      nallc=35
      linc(1:lung)=line(1:lung)
      if (lung.lt.80) then
          do 100 i=lung+1,80
  100        linc(i:i)=blank
      endif
      if (linc(1:1).eq.beg) then
          icom=0
          do 150 i=1,nallc
             if (linc(2:4).eq.allcom(i)(1:3)) icom=i
  150     continue
          if (icom.eq.0) stop 7777
          nAddComm=nAddComm+1
          icomat=icomat+1
          icomq(icomat,1)=icom
          icomq(icomat,2)=0
          ipcom=ipcom+1
      else
          ipdir=ipdir+1
!corr          if(numtrialrando.eq.10) then
!corr            if (ipdir.gt.100) go to 500
!corr          else
!corr           if(ilab.eq.0) then
!corr            if (ipdir.gt.250) go to 500
!corr           else
!corr            if (ipdir.gt.540) go to 500
!corr           endif
!corr          endif
          if (ipdir > size(card)) go to 500
          card(ipdir)=linc
          icomq(icomat,2)=icomq(icomat,2)+1
      endif
      return
  500 continue
c     if(ichoice.eq.0)then
      if(numtrialrando.eq.10) then
        ier=-1
        ipdir=ipdir-1
        write(lo,510)
      else
        ier=-1
        ipdir=ipdir-1
        write(lo,511)
      endif
  510 format(' more than 100 directives generated ',/,
     *       ' reduce the number of reflections to modify')
  511 format(' more than 250 directives generated ',/,
     *       ' reduce the number of reflections to modify')
      return
      end
!-----------------------------------------------------------------------
