
    subroutine write_message_found(pos)
    USE strutil
    USE TestModel
    USE messagemod
    implicit none
    integer, intent(in) :: pos
    call write_message('found: '//trim(i_to_s(int(vett_test(3))))//'/'//trim(i_to_s(int(vett_test(1))))//   &
    ' dist: '//trim(r_to_s(vett_test(4),3)),pos=pos)
    end subroutine write_message_found

!------------------------------------------------------------------------------------------------------------

    subroutine write_message_found1(pos,natfound,natpub,rmsd)
    USE strutil
    USE messagemod
    implicit none
    integer, intent(in) :: pos
    integer, intent(in) :: natfound,natpub
    real, intent(in)    :: rmsd
    call write_message('found: '//trim(i_to_s(natfound))//'/'//trim(i_to_s(natpub))//   &
    ' RMSD: '//trim(r_to_s(rmsd,3)),pos=pos)
    end subroutine write_message_found1

!------------------------------------------------------------------------------------------------------------

    subroutine scrp(itrial,maxtr,cfom,cfomx)
    USE Molcom
    USE commandsmod, only:allcom
    USE messagemod
    USE strutil
    implicit none
    integer, intent(in) :: itrial,maxtr
    real, intent(in)    :: cfom,cfomx
    character str*80
    common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
    integer :: icomq,maxcom,ipcom,ipdir,icomat
    character *80 MessH,Messages(200)
    common /scmess/MessH,Messages
    common/cris/numcri,jcran,maxtri,nstart,muset,nfixed,inumber,ifirst
    integer :: numcri,jcran,maxtri,nstart,muset,nfixed,inumber,ifirst
    integer :: j,iz
    real    :: ccfmx
!
    if (kscreen.eq.0) return
!
    str = ' '
!
    j=icomq(icomat,1)
    str(1:14)=allcom(j)
    if (cfomx.lt.0.0) then
       ccfmx=0.0
    else
       ccfmx=cfomx
    endif
    if (inumber.eq.0) then
       write(str(15:64),10) itrial,maxtr,cfom,ccfmx
    else
       write(str(15:79),20) inumber,maxtri,itrial,maxtr,cfom,ccfmx
    end if
10  format('Trial ',i4,' / ',i4,'  CFom = ',f6.3,'  (max = ',f6.3,') ')
20  format('Set ',i4,' / ',i4,' Trial ',i4,' / ',i4,'  CFom = ',f6.3,'  (max = ',f6.3,') ')
    iz = lung(str)
    Messages(icomat)=str(15:iz)
    call scr2()
    if (inumber == 0) then    
        call write_message('Trial '//trim(i_to_s(itrial))//'/'//trim(i_to_s(maxtr)),pos=3)
        call write_message('CFom = '//trim(r_to_s(cfom,3))//' (max ='//trim(r_to_s(ccfmx,3))//')',pos=4)
    else
        call write_message('Set '//trim(i_to_s(inumber))//'/'//trim(i_to_s(maxtri)),pos=3)
        call write_message('Trial '//trim(i_to_s(itrial))//'/'//trim(i_to_s(maxtr)),pos=4)
        call write_message('CFom = '//trim(r_to_s(cfom,3))//' (max ='//trim(r_to_s(ccfmx,3))//')',pos=5)
    endif
    return
    end

!------------------------------------------------------------------------------------------------------------

    subroutine write_message_pattern(filepow)
    USE counts, only:dvalue
    USE patternref
    USE messagemod
    USE conteggi, only:npunti
    USE General, only:nrefl, alambda
    implicit none
    character(len=*), intent(in) :: filepow
    integer                      :: pos
!
    call write_message('Data file: '//trim(filepow),pos=2)
    call write_message('2-theta min.: ',rnum=thmin,pos=3)
    call write_message('2-theta max.: ',rnum=thmax,pos=4)
    call write_message('Ncounts: ',inum=npunti,pos=5)
    call write_message('Resolution: ',rnum=dvalue(thmax,alambda),pos=5)
    pos = 5
    if (nrefl > 0) then
        pos = pos + 1
        call write_message('Reflections nr.: ',inum=nrefl,pos=pos)
    endif
    pos = pos + 1
    call write_message('Wavelength: ',rnum=alambda,pos=pos,dig=5)
!
    end subroutine write_message_pattern

!------------------------------------------------------------------------------------------------------------

   subroutine write_stbar(ix,iy)
   USE Riflessi
   USE GREXPOMOD
   USE General
   USE arrayutil
   USE Conteggi
   USE strutil
   USE counts
   USE view, only: pd_action
   USE variables, only: cryst
   use crystal_phase
   implicit none
   integer            :: ix,iy
   real               :: tth,intcount
   real               :: diff, mdiff
   real, dimension(1) :: dref
   real               :: dcount
   integer            :: loc
   integer            :: ncc
   integer            :: iselv
   integer            :: npt,nph,minph
!
   if (allocated(theta_int)) then
       npt = size(theta_int(:,7))
       iselv = 0  ! la statusbar e solo sul viewer principale
       tth = (ix - dispx(iselv)) / scalex(iselv)
       intcount = (iy - dispy(iselv)) / scaley(iselv)
       ncc = clocate(theta_int(:,7),tth)
       if (ncc == 1) then    ! mouse fuori range a sinistra
           tth = theta_int(1,7)
       endif
       if (ncc == npt) then  ! mouse fouri range a destra
           tth = theta_int(npt,7)
       endif
       if (pd_action == 8) then
           if (any(cryst(:)%numref() > 0)) then
               minph = 0
               mdiff = huge(0.0)
               do nph=1,numphase(cryst)
                  if (cryst(nph)%numref() > 0) then
                      diff = minval(abs(cryst(nph)%ref%tthd(1)-tth))
                      if (diff < mdiff) then
                          minph = nph
                          mdiff = diff
                      endif
                  endif
               enddo
               if (minph > 0) then
                   loc = minloc(abs(cryst(minph)%ref%tthd(1)-tth),dim=1)
                   dref = dvalue(cryst(minph)%ref(loc)%tthd(1),alambda)
                   dcount = dvalue(tth,alambda)
                   call PrintMess(' Count=#'//trim(i_to_s(ncc))//' 2theta='//trim(r_to_s(tth,3))//            &
                   ' I='//trim(r_to_s(intcount,3))//' d='//trim(r_to_s(dcount,3))//'           '//            &
                   ' Refl.=#'//trim(i_to_s(loc))//' h k l='//i_to_s(cryst(minph)%ref(loc)%hkl(1))//' '//      & 
                   i_to_s(cryst(minph)%ref(loc)%hkl(2))//' '//i_to_s(cryst(minph)%ref(loc)%hkl(3))//          &
                   ' 2theta='//trim(r_to_s(cryst(minph)%ref(loc)%tthd(1),3))//' d='//trim(r_to_s(dref(1),3))  &
                                 )
               endif
           else
               dcount = dvalue(tth,alambda)
               call PrintMess(' Count=#'//trim(i_to_s(ncc))//' 2theta='//trim(r_to_s(tth,3))//   &
                              ' I='//trim(r_to_s(intcount,3))//' d='//trim(r_to_s(dcount,3)))
           endif
       else
           if (nrefl > 0) then
               loc = minloc(abs(TThet(:nrefl)-tth),dim=1)
               dref = dvalue(TThet(loc),alambda)
               dcount = dvalue(tth,alambda)
               call PrintMess(' Count=#'//trim(i_to_s(ncc))//' 2theta='//trim(r_to_s(tth,3))//       &
               ' I='//trim(r_to_s(intcount,3))//' d='//trim(r_to_s(dcount,3))//'           '//       &
               ' Refl.=#'//trim(i_to_s(loc))//' h k l='//trim(i_to_s(IndHKL(loc,1)))//' '//    & 
               trim(i_to_s(IndHKL(loc,2)))//' '//trim(i_to_s(IndHKL(loc,3)))//                 &
               ' 2theta='//trim(r_to_s(TThet(loc),3))//' d='//trim(r_to_s(dref(1),3))             &
                             )
           else
               dcount = dvalue(tth,alambda)
               call PrintMess(' Count=#'//trim(i_to_s(ncc))//' 2theta='//trim(r_to_s(tth,3))//   &
                              ' I='//trim(r_to_s(intcount,3))//' d='//trim(r_to_s(dcount,3)))
           endif
       endif
   endif
!
   end subroutine write_stbar

!------------------------------------------------------------------------------------------------------------

   subroutine write_inte_routine(routine)
   USE General, only: jobname,lo
   USE strutil
   USE prognames
   USE mpi_prog
   character(len=*), intent(in) :: routine
   character(len=80), dimension(3) :: title
   character(len=80)               :: str
!
   if (mpi_prog_rank /= mpi_prog_master) return
!
   write(lo,'(//)')
   str = 'Release: '//version
   title(1) = adjustr(title(1))
   title(1) = package_alt_name//': '//trim(routine)//' routine'
   title(1)(len(title) - len_trim(str) -1 :) = str
   title(2) = ' '
   title(3) = trim(jobname)
   call write_title(lo,title,(/'l','l','c'/))
   write(lo,'(/)')
!
   end subroutine write_inte_routine

MODULE enable_amb

implicit none

CONTAINS 

    recursive subroutine abilita_tasti(scode,state)
    USE molcom
    character(len=*), intent(in)  :: scode
    integer, intent(in), optional :: state   ! 0=set no sensitive, 1=sensitive, 2=hide
    integer                       :: statet
!
    if (present(state)) then
        statet = state
    else
        statet = 1
    endif
    if (jscreen  > 0) then
        select case (trim(scode))
            case ('indexwin')
             call wmenu_set_state('File'//char(0),state)
             call tb_set_state('file',state)
             call wmenu_set_state('Solve'//char(0),state)
             call wmenu_set_state('Refine'//char(0),state)
             call wmenu_set_state('Range'//char(0),state)
             call wmenu_set_state('Indexing'//char(0),state)
             call wmenu_set_state('Space Group'//char(0),state)

            case ('pattern')
             call wmenu_set_state('File'//char(0),1)
             call abilita_tasti('view_pattern')
             call abilita_tasti('peaks',1)
             call abilita_tasti('indexing',1)
             call wmenu_set_state('View'//char(0),1)
             call wmenu_set_state('Info'//char(0),1)
             call tb_set_state('file',1)
             call tb_set_state('procedure',0)
!
!            Only Simulated Annealing and Rietveld are permitted
             call wmenu_set_state('Solve'//char(0),1)
             call wmenu_set_state('RAMM'//char(0),0)
             call wmenu_set_state('Explore trials'//char(0),0)
             call wmenu_set_state('POLPO'//char(0),0)
             call wmenu_set_state('Simulated Annealing + Direct Methods'//char(0),0)
             call wmenu_set_state('Recycle in extra'//char(0),0)

             call wmenu_set_state('Refine'//char(0),1)
             call wmenu_set_state('Resolution Bias Modification (RBM)'//char(0),0)
             call wmenu_set_state('Fourier Recycling'//char(0),0)
             call wmenu_set_state('Fourier'//char(0),0)
             call wmenu_set_state('Peak labelling'//char(0),0)

            case ('run')
             call abilita_tasti('window')
             call toolbar_set_state('Stop'//char(0),1)
             call toolbar_set_state('pointmode'//char(0),0)

            case ('run+skip')
             call abilita_tasti('window')
             call toolbar_set_state('Stop'//char(0),1)
             call toolbar_set_state('Skip'//char(0),1)
             call toolbar_set_state('pointmode'//char(0),0)

            case ('structure+pattern')
             call abilita_tasti('pattern')   ! abilita tutti i tasti dello spettro
             call abilita_tasti('structure')   
      
            case ('window')
             call wmenu_set_state('File'//char(0),0)
             call abilita_tasti('view_pattern')
             call wmenu_set_state('View'//char(0),1)
             call wmenu_set_state('Solve'//char(0),0)
             call wmenu_set_state('Refine'//char(0),0)
             call wmenu_set_state('Info'//char(0),1)
             call tb_set_state('file',0)
             call toolbar_set_state('display structure'//char(0),1)
             call tb_set_state('procedure',0)

            case ('window_pattern')
             call wmenu_set_state('File'//char(0),0)
             call wmenu_set_state('Pattern'//char(0),0)
             call tb_set_state('pattern',1)
             call wmenu_set_state('Solve'//char(0),0)
             call wmenu_set_state('Refine'//char(0),0)
             call wmenu_set_state('Info'//char(0),1)
             call tb_set_state('file',0)
             call toolbar_set_state('display structure'//char(0),0)
             call tb_set_state('procedure',0)

            case ('peaks')
             if (present(state)) then
                 call toolbar_set_state('pointmode'//char(0),state)
                 call toolbar_set_state('peaksmode'//char(0),state)
                 call wmenu_set_state('Modify Peaks'//char(0),state)
                 call wmenu_set_state('Background'//char(0),state)
             endif

            case ('indexing')
             call wmenu_set_state('Indexing'//char(0),state)

            case ('rietveld')
             call abilita_tasti('window')
             call toolbar_set_state('pointmode'//char(0),1)
             call wmenu_set_state('Background'//char(0),1)

            case ('view_pattern')
             call wmenu_set_state('Pattern'//char(0),1)
             call wmenu_set_state('Range'//char(0),0)
             call wmenu_set_state('Intervals'//char(0),0)
             call wmenu_set_state('Background'//char(0),0)
             !call wmenu_set_state('Options'//char(0),1)
             !call wmenu_set_state('Draw Legend'//char(0),1)
             !call wmenu_set_state('Fonts & Colors'//char(0),1)
             !call wmenu_set_state('Alien Programs'//char(0),1)
             call tb_set_state('pattern',1)

            case ('structure')
             call wmenu_set_state('Solve'//char(0),statet)
             call wmenu_set_state('Refine'//char(0),statet)
             call wmenu_set_state('Resolution Bias Modification (RBM)'//char(0),statet)
             call toolbar_set_state('display structure'//char(0),statet)

            case default
             write(0,*)'CODE NOT FOUND '//trim(scode)

        end select
    endif
!
    end subroutine abilita_tasti

!---------------------------------------------------------------------------------

    subroutine abilita_tasti2(nat,nrefl,np)
    integer, intent(in) :: nat   ! num. of atoms
    integer, intent(in) :: nrefl ! num. of reflections
    integer, intent(in) :: np    ! num. of counts
!
    if (np > 0) then
        call abilita_tasti('pattern',1)   
!corr        call abilita_tasti('peaks',1)   
!corr        call abilita_tasti('indexing',1)   
    endif
    if (nat > 0 .or. nrefl > 0) then
!       enable also for nats=0, user could import structure
        call abilita_tasti('structure',1)   
    else
        call abilita_tasti('structure',0)   
    endif
!
    end subroutine abilita_tasti2

!---------------------------------------------------------------------------------

    subroutine tb_set_state(string,state)
    character(len=*), intent(in) :: string
    integer, intent(in)          :: state
!
    select case(string)
        case ('file')
             call toolbar_set_state('Quit'//char(0),state)
             call toolbar_set_state('New Project'//char(0),state)
             call toolbar_set_state('Load'//char(0),state)
             call toolbar_set_state('Old project'//char(0),state)

        case ('pattern')
             call toolbar_set_state('selectionmode'//char(0),state)
             call toolbar_set_state('zoommode'//char(0),state)
             call toolbar_set_state('NoArea'//char(0),state)
             call toolbar_set_state('Reset View'//char(0),state)
             call toolbar_set_state('Zoom_left'//char(0),state)
             call toolbar_set_state('Zoom_right'//char(0),state)
             call toolbar_set_state('legendTog'//char(0),state)

        case ('procedure')
             call toolbar_set_state('Stop'//char(0),state)
             call toolbar_set_state('Skip'//char(0),state)

    end select
!
    end subroutine tb_set_state

END MODULE enable_amb
