      subroutine WriteSymmInfo(kpr)
      USE General, only: spacegr
      USE Symmetry, only: isvet
      implicit none
      integer, intent(in) :: kpr
      call spacegr%prn(kpr,prlevel=1)
      if (isvet(1) /= 0) then
          write(kpr,'(/a,3a2,4x,5a2)')' Seminvariant condition : ',isvet
      endif
      end subroutine WriteSymmInfo
!-----------------------------------------------------------------------
      subroutine MakeSymmOperators(ncoper)
      USE General, only : lo
      USE Symmetry, only: nsym,kmat,tmat,icent,centrt,latt
!
      implicit none
      integer, intent(in) :: ncoper
      integer :: ifi, ifin(2), i, kt, kt1, l, n, nTot
      real    :: tr, centra(3)
!
      nTot = nsym
      if (icent == 1) then
!
!-- Centrosymmetry
!
          do i=1, nsym
             kmat(nTot+i,1:3,1:3) = -kmat(i,1:3,1:3)
             tmat(nTot+i,1:3)     = -tmat(i,1:3)
          enddo
          nTot = nTot + nsym
      endif
      if (ncoper > 1) then
!
!-- Centring
!
          n = nTot
          do kt=2, ncoper
             do l=1, 3
                kt1 = (kt-1) * 3 + l
                centra(l) = centrt(latt, kt1)
             enddo
             do i=1, nTot
                n = n + 1
                kmat(n,1:3,1:3) = kmat(i,1:3,1:3)
                do l=1, 3
                   tr = tmat(i,l) + centra(l)
                   if (abs(tr - 1.0) < 0.001) tr = 0.0
                   tmat(n,l) = tr
                enddo
             enddo
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
!corr      subroutine OriginiRoxi()
!corr      USE General
!corr!      USE Symmetry
!corr      USE sinterface
!corr!
!corr!--fornisce le origini permesse, per tutti i gruppi spaziali
!corr!
!corr!!!!!!!!!!!!!!!!!!test
!corr          call get_origini_spg(spacegr)
!corr          return
!corr!!!!!!!!!!!!!!!!!!test
!corr      return
!corr      end
