#include <utils.h>

extern GtkWidget *finestre[6];

//extern "C" void openwave_(float *wavel, int *radtype)
extern "C" void openwave_(int *radtype, int *nwave, float wave[], float ratio[])
{
   static const char *rads[] = {"X-ray", "Synchrotron", "Neutron"};
   int nrads = G_N_ELEMENTS(rads);
   GtkWidget *dlg = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(dlg), "Set wavelength radiation");
   gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(finestre[0]));
   gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER_ON_PARENT);

   GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   GtkWidget *hbox =  table_new(6, 2, FALSE);
   gtk_container_set_border_width (GTK_CONTAINER (hbox), 20);
   gtk_container_add (GTK_CONTAINER (vbox), hbox);
   table_set_row_spacings(hbox, 10);
   table_set_col_spacings(hbox, 20);
   GtkWidget *label = gtk_label_new (" Radiation: ");
   set_alignment (label, 0, 0.5);
   table_attach_exp(hbox, label, 0, 1, 0, 1);
   GtkWidget *combo = create_combo_str(false);
   fill_combo(combo, rads, nrads, 1);
   table_attach_exp(hbox, combo, 1, 2, 0, 1);
   label = gtk_label_new (" Wavelength: ");
   set_alignment (label, 0, 0.5);
   table_attach_exp(hbox, label, 0, 1, 1, 2);
   GtkWidget  *entry = gtk_entry_new();
   gtk_entry_set_width_chars(GTK_ENTRY(entry), 10);
   gtk_entry_set_text(GTK_ENTRY(entry), g_strdup_printf("%f", wave[0]));
   g_object_set_data(G_OBJECT(dlg), "wave1", entry);
   table_attach_exp(hbox, entry, 1, 2, 1, 2);
   GtkWidget *checkb = gtk_check_button_new_with_label("Use wavelength2");
   table_attach_exp(hbox, checkb, 0, 2, 2, 3);
   label = gtk_label_new (" Wavelength2: ");
   set_alignment (label, 0, 0.5);
   table_attach_exp(hbox, label, 0, 1, 3, 4);
   entry = gtk_entry_new();
   gtk_entry_set_width_chars(GTK_ENTRY(entry), 10);
   gtk_entry_set_text(GTK_ENTRY(entry), g_strdup_printf("%f", wave[1]));
   g_object_set_data(G_OBJECT(dlg), "wave2", entry);
   table_attach_exp(hbox, entry, 1, 2, 3, 4);
   gtk_widget_set_sensitive(entry, FALSE);
   gtk_widget_set_sensitive(label, FALSE);
   g_signal_connect (checkb, "toggled", G_CALLBACK (on_cb_attiva), entry);
   g_signal_connect (checkb, "toggled", G_CALLBACK (on_cb_attiva), label);
   label = gtk_label_new (" Ratio: ");
   set_alignment (label, 0, 0.5);
   table_attach_exp(hbox, label, 0, 1, 4, 5);
   entry = gtk_entry_new();
   gtk_entry_set_width_chars(GTK_ENTRY(entry), 10);
   gtk_entry_set_text(GTK_ENTRY(entry), g_strdup_printf("%f", ratio[1]));
   g_object_set_data(G_OBJECT(dlg), "ratio2", entry);
   table_attach_exp(hbox, entry, 1, 2, 4, 5);
   gtk_widget_set_sensitive(entry, FALSE);
   gtk_widget_set_sensitive(label, FALSE);
   g_signal_connect (checkb, "toggled", G_CALLBACK (on_cb_attiva), entry);
   g_signal_connect (checkb, "toggled", G_CALLBACK (on_cb_attiva), label);


   GtkWidget *button = OK_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK);
   gtk_widget_grab_focus(button);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
             GTK_BUTTONBOX_SPREAD);
   gtk_widget_show_all(dlg);
   int response = gtk_dialog_run(GTK_DIALOG(dlg));
   ratio[0] = 1;
   if(response == GTK_RESPONSE_OK)
   {
       entry = get_widget(dlg, "wave1");
       wave[0] = (float) atof(gtk_entry_get_text(GTK_ENTRY(entry)));
       get_comboselection(combo, radtype);
       *nwave = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkb))?2:1;
       if(*nwave > 1)
       {
          entry = get_widget(dlg, "wave2");
          wave[1] = (float) atof(gtk_entry_get_text(GTK_ENTRY(entry)));
          entry = get_widget(dlg, "ratio2");
          ratio[1] = (float) atof(gtk_entry_get_text(GTK_ENTRY(entry)));
       }
   }
   else
   {
      wave[0] = 1.54056f;
      *nwave = 1;
   }
   gtk_widget_destroy(dlg);
}


