      ! -------------------------------------------------------------------
      subroutine AllocaPolpo(iAction)
      USE Polpo
      USE Symmetry
      USE General
      USE atom_type_util, only: natom_cell
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      ierv = 0
      ierr = 0
!corr      natst=0
!corr      nsymo=nsym
!corr      if(icent.ne.0)nsymo=nsymo*2
!corr      do i=1,nk
!corr        natst=natst+nw(i)
!corr      enddo
      natst = natom_cell(celem,neutro==0)
c     natst=natst+nint(natst*0.5)
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(nlinka))
     *    ALLOCATE (nlinka(20,1:natst), stat = ierv)
!
          if (ierv.ne.0) then
              write(0,*) 'Polpo Allocation Error'
              stop
          endif
      else
          IF (ALLOCATED(nlinka))
     *        DEALLOCATE (nlinka,  stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'Polpo DeAllocation Error'
              stop
          endif
      endif
!
      ierv = 0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(dlinka))
     *    ALLOCATE (dlinka(1:natst,1:natst), stat = ierv)
!
          if (ierv.ne.0) then
              write(0,*) 'Polpo Allocation Error'
              stop
          endif
      else
          IF (ALLOCATED(dlinka))
     *        DEALLOCATE (dlinka,  stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'Polpo DeAllocation Error'
              stop
          endif
      endif
!
      ierv = 0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(xeql))
     *    ALLOCATE (xeql(3,20,1:natst), stat = ierv)
!
          if (ierv.ne.0) then
              write(0,*) 'Polpo Allocation Error'
              stop
          endif
      else
          IF (ALLOCATED(xeql))
     *        DEALLOCATE (xeql,  stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'Polpo DeAllocation Error'
              stop
          endif
      endif
!
      ierv = 0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(nsyml))
     *    ALLOCATE (nsyml(20,1:natst), stat = ierv)
!
          if (ierv.ne.0) then
              write(0,*) 'Polpo Allocation Error'
              stop
          endif
      else
          IF (ALLOCATED(nsyml))
     *        DEALLOCATE (nsyml,  stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'Polpo DeAllocation Error'
              stop
          endif
      endif
!
      ierv = 0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(kcen))
     *    ALLOCATE (kcen(20,1:natst), stat = ierv)
!
          if (ierv.ne.0) then
              write(0,*) 'Polpo Allocation Error'
              stop
          endif
      else
          IF (ALLOCATED(kcen))
     *        DEALLOCATE (kcen,  stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'Polpo DeAllocation Error'
              stop
          endif
      endif
!
      ierv = 0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(xt))
     *    ALLOCATE (xt(3,1:natst,1:natst), stat = ierv)
!
          if (ierv.ne.0) then
              write(0,*) 'Polpo Allocation Error'
              stop
          endif
      else
          IF (ALLOCATED(xt))
     *        DEALLOCATE (xt,  stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'Polpo DeAllocation Error'
              stop
          endif
      endif
!
      ierv = 0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(ntt))
     *    ALLOCATE (ntt(1:natst,1:natst), stat = ierv)
!
          if (ierv.ne.0) then
              write(0,*) 'Polpo Allocation Error'
              stop
          endif
      else
          IF (ALLOCATED(ntt))
     *        DEALLOCATE (ntt,  stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'Polpo DeAllocation Error'
              stop
          endif
      endif
      if (iAction == 1) then
          nlinka(:,:) = 0
          dlinka(:,:) = 0
          xeql(:,:,:) = 0
          nsyml(:,:) = 0
          kcen(:,:) = 0
          ntt(:,:) = 0
          xt(:,:,:) = 0
      endif
!
      return
      end
! -------------------------------------------------------------------
      subroutine polyedra(ier)
      USE xdataMod
      USE Catena1
      Use Polpo
      USE Conteggi
      USE CalcProfile
      USE Atomi
      USE General
      USE Symmetry
      USE Molcom      
      USE drawatoms
      USE elements, only: numelem
      USE sinterface, only: update_model,xyzs_to_atom
      USE variables, only:atm,lconn
      USE messagemod, only: progress_bar_close
!corr      include 'rando.fi'
      USE randofi
c--
      common/ylimi/nfl,lfl,idummy(4),nfls
      common/dirc/ dirett,direto,diretm
      character dirett(500)*80,direto(500)*80,diretm(500)*80
      character gos*2,filediff*80
      character filefc*80
      common/conta/iconta
      character line*8, cff
!corr      common /profp/phkl(3000,6),dumpp,nprof,ipol
      common/partenza/istart00,istart(500),natspa,istart0,isalva
      common /fastcal/ hkle(3000,4,24),fsca(9,3000)
      common /ktuttac/itutcefou,itutce,ktutce,isoft,softbu
      common/tetrafree/ nats1(10),nats2(10),nate,k1(10),k2(10),iox(500)
     *,libt(10)
      common/ottafree/ nats1o(10),nats2o(10),nateo,k1o(10),k2o(10)
     *,libo(10)
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/occtetra/itpoly(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common /ches/ deltx,delty,deltz
      common/inpcl/ntype,ttype(10,5),nprojx,nbond,dmaxi,radnew(8)
      common/subchain/nag
      common/stampa/istampa
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /conteggisav/ npuntisav,nrefsav
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common /tab3/ ijt(6,2),iit(6),numpr(29),ktlsq(28)
!corr      common /sdir/ dm,npc,nproj,nojoin,jplt
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /directo/ kdirect,okdirectsav,jpol,ized,ifou
      common /lista30v/ store30v(30000),n30v
      common/anna/ncounmax
      common /kuse/ kuser1,kuser2,kuser3
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common /puls/Lim(190,4),iAct(190),iDepr(190),iRep(190),iFocus(190)
     *              ,ipu(190),iHB,iDeep,nFocus(5)
      common/chiquadro/chimin,chisquared,ntrialmin,chichi(150),
     *                 xchi(5,500,150),nzchi(500,150),natschi(150),
     *                 ntrialmn
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/maybe/xtri(5,500,150),natstri(150),chitri(150),
     *             nztri(500,150),nvoltet
      common/attempt/ntetrasav,nottsav,natszero,chimin0,npunti0
      dimension vvet(40),ivvet(40)
      dimension inde(150),chit(150)
      common/totaltime/t1,ttot
      character ttime*8
      character llin*80,llline*80,dire*80,tipoa*2,diret*2
      common /lista15v/ store15v(30000),n15v
      character Buffer*80
      dimension i1(3)
      dimension x1(3),x2(3)
c--------
      call CPUTime0('INIZIO')
      zero=0.6  
      nfl=1
      ier=0
      iconta=0
      rfac=0.0
      ksetfo = 0
      call write_inte_routine('Polyhedra')
!corr      if (icomat.eq.1) then
!corr                         write(cff,'(i1)') kff
!corr                         write(lo,10) cff,itle
!corr                       else
!corr                         write(lo,15) itle
!corr                       endif
      iln=1
      call srlin (iln,lsn,lix1,ljxx,lkxx,llxx)
      if(lix1.gt.0) call xfl01
      iln=2
      call srlin (iln,lsn,lix2,ljxx,lkxx,llxx)
      if(lix2.gt.0) call yfl02
!corr      jspini=-1
      call xspinb
!corr      iln=3
!corr      call srlin (iln,lsn,lix3,ljxx,lkxx,llxx)
!corr      if(lix3.gt.0) call yfl03
c---------
      call srlin (7,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
        call ysfl07(iy)
        biso = bt
      endif
      iln=37
      call srlin (iln,lsn,lix37,ljxx,lkxx,llxx)
      if (lix37.gt.0) then
          call ysfl37(npunti)
        else
          write(Msg,8)
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          ier=-1
          go to 2222
c         return
  8       format('No counts in direct acces file')
      endif
c---------
!corr   10 format(///,a1 ,78('+'),//,
!corr     1 38h expo2005  : Polyhedra  routine       ,26x,14hRelease  02.01
!corr     2 ,//,20x,20a4,/,1h ,78('+'),/)
!corr   15 format(///,1h ,78('+'),//,
!corr     1 38h expo2005  : Polyhedra  routine       ,26x,14hRelease  02.01
!corr     2 ,//,20x,20a4,/,1h ,78('+'),/)
c
      itutce=0
      itutcefou=0
      ktutce=0
      call dirpoly(ier)
      if(jpfile.eq.0.and.ntetra.eq.0.and.nott.eq.0.and.nmiss.eq.0)then
             write(Msg,8220)
             ier=-1
             call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)
             go to 2222
c            return
 8220        format('ERROR in the POLPO procedure directives')
      endif
c
c     if (ier.lt.0) return
      if (ier.lt.0) go to 2222
      iprin=0
!CROS do 100 i=1,kuser2
!CROS nz(i)=0
!CROS do 100 j=1,5
!CROS xyzs(j,i)=0.0
CR100 continue
      nkel = numelem(celem)
      klast=0
      maxcyc=0
      nemap(4) = 0
      jrecyc=0
      call inptf
!ang      if (jpfile.ne.0.and.kscreen.eq.0) then
      if (jpfile.ne.0) then
                         call getplt(ier)
c                        if (ier.lt.0) return
                         if (ier.lt.0) go to 2222
                                        kaction=4
                                        call maincl(kaction,iprin)
                                        iprsav=iprin
                                        if (iprin.eq.0) iprin=2
                                        klast=1
                                        !!!!!host=fname(3)
                                        call outpea(klast)
                                        nzmax = -9999
                                        do 120 i=1,nats
                                        if (nz(i).ne.0) then
                                           kfrag=mod(nz(i),100)
                                           nzz=iabs(nz(i))/100
                                           if (nzz.gt.nzmax)then
                                              nzmax=nzz
                                           endif
                                           nzz=nkel-nzz+1
                                           izpk(i)=nzz*100+kfrag
                                                         else
                                           kfrag=0
                                           izpk(i)=-99999
                                                         endif
  120                                   continue
                                        do 121 il=1,nats
                                           nzz=iabs(nz(il))/100
                                          if (nzz.lt.nzmax)then
                                            zrap=float(nzmax)/float(nzz)
                                            bfac(il)=zrap*biso
                                         if(bfac(il).lt.0.5)bfac(il)=0.5
                                            else
                                             bfac(il)=0.9*biso
                                         if(bfac(il).lt.0.5)bfac(il)=0.5
                                          endif
  121                                   continue
                                        errem=0.0
                                        interp=1
                                        call frm15e(nats,interp)
                                        iprin=iprsav
                                           endif
!corr      call srlin (15,lsn,lixx,ljxx,lkxx,llxx)
!corr      if (lixx.gt.0.or.n15v.gt.0) then
!corr          idisp=1
!corr          call sfl15e(nats,idisp,interp)
!corr      else
!corr          write(Msg,20)
!corr          ier=-1
!corr          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
!corr          go to 2222
!corrc         return
!corr      endif
!corr  20  format('No coordinates in direct access file')
      if(nats > 20) then
         write(Msg,'("The number of starting cations is too large.")')
         ier=-1
         call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)
         go to 2222
!corr 8221    format('The number of starting cations is too large.')
      endif

      kdirectsav=2
      kdirect=2
      iniat = 1
      call MakeLab(iniat,nats)
      interp = 1
      call frm15e(nats,interp)
      if(ifou.eq.0) then
      rfac=0.0
      iAct(12)=0
      iAct(13)=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
c     if(kdirect.eq.1)then
c     if(nSelect.eq.1)then
c         kgo = 0
c         call UseFrag(kgo,ier)
c         if (kgo.gt.0.and.ier.eq.0) then
cORO
c             if(jpfile.eq.0) then
c                do i=1,500
c                   occp(i)=1.0
c                end do
c             endif
cORO
c             call calcfc(ifc,ier)
c             if(ier.lt.0)return
c             write(lo,550)
c 550 format(/,15x,'***   Fragment information will be used as   ***',
c    &       /,15x,'***        prior information in Extra        ***')
c         endif
c         return
c     endif
c     if(ier.lt.0)return
      if (ier.lt.0) go to 2222
      endif
      call AllocaRiflessi(1)
      call AllocaPolpo(1)
      rappo=0.8
      call LoadList12(rappo,1,ier)
c     call AllocaCalcProfile(1)
      call AllocaCalcfig(1)
      call CalcProf0(ier,0)
c     if (ier.lt.0) return
      if (ier.lt.0) go to 2222
CORO  call cheshire
      call NewCheshire()
      iprier=1
      call calcolaerre(chi2,iprier)
      call to_coord(1)
c
      do i=1,150
      natschi(i)=0
      natstri(i)=0
      chitri(i)=0
      chichi(i)=0
      do j=1,500
      nzchi(j,i)=0
      nztri(j,i)=0
      do k=1,5
      xchi(k,j,i)=0.0
      xtri(k,j,i)=0.0
      enddo
      enddo
      enddo
      do 70 i=1,nats
      itpoly(i)=0
      do 75 j=1,nats
      xt(1,i,j)=0.0
      xt(2,i,j)=0.0
      xt(3,i,j)=0.0
      ntt(i,j)=0
  75  continue
  70  continue
c
      write(6,'(a)')'    ***** polyedral directives ****    '
      if(nmiss.gt.0)then
        do i=1,nmiss
           if(imiss(i).eq.1)then
           write(6,'(a,2i5,2x,a2,2x,a,3f8.2)')
     *     ' missing',nfound1(i),nfound2(i),celem(i)%lab,' tetrahedron',
     *       dmiss(i),dtolm(i),atolm(i)
           else
           write(6,'(a,2i5,2x,a2,2x,a,3f8.2)')
     *     ' missing',nfound1(i),nfound2(i),celem(i)%lab,' octahedron',
     *       dmiss(i),dtolm(i),atolm(i)
           endif
        enddo
      endif
      if(ntetra.gt.0)then
        do i=1,ntetra
           write(6,'(a,i5,3f8.2)')
     *     ' tetrahedron',ntetr(i),dtetra(i),dtolt(i),atolt(i)
        enddo
      endif
      if(nott.gt.0)then
        do i=1,nott
           write(6,'(a,1x,i5,3f8.2)')
     *     ' octahedron',notta(i),dotta1(i),dtolo(i),atolo(i)
        enddo
      endif
      write(6,'(a)')'    *******************************    '
      if(itet.eq.1) then
      do i=1,ntetra
       if(ntetr(i).gt.nats) then
         write(lo,*)
         write(lo,'(22h error in directive : ,a80)') dirett(i)
         ier=-1
         go to 2222
c        return
       endif
      end do
      endif
c
      if(iott.eq.1) then
      do i=1,nott
       if(notta(i).gt.nats) then
         write(lo,*)
         write(lo,'(22h error in directive : ,a80)') direto(i)
         ier=-1
         go to 2222
c        return
       endif
      end do
      endif
c
      if(nmiss.gt.0) then
      do i=1,nmiss
       if(nfound1(i).gt.nats.or.nfound2(i).gt.nats) then
         write(lo,*)
         write(lo,'(22h error in directive : ,a80)') diretm(i)
         ier=-1
         go to 2222
c        return
       endif
      end do
      endif
c
      natsp=nats
      call Fillg
      a=cell(1)
      b=cell(2)
      c=cell(3)
      alfa=cell(4)
      beta=cell(5)
      gamma=cell(6)
c     b2=b**2
c     c2=c**2
c     a2=a**2
      inv=0
      call Orto_new(a, b, c, alfa, beta, gamma,inv)
      inv=1
      call Orto_new(a, b, c, alfa, beta, gamma,inv)
      iiy=67543
      iix=iiy
      do ii=1,6
         cell(ii)=cell(ii)
      enddo
      do 31 ki=1,3
      ang(ki)=((pi*cell(ki+3))/180.0)
   31 continue
      do 3 ii=1,3
      do 4 j=1,3
      ggMat(ii,j)=0.0
   4  continue
   3  continue
      do 50 ii=1,3
      do 60 j=1,3
      if(ii.eq.j)then
                ggMat(ii,j)=ggMat(ii,j)+cell(ii)*cell(j)
                goto 65
                end if
      ii1=abs(ii-j)
      if(ii1.eq.2)then
                 ggMat(ii,j)=ggMat(ii,j)+cell(ii)*cell(j)*cos(ang(2))
                 goto 65
                 end if
      if((ii.eq.1.and.j.eq.2).or.(ii.eq.2.and.j.eq.1))then
                 ggMat(ii,j)=ggMat(ii,j)+cell(ii)*cell(j)*cos(ang(3))
                 goto 65
                 end if
      ggMat(ii,j)=ggMat(ii,j)+cell(ii)*cell(j)*cos(ang(1))
 65   continue
 60   continue
 50   continue
      do 1220 i=1,500 
      itpoly(i)=0.0
 1220 continue
      ifail=0
      nvoltemax=1000
      isalva=1
      chimin0=1.0E+10
      ntrial = 0
      ntrialmin = 0
      ntrialmn = 0
      nvosta=0
      do 1019 i=nats+1,500
      xyzs(1,i)=0.0
      xyzs(2,i)=0.0
      xyzs(3,i)=0.0
 1019 continue
      natszero=nats
!
!     inizializza progress-bar 
!
      call scrper(' ',0,0)
!
!     call falsogruppo
c     if(kdirect.eq.1)then
      if(nmiss.gt.0)then
      if(biso.lt.1.0)biso=1.0
      call statuslink(ier)
c     if(ier.lt.0) return
      if (ier.eq.-1) go to 2222
      ntetrasav=ntetra
      nottsav=nott
      i911=0
      max911=50
 911  continue
      call addcat(ier)
      if(ier.lt.0)then
      do 1020 i=1,nats 
      itpoly(i)=0.0
 1020 continue
      ntetra=ntetrasav
      nott=nottsav
      nats=natszero
      ier=0
      i911=i911+1
      if(i911.lt.max911) go to 911
      write(lo,*)'            **** No Reliable Model Found ****'
      write(lo,*)'** Try to modify polyhedral distance or tolerance **'
      ier=-1
      go to 2222
      endif
      iaddcat=0
      ilinka=0
      endif
      call statuslink(ier)
c     if(ier.lt.0) return
      if (ier.eq.-1) go to 2222
c     call statuslink_old
      if(nmiss.gt.0)then
      if(itimem.eq.0)then
      nvoltemax=20
      elseif(itimem.eq.1)then
      nvoltemax=10
      elseif(itimem.eq.2)then
      nvoltemax=50
      endif
      write(lo,'(/,a,i3)')'  The number of atomic bridges to build is:'
     *,nmiss
      endif
      nvoltet=0
      natschi(1)=nats
      do j=1,natschi(1)
      xchi(1,j,1)=xyzs(1,j)
      xchi(2,j,1)=xyzs(2,j)
      xchi(3,j,1)=xyzs(3,j)
      xchi(4,j,1)=xyzs(4,j)
      xchi(5,j,1)=xyzs(5,j)
      nzchi(j,1)=nz(j)
      enddo    
      nattem=0
      if(nmiss.gt.0)then
      do 99998 j=1,nmiss
      write(lo,2999) j
 2999 format(/,'   Bridge #  ',i3,'     Input cation :')
      write(lo,'(/,a,/)')
     *'                     Atom           X         Y         Z    '
      do 99999 i=1,nmiss
      kt=nfound1(i)
      write(lo,'(20x,i3,1h),5x,3f10.3)')kt,(xyzs(kp,kt),kp=1,3)
      kt=nfound2(i)
      write(lo,'(20x,i3,1h),5x,3f10.3)')kt,(xyzs(kp,kt),kp=1,3)
99999 continue
99998 continue
      endif
      do 1000 nvolte=1,nvoltemax
      iarret = 0
      idisp=1
      call sfl15e(nats,idisp,interp)
      if(ilinka.gt.0.and.nmiss.eq.0)then
         call legati(nvolte,nvosta,iarret,ier)
!
!        Manage progress-bar
!
         write(Buffer,102) nvolte,nvoltemax
  102    format(' Adding the missing atoms. Trial ',i5,' / ',
     *i5)
         call scrper(Buffer,nvolte,nvoltemax)
!
      endif
c     if (ier.eq.-1) return    
      if (ier.eq.-1) go to 2222
      if (iarret.eq.-1) goto 1001
      if(itet.ne.0.or.iott.ne.0) call 
     *whatbuild(nvolte,iarret)
      if (iarret.eq.-1) go to 1001
      if(nmiss.gt.0)then
      idisp=1
      call sfl15e(nats,idisp,interp)
      iprier=0
      call calcolaerre(chisquare,iprier)
      nvoltet=nvoltet+1
      ifail=1
      natstri(nvoltet)=nats
      chitri(nvoltet)=chisquare
      do 3023 ji=1,nats
      xtri(1,ji,nvoltet)=xyzs(1,ji)
      xtri(2,ji,nvoltet)=xyzs(2,ji)
      xtri(3,ji,nvoltet)=xyzs(3,ji)
      xtri(4,ji,nvoltet)=xyzs(4,ji)
      xtri(5,ji,nvoltet)=xyzs(5,ji)
      nztri(ji,nvoltet)=nz(ji)
 3023 continue
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      call to_coord(1)
      endif
      if(nate.ne.0)
     *call freetetra(nvolte,iarret)
      if (iarret.eq.-1) then
*         write(6,*) ' RIFIUTO CONFIGURAZIONE freetetra'
          goto 1001
      endif
      if(nateo.ne.0)call freeotta(nvolte,iarret)
      if (iarret.eq.-1) then
*         write(6,*) ' RIFIUTO CONFIGURAZIONE freeotta'
          goto 1001
      endif
      if((nmiss.gt.0.and.nate.ne.0).or.(nmiss.gt.0.and.nateo.ne.0))then
      npunti0=npunti
      idisp=1
      call sfl15e(nats,idisp,interp)
      iprier=1
      call calcolaerre(chisquare,iprier)
      nvoltet=nvoltet+1
      natstri(nvoltet)=nats
      chitri(nvoltet)=chisquare
      do 3012 ji=1,nats
      xtri(1,ji,nvoltet)=xyzs(1,ji)
      xtri(2,ji,nvoltet)=xyzs(2,ji)
      xtri(3,ji,nvoltet)=xyzs(3,ji)
      xtri(4,ji,nvoltet)=xyzs(4,ji)
      xtri(5,ji,nvoltet)=xyzs(5,ji)
      nztri(ji,nvoltet)=nz(ji)
 3012 continue
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      call to_coord(1)
      endif
      if(nmiss.eq.0.and.nattem.lt.150)then
      if(chisquared.lt.chimin)then
      chimin=chisquared
      ntrialmn = ntrialmin
      endif
      nattem=nattem+1
      chichi(nattem)=chisquared
      idisp=1
      call sfl15e(nats,idisp,interp)
      natschi(nattem)=nats
      do 3011 j=1,natschi(nattem)
      xchi(1,j,nattem)=xyzs(1,j)
      xchi(2,j,nattem)=xyzs(2,j)
      xchi(3,j,nattem)=xyzs(3,j)
      xchi(4,j,nattem)=xyzs(4,j)
      xchi(5,j,nattem)=xyzs(5,j)
      nzchi(j,nattem)=nz(j)
 3011 continue
      write(lo,'(//,15x,a,//)')' Feasible configuration '
      write(lo,'(a,/)')
     *' Atom           X         Y         Z       B-iso'
      do 3311 jk=1,nats
      if(nz(jk).eq.0) go to 3311
      write(lo,'(2x,a,4f10.4)')celem(iabs(nz(jk)/100))%lab(1:2),
     *(xyzs(jkk,jk),jkk=1,3),bfac(jk)
 3311 continue
CANG  endif
 3013 continue
      kdirect=1
      kdirectsav=3
      interp=0
      call frm15e(nats,interp)
      rfac=chichi(nattem)
      jpol=0
      kdirectsav=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      call to_coord(1)
      endif
 1001 continue
      if(nmiss.gt.0.and.nvolte.lt.nvoltemax)then
      do 1040 i=1,nats 
      itpoly(i)=0.0
 1040 continue
      ntetra=ntetrasav
      nott=nottsav
      nats=natszero
      i912=0
      max912=50
 912  continue
      call addcat(ier)
      if(ier.lt.0)then
      do 1021 i=1,nats 
      itpoly(i)=0.0
 1021 continue
      ntetra=ntetrasav
      nott=nottsav
      nats=natszero
      ier=0
      i912=i912+1
      if(i912.lt.max912)go to 912
      write(lo,*)'            **** No Reliable Model Found ****'
      write(lo,*)'** Try to modify polyhedral distance or tolerance **'
      ier=-1
      go to 2222
      go to 912
      endif
      if(ier.lt.0)go to  1000
      ilinka=0
      call statuslink(ier)
c     if(ier.lt.0) return
      if(ier.lt.0) go to 2222
      endif
 1000 continue
 1003 continue
CORO
      if(nmiss.eq.0)then
      if(nattem.eq.0) then
        write(lo,*) 
        write(lo,*) ' **** No Located Atoms **** '
        jpol=0
        kdirectsav=0
        nats=natschi(1)
        do jj=1,nats
          xyzs(1,jj)=xchi(1,jj,1)
          xyzs(2,jj)=xchi(2,jj,1)
          xyzs(3,jj)=xchi(3,jj,1)
          xyzs(4,jj)=xchi(4,jj,1)
          xyzs(5,jj)=xchi(5,jj,1)
          nz(jj)=nzchi(jj,1)
        enddo
c       do inats=1,nats
c         kblock(inats)=1
c       enddo
      interp=1
      call frm15e(nats,interp)
      idisp=1
      call sfl15e(nats,idisp,interp)
!corr      iconn(1)=-1
c     jab=3
c     call molplo()
      call draw_xyzs(conn=.true.)
      do inats=1,nats
        kblock(inats)=1
      enddo
      call lastplot()   !!!!rfac)
       ier=-1
       go to 2222
c      return
      endif 
CCCCCCCCCCCCCCCCCCCCCCCCC
      do 4200 j=1,nattem
      chit(j)=chichi(j)
 4200 continue
      do 4210 j=1,nattem
      cmin=9999999999999.0
      do 5200 jj=1,nattem
      if(chichi(jj).lt.cmin)then
      cmin=chichi(jj)
      jjsav=jj
      endif
 5200 continue
      chichi(jjsav)=99999999999.0
      inde(j)=jjsav
 4210 continue
      write(lo,'(/,a,i8)')'  Number of feasible solutions:',nattem
      if(nattem.gt.0)then
      write(lo,'(/,a)')'  The ten lowest fom value solutions are given'
      nvoltem=amin0(nattem,10)   
      do 6200 jj=1,nvoltem
      jk=inde(jj)
      nats=natschi(jk)
      do 3200 j=1,nats
      xyzs(1,j)=xchi(1,j,jk)
      xyzs(2,j)=xchi(2,j,jk)
      xyzs(3,j)=xchi(3,j,jk)
      xyzs(4,j)=xchi(4,j,jk)
      xyzs(5,j)=xchi(5,j,jk)
      nz(j)=nzchi(j,jk)
 3200 continue
      kdirect=0
      kdirectsav=3
      interp=0
      iniat = 1
      write(lo,'(/a,i3,a,f10.5)') '  Feasible solution #',jj,
c    *' Rwp',chit(jk)                
     *' fom',chit(jk)                
      write(lo,'(/,a,/)')
     *' Atom       X         Y         Z       B-iso'
      do 3211 jk=1,nats
      if(nz(jk).eq.0) go to 3211
      write(lo,'(2x,a,4f10.4)')celem(iabs(nz(jk)/100))%lab(1:2),
     *(xyzs(jkk,jk),jkk=1,3),bfac(jk)
 3211 continue
      call to_coord(1)
      if(jj.le.10)then
      call MakeLab(iniat,nats)
      if(jj.eq.1)then
      iconn(1)=-1
      call frm15e(nats,interp)
      jpol=0
      kdirectsav=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
c     call lastplot(rfac)
      endif
      endif
 6200 continue
      endif
      endif
CCCCCCCCCCCCCCCCCCCCCCCCC
CORO
C     kdirectsav=3
C     interp=0
C     natsav=nats
c----------------------------
C     iequiv = 0
C     if (ntetra.eq.0) go to 1505
C     do 1500 i = 1,ntetra
C           i2=ntetr(i)
C           do 1501 j=1,itpoly(i2)
C           do 1502 ii=1,nats
****           if (xt(1,i2,j).eq.xyzs(1,ii).and.xt(2,i2,j).eq.xyzs(2,ii)
**** *         .and.xt(3,i2,j).eq.xyzs(3,ii)) then
C              x1(1) = xyzs(1,ii)
C              x1(2) = xyzs(2,ii)
C              x1(3) = xyzs(3,ii)
C              x2(1) = xt(1,i2,j)
C              x2(2) = xt(2,i2,j)
C              x2(3) = xt(3,i2,j)
C              call distanzaa(ggMat,x1,x2,dcal)
C              if (dcal.lt.zero) goto 1501
C1502      continue
C          iequiv = iequiv + 1
C          nats = nats + 1
C          xyzs(1,nats) = xt(1,i2,j)
C          xyzs(2,nats) = xt(2,i2,j)
C          xyzs(3,nats) = xt(3,i2,j)
C          xyzs(4,nats) = xyzs(4,natsav)
C          nz(nats) = nz(natsav)
C          bfac(nats) = bfac(natsav)
C1501 continue
C1500 continue
C1505 continue
C     if (nott.eq.0) go to 1606
C          do 1600 i=1,nott
C           i2=notta(i)
C           do 1601 j=1,itpoly(i2)
C           do 1602 ii=1,nats
****           if (xt(1,i2,j).eq.xyzs(1,ii).and.xt(2,i2,j).eq.xyzs(2,ii)
**** *         .and.xt(3,i2,j).eq.xyzs(3,ii)) then
C              x1(1) = xyzs(1,ii)
C              x1(2) = xyzs(2,ii)
C              x1(3) = xyzs(3,ii)
C              x2(1) = xt(1,i2,j)
C              x2(2) = xt(2,i2,j)
C              x2(3) = xt(3,i2,j)
C              call distanzaa(ggMat,x1,x2,dcal)
C              if (dcal.lt.zero) goto 1601
C1602       continue
C          iequiv = iequiv + 1
C          nats = nats + 1
C          xyzs(1,nats) = xt(1,i2,j)
C          xyzs(2,nats) = xt(2,i2,j)
C          xyzs(3,nats) = xt(3,i2,j)
C          xyzs(4,nats) = xyzs(4,natsav)
C          nz(nats) = nz(natsav)
C          bfac(nats) = bfac(natsav)
C1601      continue
C1600      continue
C1606 continue
*     write(6,*) ' Number of asymmetric atoms',natsav
*     write(6,*) ' Number of equivalent added atoms',iequiv
c----------------------------
C     do 5000 i=1,ntetra + nott
*     write(6,*)'NATSC',(xyzs(k,i),k=1,3),bfac(nats),nz(nats)
C     if(it(i).eq.0)go to 5000
C     do 6000 j=1,itpoly(i)
*     write(6,*)'XT   ',(xt(k,i,j),k=1,3)
C6000 continue
C5000 continue
CCCC  iniat = 1
CCCC  call MakeLab(iniat,nats)
CCCC  call frm15e(nats,interp)
CCCC  jpol=0
CCCC  kdirectsav=0
c     do inats=1,nats
c       kblock(inats)=0
c     enddo
CCCC  iconn(1)=-1
c     jab=3
c     call molplo()
CCCC  call lastplot(rfac)
CCCC  endif
      if(nmiss.gt.0)then
      do 4100 j=1,nvoltet
      chit(j)=chitri(j)
 4100 continue
      do 4110 j=1,nvoltet
      cmin=9999999999999.0
      do 5100 jj=1,nvoltet
      if(chitri(jj).lt.cmin)then
         cmin=chitri(jj)
         jjsav=jj
      endif
 5100 continue
      chitri(jjsav)=99999999999.0
      inde(j)=jjsav
 4110 continue
      write(lo,'(/,a,i8)')'  Number of feasible solutions:',nvoltet
      if(nvoltet.gt.0)then
      write(lo,'(/,a)')'  The five lowest fom value solutions are given'
      nvoltem=amin0(nvoltet,5)   
      do 6100 jj=1,nvoltem
      jk=inde(jj)
      nats=natstri(jk)
      do 3100 j=1,nats
      xyzs(1,j)=xtri(1,j,jk)
      xyzs(2,j)=xtri(2,j,jk)
      xyzs(3,j)=xtri(3,j,jk)
      xyzs(4,j)=xtri(4,j,jk)
      xyzs(5,j)=xtri(5,j,jk)
      nz(j)=nztri(j,jk)
 3100 continue
      kdirect=0
      kdirectsav=3
      interp=0
      iniat = 1
      write(lo,'(/a,i3,a,f10.5)') '  Feasible solution #',jj,
     *' fom',chit(jk)                
      write(lo,'(/,a,/)')
     *' Atom       X         Y         Z       B-iso'
      do 3111 jk=1,nats
      if(nz(jk).eq.0) go to 3111
      write(lo,'(2x,a,4f10.4)')celem(iabs(nz(jk)/100))%lab(1:2),
     *(xyzs(jkk,jk),jkk=1,3),bfac(jk)
 3111 continue
      call to_coord(1)
      if(jj.le.5)then
      call MakeLab(iniat,nats)
      if(jj.eq.1)then
         iconn(1)=-1
         call frm15e(nats,interp)
         jpol=0
         kdirectsav=0
         do inats=1,nats
           kblock(inats)=1
         enddo
         call lastplot()  !!!!!rfac)
      endif
      endif
 6100 continue
      endif
      endif
      idisp=1
      call sfl15e(nats,idisp,interp)
 2222 continue
      call progress_bar_close()
!corr      call AllocaConteggi(2)
!
!     update atm,cryst(1). lconn from draw_atoms is used because iconn(1) == -1
      call xyzs_to_atom(atm)
      call update_model(atm,lconn,1)
      call AllocaCalcProfile(2)
      call AllocaCalcfig(2)
      call AllocaPolpo(2)
      npunti=npuntisav
 1002 continue
      return
      end
c--------------------------------------------------------------
      subroutine dirpoly(ier)
      USE General
      USE Symmetry
      Use Polpo
      USE Atomi
      USE Liste      
      USE Molcom      
      USE PatternRef
      USE elements, only: pxen_from_specie,numelem
      USE commandsmod
c
      common/dirc/ dirett,direto,diretm
      character dirett(500)*80,direto(500)*80,diretm(500)*80
      character line*80,dire*80,diret*80,linesav*80,filet*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/tetrafree/ nats1(10),nats2(10),nate,k1(10),k2(10),iox(500)
     *,libt(10)
      common/inpcl/ntype,ttype(10,5),nprojx,nbond,dmaxi,radnew(8)
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/stampa/istampa
      common /misc/ t(3,3),dxmax(3),mcon,iwt,fom(11)
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common /kuse/ kuser1,kuser2,kuser3
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common / data/  store (30000)
      common /graphic_restart/kgraph_restart,ncyc_restart,nset_restart
      dimension ltype(10,5)
      equivalence (ltype(1,1),ttype(1,1))
      dimension vet(40),ivet(40)
c-- set default values
c
      ipdir = get_ipdir(commands,icomat)
      istampa=0
      itet=0
      iott=0
      nmiss=0
      itimem=0
      do 12 i=1,10
      imiss(i)=0
      dmiss(i)=0.0
      dtolm=0.3
      atolm=0.3
 12   continue
      ic=0
      kuser1=10000
      kuser2=300
      kuser3=25100
      kuser3=100000
      nott=0
      ntetra=0
      ilinka=0
      do 5 i=1,500
         dtetra(i) = 0.0
         dotta1(i) = 0.0
         notta(i) = 0
         iox(i) = 0
 5    continue
      ier=0
      jpfile=0
      dmaxi=0.0
      dmax=3.0
      ntype=0
      nbond = 1
!corr      call yfl03
      m3=l3
      do 10 i=1,numelem(celem)
*     radii(i,1) = store(m3+15)
      m3=m3+md3
   10 radnew(i)=-1.0
      kradii = 0
      do 20 i=1,5
      do 20 j=1,10
   20 ttype(j,i)=0
      do 30 i=1,500
      dtolt(i)=0.2
      atolt(i)=0.13
      dtolo(i)=0.2
      atolo(i)=0.17
   30 kblock(i)=0
      do 40 i=1,40
      vet(i)=0.0
      ivet(i)=0
 40   continue
c
      if(kgraph_restart.gt.0)go to 8000
      icmax=icomq(icomat,2)
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
      if (dire(1:4).eq.'fmon') then
         itimem=2
         go to 100
         endif
      if (dire(1:4).eq.'smon') then
         itimem=1
         go to 100
         endif
      if (dire(1:4).eq.'prin') then
         istampa=1
         go to 100
         endif
      if (dire(1:4).eq.'frag') then
          jpfile=kform
          read(line,'(a)') filet
          nlenb=80
          istat=2
          iform=1
          if (jopen(jpfile,filet,istat,iform,ier).ne.0) go to 9100
          jpfile=-jpfile
          go to 100
          endif
        if (dire(1:4).eq.'tetr') then
          itet=1
          ntetra=ntetra+1
          iopt=0
          call getnum(line,vet,ivet,iv,iopt)
          if (iopt.eq.-1) go to 9000
          if (iv.ne.4) go to 9000
          if(ivet(1).le.0)go to 9000
          ntetr(ntetra)=ivet(1)
          if(vet(2).le.0.0.or.vet(2).gt.dmax)go to 9000
          dtetra(ntetra)=vet(2)
          dtolt(ntetra)=vet(3)
          atolt(ntetra)=vet(4)
          dirett(ntetra)=diret
          go to 100
        endif
        if (dire(1:4).eq.'octa') then
          iott=1
          nott=nott+1
          iopt=0
          call getnum(line,vet,ivet,iv,iopt)
          if (iopt.eq.-1) go to 9000
          if (iv.ne.4) go to 9000
          if(ivet(1).le.0)go to 9000
          notta(nott)=ivet(1)
          if(vet(2).le.0.0.or.vet(2).gt.dmax)go to 9000
          dotta1(nott)=vet(2)
          dtolo(nott)=vet(3)
          atolo(nott)=vet(4)
          direto(nott)=diret
          go to 100
        endif
        if (dire(1:4).eq.'miss') then
c         if(itet.eq.0.and.iott.eq.0) go to 9001
          nmiss=nmiss+1
          call cutst(line,lenp,dire,lend)
          call lcase(dire)
          iopt=0
          call getnum(dire,vet,ivet,iv,iopt)
          if (iopt.eq.-1.or.ivet(1).le.0) go to 9000
          nfound1(nmiss)=ivet(1)
          call cutst(line,lenp,dire,lend)
          call lcase(dire)
          iopt=0
          call getnum(dire,vet,ivet,iv,iopt)
          if (iopt.eq.-1.or.ivet(1).le.0) go to 9000
          nfound2(nmiss)=ivet(1)
c
          if(nfound1(nmiss).eq.nfound2(nmiss)) go to 9000
c
          call cutst(line,lenp,dire,lend)
!corr          call lcase(dire)
          if (lend.eq.0) go to 9000
!corr          read(dire(1:2),'(a2)')kmiss(nmiss)
          kmiss(nmiss) = pxen_from_specie(dire)
          call cutst(line,lenp,dire,lend)
          call lcase(dire)
          if (lend.eq.0) go to 9000
          iopt=0
          call getnum(line,vet,ivet,iv,iopt)
          if (iopt.eq.-1) go to 9000
          if(iv.ne.3) go to 9000
          if(vet(1).le.0.0.or.vet(1).gt.dmax)go to 9000
          if(dire(1:4).eq.'tetr')then
          imiss(nmiss)=1
          else
          imiss(nmiss)=2
          endif
          dmiss(nmiss)=vet(1)
          dtolm(nmiss)=vet(2)
          atolm(nmiss)=vet(3)
          diretm(nmiss)=diret
          go to 100
        endif
 9000 continue
      ier=-1
      write(Msg,9011) diret(1:Lung(diret))
 9011 format('Error in directive: ',a)
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      return
 9001 continue
      ier=-1
      write(Msg,9002) diret(1:Lung(diret))
 9002 format('error: the directive ',a,
     &       ' must be associated to another one')
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      return
 9100 continue
      write(Msg,9110) ier,filet
 9110 format('open error - code =',i5,
     *       ' Fragment file ',a)
      ier=-1
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      return
 8000 continue
CCCC
      if(kgraph_restart.eq.0)go to 1111
      if(num_polpo1.gt.0)then
      do i=1,num_polpo1
         itet=1
         if(ncoord_p1(i).eq.1)then
          ntetra=ntetra+1
          ntetr(ntetra)=natomo_p1(i)
          dtetra(ntetra)=dist_p1(i)
          if(dtetra(ntetra).le.0.0.or.dtetra(ntetra).gt.dmax)then
          ferror=dtetra(ntetra)
          go to 9500
          endif
          dtolt(ntetra)=tol_dis_p1(i)
          atolt(ntetra)=tol_ang_p1(i)
          endif
         if(ncoord_p1(i).eq.2)then
          iott=1
          nott=nott+1
          notta(nott)=natomo_p1(i)
          dotta1(nott)=dist_p1(i)
          if(dotta1(nott).le.0.0.or.dotta1(nott).gt.dmax)then
          ferror=dotta1(nott)
          go to 9500
          endif
          dtolo(nott)=tol_dis_p1(i)
          atolo(nott)=tol_ang_p1(i)
        endif
      enddo
      endif
      if(num_polpo2.gt.0)then
      itimem=kmethod
      do i=1,num_polpo2
c         if(itet.eq.0.and.iott.eq.0) go to 9501
          nmiss=nmiss+1
          nfound1(nmiss)=natomo1_p2(i)
          nfound2(nmiss)=natomo2_p2(i)
          if(nfound1(nmiss).eq.nfound2(nmiss))then
          ferror=nfound1(nmiss)
          go to 9500
          endif
!corr          kmiss(nmiss)=nalf(nspec_p2(i))   
          kmiss(nmiss)=celem(nspec_p2(i))%ptab
          if(ncoord_p2(i).eq.1)then
          imiss(nmiss)=1
          else
          imiss(nmiss)=2
          endif
          dmiss(nmiss)=dist_p2(i)
          if(dmiss(i).le.0.0.or.dmiss(i).gt.dmax)then
          ferror=dmiss(i)
          go to 9500
          endif
          dtolm(nmiss)=tol_dis_p2(i)
          atolm(nmiss)=tol_ang_p2(i)
      enddo
      endif
      go to 1112
 9500 continue
      ier=-1
      write(Msg,9511) ferror
 9511 format('Error in parameter: ',f10.4)
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)
      return
 9501 continue
      ier=-1
      write(Msg,9502)
 9502 format('error in the selected coordination')
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)
      return
 1111 continue
 1112 continue
CCCC
CNEW
         if(ntetra.gt.1) then
            do i=1,ntetra
             do j=i+1,ntetra
              if(ntetr(i).eq.ntetr(j)) go to 9003
             end do
            end do
        go to 13
 9003 continue
       ier=-1
       write(Msg,9014)
 9014  format('Error. The directives tetr',
     &        ' are related to the same cation')
       call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
       return
       endif
c
 13    continue
         if(nott.gt.1) then
            do i=1,nott
             do j=i+1,nott
              if(notta(i).eq.notta(j)) go to 9004
             end do
            end do
        go to 23
 9004 continue
        ier=-1
        write(Msg,9015)
 9015   format('Error: The directives octa',
     &         ' are related to the same cation')
        call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
        return
        endif
c
 23     continue
c     ioxx=0
c     do 101 j=1,nk
c       if(no(j).eq.8)then
c       ioxx=1
c       go to 102
c       endif
c 101 continue
c     if(ioxx.eq.0)then
c       ier=-1
c       write(Msg,9115)
c9115   format('Error: The POLPO procedure',
c    &         ' can be used for oxigen completion.'
c    &         ' No oxigen is in the unit cell content.')
c       call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)
c       return
c     endif
c 102 continue
         if(itet.ne.0.and.iott.ne.0) then
          do i=1,nott
            do j=1,ntetra
             if(ntetr(j).eq.notta(i)) go to 9005
            end do 
          end do 
        return
 9005 continue
      ier=-1
      write(Msg,9016)
 9016 format(' Error: The directives octa and tetr ',
     &       ' are related to the same cation')
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      return
         endif
c
CNEW
      return
      end
c--------------------------------------------------------------
      subroutine GeneraTetraedro(xo,xxx,d1)
      USE General
*      common/trig/sint(45000),pi,twopi,dtor,rtod
c-- genera a partire dalle coordinate ortogonali il tetraedro nota
c-- la distanza d1 dell' atomo centrale dall' ossigeno (partendo da 
c--    xo coordinate ortogonali)
         dimension xo(3),xxx(4,3)
c
c--- Riportare in cella
c
         ang=109.47
         d11 = d1*cos(ang*dtor)
         d22 = d1*sin(ang*dtor)
         d33=d1*d11/d22
         a=d22**2
         b=sqrt(d22**2-(d33**2)*
     *   ((1.0-cos(ang*dtor))**2))
         b=b/d1
         xxx(1,1) = xo(1) +d1
         xxx(1,2) = xo(2) 
         xxx(1,3) = xo(3) 
         xxx(2,1) = xo(1) +d11
         xxx(2,2) = xo(2) +d22
         xxx(2,3) = xo(3) 
         xxx(3,1) = xo(1) + d11
         xxx(3,2) = xo(2) + d33*(1.0-cos(ang*dtor))
         xxx(3,3) = xo(3) + b*d1                        
         xxx(4,1) = xo(1) + d11
         xxx(4,2) = xo(2) + d33*(1.0-cos(ang*dtor))
         xxx(4,3) = xo(3) - b*d1                        
         return
         end
c-----------------------------------------------------------------
      subroutine calcolaerre(sumdif2,iprier)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE CalcProfile
      USE Atomi
      USE General
      USE Symmetry
      USE extramodule, only: inizc,ifinc
!corr      include 'rando.fi'
      USE randofi
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/stampa/istampa
      common /misc/ t(3,3),dxmax(3),mcon,iwt,fom(11)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
!corr      common /profp/phkl(3000,6),dumpp,nprof,ipol
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /fastcal/ hkle(3000,4,24),fsca(9,3000)
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common /derrig00/ act(3000),bct(3000),actd(3000,6),bctd(3000,6)
      common /shiftrig/ shiftr(7),crap(7)
      common/anna1/sumobs,sumobsnobac
!corr      common/anna2/inizc(3000),ifinc(3000)
      dimension fcalco(3000),fosse(3000)
      dimension nww(8)
      dimension xo(11),xn(11),key(10),shift(4)

c
      do 2 i=1,11
           xo(i) = 0.0
           xn(i) = 0.0
  2   continue
      do 401 j=1,nats
        xo(1)=xyzs(1,j)
        xo(2)=xyzs(2,j)
        xo(3)=xyzs(3,j)
        iser=j
        iactn=1
        khead=0
        ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
        xyzs(1,j)=xn(1)
        xyzs(2,j)=xn(2)
        xyzs(3,j)=xn(3)
        xyzs(5,j) = 1.0/float(key(10))
  401 continue
  444 continue
      do 100 i=1,nrefl
      rho=SetFob(i,5)
      act(i)=0.0
      bct(i)=0.0
      do 400 jj=1,nats
      if (nz(jj).eq.0) go to 400
      kz=abs(nz(jj)/100)
      vetint(jj)=xyzs(4,jj)
!!!   fkz=sign(fsca(kz,i),vetint(jj))
      fkz=fsca(kz,i)
      arg=-bfac(jj)*rho
      effe=pts*fkz*exp(arg)
      tfocc=effe*xyzs(5,jj)
      tfocp=tfocc*twopi
      iref=0
      call sfacyyyp(i,jj,contc,conts,tfocp,iref)
      contc=contc*tfocc
      conts=conts*tfocc
      act(i)=act(i)+contc
      bct(i)=bct(i)+conts
  400 continue
  100 continue
      do 1500 i=1,npunti
      theta_int(i,3)=0.0
      theta_int(i,5)=0.0
c     if(nmiss.gt.0)theta_int(i,5)=1.0
      theta_int(i,5)=1.0
 1500 continue
      sumfo=0.0
      sumfc=0.0
      do 2000 j=1,nrefl
      iniz = inizc(j)
      ifin = ifinc(j)
      fcalco(j)=act(j)**2+bct(j)**2
      ffx=fcalco(j)*Mult(j)*clp(j)
      fosse(j)=sqrt(SetFob(j,4))
      fcalco(j)=sqrt(fcalco(j))
      sumfo=sumfo+fosse(j)
      sumfc=sumfc+fcalco(j)
      do 611 nnn=iniz,ifin
      theta_int(nnn,3)=theta_int(nnn,3)+ffx*profcalc(j,nnn-iniz+1)
      theta_int(nnn,5)=1.0                                   
  611 continue
 2000 continue
      sumo=0.0
      sumc=0.0
      do 3000 i=1,npunti
      sumc=sumc+theta_int(i,3)
      sumo=sumo+(theta_int(i,2)-back_int(i,2))
 3000 continue
      if(sumc.lt.-0.00000001.or.sumc.gt.0.000000001)then
      scal=sumo/sumc
      else
      scal=0.0
      endif
      sumdif2=0.0
      sumdif=0.0
      sumobs=0.0
      sumobs1=0.0
      do 5000 i=1,npunti
      if(theta_int(i,5).lt.1.0)go to 5000
      if(theta_int(i,2).gt.0.0)then
      peso=1.0/theta_int(i,2)
      else
      peso=0.0
      endif
c     if(nmiss.gt.0)peso=sqrt(peso)
      peso=sqrt(peso)
      diff=theta_int(i,2)-back_int(i,2)-scal*theta_int(i,3)
      sumdif2=sumdif2+((diff)**2)*peso
      sumobs=sumobs+peso*(theta_int(i,2)**2)
      if((theta_int(i,2)-back_int(i,2)).gt.0.0)then
      sumdif=sumdif+abs(diff)*peso
      sumobs1=sumobs1+abs(theta_int(i,2)-back_int(i,2))
      endif
 5000 continue
      ntrial = ntrial + 1
      sumdif2=sumdif2/sumobs
c     sumdif2=sumdif2/float(npunti)
      sumdif2=sqrt(sumdif2)
c     if(nmiss.gt.0)sumdif2=(sumdif/sumobs1)*100.0
      sumdif2=(sumdif/sumobs1)*100.0
      if(iprier.gt.0)then
      if(nmiss.eq.0)then
c     write(lo,'(/,a,f25.5,a,i7)')'  chi2 minimized function',sumdif2,
c    *' trial #',ntrial
c     write(lo,'(/,a,f8.3,a,i7)')'     R-profile',sumdif/sumobs,
c    *' trial #',ntrial
      else
      if(istampa.gt.0)then
      if(ntrial.eq.1)then
      write(lo,'(/,a,f25.5,a,a)')'  fom  minimized function',sumdif2,
     *' trial :',' starting'
      else
      write(lo,'(/,a,f25.5,a,i7)')'  fom  minimized function',sumdif2,
     *' trial #',ntrial
      endif
      endif
      endif
      endif
c----
      return
      end
c-----------------------------------------------------------------------
c     structure factor calculation
      subroutine sfacyyyp(i,jj,contc,conts,tfocp,iref)
      USE Atomi
c
      USE General
      USE Symmetry
      common/stampa/istampa
      common /fastcal/ hkle(3000,4,24),fsca(9,3000)
c
      at=0.0
      bt=0.0
      do 1000 j=1,nsym
      arg=amod(hkle(i,1,j)*xyzs(1,jj)
     *        +hkle(i,2,j)*xyzs(2,jj)
     *        +hkle(i,3,j)*xyzs(3,jj)
     *        +hkle(i,4,j),1.0)
      iarg=int(36000.0*arg+0.5)+1
      if(iarg.eq.36001) iarg=1
      if(iarg.le.0)iarg=36000+iarg
      at=at+cost(iarg)
      bt=bt+sint(iarg)
c     write(6,'(a,i6,6f10.4)') 'tua ',iarg-1,
c    *       dtor*float(iarg-1)/100.,
c    *      (arg*twopi),
c    *      cost(iarg),cos(twopi*arg),sint(iarg),sin(twopi*arg)
 1000 continue
      if (icent.eq.0) then
                        contc=at
                        conts=bt
                      else
                        contc=2.0*at
                        conts=0.0
                      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine buildtetra(kkk,iarret)
      Use Polpo
      USE Atomi
      USE General
      USE elements, only: pxen_from_specie,numelem
!corr      include 'rando.fi'
      USE randofi
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/chiquadro/chimin,chisquared,ntrialmin,chichi(150),
     *                 xchi(5,500,150),nzchi(500,150),natschi(150),
     *                 ntrialmn
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/stampa/istampa
      common/Gmatrix/ggMat(3,3)
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/occtetra/it(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /matr/rmz(3,3),rmiz(3,3)
      common/tetrafree/ nats1(10),nats2(10),nate,k1(10),k2(10),iox(500)
     *,libt(10)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      dimension xorig(3),x1(3),xo(3),x2(3),x3(3),xxxx(4,3)
      dimension xoo(11),xn(11),key(10)
      dimension itsav(500)
      character oo*2                             
c
      oo(1:2)='o '
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      do jk=1,10
      libt(jk)=0
      end do
      dsog=0.6
      dsogok=0.6
      if(nmiss.ne.0)then
c     dsog=0.4
c     dsogok=0.4
CATT  dsog=0.4
      dsog=0.4
      dsogok=0.5
      endif
      doxigen = 1.6
      do 2 i=1,11
           xoo(i) = 0.0
           xn(i) = 0.0
  2   continue
      i=kkk
      nat1=nats
      alfa=109.47*dtor
      jj=ntetr(i)
CATT  jj=kkk
CATT  ipp(i)=jj
      do 200 j=1,numelem(celem)
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          jsav=j
          go to 203
      endif
  200 continue
  203 continue
      xorig(1)=xyzs(1,jj)
      xorig(2)=xyzs(2,jj)
      xorig(3)=xyzs(3,jj)
CORO
      itsav(jj)=it(jj)
CORO
 1000 continue
      if(it(jj).eq.0)then
      iaccet=0
      xo(1)=0.0
      xo(2)=0.0
      xo(3)=0.0
      d1=dtetra(i)
      call GeneraTetraedro(xo,xxxx,d1)
      do 150 k=1,4
      x1(1)=xxxx(k,1)
      x1(2)=xxxx(k,2)
      x1(3)=xxxx(k,3)
      call molt1_rot(rmiz, x1, xo)
      if(iaccet.ne.0) then
      natsav=nats
      nats=nats-iaccet
      endif
      do 500 ijk=1,nats
      x1(1)=xo(1)+xorig(1)
      x1(2)=xo(2)+xorig(2)
      x1(3)=xo(3)+xorig(3)
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
c     call distanzaeq_old(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
      iarret=-1
      return
      endif
 500  continue
      if(iaccet.ne.0) nats=natsav
      iaccet=iaccet+1
      nats=nats+1
c----
c---- check posizioni speciali
c----
      xoo(1)=x1(1) 
      xoo(2)=x1(2)
      xoo(3)=x1(3)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
c----
      x1(1)=xn(1) 
      x1(2)=xn(2)
      x1(3)=xn(3)
      xyzs(1,nats)=xn(1)
      xyzs(2,nats)=xn(2)
      xyzs(3,nats)=xn(3)
      xyzs(4,nats)=vetintsav
c----
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.*biso          
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
      it(jj)=it(jj)+1
      xt(1,jj,it(jj))=xyzs(1,nats)
      xt(2,jj,it(jj))=xyzs(2,nats)
      xt(3,jj,it(jj))=xyzs(3,nats)
      ntt(jj,it(jj))=nats
c----------
      iesit=0
      call checkequivtb(x1,jj,jj,iesit)
      if(ntetra.gt.0)call checkequivt(x1,jj,jj)
      if(nott.gt.0)call checkequivo(x1,jj,jj)
      if (iesit.eq.1) go to 1000
c----------
 501  continue
 150  continue
      elseif(it(jj).eq.1)then
      iok=0
 506  continue
      d1=dtetra(i)
      x1(1)=xt(1,jj,it(jj))-xorig(1)
      x1(2)=xt(2,jj,it(jj))-xorig(2)
      x1(3)=xt(3,jj,it(jj))-xorig(3)
      call molt1_rot(rmz, x1, x2)
      call generat1(x2,d1,alfa,x3,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x3, xo)
      do 510 ijk=1,nats
      x2(1)=xo(1)+xorig(1)
      x2(2)=xo(2)+xorig(2)
      x2(3)=xo(3)+xorig(3)
      x1(1)=xyzs(1,ijk)
      x1(2)=xyzs(2,ijk)
      x1(3)=xyzs(3,ijk)
c     call distanzaeq_old(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
CANGE if(dcal.lt.dsogok) then
      if(dcal.lt.dsog) then
      iarret=-1
      return
      endif
 510  continue
      nats=nats+1
c----
c---- check posizioni speciali
c----
      xoo(1)=x2(1) 
      xoo(2)=x2(2)
      xoo(3)=x2(3)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
c----
      xyzs(1,nats)=xn(1)
      xyzs(2,nats)=xn(2)
      xyzs(3,nats)=xn(3)
      x2(1)=xn(1) 
      x2(2)=xn(2)
      x2(3)=xn(3)
      xyzs(4,nats)=vetintsav
c----
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.0*biso          
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
      it(jj)=it(jj)+1
      xt(1,jj,it(jj))=xyzs(1,nats)
      xt(2,jj,it(jj))=xyzs(2,nats)
      xt(3,jj,it(jj))=xyzs(3,nats)
      ntt(jj,it(jj))=nats
c----------
      iesit=0
      call checkequivtb(x2,jj,jj,iesit)
      if(ntetra.gt.0)call checkequivt(x2,jj,jj)
      if(nott.gt.0)call checkequivo(x2,jj,jj)
      if (iesit.eq.1) go to 1000
c----------
 511  continue
      do 295 k=it(jj)+1,4
      iok=0
 293  continue
      d1=dtetra(i)
      x1(1)=xt(1,jj,k-2)-xorig(1)
      x1(2)=xt(2,jj,k-2)-xorig(2)
      x1(3)=xt(3,jj,k-2)-xorig(3)
      call molt1_rot(rmz, x1, x2)
      x1(1)=xt(1,jj,k-1)-xorig(1)
      x1(2)=xt(2,jj,k-1)-xorig(2)
      x1(3)=xt(3,jj,k-1)-xorig(3)
      call molt1_rot(rmz, x1, x3)
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x1, xo)
      do 519 ijk=1,it(jj)
      x1(1)=xo(1)+xorig(1)
      x1(2)=xo(2)+xorig(2)
      x1(3)=xo(3)+xorig(3)
      x2(1)=xt(1,jj,ijk)
      x2(2)=xt(2,jj,ijk)
      x2(3)=xt(3,jj,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      endif
      endif
 519  continue
      do 520 ijk=1,nats
      x1(1)=xo(1)+xorig(1)
      x1(2)=xo(2)+xorig(2)
      x1(3)=xo(3)+xorig(3)
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
c     call distanzaeq_old(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
CANGE if(dcal.lt.dsogok)then
      if(dcal.lt.dsog)then
      iarret=-1
      return
      endif
 520  continue
      nats=nats+1
c----
c---- check posizioni speciali
c----
      xoo(1)=x1(1) 
      xoo(2)=x1(2)
      xoo(3)=x1(3)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
c----
      xyzs(1,nats)=xn(1)
      xyzs(2,nats)=xn(2)
      xyzs(3,nats)=xn(3)
      x1(1)=xn(1) 
      x1(2)=xn(2)
      x1(3)=xn(3)
      xyzs(4,nats)=vetintsav
c----
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.0*biso          
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
      it(jj)=it(jj)+1
      xt(1,jj,it(jj))=xyzs(1,nats)
      xt(2,jj,it(jj))=xyzs(2,nats)
      xt(3,jj,it(jj))=xyzs(3,nats)
      ntt(jj,it(jj))=nats
c----------
      iesit=0
      call checkequivtb(x1,jj,jj,iesit)
      if(ntetra.gt.0)call checkequivt(x1,jj,jj)
      if(nott.gt.0)call checkequivo(x1,jj,jj)
      if (iesit.eq.1) go to 1000
c----------
 521  continue
 295  continue
      else
      do 300 k=it(jj)+1,4
      iok=0
 393  continue
      d1=dtetra(i)
      x1(1)=xt(1,jj,k-2)-xorig(1)
      x1(2)=xt(2,jj,k-2)-xorig(2)
      x1(3)=xt(3,jj,k-2)-xorig(3)
      call molt1_rot(rmz, x1, x2)
      x1(1)=xt(1,jj,k-1)-xorig(1)
      x1(2)=xt(2,jj,k-1)-xorig(2)
      x1(3)=xt(3,jj,k-1)-xorig(3)
      call molt1_rot(rmz, x1, x3)
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x1, xo)
      do 529 ijk=1,it(jj)
      x1(1)=xo(1)+xorig(1)
      x1(2)=xo(2)+xorig(2)
      x1(3)=xo(3)+xorig(3)
      x2(1)=xt(1,jj,ijk)
      x2(2)=xt(2,jj,ijk)
      x2(3)=xt(3,jj,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  393
      endif
      endif
 529  continue
      do 530 ijk=1,nats
      x1(1)=xo(1)+xorig(1)
      x1(2)=xo(2)+xorig(2)
      x1(3)=xo(3)+xorig(3)
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
c     call distanzaeq_old(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
CANGE if(dcal.lt.dsogok)then
      if(dcal.lt.dsog)then
      iarret=-1
      return
      endif
 530  continue
      angsog1 = 109.47*(1.0-atolt(jj))
      angsog2 = 109.47*(1.0+atolt(jj))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      do 551 ii=1,it(jj)
      x2(1)=xyzs(1,jj)
      x2(2)=xyzs(2,jj)
      x2(3)=xyzs(3,jj)
      x3(1)=xt(1,jj,ii)
      x3(2)=xt(2,jj,ii)
      x3(3)=xt(3,jj,ii)
      call angolon2(ggMat,x1,x2,x3,ang1)
      if (ang1.lt.angsog1.or.ang1.gt.angsog2) then
      iarret=-1
      return
      endif
 551  continue
      nats=nats+1
c----
c---- check posizioni speciali
c----
      xoo(1)=x1(1) 
      xoo(2)=x1(2)
      xoo(3)=x1(3)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
c----
      xyzs(1,nats)=xn(1)
      xyzs(2,nats)=xn(2)
      xyzs(3,nats)=xn(3)
      x1(1)=xn(1) 
      x1(2)=xn(2)
      x1(3)=xn(3)
      xyzs(4,nats)=vetintsav
c----
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.0*biso          
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
      it(jj)=it(jj)+1
      xt(1,jj,it(jj))=xyzs(1,nats)
      xt(2,jj,it(jj))=xyzs(2,nats)
      xt(3,jj,it(jj))=xyzs(3,nats)
      ntt(jj,it(jj))=nats
c----------
      iesit=0
      call checkequivtb(x1,jj,jj,iesit)
      if(ntetra.gt.0)call checkequivt(x1,jj,jj)
      if(nott.gt.0)call checkequivo(x1,jj,jj)
      if (iesit.eq.1) go to 1000
c----------
 531  continue
 300  continue
      endif
      ndifnats=nats-nat1
      itdif=it(jj)-itsav(jj)
c--------
      if(nmiss.gt.0)go to 609
      do 600 il=1,ilinka
      ilk=iordcon(il)
      n00=0
      if(nlinka(1,ilk).eq.jj) then
CANG
      do 601 ijk=2,nlegat(ilk)
      if(nlinka(ijk,ilk).ne.jj) n00=n00+1
 601  continue
CANG
CANG     if (nlegat(ilk).gt.1) return
         if (n00.gt.1) return
      endif
 600  continue
 609  continue
c--------
      if(ndifnats.eq.3.or.ndifnats.eq.4.or.itdif.eq.3.or.itdif.eq.4)then
      nate=nate+1
      nats2(nate)=nats
      nats1(nate)=nat1+1
      k1(nate)=jj
      k2(nate)=ntt(jj,1)
      endif
      if(ndifnats.eq.4.or.itdif.eq.4) libt(nate)=nate
      return
      end
c-----------------------------------------------------------------
      subroutine genera0(i1,i2,x1,d1,d2,x2,iok,ier)
      USE General
      dimension x1(3),x2(3)
c
c---- se un lato e' > della somma degli altri due mettere
      zero=0.0001
      d = sqrt(x1(1)**2+x1(2)**2+x1(3)**2)
      if (d.gt.(d1+d2)) then
      if(i1.ne.0.and.i2.ne.0)then
      write(lo,100)d1,i1,d2,i2
*         write(6,*) ' Aumentare d1 e/o d2, nella genera0 radice negat.'   
 100  format(/,' *** Increase the coordination distance',f8.3,
     *         ' of cation',i3,/,
     *         ' and/or the coordination distance', f8.3,' of the ' 
     *         'cation',i3,' *** ',/)
      else
      write(lo,101)d1,d2
 101  format(/,' *** Increase the cation-anion distances,',
     *        2f8.3,' *** ',/)
      endif
          ier=-1
          return
      endif
c--------------
      if(abs(x1(1)).lt.zero.and.abs(x1(3)).lt.zero)then
      da=(d1**2+x1(2)**2-d2**2)/(2.0*x1(2))
      daa=d1**2-da**2
      if(iok.eq.0)then
      x2(1)=sqrt(daa)
      else
      x2(1)=-sqrt(daa)
      endif
      x2(2)=da
      x2(3)=0.0
      return
c--------------
      elseif(abs(x1(1)).lt.zero.and.abs(x1(2)).lt.zero)then
      da=(d1**2+x1(3)**2-d2**2)/(2.0*x1(3))
      daa=d1**2-da**2
      if(iok.eq.0)then
      x2(2)=sqrt(daa)
      else
      x2(2)=-sqrt(daa)
      endif
      x2(3)=da
      x2(1)=0.0
      return
c--------------
      elseif(abs(x1(2)).lt.zero.and.abs(x1(3)).lt.zero)then
      da=(d1**2+x1(1)**2-d2**2)/(2.0*x1(1))
      daa=d1**2-da**2
      if(iok.eq.0)then
      x2(3)=sqrt(daa)
      else
      x2(3)=-sqrt(daa)
      endif
      x2(1)=da
      x2(2)=0.0
      return
      endif
c--------------
      dd=(d1**2+d**2-d2**2)/2.0
c--------------
      if(x1(1).eq.0.0) then
      x2(1)=0.0
      a=dd/x1(2)
      b=x1(3)/x1(2) 
      c=(a*b)**2-(1.0+b**2)*(a**2-d1**2)
      cc=sqrt(c)
      if(iok.eq.0)then
      x2(3)=(a*b+cc)/(1.0+b**2)
      else
      x2(3)=(a*b-cc)/(1.0+b**2)
      endif
      x2(2)=a-b*x2(3)
      return
      endif
c--------------
      if(x1(2).eq.0.0) then
      x2(2)=0.0
      a=dd/x1(1)
      b=x1(3)/x1(1) 
      c=(a*b)**2-(1.0+b**2)*(a**2-d1**2)
      cc=sqrt(c)
      if(iok.eq.0)then
      x2(3)=(a*b+cc)/(1.0+b**2)
      else
      x2(3)=(a*b-cc)/(1.0+b**2)
      endif
      x2(1)=a-b*x2(3)
      return
      endif
c--------------
      x2(3)=0.0             
      a=dd/x1(1)
      b=x1(2)/x1(1)
      c=(a*b)**2-(1.0+b**2)*(a**2-d1**2)
      cc=sqrt(c)
      if(iok.eq.0)then
      x2(2)=(a*b+cc)/(1.0+b**2)
      else
      x2(2)=(a*b-cc)/(1.0+b**2)
      endif
      x2(1)=a-b*x2(2)
      return
      end
c--------------------------------------------------------------
      subroutine generat1(x1,d,alfa,x2,iok,iarret)
      USE General
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/stampa/istampa
      dimension x1(3),x2(3)
c
      zero=1.0E-5
      c1=cos(alfa)
      if(abs(c1).lt.zero)c1=0.0
      d1=sqrt(x1(1)**2+x1(2)**2+x1(3)**2)
CORO
      if(abs(x1(1)).lt.zero.and.abs(x1(2)).lt.zero)then
        x2(1)=0.0
        x2(3)=(d*d1*c1)/x1(3)
        r=(d**2)-x2(3)**2
        if(r.gt.0.0) then
         r=sqrt(r)
         if(iok.eq.0)then
          x2(2)=r
         else    
          x2(2)=-r
         endif
        else
c         write(6,*) ' ---------------------------'
c         write(6,*) ' Radice negativa in generat1'
c         write(6,*) ' ---------------------------'
          iarret = -1
          return
        endif
        return
      endif
c---------------
      if(abs(x1(1)).lt.zero.and.abs(x1(3)).lt.zero)then
        x2(1)=0.0
        x2(2)=(d*d1*c1)/x1(2)
        r=(d**2)-x2(2)**2
        if(r.gt.0.0) then
         r=sqrt(r)
         if(iok.eq.0)then
          x2(3)=r
         else    
          x2(3)=-r
         endif
        else
c         write(6,*) ' ---------------------------'
c         write(6,*) ' Radice negativa in generat1'
c         write(6,*) ' ---------------------------'
          iarret = -1
          return
        endif
        return
      endif
c---------------
      if(abs(x1(2)).lt.zero.and.abs(x1(3)).lt.zero)then
        x2(2)=0.0
        x2(1)=(d*d1*c1)/x1(1)
        r=(d**2)-x2(1)**2
        if(r.gt.0.0) then
         r=sqrt(r)
         if(iok.eq.0)then
          x2(3)=r
         else    
          x2(3)=-r
         endif
        else
c         write(6,*) ' ---------------------------'
c         write(6,*) ' Radice negativa in generat1'
c         write(6,*) ' ---------------------------'
          iarret = -1
          return
        endif
        return
      endif
c---------------
      if(abs(x1(2)).lt.zero)then
         a=x1(1)**2+x1(3)**2
         b=d*d1*x1(3)*c1            
         c=(d*d1*c1)**2-(x1(1)*d)**2
         x2(2)=0.0
         r=(b**2)-a*c
       if(r.gt.0.0)then
         r=sqrt(r)
         if(iok.eq.0)then
          x2(3)=(b+r)/a
         else
          x2(3)=(b-r)/a
         endif
          x2(1)=d*d1*c1/x1(1)-x2(3)*x1(3)/x1(1)
       else
c         write(6,*) ' ---------------------------'
c         write(6,*) ' Radice negativa in generat1'
c         write(6,*) ' ---------------------------'
          iarret = -1
          return
       endif
       return
      endif
c---------------
      if(abs(x1(1)).lt.zero)then
         a=x1(2)**2+x1(3)**2
         b=d*d1*x1(3)*c1            
         c=(d*d1*c1)**2-(x1(2)*d)**2
         x2(1)=0.0
         r=(b**2)-a*c
       if(r.gt.0.0)then
        r=sqrt(r)
        if(iok.eq.0)then
         x2(3)=(b+r)/a
        else
         x2(3)=(b-r)/a
        endif
         x2(2)=d*d1*c1/x1(2)-x2(3)*x1(3)/x1(2)
       else
c         write(6,*) ' ---------------------------'
c         write(6,*) ' Radice negativa in generat1'
c         write(6,*) ' ---------------------------'
          iarret = -1
          return
       endif
       return
      endif
c---------------
      a=x1(1)**2+x1(2)**2
      c=(d**2)*(d1**2)*(c1**2)-(x1(1)**2)*(d**2)
CORO
c     if(sqrt(a).gt.(d+0.0001)) then
c      write(6,*) 'A>D IN GENERAT1',sqrt(a),d+0.0001
c      iarret = -1
c      return
c     endif
CORO
      b=d*d1*x1(2)*c1            
      x2(3)=0.0
      r=(b**2)-a*c
      if(r.gt.0.0)then
      r=sqrt(r)
      if(iok.eq.0)then
      x2(2)=(b+r)/a
      else
      x2(2)=(b-r)/a
      endif
      x2(1)=d*d1*c1/x1(1)-x2(2)*x1(2)/x1(1)
      else
      a=x1(1)**2+x1(3)**2
      b=d*d1*x1(3)*c1            
      c=(d*d1*c1)**2-(x1(1)*d)**2
      x2(2)=0.0
      r=(b**2)-a*c
      if (r.lt.0.0) then
c         write(6,*) ' ---------------------------'
c         write(6,*) ' Radice negativa in generat1'
c         write(6,*) ' ---------------------------'
          iarret = -1
          return
      endif
      r=sqrt(r)
      if(iok.eq.0)then
      x2(3)=(b+r)/a
      else
      x2(3)=(b-r)/a
      endif
      x2(1)=d*d1*c1/x1(1)-x2(3)*x1(3)/x1(1)
      endif
      return
      end 
c--------------------------------------------------------------
      subroutine generat2(x1,x2,d,alfa,x3,iok,iarret)
      USE General
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/stampa/istampa
      dimension x1(3),x2(3),x3(3)
      double precision a,b,c,dprimo,r,s,t,rr,xx1,xx2
c
      zero=1.0E-5
      zero1=1.0E-30
      c1=cos(alfa)
      if(abs(c1).lt.zero)c1=0.0
CORO
c     if(abs(x1(1)).lt.zero.and.abs(x1(2)).lt.zero.and
c    *.abs(x2(1)).lt.zero) then
c     d1a=x1(3)
c     d2a=x2(2)**2+x2(3)**2
c     x3(3)=d*d1a*c1/x1(3)
c     e=(d*d2a*c1)/x2(2)
c     ee=(d*d1a*c1*x2(3))/(x2(2)*x1(3))
c     eee=e-ee
c     x3(2)=eee
c     r=-eee**2+d**2-x3(3)**2
c     if (r.lt.0.0) then
c         write(6,*) ' ---------------------------'
c         write(6,*) ' Radice negativa in generat2'
c         write(6,*) ' ---------------------------'
c         iarret = -1
c         return
c     endif
c     r=sqrt(r)
c     if(iok.eq.0)then
c     x3(1)=r
c     else
c     x3(1)=-r
c     endif
c     per=-x3(1)*x2(2)
c     if(abs(per).lt.zero.and.iok.eq.0)then
c     x3(1)=-r
c     else
c     x3(1)=+r
c     endif
c     return
c     endif
CORO
      if(abs(x1(1)).lt.zero.and.abs(x1(2)).lt.zero.
     *and.x2(1).gt.zero.and.x1(3).gt.zero) then
      d1a=x1(3)
      d2a=x2(1)**2+x2(2)**2+x2(3)**2
      x3(3)=d*d1a*c1/x1(3)
      a1=d*d2a*c1/x2(1)
      a2=(d*d1a*c1*x2(3))/(x2(1)*x1(3))
      a=a1-a2
      b=1.0+(x2(2)**2)/(x2(1)**2)
      c=a*(x2(2)/x2(1))
      ee=(d*d1a*c1/x1(3))**2
      e=(a**2)-(d**2)+ee
      r=(c**2)-e*b
      if (r.lt.0.0) then
c         write(6,*) ' ---------------------------'
c         write(6,*) ' Radice negativa in generat2'
c         write(6,*) ' ---------------------------'
          iarret = -1
          return
      endif
      r=sqrt(r)
      if(iok.eq.0)then
      x3(2)=(c+r)/b
      else
      x3(2)=(c-r)/b
      endif
      x3(1)=a-x3(2)*x2(2)/x2(1)
      per=x2(1)*x3(2)-x3(1)*x2(2)
      if(abs(per).lt.zero.and.iok.eq.0)then
      x3(2)=(c-r)/b
      x3(1)=a-x3(2)*x2(2)/x2(1)
      elseif(abs(per).lt.zero.and.iok.eq.1)then
      x3(2)=(c+r)/b
      x3(1)=a-x3(2)*x2(2)/x2(1)
      endif 
      return
      endif
CORO
      d1a=sqrt(x1(1)**2+x1(2)**2+x1(3)**2)
      d2a=sqrt(x2(1)**2+x2(2)**2+x2(3)**2)
      xx1=(x2(1)*x1(3)-x1(1)*x2(3))
      xx2=(x1(1)*x2(2)-x2(1)*x1(2))
c----
      if (abs(xx2).lt.zero1) then 
      if (alfa.gt.1.570.and.alfa.lt.1.571)then
      a1=abs(x1(1)+x2(1))
      a2=abs(x1(2)+x2(2))
      a3=abs(x1(3)+x2(3))
      if(a1.lt.zero.and.a2.lt.zero.and.a3.lt.zero)then
      aa=(d**2)/(1.0+(x1(3)/x1(2))**2)
      if(aa.lt.0.0)then
      iarret=-1
      return
      endif
      if(iok.eq.0)then
      x3(3)=sqrt(aa)
      else
      x3(3)=-sqrt(aa)
      endif
      x3(1)=0.0
      x3(2)=-x3(3)*x1(3)/x1(2)
      return
      endif
      endif
         iarret = -1
*        write(6,*)' ----------------------------'
*        write(6,*)' denominatore = 0 nella generat2'
*        write(6,*)' ----------------------------'
         return
      endif
c----
      a=xx1/xx2                                                
      b=(d*c1*(d2a*x1(1)-d1a*x2(1)))/xx2                               
c----
      if (abs(x1(1)).lt.zero) then 
      if (x1(2).ne.0.0.and.x2(1).ne.0.0) then 
         aa=(x1(3)*x2(2))/(x1(2)*x2(1))-x2(3)/x2(1)
         aa=aa**2
         bb=-x1(3)/x1(2)
         bb=bb**2
         ee=(d**2)/(1.0+aa+bb)
         if(ee.lt.0.0)then
         iarret=-1
         return
         endif
         if(iok.eq.0)then
         x3(3)=sqrt(ee)
         else
         x3(3)=-sqrt(ee)
         endif
         x3(2)=-x3(3)*x1(3)/x1(2)
         fff=(x1(3)*x2(2))/(x1(2)*x2(1))-(x2(3)/x2(1))
         x3(1)=x3(3)*fff
         return
         endif
         iarret = -1
*        write(6,*)' ------------------------'
*        write(6,*)' X1(1) = 0 nella generat2'
*        write(6,*)' ------------------------'
         return
      endif
      if (abs(x2(1)).lt.zero) then 
      if (x2(2).ne.0.0.and.x1(1).ne.0.0) then 
         aa=(x2(3)*x1(2))/(x2(2)*x1(1))-x1(3)/x1(1)
         aa=aa**2
         bb=-x2(3)/x2(2)
         bb=bb**2
         ee=(d**2)/(1.0+aa+bb)
         if(ee.lt.0.0)then
         iarret=-1
         return
         endif
         if(iok.eq.0)then
         x3(3)=sqrt(ee)
         else
         x3(3)=-sqrt(ee)
         endif
         x3(2)=-x3(3)*x2(3)/x2(2)
         fff=(x2(3)*x1(2))/(x2(2)*x1(1))-(x1(3)/x1(1))
         x3(1)=x3(3)*fff
         return
         endif
         iarret = -1
*        write(6,*)' ------------------------'
*        write(6,*)' X1(1) = 0 nella generat2'
*        write(6,*)' ------------------------'
         return
      endif
c----
      c=((d*d1a)*c1/x1(1))-x1(2)*b/x1(1)
      dprimo=(x1(2)*a/x1(1))+x1(3)/x1(1)
      t=(dprimo**2)+(a**2)+1.0
      r=c*dprimo-a*b
      s=b**2+c**2-d**2
      rr=r**2-s*t
      if (rr.lt.0.0) then
c         write(6,*) ' ---------------------------'
c         write(6,*) ' Radice negativa in generat2'
c         write(6,*) ' ---------------------------'
          iarret = -1
          return
      endif
      rr=sqrt(rr)
      if(iok.eq.0)then
      x3(3)=(r+rr)/t
      else
      x3(3)=(r-rr)/t
      endif
      x3(2)=a*x3(3)+b
      x3(1)=c-dprimo*x3(3)
      per=x2(1)*x3(2)-x3(1)*x2(2)
      if(abs(per).lt.zero.and.iok.eq.0)then
      x3(3)=(r-rr)/t
      x3(2)=a*x3(3)+b
      x3(1)=c-dprimo*x3(3)
      elseif(abs(per).lt.zero.and.iok.eq.1)then
      x3(3)=(r+rr)/t
      x3(2)=a*x3(3)+b
      x3(1)=c-dprimo*x3(3)
      endif 
      return
      end
c--------------------------------------------------------------
      subroutine generat0(x1,x2,d1,d,alfa,x3)
      USE General
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/stampa/istampa
      dimension x1(3),x2(3),x3(3)
c
      x3(3)=0.0
      zero=1.0E-5
      c1=cos(alfa)
      if(abs(c1).lt.zero)c1=0.0
      d3=sqrt(x2(1)**2+x2(2)**2+x2(3)**2)
      d2=sqrt(x1(1)**2+x1(2)**2+x1(3)**2)
      a1=(d**2-d1**2+d3**2)/2.0
      a1=a1/x2(1)                    
      a2=x2(2)/x2(1)                  
      b1=d2*d*c1-a1*x1(1)
      b2=x1(2)-a2*x1(1)                 
      x3(2)=b1/b2
      x3(1)=a1-a2*x3(2)
      return
      end
c-----------------------------------------------------------------
      subroutine legati(nvolte,nvosta,iarret,ier)          
      Use Polpo
      USE Atomi
      USE General
      USE elements, only: pxen_from_specie,numelem
!corr      include 'rando.fi'
      USE randofi
      character oo*2                             
      common/connet/nvol,idem,jlsav,x22(3,500),isavsym(20),i1sav(20),
     *i2sav(20),savjj,istatus,ksavcen(20)
      common/salvax/xxsav(5,500)
      common/stampa/istampa
      common/lievrot/iruotat
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/chiquadro/chimin,chisquared,ntrialmin,chichi(150),
     *                 xchi(5,500,150),nzchi(500,150),natschi(150),
     *                 ntrialmn
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/tetrafree/ nats1(10),nats2(10),nate,k1(10),k2(10),iox(500)
     *,libt(10)
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/occtetra/it(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/itsalva/itsalva(500),xtsalva(3,500,500),nttsalva(500,500)
      common /matr/rmz(3,3),rmiz(3,3)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common /matr1/ rx(3,3),ry(3,3),rz(3,3)
      common/Gmatrix/ggMat(3,3)
      common/partenza/istart00,istart(500),natspa,istart0,isalva
      common/sstart/itstart(500),xtstart(3,500,500)
      common/nstartt/nstart0
      dimension x1(3),x2(3),x3(3),x4(3),xorig(3)
      dimension x11(3),xo(3),dp(500)
      dimension xx1(3),xp(3),xx2(3),xtet(4,4),xxt(3)
      dimension xoo(11),xn(11),key(10),xm(3),xotta(4,6)
c
      iruotat=0
      oo(1:2)='o '
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      do 60 i=1,11  
      xoo(i)=0.0
 60   continue
      if(isalva.eq.1)then
      istart0=istart00
      do 70 i=1,nats
      it(i)=0
      itsalva(i)=0
      do 75 j=1,nats
      istart(j)=0
      xt(1,i,j)=0.0
      xt(2,i,j)=0.0
      xt(3,i,j)=0.0
      ntt(i,j)=0
      xtsalva(1,i,j)=0.0
      xtsalva(2,i,j)=0.0
      xtsalva(3,i,j)=0.0
      nttsalva(i,j)=0
  75  continue
  70  continue
      istart(1)=1          
      endif
      do 2 i=1,11
           xoo(i) = 0.0
           xn(i) = 0.0
  2   continue
      dsog=0.6
      dsogok=0.6
      doxigen = 2.0
      if(nvolte.eq.1)nstart0=0
      zero=1.E-5
      natspa=nats
      do 101 j=1,numelem(celem)
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          jsav=j
          go to 103
      endif
  101 continue
  103 continue
      ilegati=0
c-----------
c     write(6,*)' NVOLTE e NATS in legati',nvolte,nats
c-----------
      do 100 kkkk=1,ilinka
      i=iordcon(kkkk)
      do 1071 k=1,nats
      it(k)=itsalva(k)
      do 1076 j=1,nats
      xt(1,k,j)=xtsalva(1,k,j)
      xt(2,k,j)=xtsalva(2,k,j)
      xt(3,k,j)=xtsalva(3,k,j)
      ntt(k,j)=nttsalva(k,j)
 1076 continue
 1071 continue
CABBA
CABBA if(i.lt.isalva)go to 100
      if(kkkk.lt.isalva)go to 100
CABBA
      i1=nlinka(1,i)
      i2=nlinka(2,i)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      do 611 k=1,ntetra
      i3=ntetr(k)
      if(i1.eq.i3) icod1=4
      if(i2.eq.i3) icod2=4
 611  continue
      do 612 k=1,nott
      i3=notta(k)
      if(i1.eq.i3) icod1=6
      if(i2.eq.i3) icod2=6
 612  continue
      if(it(i1).eq.icod1)go to 100
      if(it(i2).eq.icod2)go to 100
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      d1=dlinka(1,i)
      d2=dlinka(2,i)
      dp(i1)=d1
      dp(i2)=d2
      if(((kkkk.eq.1.and.nvolte.eq.1).or.
     *(kkkk.gt.1.and.it(i1).eq.0)))then
      iok=0
 499  continue
      ilegati=1
      x1(1)=xeql(1,2,i)-xyzs(1,i1)
      x1(2)=xeql(2,2,i)-xyzs(2,i1)
      x1(3)=xeql(3,2,i)-xyzs(3,i1)
      call molt1_rot(rmz, x1, x2)
      dis=sqrt(x2(3)**2+x2(2)**2)
      tet=acos(x2(2)/dis)
      coss=x2(2)/dis
      sinn=x2(3)/dis
      do 89 k=1,2
      call MatRx(tet)
      do j=1,3
       x11(j)=x2(j)          
      end do
      call molt1_rot(rx, x11, x4)
      d1=dp(i1)
      d2=dp(i2)
      if(abs(x4(3)).gt.zero)then
      tet=-tet
      else
      go to 90
      endif
 89   continue
 90   continue
c     write(6,*)'GENERA0',i1,i2
      call genera0(i1,i2,x4,d1,d2,x3,iok,ier)
      if (ier.eq.-1) return
      tet=-tet
      call MatRx(tet)
      do j=1,3
        x11(j)=x3(j)
      end do
      call molt1_rot(rx, x11, x3)
      call molt1_rot(rmiz, x3, xo)
      x2(1)=xo(1)+xyzs(1,i1)
      x2(2)=xo(2)+xyzs(2,i1)
      x2(3)=xo(3)+xyzs(3,i1)
      do 500 ijk=1,nats
      x1(1)=xyzs(1,ijk)
      x1(2)=xyzs(2,ijk)
      x1(3)=xyzs(3,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok) then
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       go to 100
CORO  iarret=-1
CORO  go to 3000
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      endif
 500  continue
      nats=nats+1
      nstart0=nstart0+1
      istart0=nats
      istart(kkkk) = kkkk
      isalva=kkkk      
      if(kkkk.eq.1.and.nvolte.eq.1) istart00=nats
      it(i1)=it(i1)+1
      if (i1.ne.i2) it(i2)=it(i2)+1
cprova
      if(i.eq.1.and.nvolte.eq.1)then
c     x2(1)= 0.444
c     x2(2)= 0.228
c     x2(3)= 0.494
c     x2(1)= 0.8  
c     x2(2)= 0.504
c     x2(3)= 0.06 
Cnizr
c     x2(1)= 0.582
c     x2(2)= 0.332
c     x2(3)= 0.567
Cnizr
      endif
c----
c---- check posizioni speciali
c----
      xoo(1)=x2(1) 
      xoo(2)=x2(2)
      xoo(3)=x2(3)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
      xm(1)=xn(1)
      xm(2)=xn(2)
      xm(3)=xn(3)
c     xm(1)=.692 
c     xm(2)=.785   
c     xm(3)=.185   
CROX   
*     xm(1)= -0.089
*     xm(2)= .899   
*     xm(3)= 1.057   
CROX   
c----
      xyzs(1,nats)=xm(1)
      xyzs(2,nats)=xm(2)
      xyzs(3,nats)=xm(3)
      xyzs(4,nats)=vetintsav
c----
c     write(6,*) 'ISTART00', istart00
*     write(lo,'(/,a,2i4,3f10.4)')'first located anion',i1,i2,
*    *(xyzs(k,nats),k=1,3)
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.0*biso          
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
      xt(1,i1,it(i1))=xyzs(1,nats)
      xt(2,i1,it(i1))=xyzs(2,nats)
      xt(3,i1,it(i1))=xyzs(3,nats)
CORO
      if(isavsym(kkkk).ne.0.or.ksavcen(kkkk).ne.1.
     *   and.i1sav(kkkk).eq.i1.
     *   and.i2sav(kkkk).eq.i2) then
          x2(1)=xyzs(1,nats)
          x2(2)=xyzs(2,nats)
          x2(3)=xyzs(3,nats)
          nsymm=isavsym(kkkk)
          ncenn=ksavcen(kkkk)
          call equitt1(x2,nsymm,ncenn)
          if (i2.ne.i1) then
              xt(1,i2,it(i2))=x2(1)
              xt(2,i2,it(i2))=x2(2)
              xt(3,i2,it(i2))=x2(3)
          endif
      else
          xt(1,i2,it(i2))=xyzs(1,nats)
          xt(2,i2,it(i2))=xyzs(2,nats)
          xt(3,i2,it(i2))=xyzs(3,nats)
      endif
CORO
*     write(6,*) 'XT located',i2,(xt(k,i2,it(i2)),k=1,3)
      ntt(i2,it(i2))=nats
      ntt(i1,it(i1))=nats
      itsalva(i1)=it(i1)
CORO
      do kl=1,nats
      itstart(kl)=it(kl)
      do lk=1,3
      xtstart(lk,kl,kl)=xt(lk,kl,kl)
      end do
      end do
CORO
      xtsalva(1,i1,it(i1))=xt(1,i1,it(i1))
      xtsalva(2,i1,it(i1))=xt(2,i1,it(i1))
      xtsalva(3,i1,it(i1))=xt(3,i1,it(i1))
      nttsalva(i1,it(i1))=ntt(i1,it(i1))
      itsalva(i2)=it(i2)
      xtsalva(1,i2,it(i2))=xt(1,i2,it(i2))
      xtsalva(2,i2,it(i2))=xt(2,i2,it(i2))
      xtsalva(3,i2,it(i2))=xt(3,i2,it(i2))
      nttsalva(i2,it(i2))=ntt(i2,it(i2))
c----------
      if(ntetra.gt.0)call checkequivt(xm,i1,i2)
      if(nott.gt.0)call checkequivo(xm,i1,i2)
c----------
c----
      do imm=1,nats
         xxsav(1,imm)=xyzs(1,imm)
         xxsav(2,imm)=xyzs(2,imm)
         xxsav(3,imm)=xyzs(3,imm)
         xxsav(4,imm)=xyzs(4,imm)
         xxsav(5,imm)=xyzs(5,imm)
      enddo
c----
 501  continue
      elseif(kkkk.eq.isalva.and.nvolte.gt.1.and.istart(kkkk).gt.0)then
      do 601 k=1,ntetra
      i3=ntetr(k)
      if(i1.eq.i3) icod1=4
      if(i2.eq.i3) icod2=4
 601  continue
      do 602 k=1,nott
      i3=notta(k)
      if(i1.eq.i3) icod1=6
      if(i2.eq.i3) icod2=6
 602  continue
      if(isalva.gt.1) then
      do kl=1,nats
      it(kl)=itstart(kl)
      do lk=1,3
      xt(lk,kl,kl)=xtstart(lk,kl,kl)
      end do
      end do
      endif
      if(it(i1).eq.icod1.and.it(i2).eq.icod2) go to 100
      nats=istart0
      natspa=nats-1
      if(isalva.eq.1) then
      it(i1)=it(i1)+1
CABBA it(i2)=it(i2)+1
      if (i1.ne.i2) it(i2)=it(i2)+1
      endif
*     write(6,*) ' NATS ISTART0 prima call ruotapartenza',nats,istart0
*     write(6,*) ' ISTART00 prima call ruotapartenza',istart00
CABBA
      if (istart0.gt.istart00) then
          nvosta = nvosta+1
               do imn=1,nats
                  xyzs(1,imn)=xxsav(1,imn)
                  xyzs(2,imn)=xxsav(2,imn)
                  xyzs(3,imn)=xxsav(3,imn)
                  xyzs(4,imn)=xxsav(4,imn)
                  xyzs(5,imn)=xxsav(5,imn)
               enddo
          if (nvosta.eq.50) then
*             write(6,*)' ISTART0 e ISTART00 NVOSTA',
*    *         istart0,istart00,nvosta
              isalva = 1      
              iarret = -1
              nvosta = 0 
              return
          endif
      endif
c     write(6,*) 'ISTART0', istart0
      call ruotapartenza(i1,i2,istart0,istart0,nvolte,i)
      xoo(1)=xyzs(1,istart0) 
      xoo(2)=xyzs(2,istart0)
      xoo(3)=xyzs(3,istart0)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
      xm(1)=xn(1)
      xm(2)=xn(2)
      xm(3)=xn(3)
c----
      xyzs(1,nats)=xm(1)
      xyzs(2,nats)=xm(2)
      xyzs(3,nats)=xm(3)
c----
*     write(lo,'(/,a,2i4,3f10.4)')'rotated first anion',i1,i2,
*    *(xyzs(k,nats),k=1,3)
      xt(1,i1,it(i1))=xyzs(1,nats)
      xt(2,i1,it(i1))=xyzs(2,nats)
      xt(3,i1,it(i1))=xyzs(3,nats)
CORO
      if(isavsym(kkkk).ne.0.or.ksavcen(kkkk).ne.1.
     *   and.i1sav(kkkk).eq.i1.
     *   and.i2sav(kkkk).eq.i2) then
          x2(1)=xyzs(1,nats)
          x2(2)=xyzs(2,nats)
          x2(3)=xyzs(3,nats)
          nsymm=isavsym(kkkk)
          ncenn=ksavcen(kkkk)
          call equitt1(x2,nsymm,ncenn)
          xt(1,i2,it(i2))=x2(1)
          xt(2,i2,it(i2))=x2(2)
          xt(3,i2,it(i2))=x2(3)
      else
          xt(1,i2,it(i2))=xyzs(1,nats)
          xt(2,i2,it(i2))=xyzs(2,nats)
          xt(3,i2,it(i2))=xyzs(3,nats)
      endif
*     write(6,*) 'XT located',i2,(xt(k,i2,it(i2)),k=1,3)
CORO
      ntt(i2,it(i2))=nats
      ntt(i1,it(i1))=nats
c----------
      if(ntetra.gt.0)call checkequivt(xm,i1,i2)
      if(nott.gt.0)call checkequivo(xm,i1,i2)
c----------
      endif
      call metti(i,vetintsav,nzSavv,iarret)
      if (iarret.eq.-1) go to 3000    
      icon=0
      do 900 kkk1=1,ilinka
      k=iordcon(kkk1)
      jj=nlinka(1,k)
      if(nsyml(1,k).eq.100)then
      itr=4
      elseif(nsyml(1,k).eq.200)then
      itr=6
      endif
      if(it(jj).ge.2.and.it(jj).lt.itr)icon=1
 900  continue
      if(icon.eq.1)call whatbuild2(iarret)
      if(iarret.eq.-1)go to 3000
      isalva=kkkk+1
*     write(6,*) 'ISALVA',isalva
      do 1070 k=1,nats
      itsalva(k)=it(k)
      do 1075 j=1,nats
      xtsalva(1,k,j)=xt(1,k,j)
      xtsalva(2,k,j)=xt(2,k,j)
      xtsalva(3,k,j)=xt(3,k,j)
      nttsalva(k,j)=ntt(k,j)
 1075 continue
 1070 continue
 100  continue
CORO  write(lo,'(//,15x,a,i8,//)')' Feasible 
CORO *      configuration    attempt nr. ',ntrialmn
c     write(lo,'(//,15x,a,//)')' Feasible configuration '
c     write(lo,'(a,/)')
c    *' Atom           X         Y         Z       B-iso'
      iprier=1
      call calcolaerre(chi2,iprier)
      chisquared=chi2
      ntrialmin=ntrial
      iniat = 1
      call MakeLab(iniat,nats)
      kdirect=1
      interp=0
      call frm15e(nats,interp)
c     do 1000 i=1,nats
c     write(lo,'(2x,a8,4f10.4)')aLab(i),(xyzs(k,i),k=1,3),bfac(i)
c1000 continue
      jpol=0
      kdirectsav=0
c     do inats=1,nats
c       kblock(inats)=1
c     enddo
C18   iconn(1)=-1
C18   jab=3
C18   call molplo()
      isalva=1
      return
 3000 continue
      do 3005 ii=kkkk,1,-1
CABBA
      if (istart(ii).gt.0) then
         isalva=istart(ii)
         go to 3006
      endif
 3005 continue
 3006 continue
      if(istampa.gt.0)write(lo,'(/,a)') ' Failed attempt'                             
      return
      end
c ------------------------------------------------------------------
      subroutine MatRz(gamm)
      common /matr1/rx(3,3),ry(3,3),rz(3,3)
c----
      rz(1,1) = cos(gamm)
      rz(1,2) = - sin(gamm)
      rz(1,3) = 0
      rz(2,1) = sin(gamm)
      rz(2,2) = cos(gamm)
      rz(2,3) = 0
      rz(3,1) = 0
      rz(3,2) = 0
      rz(3,3) = 1
      return
      end
c ------------------------------------------------------------------
      subroutine MatRx(alff)
      common /matr1/rx(3,3),ry(3,3),rz(3,3)
c----
      rx(1,1) = 1
      rx(1,2) = 0
      rx(1,3) = 0
      rx(2,1) = 0
      rx(2,2) = cos(alff)
      rx(2,3) = -sin(alff)
      rx(3,1) = 0
      rx(3,2) = sin(alff)
      rx(3,3) = cos(alff)
c----
      return
      end
c ------------------------------------------------------------------
      subroutine equitt(x,k,kt)
c
c-- calcola  la posizione equivalente per la matrice  k-esima
c
      USE Symmetry
      dimension x(3),x1(3)
c
      do 10 i=1,3
      x1(i)=0
      do 10 j=1,3
   10 x1(i)=x1(i)+x(j)*kmat(k,i,j)
      do 20 i=1,3
   20 x(i)=x1(i)
      do 15 l=1,3
        x(l) = x(l) + tmat(k,l)
c       if(k.gt.1)then
c       if (x(l).lt.0.) x(l)=x(l)-int(x(l))+1.
c       if (x(l).ge.1.) (l)=x(l)-int(x(l))
c       endif
 15   continue
      do 99 l=1,3
      ktl=(kt-1)*3+l
      x(l)=x(l)+centrt(latt,ktl)
 99   continue
      return
      end
c----------------------------------------------------------------
      subroutine checkequivt(xo,i1,i2)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell
      real, dimension(3,3) :: gm
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/occtetra/it(500)
      common/stampa/istampa
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/Gmatrix/ggMat(3,3)
      dimension xo(3),xeq(3),xoo(3),xcat(3)
      dimension x1(3),x2(3),xb2(3),s(3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
      dimension vet(2)
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
c     write(6,*) ' INIZIO IT in checkeqvt',(it(kk),kk=1,4)
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
c-
c     do 10 ii=2,nsym2
c        xeq(1) = xo(1)
c        xeq(2) = xo(2)
c        xeq(3) = xo(3)
c        call equitt(xeq,ii)
c         call distanzan(ggMat,xo,xeq,dist)
c----------
      ifin=icent+1
      do 10 kt=1,spacegr%ncoper
        do 10 ifi=1,ifin
          coef=vet(ifi)
          do 10 k=1,nsym
            if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 10
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,k,coef,xeq,kt)
            !call xdist(xb2,xeq,dist,s)
            call xdisteqs(xb2,xeq,gm,dist,s)
            xeq(1)=xb2(1)+s(1)
            xeq(2)=xb2(2)+s(2)
            xeq(3)=xb2(3)+s(3)
c----------
          if (dist.gt.0.000001.and.dist.le.dmin) then
*            write(6,*)' CORDINATE X0 INIZIALI =',xo
             xo(1) = (xo(1) + xeq(1))/2.
             xo(2) = (xo(2) + xeq(2))/2.
             xo(3) = (xo(3) + xeq(3))/2.
c----
             xyzs(1,nats)=xo(1)
             xyzs(2,nats)=xo(2)
             xyzs(3,nats)=xo(3)
c----
             xt(1,i1,it(i1))=xyzs(1,nats)
             xt(2,i1,it(i1))=xyzs(2,nats)
             xt(3,i1,it(i1))=xyzs(3,nats)
             xt(1,i2,it(i2))=xyzs(1,nats)
             xt(2,i2,it(i2))=xyzs(2,nats)
             xt(3,i2,it(i2))=xyzs(3,nats)
*            write(6,*)' CORDINATE X0 MODIFICATE =',xo
             go to 11
           endif
   10    continue
   11    continue
c--
c----- check se un equivalente di xo e' legato con i cationi
c--
      do 35 i = 1,ntetra
      angsog1 = 109.47*(1.0-atolt(i))
      angsog2 = 109.47*(1.0+atolt(i))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
        dist1=dtetra(i)*(1.0-dtolt(i)) 
        dist2=dtetra(i)*(1.0+dtolt(i))
        jj = ntetr(i)
CANG
        if(jj.eq.i1) go to 35
CANG
        xcat(1) = xyzs(1,jj) 
        xcat(2) = xyzs(2,jj) 
        xcat(3) = xyzs(3,jj) 
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c          call equitt(xeq,ii)
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 kj=1,nsym
c           if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
c-----------------
        iser=1
        iactn=1
        khead=0
*       write(6,*)'xeq prima kspec in checkeqvt',xeq
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
*       if(1.0/float(key(10)).lt.1.) then
*          write(6,*)'OCCUPANZA=',1.0/float(key(10))
*          write(6,*)'xeq prima kspec in checkeqvt',xo1
*          write(6,*)'xeq dopo kspec in checkeqvt',xeq
*       endif
c---
c         call distanzan(ggMat,xcat,xeq,dist)
          !call xdist(xcat,xeq,dist,s)
          call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if (dist.ge.dist1.and.dist.le.dist2) then
             if (it(jj).eq.0) then
                 it(jj)=it(jj)+1
                 xt(1,jj,it(jj))=xeq(1)       
                 xt(2,jj,it(jj))=xeq(2)       
                 xt(3,jj,it(jj))=xeq(3)       
                 ntt(jj,it(jj))=nats         
             elseif (it(jj).ge.1.and.it(jj).lt.4) then
c--
c-- accetto solo atomi che formano angolo (109+/-soglia) con gli altri del tetraedro
c--
                 iok = 1
                 do 40 k=1,it(jj)
                    xoo(1) = xt(1,jj,k)
                    xoo(2) = xt(2,jj,k)
                    xoo(3) = xt(3,jj,k)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if (ang1.lt.angsog1.or.ang1.gt.angsog2) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    do 110 k=1,it(jj)
                    x1(1)=xt(1,jj,k)
                    x1(2)=xt(2,jj,k)
                    x1(3)=xt(3,jj,k)
                    do 120 kk=k+1,it(jj)+1
                    if(kk.lt.it(jj)+1)then
                    x2(1)=xt(1,jj,kk)
                    x2(2)=xt(2,jj,kk)
                    x2(3)=xt(3,jj,kk)
                    else
                    x2(1)=xeq(1)            
                    x2(2)=xeq(2)            
                    x2(3)=xeq(3)            
                    endif
c                   call distanzan(ggMat,x1,x2,dcal)
c                   call distanzaeq(ggMat,x1,x2,dcal)
                    call distanzaeq(x1,x2,dcal)
                    if(dcal.lt.0.6.and.dcal.gt.0.0)go to 130
 120                continue
 110                continue
                    it(jj)=it(jj)+1
                    xt(1,jj,it(jj))=xeq(1)     
                    xt(2,jj,it(jj))=xeq(2)     
                    xt(3,jj,it(jj))=xeq(3)     
                    ntt(jj,it(jj))=nats       
 130                continue
                 endif
             endif 
          endif
 25   continue
 35   continue
c     write(6,*) ' FINE IT in checkeqvt',(it(kk),kk=1,4)
      return
      end 
c-----------------------------------------------------------------
      subroutine Fillg
      USE General
      common/Gmatrix/ggMat(3,3)
      dimension ang(3)
c----
      do 1 ki=1,3
           ang(ki)=((pi*cell(ki+3))/180.0)
   1  continue
c
      ggMat(:,:)=0.0

      ggMat(1,1)=cell(1)**2
      ggMat(2,2)=cell(2)**2
      ggMat(3,3)=cell(3)**2
      ggMat(1,2)=cell(1)*cell(2)*cos(ang(3))
      ggMat(1,3)=cell(1)*cell(3)*cos(ang(2))
      ggMat(2,3)=cell(2)*cell(3)*cos(ang(1))
      ggMat(3,1)=ggMat(1,3)
      ggMat(2,1)=ggMat(1,2)
      ggMat(3,2)=ggMat(2,3)
      return
      end
c ------------------------------------------------------
      subroutine distanzan(ggMat,x1,x2,dcal)   
      dimension x1(3),x2(3)
      dimension r(3),r2(3),sottr(3),ggMat(3,3),diff(3)
c
         distsogg=0.5
         do 200 j=1,3
            diff(j)=x1(j)-x2(j)
            sottr(j)=abs(diff(j))
            if (sottr(j).gt.distsogg) then
                diff(j)=x1(j)+1.0-x2(j)
                sottr(j)=abs(diff(j))
                if (sottr(j).gt.distsogg) then
                    diff(j)=x1(j)-1.0-x2(j)
                    sottr(j)=abs(diff(j))
CANG
                    if (sottr(j).gt.distsogg) then
                        diff(j)=x1(j)+2.0-x2(j)
                        sottr(j)=abs(diff(j))
                        if (sottr(j).gt.distsogg) then
                            diff(j)=x1(j)-2.0-x2(j)
                            sottr(j)=abs(diff(j))
                        end if
                    end if
CANG
                end if
            end if
      sottr(j)=diff(j)
 200     continue
      x2(1)=x1(1)-diff(1)
      x2(2)=x1(2)-diff(2)
      x2(3)=x1(3)-diff(3)
      do 69 k=1,3
      r(k)=0.0
 69   continue
      do 70 k=1,3
            do 80 jj=1,3
               r(k)=r(k)+sottr(jj)*ggMat(jj,k)
 80         continue
 70         continue
      v=0
      do 90 k=1,3
            v=v+sottr(k)*r(k)
 90   continue
      dcal=sqrt(v)
      return
      end
c------------------------------------------------
      subroutine MatTott(x1,a,b,c,d,tet)
cc
      USE General
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      dimension x1(3)
cc
      ctet=cos(tet)
      stet=sin(tet)
cc
      rtot(1,1) = d*ctet
      rtot(1,2) = -1./d*(a*b*ctet+c*stet)
      rtot(1,3) = 1./d*(-a*c*ctet+b*stet)
      rtot(1,4) = -(x1(1)*rtot(1,1)+x1(2)*rtot(1,2)+x1(3)*rtot(1,3))
      rtot(2,1) = d*stet
      rtot(2,2) = 1./d*(-a*b*stet+c*ctet)
      rtot(2,3) = -1./d*(a*c*stet+b*ctet)
      rtot(2,4) = -(x1(1)*rtot(2,1)+x1(2)*rtot(2,2)+x1(3)*rtot(2,3))
      rtot(3,1) = a
      rtot(3,2) = b
      rtot(3,3) = c
      rtot(3,4) = -(x1(1)*a+x1(2)*b+x1(3)*c)
      rtot(4,1) = 0.
      rtot(4,2) = 0.
      rtot(4,3) = 0.
      rtot(4,4) = 1
CC
      return
      end
c ------------------------------------------------------------------
      subroutine MatTotti(x1,a,b,c,d)
cc
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      dimension x1(3)
cc
      rtoti(1,1) = d
      rtoti(1,2) = 0.
      rtoti(1,3) = a
      rtoti(1,4) = x1(1)
      rtoti(2,1) = -a*b/d
      rtoti(2,2) = c/d
      rtoti(2,3) = b
      rtoti(2,4) = x1(2)
      rtoti(3,1) = -a*c/d
      rtoti(3,2) = -b/d
      rtoti(3,3) = c
      rtoti(3,4) = x1(3)
      rtoti(4,1) = 0.
      rtoti(4,2) = 0.
      rtoti(4,3) = 0.
      rtoti(4,4) = 1
CC
      return
      end
c ------------------------------------------------------------------
      subRoutine molt1_rott(a, b1, c)
!corr      dimension a(4,4), b1(4), c(4)
      dimension a(4,4), b1(4), c(3)
c
c ---  matrix * vector
c
      do 20 i=1, 3
         c(i) = 0
         do 10 j=1, 4
            c(i) = c(i) + a(i,j) * b1(j)
   10    continue
   20 continue
c
      return
      end
c----------------------------------------------------------------
      subroutine molt2_rott(b2, d, w)
        dimension b2(4,4), d(4,4), w(4,4)
c
c ---  matrix * matrix
c
      do 30 i = 1 , 4
         do 20 j = 1 , 4
            dum = 0
            do 10 k = 1 , 4
               dum = dum + b2(i, k) * d(k, j)
   10       continue
            w(i, j) = dum
   20    continue
   30 continue
c
      return
      end
c ------------------------------------------------------------------
      subroutine angolon(ggMat,x1,x2,x3,angcal)   
      USE General
      dimension x1(3),x2(3),x3(3)
      dimension xa(3),xb(3) 
      dimension r(3),r2(3),sottr(3),ang(3),ggMat(3,3)
c
      xa(1)=(x1(1)-x2(1))
      xa(2)=(x1(2)-x2(2))
      xa(3)=(x1(3)-x2(3))
      xb(1)=(x3(1)-x2(1))
      xb(2)=(x3(2)-x2(2))
      xb(3)=(x3(3)-x2(3))
      call scalar(ggMat,xa,xb,xs1)
      call scalar(ggMat,xa,xa,xs2)
      call scalar(ggMat,xb,xb,xs3)
      if((abs(xs2).lt.0.00001).or.(abs(xs3).lt.0.00001))then
      cosang=1.0 
      else
      cosang=xs1/(sqrt(xs2)*sqrt(xs3))
      endif
      if (cosang .gt. 0.999999) cosang = 1.0            
      if (cosang .gt.-0.000001.and.cosang.lt.0.000001) cosang = 0.0            
      if (cosang .lt.-0.999999) cosang =-1.0            
      angcal=acos(cosang)
      return
      end
c------------------------------------------------
      subroutine scalarn(ggMat,x1,x2,sx)   
      USE General
      dimension x1(3),x2(3)
      dimension r(3),r2(3),sottr(3),ang(3),ggMat(3,3)
      dimension diff(3)
c
      distsogg=0.5
         do 200 j=1,3
            diff(j)=x1(j)
            sottr(j)=abs(diff(j))
            if (sottr(j).gt.distsogg) then
                diff(j)=x1(j)+1.0
                sottr(j)=abs(diff(j))
                if (sottr(j).gt.distsogg)then
                    diff(j)=x1(j)-1.0
                    sottr(j)=abs(diff(j))
                end if
            end if
 200     continue
      do 79 k=1,3
      r(k)=0.0
 79   continue
      do 75 k=1,3
            do 85 jj=1,3
               r(k)=r(k)+sottr(jj)*ggMat(jj,k)
 85         continue
 75         continue
         do 210 j=1,3
            diff(j)=x2(j)
            sottr(j)=abs(diff(j))
            if (sottr(j).gt.distsogg)then
                diff(j)=x2(j)+1.0
                sottr(j)=abs(diff(j))
                if (sottr(j).gt.distsogg)then
                    diff(j)=x2(j)-1.0
                    sottr(j)=abs(diff(j))
                end if
            end if
 210     continue
      sx=0.0
      do 901 k=1,3
            sx=sx+sottr(k)*r(k)
 901  continue
      return
      end
c-----------------------------------------------------------------------
      subroutine buildotta(kkk,iarret)
      Use Polpo
      USE Atomi
      USE General
      USE elements, only: pxen_from_specie,numelem
      common/chiquadro/chimin,chisquared,ntrialmin,chichi(150),
     *                 xchi(5,500,150),nzchi(500,150),natschi(150),
     *                 ntrialmn
      common/stampa/istampa
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/occtetra/it(500)
      common/ottafree/ nats1o(10),nats2o(10),nateo,k1o(10),k2o(10)
     *,libo(10)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/Gmatrix/ggMat(3,3)
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/tetrafree/ nats1(10),nats2(10),nate,k1(10),k2(10),iox(500)
     *,libt(10)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /matr/rmz(3,3),rmiz(3,3)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      dimension xorig(3),x1(3),xo(3),x2(3),x3(3),xxxx(3,6)
      dimension xoo(11),xn(11),key(10)
      dimension itsav(500)
      character oo*2                             
c
      oo(1:2)='o '
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      do jk=1,10
      libo(jk)=0
      end do
      dsog = 0.6
      dsogok = 0.6
c     if(nmiss.gt.0)then
c     dsog=0.7
c     dsogok=0.7
c     endif
      if(nmiss.ne.0)then
c     dsog=0.4
c     dsogok=0.4
CATT  dsog=0.4
      dsog=0.4
CATT  dsogok=0.8
      dsogok=0.5
      endif
      doxigen = 1.6
      do 2 i=1,11
           xoo(i) = 0.0
           xn(i) = 0.0
  2   continue
      i=kkk
      nat1=nats
      alfa=90.*dtor
      jj=notta(i)
CATT  jj=kkk                  
CATT  ippo(i)=jj
      do 200 j=1,numelem(celem)
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          jsav=j
          go to 203
      endif
  200 continue
  203 continue
      dd1=dotta1(i)
      dd2=dotta1(i)
      dmaxx = dd1
      dminn = dd2
      xorig(1)=xyzs(1,jj)
      xorig(2)=xyzs(2,jj)
      xorig(3)=xyzs(3,jj)
CORO
      itsav(jj)=it(jj)
CORO
 1000 continue
      if(it(jj).eq.0)then
      iaccet=0
      xo(1)=0.0
      xo(2)=0.0
      xo(3)=0.0
      call GeneraOttaedro(xo,xxxx,dd1,dd2)
      do 150 k=1,6
      x1(1)=xxxx(1,k)
      x1(2)=xxxx(2,k)
      x1(3)=xxxx(3,k)
      call molt1_rot(rmiz, x1, xo)
      x1(1)=xo(1)+xorig(1)
      x1(2)=xo(2)+xorig(2)
      x1(3)=xo(3)+xorig(3)
       if(iaccet.ne.0) then
      natsav=nats
      nats=nats-iaccet
      endif
      do 500 ijk=1,nats
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
c     call distanzaeq_old(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
      iarret=-1
      return
      endif
 500  continue
      if(iaccet.ne.0) nats=natsav
      iaccet=iaccet+1
      nats=nats+1
c----
c---- check posizioni speciali
c----
      xoo(1)=x1(1) 
      xoo(2)=x1(2)
      xoo(3)=x1(3)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
c----
      xyzs(1,nats)=xn(1)
      xyzs(2,nats)=xn(2)
      xyzs(3,nats)=xn(3)
      x1(1)=xn(1) 
      x1(2)=xn(2)
      x1(3)=xn(3)
      xyzs(4,nats)=vetintsav
c----
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.0*biso          
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
      it(jj)=it(jj)+1
      xt(1,jj,it(jj))=xyzs(1,nats)
      xt(2,jj,it(jj))=xyzs(2,nats)
      xt(3,jj,it(jj))=xyzs(3,nats)
      ntt(jj,it(jj))=nats
c----------
      iesit=0
      call checkequivob(x1,jj,jj,iesit)
      if(ntetra.gt.0)call checkequivt(x1,jj,jj)
      if(nott.gt.0)call checkequivo(x1,jj,jj)
      if (iesit.eq.1) go to 1000
c----------
 501  continue
 150  continue
      elseif(it(jj).eq.1)then
      iok=0
 506  continue
      x1(1)=xt(1,jj,it(jj))
      x1(2)=xt(2,jj,it(jj))
      x1(3)=xt(3,jj,it(jj))
      x2(1)=xorig(1)
      x2(2)=xorig(2)
      x2(3)=xorig(3)
c     call distanzaeq_old(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      da=abs(dcal-dd1)
      db=abs(dcal-dd2)
      if(da.lt.db)then
      dd0=dd1
      dd00=dd2
      else
      dd0=dd2
      dd00=dd1
      endif
      x1(1)=xt(1,jj,it(jj))-xorig(1)
      x1(2)=xt(2,jj,it(jj))-xorig(2)
      x1(3)=xt(3,jj,it(jj))-xorig(3)
      call molt1_rot(rmz, x1, x2)
      call generat1(x2,dd0,alfa,x3,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x3, xo)
      do 510 ijk=1,nats
      x2(1)=xo(1)+xorig(1)
      x2(2)=xo(2)+xorig(2)
      x2(3)=xo(3)+xorig(3)
      x1(1)=xyzs(1,ijk)
      x1(2)=xyzs(2,ijk)
      x1(3)=xyzs(3,ijk)
c     call distanzaeq_old(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
CANGE if(dcal.lt.dsogok) then
      if(dcal.lt.dsog) then
      iarret=-1
      return
      endif
 510  continue
      nats=nats+1
c----
c---- check posizioni speciali
c----
      xoo(1)=x2(1) 
      xoo(2)=x2(2)
      xoo(3)=x2(3)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
c----
      xyzs(1,nats)=xn(1)
      xyzs(2,nats)=xn(2)
      xyzs(3,nats)=xn(3)
      x2(1)=xn(1) 
      x2(2)=xn(2)
      x2(3)=xn(3)
      xyzs(4,nats)=vetintsav
c----
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.0*biso          
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
      it(jj)=it(jj)+1
      xt(1,jj,it(jj))=xyzs(1,nats)
      xt(2,jj,it(jj))=xyzs(2,nats)
      xt(3,jj,it(jj))=xyzs(3,nats)
      ntt(jj,it(jj))=nats
c----------
      iesit=0
      call checkequivob(x2,jj,jj,iesit)
      if(ntetra.gt.0)call checkequivt(x2,jj,jj)
      if(nott.gt.0)call checkequivo(x2,jj,jj)
      if (iesit.eq.1) go to 1000
c----------
 511  continue
      do 295 k=it(jj)+1,6
      alfa=90.0*dtor
      iok=0
 293  continue
      if (k.le.4) then
          d1=dd0
        else
          d1=dd00 
      endif
      x1(1)=xt(1,jj,k-2)-xorig(1)
      x1(2)=xt(2,jj,k-2)-xorig(2)
      x1(3)=xt(3,jj,k-2)-xorig(3)
      call molt1_rot(rmz, x1, x2)
      x1(1)=xt(1,jj,k-1)-xorig(1)
      x1(2)=xt(2,jj,k-1)-xorig(2)
      x1(3)=xt(3,jj,k-1)-xorig(3)
      call molt1_rot(rmz, x1, x3)
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x1, xo)
      do 559 ijk=1,it(jj)
      x1(1)=xo(1)+xorig(1)
      x1(2)=xo(2)+xorig(2)
      x1(3)=xo(3)+xorig(3)
      x2(1)=xt(1,jj,ijk)
      x2(2)=xt(2,jj,ijk)
      x2(3)=xt(3,jj,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      endif
      endif
 559  continue
      do 520 ijk=1,nats
      x1(1)=xo(1)+xorig(1)
      x1(2)=xo(2)+xorig(2)
      x1(3)=xo(3)+xorig(3)
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
c     call distanzaeq_old(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
CANGE if(dcal.lt.dsogok)then
      if(dcal.lt.dsog)then
      iarret=-1
      return
      endif
 520  continue
      nats=nats+1
c----
c---- check posizioni speciali
c----
      xoo(1)=x1(1) 
      xoo(2)=x1(2)
      xoo(3)=x1(3)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
c----
      xyzs(1,nats)=xn(1)
      xyzs(2,nats)=xn(2)
      xyzs(3,nats)=xn(3)
      x1(1)=xn(1) 
      x1(2)=xn(2)
      x1(3)=xn(3)
      xyzs(4,nats)=vetintsav
c----
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.0*biso          
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
      it(jj)=it(jj)+1
      xt(1,jj,it(jj))=xyzs(1,nats)
      xt(2,jj,it(jj))=xyzs(2,nats)
      xt(3,jj,it(jj))=xyzs(3,nats)
      ntt(jj,it(jj))=nats
c----------
      iesit=0
      call checkequivob(x1,jj,jj,iesit)
      if(ntetra.gt.0)call checkequivt(x1,jj,jj)
      if(nott.gt.0)call checkequivo(x1,jj,jj)
      if (iesit.eq.1) go to 1000
c----------
 521  continue
 295  continue
      else
c     do 300 k=it(jj)+1,6
c     alfa=90.0*dtor
c     iott180=0
c     iott90=0
c     pi2=pi*0.5
c     if(it(jj).ge.3)then
c     do 396 ik=1,it(jj)
c     do 496 ikk=1,it(jj)
c     x1(1)=xt(1,jj,ik)
c     x1(2)=xt(2,jj,ik)
c     x1(3)=xt(3,jj,ik)
c     x2(1)=xyzs(1,jj)
c     x2(2)=xyzs(2,jj)
c     x2(3)=xyzs(3,jj)
c     x3(1)=xt(1,jj,ikk)
c     x3(2)=xt(2,jj,ikk)
c     x3(3)=xt(3,jj,ikk)
c     call angolo(ggMat,x1,x2,x3,anglo)
c     if(abs(anglo).gt.(pi2-0.5).and.abs(anglo).lt.(pi2+0.5))then
c     k190=ik
c     k290=ikk
c     iott90=1
c     endif
c496  continue
c396  continue
c     endif
CANG
cc
      iott90=0
      iott180=0
      do 300 k=it(jj)+1,6
      alfa=90.0*dtor
      pi2=pi*0.5
      do 396 ik=1,it(jj)         
      do 496 ikk=1,it(jj)
      if(ik.eq.ikk)go to 496
      x1(1)=xt(1,jj,ik)
      x1(2)=xt(2,jj,ik)
      x1(3)=xt(3,jj,ik)
      x2(1)=xyzs(1,jj)
      x2(2)=xyzs(2,jj)
      x2(3)=xyzs(3,jj)
      x3(1)=xt(1,jj,ikk)
      x3(2)=xt(2,jj,ikk)
      x3(3)=xt(3,jj,ikk)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(iott90.eq.0)then
      if(abs(anglo).gt.(pi2-0.5).and.abs(anglo).lt.(pi2+0.5))then
      k190=ik
      k290=ikk
      iott90=1
      endif
      endif
      if(abs(anglo).gt.(pi-0.5).and.abs(anglo).lt.(pi+0.5))iott180=1
 496  continue
 396  continue
c
c     do 333 ki=2,it(jj)
c     x1(1)=xt(1,jj,ki)-xorig(1)
c     x1(2)=xt(2,jj,ki)-xorig(2)
c     x1(3)=xt(3,jj,ki)-xorig(3)
c     ki=k-2    
c     x1(1)=xt(1,jj,ki)-xorig(1)
c     x1(2)=xt(2,jj,ki)-xorig(2)
c     x1(3)=xt(3,jj,ki)-xorig(3)
c     call molt1_rot(rmz, x1, x2)
c     do 335 kk=k-1,1,-1                
c     if(kk.eq.ki)go to 335
c     x1(1)=xt(1,jj,kk)-xorig(1)
c     x1(2)=xt(2,jj,kk)-xorig(2)
c     x1(3)=xt(3,jj,kk)-xorig(3)
c     call molt1_rot(rmz, x1, x3)
      iok=0
c     iprova=0
 393  continue
      if (k.le.3) then
         d1=dmaxx
       else
         d1=dminn
      endif
CANG
CANG  if(iott90.eq.0.or.k.gt.(it(jj)+1))then
      if(iott90.eq.0.or.k.eq.6.or.iott180.eq.0)then
      x1(1)=xt(1,jj,k-2)-xorig(1)
      x1(2)=xt(2,jj,k-2)-xorig(2)
      x1(3)=xt(3,jj,k-2)-xorig(3)
      call molt1_rot(rmz, x1, x2)
      x1(1)=xt(1,jj,k-1)-xorig(1)
      x1(2)=xt(2,jj,k-1)-xorig(2)
      x1(3)=xt(3,jj,k-1)-xorig(3)
      call molt1_rot(rmz, x1, x3)
      else
      x1(1)=xt(1,jj,k190)-xorig(1)
      x1(2)=xt(2,jj,k190)-xorig(2)
      x1(3)=xt(3,jj,k190)-xorig(3)
      call molt1_rot(rmz, x1, x2)
      x1(1)=xt(1,jj,k290)-xorig(1)
      x1(2)=xt(2,jj,k290)-xorig(2)
      x1(3)=xt(3,jj,k290)-xorig(3)
      call molt1_rot(rmz, x1, x3)
      endif
CANG
CANG  x1(1)=xt(1,jj,k-2)-xorig(1)
CANG  x1(2)=xt(2,jj,k-2)-xorig(2)
CANG  x1(3)=xt(3,jj,k-2)-xorig(3)
CANG  call molt1_rot(rmz, x1, x2)
CANG  x1(1)=xt(1,jj,k-1)-xorig(1)
CANG  x1(2)=xt(2,jj,k-1)-xorig(2)
CANG  x1(3)=xt(3,jj,k-1)-xorig(3)
CANG  call molt1_rot(rmz, x1, x3)
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if (iarret.eq.-1) return
c     if(iarret.eq.-1)then
c     iprova=-1
c     iarret=0
c     go to 335
c     endif
      call molt1_rot(rmiz, x1, xo)
      do 569 ijk=1,it(jj)
      x1(1)=xo(1)+xorig(1)
      x1(2)=xo(2)+xorig(2)
      x1(3)=xo(3)+xorig(3)
      x2(1)=xt(1,jj,ijk)
      x2(2)=xt(2,jj,ijk)
      x2(3)=xt(3,jj,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  393
      endif
      endif
 569  continue
      do 530 ijk=1,nats
      x1(1)=xo(1)+xorig(1)
      x1(2)=xo(2)+xorig(2)
      x1(3)=xo(3)+xorig(3)
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
c     call distanzaeq_old(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
CANGE if(dcal.lt.dsogok)then
      if(dcal.lt.dsog)then
      iarret=-1
      return
c     iprova=-1
c     go to 335
      endif
 530  continue
      angsog1 = 90.0*(1.0-atolo(jj))
      angsog2 = 90.0*(1.0+atolo(jj))
      angsog11 = 180.0*(1.0-atolo(jj))
      angsog22 = 180.0*(1.0+atolo(jj))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
      do 551 ii=1,it(jj)
      x2(1)=xyzs(1,jj)
      x2(2)=xyzs(2,jj)
      x2(3)=xyzs(3,jj)
      x3(1)=xt(1,jj,ii)
      x3(2)=xt(2,jj,ii)
      x3(3)=xt(3,jj,ii)
      call angolon2(ggMat,x1,x2,x3,ang1)
      if ((ang1.lt.angsog1).or.(ang1.gt.angsog2.and.
     *  ang1.lt.angsog11).or.(ang1.gt.angsog22)) then
      iarret=-1
      return
c     iprova=-1
      endif
 551  continue
c      go to 336
c335  continue
c333  continue
c     if(iprova.eq.-1)then
c     iarret=-1
c     return
c     endif
c336  continue
      nats=nats+1
c----
c---- check posizioni speciali
c----
      xoo(1)=x1(1) 
      xoo(2)=x1(2)
      xoo(3)=x1(3)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
c----
      xyzs(1,nats)=xn(1)
      xyzs(2,nats)=xn(2)
      xyzs(3,nats)=xn(3)
      x1(1)=xn(1) 
      x1(2)=xn(2)
      x1(3)=xn(3)
      xyzs(4,nats)=vetintsav
c----
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.0*biso          
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
      it(jj)=it(jj)+1
      xt(1,jj,it(jj))=xyzs(1,nats)
      xt(2,jj,it(jj))=xyzs(2,nats)
      xt(3,jj,it(jj))=xyzs(3,nats)
      ntt(jj,it(jj))=nats
c----------
      iesit=0
      call checkequivob(x1,jj,jj,iesit)
      if(ntetra.gt.0)call checkequivt(x1,jj,jj)
      if(nott.gt.0)call checkequivo(x1,jj,jj)
      if (iesit.eq.1) go to 1000
c----------
 531  continue
 300  continue
      endif
c-----
c--------
      if(nmiss.gt.0)go to 603
      do 600 il=1,ilinka
      ilk=iordcon(il)
      n00=0
      if(nlinka(1,ilk).eq.jj) then
CANG
      do 601 ijk=2,nlegat(ilk)
      if(nlinka(ijk,ilk).ne.jj) n00=n00+1
 601  continue
CANG
CANG     if (nlegat(ilk).gt.1) return
         if (n00.gt.1) return
      endif
 600  continue
 603  continue
c--------
      ndifnats=nats-nat1
      itdif=it(jj)-itsav(jj)
      if(ndifnats.eq.5.or.ndifnats.eq.6.or.itdif.eq.5.or.itdif.eq.6)then
         nateo=nateo+1
         nats2o(nateo)=nats
         nats1o(nateo)=nat1+1
         k1o(nateo)=jj
         k2o(nateo)=ntt(jj,1)
      endif
CORO  if(ndifnats.eq.6.or.itdif.eq.6) libo(nate)=nate
      if(ndifnats.eq.6.or.itdif.eq.6) libo(nateo)=nateo
c-----
      return
      end
c-----------------------------------------------------------------
      subroutine GeneraOttaedro(xo,xx,d1,d2)
      USE General
c-- genera a partire dalle coordinate ortogonali il poliedro note
c-- le distanze d1 e d2 (partendo da xo coordinate ortogonali)
         dimension xo(3),xx(3,6)
c
c
         dd1 = d1*cos(45.*dtor)
*        write(6,*) ' DD1 =',dd1
c
c---
         xx(1,1) = xo(1) - dd1
         xx(2,1) = xo(2) - dd1
         xx(3,1) = xo(3) 
c---
         xx(1,2) = xo(1) + dd1
         xx(2,2) = xo(2) - dd1
         xx(3,2) = xo(3) 
c---
         xx(1,3) = xo(1) + dd1
         xx(2,3) = xo(2) + dd1
         xx(3,3) = xo(3) 
c---
         xx(1,4) = xo(1) - dd1
         xx(2,4) = xo(2) + dd1
         xx(3,4) = xo(3) 
c---
         xx(1,5) = xo(1) 
         xx(2,5) = xo(2)
         xx(3,5) = xo(3) + d2
c---
         xx(1,6) = xo(1) 
         xx(2,6) = xo(2)
         xx(3,6) = xo(3) - d2
c---
         return
         end
c-----------------------------------------------------------------
      subroutine checkequivo(xo,i1,i2)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell
      real, dimension(3,3) :: gm
      common/occtetra/it(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/stampa/istampa
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/Gmatrix/ggMat(3,3)
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3)
      dimension x1(3),x2(3),xb2(3),s(3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
      dimension vet(2)
c
      vet(1)= 1.0
      vet(2)=-1.0
      gm = matrice_metrica(cell)
c-    
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
c     write(6,*) ' inizio IT in checkeqvo',(it(kk),kk=1,4)
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
c-
c     do 10 ii=2,nsym2
c        xeq(1) = xo(1)
c        xeq(2) = xo(2)
c        xeq(3) = xo(3)
c        call equitt(xeq,ii)
c----------
c         call distanzan(ggMat,xo,xeq,dist)
c----------
      ifin=icent+1
        do 10 kt=1,spacegr%ncoper
        do 10 ifi=1,ifin
          coef=vet(ifi)
          do 10 k=1,nsym
            if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 10
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,k,coef,xeq,kt)
            !call xdist(xb2,xeq,dist,s)
            call xdisteqs(xb2,xeq,gm,dist,s)
            xeq(1)=xb2(1)+s(1)
            xeq(2)=xb2(2)+s(2)
            xeq(3)=xb2(3)+s(3)
          if (dist.gt.0.000001.and.dist.le.dmin) then
*            write(6,*)' CORDINATE X0 INIZIALI =',xo
             xo(1) = (xo(1) + xeq(1))/2.
             xo(2) = (xo(2) + xeq(2))/2.
             xo(3) = (xo(3) + xeq(3))/2.
c----
             xyzs(1,nats)=xo(1)
             xyzs(2,nats)=xo(2)
             xyzs(3,nats)=xo(3)
c----
             xt(1,i1,it(i1))=xyzs(1,nats)
             xt(2,i1,it(i1))=xyzs(2,nats)
             xt(3,i1,it(i1))=xyzs(3,nats)
             xt(1,i2,it(i2))=xyzs(1,nats)
             xt(2,i2,it(i2))=xyzs(2,nats)
             xt(3,i2,it(i2))=xyzs(3,nats)
*            write(6,*)' CORDINATE X0 MODIFICATE =',xo
*            write(6,*)' CORDINATE X0 MODIFICATE =',xo
             go to 11
           endif
   10    continue
   11    continue
c-    
c----- check se un equivalente di xo e' legato con i cationi
c--
      do 35 i = 1,nott
      angsog1 = 90.0*(1.0-atolo(i))
      angsog2 = 90.0*(1.0+atolo(i))
      angsog11 = 180.0*(1.0-atolo(i))
      angsog22 = 180.0*(1.0+atolo(i))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
        dist1=dotta1(i)*(1.0-dtolo(i))
        dist2=dotta1(i)*(1.0+dtolo(i))
        dist3=dotta1(i)*(1.0-dtolo(i))
        dist4=dotta1(i)*(1.0+dtolo(i))
        jj = notta(i)
CANG
        if(jj.eq.i1) go to 35
CANG
c-
        xcat(1) = xyzs(1,jj) 
        xcat(2) = xyzs(2,jj) 
        xcat(3) = xyzs(3,jj) 
c-
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c---
c          call equitt(xeq,ii)
c-----------------
      ifin=icent+1
      do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 kj=1,nsym
c           if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
        iser=1
        iactn=1
        khead=0
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
*       if(1.0/float(key(10)).lt.1.) then
*          write(6,*)'OCCUPANZA=',1.0/float(key(10))
*          write(6,*)'xeq prima kspec in checkeqvo',xo1
*          write(6,*)'xeq dopo kspec in checkeqvo',xeq
*       endif
c---
c-----------------
c         call distanzan(ggMat,xcat,xeq,dist)
          !call xdist(xcat,xeq,dist,s)
          call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if ((dist.ge.dist1.and.dist.le.dist2)
     *    .or.(dist.ge.dist3.and.dist.le.dist4)) then
             if (it(jj).eq.0) then
                 it(jj)=it(jj)+1
                 xt(1,jj,it(jj))=xeq(1)       
                 xt(2,jj,it(jj))=xeq(2)       
                 xt(3,jj,it(jj))=xeq(3)       
                 ntt(jj,it(jj))=nats         
CAN          elseif (it(jj).ge.1.and.it(jj).lt.4) then
             elseif (it(jj).ge.1.and.it(jj).lt.6) then
c--
c-- accetto solo atomi che formano angolo (90+/-soglia) con gli altri dell'ottaedro
c--
                 iok = 1
                 do 40 k=1,it(jj)
                    xoo(1) = xt(1,jj,k)
                    xoo(2) = xt(2,jj,k)
                    xoo(3) = xt(3,jj,k)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if ((ang1.lt.angsog1).or.(ang1.gt.angsog2.and. 
     *              ang1.lt.angsog11).or.(ang1.gt.angsog22)) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    do 110 k=1,it(jj)
                    x1(1)=xt(1,jj,k)
                    x1(2)=xt(2,jj,k)
                    x1(3)=xt(3,jj,k)
                    do 120 kk=k+1,it(jj)+1
                    if(kk.lt.it(jj)+1)then
                    x2(1)=xt(1,jj,kk)
                    x2(2)=xt(2,jj,kk)
                    x2(3)=xt(3,jj,kk)
                    else
                    x2(1)=xeq(1)            
                    x2(2)=xeq(2)            
                    x2(3)=xeq(3)            
                    endif
c                   call distanzan(ggMat,x1,x2,dcal)
c                   call distanzaeq(ggMat,x1,x2,dcal)
                    call distanzaeq(x1,x2,dcal)
                    if(dcal.lt.0.6.and.dcal.gt.0.0)go to 130
 120                continue
 110                continue
                    it(jj)=it(jj)+1
                    xt(1,jj,it(jj))=xeq(1)     
                    xt(2,jj,it(jj))=xeq(2)     
                    xt(3,jj,it(jj))=xeq(3)     
                    ntt(jj,it(jj))=nats       
 130                continue
                 endif
             endif 
          endif
 25   continue
 35   continue
c     write(6,*) ' FINE IT in checkeqvo',(it(kk),kk=1,4)
      return
      end 
c-----------------------------------------------------------------
      subroutine ruotapartenza(i1,i2,n1,n2,il,iii)
      Use Polpo
      USE Atomi
      USE General
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/partenza/istart00,istart(500),natspa,istart0,isalva
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/occtetra/it(500)
      dimension  xtet(3,4),x1(3),x2(3),xortet(4,8)
      dimension w(4,4),x11(4),x1t(4),x3(3),xa(3)
c
      if(iii.eq.0)then
      x1(1)=xt(1,i2,1)
      x1(2)=xt(2,i2,1)
      x1(3)=xt(3,i2,1)
      else
      x1(1)=xeql(1,1,iii)
      x1(2)=xeql(2,1,iii)
      x1(3)=xeql(3,1,iii)
      endif
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      if(iii.eq.0)then
      x1(1)=xyzs(1,i2)
      x1(2)=xyzs(2,i2)
      x1(3)=xyzs(3,i2)
      else
      x1(1)=xeql(1,2,iii)
      x1(2)=xeql(2,2,iii)
      x1(3)=xeql(3,2,iii)
      endif
      call molt1_rot(rmz, x1, x2)
      xortet(1,2)=x2(1)
      xortet(2,2)=x2(2)
      xortet(3,2)=x2(3)
      kk=0
      do 100 k=n1,n2
      kk=kk+1
c     write(6,*)(xyzs(kkk,k),kkk=1,3)
      x1(1)=xyzs(1,k)
      x1(2)=xyzs(2,k)
      x1(3)=xyzs(3,k)
      call molt1_rot(rmz, x1, x2)
      xortet(1,kk+2)=x2(1)
      xortet(2,kk+2)=x2(2)
      xortet(3,kk+2)=x2(3)
 100  continue
c---
c
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      nmax=4
      do 10 ii=1,nmax
      do 20 j=1,nmax
      if(ii.le.4.and.j.le.4)w(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtot(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtoti(ii,j)=0.0
 20   continue
 10   continue
      do i=1,3
      x2(i)=xortet(i,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      yfl=twopi*yfl
      call MatTott(x2,adif,bdif,cdif,ddif,yfl)
      call molt2_rott(rtoti, rtot, w)
         do 200 k=1,kk
          xortet(4,k+2)=1
         do j=1,4
           x11(j)=xortet(j,k+2)
         end do
          call molt1_rott(w, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
          do j=1,3
             xyzs(j,n1+k-1)=x1(j)
          end do
c         write(6,*) 'COORD.',n1,k,(xyzs(j,n1+k-1),j=1,3)
 200      continue
c-------
      return
      end
c -------------------------------------------------------------------------
      subroutine freetetra(nvolte,iarret)
      Use Polpo
      USE Atomi
c
      USE General
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/maybe/xtri(5,500,150),natstri(150),chitri(150),
     *             nztri(500,150),nvoltet
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/itsalva2/itsalva2(500),xtsalva2(3,500,500)
     *                ,natsalva
      common/chiquadro/chimin,chisquared,ntrialmin,chichi(150),
     *                 xchi(5,500,150),nzchi(500,150),natschi(150),
     *                 ntrialmn
      common/Gmatrix/ggMat(3,3)
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/occtetra/it(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /matr/rmz(3,3),rmiz(3,3)
      common/tetrafree/ nats1(10),nats2(10),nate,k1(10),k2(10),iox(500)
     *,libt(10)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      dimension xorig(3),x1(3),xo(3),x2(3),x3(3),xxxx(3,4)
      dimension xoo(11),xn(11),key(10)
      dimension yfl1(3)
c
      iarr = -1    
      doxigen = 2.2
      chimn=1.0E+15
      do 2000 i=1,nate
      idisp=1
      call sfl15e(nats,idisp,interp)
      n1=k2(i)         
      jj=k1(i)
      if(libt(i).ne.i) then
CANG  do 780 il=1,50 
      do 780 il=1,10 
      ill=il-1
      if(ill.ne.0)then
      do 70 ij1=1,natsalva
      it(ij1)=itsalva2(ij1)
      do 75 j=1,it(ij1)
      xt(1,ij1,j)=xtsalva2(1,ij1,j)
      xt(2,ij1,j)=xtsalva2(2,ij1,j)
      xt(3,ij1,j)=xtsalva2(3,ij1,j)
  75  continue
  70  continue
      kk1=nats1(i)
      kk2=nats2(i) 
      iii=0
c     do ik=kk1,kk2
c      if(xyzs(5,ik).lt.1.0) then
c       write(6,*) 'POS',ik,xyzs(5,ik)
c       return
c      endif
c     end do
c     write(6,*) 'SONO IN FREETETRA'
      call ruotapartenza(n1,jj,kk1,kk2,ill,iii)
c----------------------------------------------
c--- Non calcolo R-prof se uno degli ossigeni e'
c--- a distanza < 2.2 da un altro atomo di ossigeno
c----------------------------------------------
      do 856 jo=kk1,kk2   
         if (iox(jo).eq.0) goto 856
         x2(1) = xyzs(1,jo)
         x2(2) = xyzs(2,jo)
         x2(3) = xyzs(3,jo)
         xoo(1)=x2(1)
         xoo(2)=x2(2)
         xoo(3)=x2(3)
         iser = jo
         iactn=1
         khead=0
         ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
         xyzs(5,jo) = 1.0/float(key(10))
         x2(1)=xn(1)
         x2(2)=xn(2)
         x2(3)=xn(3)
CANG   do 855 io=1,nats
CANG     if (iox(io).eq.0) goto 855
CANG     if(io.ge.kk1.and.io.le.kk2)go to 855
CANG     x1(1) = xyzs(1,io)
CANG     x1(2) = xyzs(2,io)
CANG     x1(3) = xyzs(3,io)
CANG     call distanzan(ggMat,x1,x2,dcal)
c        if (dcal.lt.doxigen) then
c           write(6,*)' DCAL -ossigeno < 2.2 nella FREETETRA',dcal
c           write(6,*)' io,jo x1,x2 ',io,jo,x1,x2
c           go to 781
c        endif
C855   continue
         xyzs(1,jo) = x2(1)
         xyzs(2,jo) = x2(2)
         xyzs(3,jo) = x2(3)
         it(jj)=it(jj)+1
         xt(1,jj,it(jj))=x2(1)
         xt(2,jj,it(jj))=x2(2)
         xt(3,jj,it(jj))=x2(3)
         if(ntetra.gt.0)call checkequivt(x2,jj,jj)
         if(nott.gt.0)call checkequivo(x2,jj,jj)
 856     continue
c----------------------------------------------
CANNA
c----------------------------------------------
c--- Non calcolo R-prof se uno degli ossigeni e'
c--- a distanza < 2.2 da un altro atomo di ossigeno
c----------------------------------------------
c     elseif (ill.eq.0) then
c     do 850 io=1,nats
c        if (io.ge.kk1.and.io.le.kk2.or.iox(io).eq.0) goto 850
c        if (iox(io).eq.0) goto 850
c        x1(1) = xyzs(1,io)
c        x1(2) = xyzs(2,io)
c        x1(3) = xyzs(3,io)
c        do 851 jo=kk1,kk2
c           if (iox(jo).eq.0) goto 851
c           x2(1) = xyzs(1,jo)
c           x2(2) = xyzs(2,jo)
c           x2(3) = xyzs(3,jo)
c           call distanzan(ggMat,x1,x2,dcal)
c           if (dcal.lt.doxigen) then
c              write(6,*)' DCAL -ossigeno < 2.2 nella FREETETRA',dcal
c              write(6,*)' io,jo x1,x2 ',io,jo,x1,x2
c              go to 781
c           endif
c851     continue
c850  continue
      endif
c----------------------------------------------
      iarr = 0
      if(nmiss.eq.0)then
      iprier=1
      else
      iprier=0
      endif
      call calcolaerre(chi2,iprier)
C     if(nmiss.gt.0.and.chi2.lt.1.00*chimn)then
C     nvoltet=nvoltet+1
C     write(6,*)'CHISQUARED',chi2
C     natstri(nvoltet)=nats
C     chitri(nvoltet)=chisquare
C     do 3012 ji=1,nats
C     xtri(1,ji,nvoltet)=xyzs(1,ji)
C     xtri(2,ji,nvoltet)=xyzs(2,ji)
C     xtri(3,ji,nvoltet)=xyzs(3,ji)
C     xtri(4,ji,nvoltet)=xyzs(4,ji)
C     xtri(5,ji,nvoltet)=xyzs(5,ji)
C     nztri(ji,nvoltet)=nz(ji)
C3012 continue
C     endif
c     call to_coord(1)
      if(chi2.lt.chimn)then
      chimn=chi2
      ntrialmin=ntrial
c     write(6,*)'CHI2 diminuito',il
c     do 1000 ii=1,nats
c     write(6,'(i5,3f10.3)')nz(ii),(xyzs(k,ii),k=1,3)
c1000 continue
CCCC  kdirect=1
CCCC  interp=0
      call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
      endif
 781  continue          
 780  continue
CORO
      else
      kk1=nats1(i)
      kk2=nats2(i)
c     angstep=10
c     do 200 ang1=0,180-angstep,angstep
c      do 200 ang2=0,360-angstep,angstep
c       do 200 ang3=0,360-angstep,angstep
      do 300 ll=1,50
      do 301 ik=1,3
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      yfl1(ik)=twopi*yfl
 301  continue
      call RuotAtomi(yfl1,jj,kk1,kk2)
      if(nmiss.gt.0)then
      iprier=0
      else
      iprier=1
      endif
      call calcolaerre(chi2,iprier)
C     if(nmiss.gt.0.and.chi2.lt.1.00*chimn)then
C     nvoltet=nvoltet+1
C     write(6,*)'CHISQUARED',chi2
C     natstri(nvoltet)=nats
C     chitri(nvoltet)=chisquare
C     do 3032 ji=1,nats
C     xtri(1,ji,nvoltet)=xyzs(1,ji)
C     xtri(2,ji,nvoltet)=xyzs(2,ji)
C     xtri(3,ji,nvoltet)=xyzs(3,ji)
C     xtri(4,ji,nvoltet)=xyzs(4,ji)
C     xtri(5,ji,nvoltet)=xyzs(5,ji)
C     nztri(ji,nvoltet)=nz(ji)
C3032 continue
C     endif
c     call to_coord(1)
      if(chi2.lt.chimn)then
      chimn=chi2
      ntrialmin=ntrial
c     write(6,*)'CHI2 diminuito su tetraedro libero',ll
c     do 1001 ii=1,nats
c     write(6,'(i5,3f10.3)')nz(ii),(xyzs(k,ii),k=1,3)
c1001 continue
      kdirect=1
      interp=0
      call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
      endif
c200  continue
 300  continue
      endif
CORO
 2000 continue
      chisquared=chimn
c     if(nmiss.gt.0)
c    *write(lo,'(a,f10.4)')'  errep by rotating the tetrahedron',chimn
c     iarret = iarr
      iarret = 0   
      return
      end
c-----------------------------------------------------------------
      subroutine freeotta(nvolte,iarret)
      Use Polpo
      USE Atomi
c
      USE General
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/maybe/xtri(5,500,150),natstri(150),chitri(150),
     *             nztri(500,150),nvoltet
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/itsalva2/itsalva2(500),xtsalva2(3,500,500)
     *                ,natsalva
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/tetrafree/ nats1(10),nats2(10),nate,k1(10),k2(10),iox(500)
     *,libt(10)
      common/chiquadro/chimin,chisquared,ntrialmin,chichi(150),
     *                 xchi(5,500,150),nzchi(500,150),natschi(150),
     *                 ntrialmn
      common/Gmatrix/ggMat(3,3)
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/occtetra/it(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /matr/rmz(3,3),rmiz(3,3)
      common/ottafree/ nats1o(10),nats2o(10),nateo,k1o(10),k2o(10)
     *,libo(10)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      dimension xorig(3),x1(3),xo(3),x2(3),x3(3),xxxx(3,4)
      dimension xoo(11),xn(11),key(10)
      dimension yfl1(3)
c
      chimn=1.0E+15
      iarr = -1    
      doxigen = 2.2
      do 2000 i=1,nateo
      idisp=1
      call sfl15e(nats,idisp,interp)
      n1=k2o(i)         
      jj=k1o(i)
      if(libo(i).ne.i) then
CANG  do 780 il=1,50 
      do 780 il=1,10 
      ill=il-1
      if(ill.ne.0)then
      do 70 ij1=1,natsalva
      it(ij1)=itsalva2(ij1)
      do 75 j=1,it(ij1)   
      xt(1,ij1,j)=xtsalva2(1,ij1,j)
      xt(2,ij1,j)=xtsalva2(2,ij1,j)
      xt(3,ij1,j)=xtsalva2(3,ij1,j)
  75  continue
  70  continue
      kk1=nats1o(i)
      kk2=nats2o(i)
      iii=0
c     do ik=kk1,kk2
c      if(xyzs(5,ik).lt.1.0) then
c       write(6,*) 'POS',ik,xyzs(5,ik)
c       return
c      endif
c     end do
c     write(6,*) 'SONO IN FREEOTTA'
      call ruotapartenza(n1,jj,kk1,kk2,ill,iii)
c----------------------------------------------
c--- Non calcolo R-prof se uno degli ossigeni e'
c--- a distanza < 2.2 da un altro atomo di ossigeno
c----------------------------------------------
      do 851 jo=kk1,kk2
        if (iox(jo).eq.0) goto 851
         x2(1) = xyzs(1,jo)
         x2(2) = xyzs(2,jo)
         x2(3) = xyzs(3,jo)
         xoo(1)=x2(1)
         xoo(2)=x2(2)
         xoo(3)=x2(3)
         iser = jo
         iactn=1
         khead=0
         ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
         xyzs(5,jo) = 1.0/float(key(10))
         x2(1)=xn(1)
         x2(2)=xn(2)
         x2(3)=xn(3)
CANG  do 850 io=1,nats
CANG     if (io.ge.kk1.and.io.le.kk2) goto 850
CANG     if (iox(io).eq.0) goto 850
CANG     x1(1) = xyzs(1,io)
CANG     x1(2) = xyzs(2,io)
CANG     x1(3) = xyzs(3,io)
CANG     call distanzan(ggMat,x1,x2,dcal)
c        if (dcal.lt.doxigen) then
c            write(6,*)' DCAL -ossigeno < 2.2 nella FREEOTTA',dcal
c            write(6,*)' io,jo x1,x2 ',io,jo,x1,x2
c            go to 781
c        endif
C850  continue
         xyzs(1,jo) = x2(1)
         xyzs(2,jo) = x2(2)
         xyzs(3,jo) = x2(3)
         it(jj)=it(jj)+1
         xt(1,jj,it(jj))=x2(1)
         xt(2,jj,it(jj))=x2(2)
         xt(3,jj,it(jj))=x2(3)
         if(ntetra.gt.0)call checkequivt(x2,jj,jj)
         if(nott.gt.0)call checkequivo(x2,jj,jj)
 851     continue
c----------------------------------------------
      iarr = 0
      iprier=1
      call calcolaerre(chi2,iprier)
c----------------------------------------------
      endif
      if(nmiss.eq.0)then
      iprier=1
      else
      iprier=0
      endif
      call calcolaerre(chi2,iprier)
c     if(nmiss.gt.0.and.chi2.lt.1.00*chimn)then
c     nvoltet=nvoltet+1
c     write(6,*)'CHISQUARED',chi2
c     natstri(nvoltet)=nats
c     chitri(nvoltet)=chisquare
c     do 3012 ji=1,nats
c     xtri(1,ji,nvoltet)=xyzs(1,ji)
c     xtri(2,ji,nvoltet)=xyzs(2,ji)
c     xtri(3,ji,nvoltet)=xyzs(3,ji)
c     xtri(4,ji,nvoltet)=xyzs(4,ji)
c     xtri(5,ji,nvoltet)=xyzs(5,ji)
c     nztri(ji,nvoltet)=nz(ji)
c3012 continue
c     endif
c     call to_coord(1)
      if(chi2.lt.chimn)then
      chimn=chi2
      ntrialmin=ntrial
c     write(6,*)'CHI2 diminuito',il
c     do 1000 ii=1,nats
c     write(6,'(i5,3f10.3)')nz(ii),(xyzs(k,ii),k=1,3)
c1000 continue
      kdirect=1
      interp=0
      call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
      endif
 781  continue
 780  continue
CORO
      else
      kk1=nats1o(i)
      kk2=nats2o(i)
c     angstep=10
c     do 200 ang1=0,180-angstep,angstep
c      do 200 ang2=0,360-angstep,angstep
c       do 200 ang3=0,360-angstep,angstep
      do 300 ll=1,50
      do 301 ik=1,3
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      yfl1(ik)=twopi*yfl
 301  continue
      call RuotAtomi(yfl1,jj,kk1,kk2)
      if(nmiss.eq.0)then
      iprier=1
      else
      iprier=0
      endif
      call calcolaerre(chi2,iprier)
c     if(nmiss.gt.0.and.chi2.lt.1.00*chimn)then
c     nvoltet=nvoltet+1
c     write(6,*)'CHISQUARED',chi2
c     natstri(nvoltet)=nats
c     chitri(nvoltet)=chisquare
c     do 3032 ji=1,nats
c     xtri(1,ji,nvoltet)=xyzs(1,ji)
c     xtri(2,ji,nvoltet)=xyzs(2,ji)
c     xtri(3,ji,nvoltet)=xyzs(3,ji)
c     xtri(4,ji,nvoltet)=xyzs(4,ji)
c     xtri(5,ji,nvoltet)=xyzs(5,ji)
c     nztri(ji,nvoltet)=nz(ji)
c3032 continue
c     endif
c     call to_coord(1)
      if(chi2.lt.chimn)then
      chimn=chi2
      ntrialmin=ntrial
c     write(6,*)'CHI2 diminuito su tetraedro libero',ll
c     do 1001 ii=1,nats
c     write(6,'(i5,3f10.3)')nz(ii),(xyzs(k,ii),k=1,3)
c1001 continue
      kdirect=1
      interp=0
      call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
      endif
c200  continue
 300  continue
      endif
 2000 continue
      chisquared=chimn
c     if(nmiss.gt.0)
c    *write(lo,'(a,f10.4)')'  errep by rotating the octahedron',chimn
c     iarret = iarr
      iarret = 0    
      return
      end
c-----------------------------------------------------------------
      subroutine distanzaa(ggMat,x1,x2,dcal)   
      dimension x1(3),x2(3)
      dimension r(3),r2(3),sottr(3),ggMat(3,3)
c
      diff1=(x1(1)-x2(1))
      diff2=(x1(2)-x2(2))
      diff3=(x1(3)-x2(3))
      sottr(1)=diff1
      sottr(2)=diff2
      sottr(3)=diff3
      do 69 k=1,3
      r(k)=0.0
 69   continue
      do 70 k=1,3
            do 80 jj=1,3
               r(k)=r(k)+sottr(jj)*ggMat(jj,k)
 80         continue
 70         continue
      v=0
      do 90 k=1,3
            v=v+sottr(k)*r(k)
 90   continue
      dcal=sqrt(v)
      return
      end
c------------------------------------------------
      subroutine checkequivtt(xo,i1,ic1,xtet)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell
      real, dimension(3,3) :: gm
      common/occtetra/it(500)
      common/stampa/istampa
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/Gmatrix/ggMat(3,3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
c-    
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3),xtet(4,4),xb2(3),s(3)
      dimension vet(2)
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
c     write(6,*) ' INIZIO IT in checkeqvtt',(it(kk),kk=1,4)
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
c--
      do 5 il =1,ntetra
         if (ntetr(il).eq.i1) then
             idir = i1
             go to 6
         endif
 5    continue
 6    continue
c--
c-
c     do 10 ii=2,nsym2
c        xeq(1) = xo(1)
c        xeq(2) = xo(2)
c        xeq(3) = xo(3)
c        call equitt(xeq,ii)
c----------
c         call distanzan(ggMat,xo,xeq,dist)
c----------
      ifin=icent+1
        do 10 kt=1,spacegr%ncoper
        do 10 ifi=1,ifin
          coef=vet(ifi)
          do 10 kj=1,nsym
            if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 10
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
            !call xdist(xb2,xeq,dist,s)
            call xdisteqs(xb2,xeq,gm,dist,s)
            xeq(1)=xb2(1)+s(1)
            xeq(2)=xb2(2)+s(2)
            xeq(3)=xb2(3)+s(3)
          if (dist.gt.0.000001.and.dist.le.dmin) then
*            write(6,*)' CORDINATE X0 INIZIALI =',xo
             xo(1) = (xo(1) + xeq(1))/2.
             xo(2) = (xo(2) + xeq(2))/2.
             xo(3) = (xo(3) + xeq(3))/2.
c----
             xtet(1,ic1)=xo(1)
             xtet(2,ic1)=xo(2)
             xtet(3,ic1)=xo(3)
c----
*            write(6,*)' CORDINATE X0 MODIFICATE =',xo
             go to 11
           endif
   10    continue
   11    continue
c--
c----- check se un equivalente di xo e' legato con i cationi
c--
      angsog1 = 109.47*(1.0-atolt(idir))
      angsog2 = 109.47*(1.0+atolt(idir))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
c--
        dist1=dtetra(i1)*(1.0-dtolt(idir))
        dist2=dtetra(i1)*(1.0+dtolt(idir))
c-
        xcat(1) = xyzs(1,i1) 
        xcat(2) = xyzs(2,i1) 
        xcat(3) = xyzs(3,i1) 
c-
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c---
c          call equitt(xeq,ii)
c-----------------
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 k=1,nsym
c           if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,k,coef,xeq,kt)
        iser=1
        iactn=1
        khead=0
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
*       if(1.0/float(key(10)).lt.1.) then
*          write(6,*)'OCCUPANZA=',1.0/float(key(10))
*          write(6,*)'xeq prima kspec in checkeqvtt',xo1
*          write(6,*)'xeq dopo kspec in checkeqvtt',xeq
*       endif
c---
c         call distanzan(ggMat,xcat,xeq,dist)
          !call xdist(xcat,xeq,dist,s)
          call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if (dist.ge.dist1.and.dist.le.dist2) then
c--
c-- accetto solo atomi equiv. che formano angolo (109+/-soglia) con gli altri 
c-- dello stesso tetraedro
c--
                 iok = 1
                 do 40 kk=1,ic1
                    xoo(1) = xtet(1,kk)
                    xoo(2) = xtet(2,kk)
                    xoo(3) = xtet(3,kk)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if (ang1.lt.angsog1.or.ang1.gt.angsog2) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    ic1=ic1 + 1
                    if (ic1.le.4) then
                        xtet(1,ic1)=xeq(1)     
                        xtet(2,ic1)=xeq(2)     
                        xtet(3,ic1)=xeq(3)     
                        xtet(4,ic1)=0.0        
CANG
c                   if(ic1.eq.2)then
                    it(i1)=it(i1)+1
                    xt(1,i1,it(i1))=xeq(1)     
                    xt(2,i1,it(i1))=xeq(2)     
                    xt(3,i1,it(i1))=xeq(3)     
c                   endif
CANG
                    endif
                 endif
          endif
 25   continue
c     write(6,*) ' FINE IT in checkeqvtt',(it(kk),kk=1,4)
      return
      end 
c-----------------------------------------------------------------
      subroutine checkequivoo(xo,i1,ic1,xotta)
      Use Polpo
      USE Atomi
      USE Symmetry
      USE general, only:cell,spacegr,newvet
      USE cgeom
      USE unit_cell
      common/stampa/istampa
      common/occtetra/it(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/Gmatrix/ggMat(3,3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
c-    
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3),xotta(4,6),xb2(3),s(3)
      dimension vet(2)
c
      real, dimension(3,3) :: gm
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c--
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
c     write(6,*) ' INIZIO IT in checkeqvoo',(it(kk),kk=1,4)
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
c-
      do 5 il =1,nott
         if (notta(il).eq.i1) then
             idir = i1
             go to 6
         endif
 5    continue
 6    continue
c--
c     do 10 ii=2,nsym2
c        xeq(1) = xo(1)
c        xeq(2) = xo(2)
c        xeq(3) = xo(3)
c        call equitt(xeq,ii)
c----------
c         call distanzan(ggMat,xo,xeq,dist)
c----------
      ifin=icent+1
        do 10 kt=1,spacegr%ncoper
        do 10 ifi=1,ifin
          coef=vet(ifi)
          do 10 k=1,nsym
            if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 10
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,k,coef,xeq,kt)
            !call xdist(xb2,xeq,dist,s)
            call xdisteqs(xb2,xeq,gm,dist,s)
            xeq(1)=xb2(1)+s(1)
            xeq(2)=xb2(2)+s(2)
            xeq(3)=xb2(3)+s(3)
          if (dist.gt.0.000001.and.dist.le.dmin) then
*            write(6,*)' CORDINATE X0 INIZIALI =',xo
             xo(1) = (xo(1) + xeq(1))/2.
             xo(2) = (xo(2) + xeq(2))/2.
             xo(3) = (xo(3) + xeq(3))/2.
c----
             xotta(1,ic1)=xo(1)
             xotta(2,ic1)=xo(2)
             xotta(3,ic1)=xo(3)
c----
*            write(6,*)' CORDINATE X0 MODIFICATE =',xo
             go to 11
           endif
   10    continue
   11    continue
c--
c----- check se un equivalente di xo e' legato con i cationi
c--
      angsog1 = 90.0*(1.0-atolo(idir))
      angsog2 = 90.0*(1.0+atolo(idir))
      angsog11 = 180.0*(1.0-atolo(idir))
      angsog22 = 180.0*(1.0+atolo(idir))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
c--
        dist1=dotta1(i1)*(1.0-dtolo(idir))
        dist2=dotta1(i1)*(1.0+dtolo(idir))
        dist3=dotta1(i1)*(1.0-dtolo(idir))
        dist4=dotta1(i1)*(1.0+dtolo(idir))
c-
        xcat(1) = xyzs(1,i1) 
        xcat(2) = xyzs(2,i1) 
        xcat(3) = xyzs(3,i1) 
c-
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c---
c          call equitt(xeq,ii)
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 k=1,nsym
c           if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,k,coef,xeq,kt)
c-----------------
        iser=1
        iactn=1
        khead=0
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
*       if(1.0/float(key(10)).lt.1.) then
*          write(6,*)'OCCUPANZA=',1.0/float(key(10))
*          write(6,*)'xeq prima kspec in checkeqvoo',xo1
*          write(6,*)'xeq dopo kspec in checkeqvoo',xeq
*       endif
c---
c         call distanzan(ggMat,xcat,xeq,dist)
          !call xdist(xcat,xeq,dist,s)
          call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if ((dist.ge.dist1.and.dist.le.dist2)
     *    .or.(dist.ge.dist3.and.dist.le.dist4)) then
c--
c-- accetto solo atomi equiv. che formano angolo (90+/-soglia) con gli altri 
c-- dello stesso ottaedro
c--
                 iok = 1
                 do 40 kk=1,ic1
                    xoo(1) = xotta(1,kk)
                    xoo(2) = xotta(2,kk)
                    xoo(3) = xotta(3,kk)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if ((ang1.lt.angsog1).or.(ang1.gt.angsog2.and. 
     *              ang1.lt.angsog11).or.(ang1.gt.angsog22)) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    ic1=ic1 + 1
                    if (ic1.le.6) then
                        xotta(1,ic1)=xeq(1)     
                        xotta(2,ic1)=xeq(2)     
                        xotta(3,ic1)=xeq(3)     
                        xotta(4,ic1)=0.0        
CANG
c                   if(ic1.eq.2)then
                    it(i1)=it(i1)+1
                    xt(1,i1,it(i1))=xeq(1)     
                    xt(2,i1,it(i1))=xeq(2)     
                    xt(3,i1,it(i1))=xeq(3)     
c                   endif
CANG
                    endif
                 endif
          endif
 25   continue
c     write(6,*) ' FINE IT in checkeqvoo',(it(kk),kk=1,4)
      return
      end 
c-----------------------------------------------------------------
      subroutine whatbuild(nvolte,iarret)
      Use Polpo
      USE Atomi
      USE General
!corr      include 'rando.fi'
      USE randofi
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/stampa/istampa
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/chiquadro/chimin,chisquared,ntrialmin,chichi(150),
     *                 xchi(5,500,150),nzchi(500,150),natschi(150),
     *                 ntrialmn
      common/ottafree/ nats1o(10),nats2o(10),nateo,k1o(10),k2o(10)
     *,libo(10)
      common/itsalva2/itsalva2(500),xtsalva2(3,500,500)
     *                ,natsalva
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/Gmatrix/ggMat(3,3)
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/occtetra/it(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /matr/rmz(3,3),rmiz(3,3)
      common/tetrafree/ nats1(10),nats2(10),nate,k1(10),k2(10),iox(500)
     *,libt(10)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common/priorita/ntetrap(500),nottp(500)
      dimension ntetrmax(500),nottamax(500),itapp(500),itappo(500)
      dimension x1(3),x2(3),x3(3)
c
      nate=0
      nateo=0
      do 50 i=1,nats
      itappo(i)=it(i)
      itapp(i)=it(i)
 50   continue
      do 70 i=1,nats
      itsalva2(i)=it(i)
      do 75 j=1,it(i)
      xtsalva2(1,i,j)=xt(1,i,j)
      xtsalva2(2,i,j)=xt(2,i,j)
      xtsalva2(3,i,j)=xt(3,i,j)
  75  continue
  70  continue
      natsalva=nats
      if(ntetra.gt.0)then
      do 100 i=1,ntetra
      itmax1=-9999999
      do 150 j=1,ntetra
      jj=ntetr(j)
      if(it(jj).gt.itmax1)then
      itmax1=it(jj)
      jjsav=jj
      jsav=j
      endif
 150  continue
      ntetrmax(i)=jjsav
      ntetrap(i)=jsav
      it(jjsav)=-9999999
 100  continue
      do 55 i=1,nats
      it(i)=itappo(i)
 55   continue
      endif
      if(nott.gt.0)then
      pi1=pi-0.1
      pi2=pi+0.1
      do 400 j=1,nott
      jj=notta(j)
      ito=it(jj)
      if(ito.eq.2)then
      do 500 k=1,ito-1
      do 600 kk=k+1,ito
      x1(1)=xt(1,jj,k)
      x1(2)=xt(2,jj,k)
      x1(3)=xt(3,jj,k)
      x2(1)=xyzs(1,jj)
      x2(2)=xyzs(2,jj)
      x2(3)=xyzs(3,jj)
      x3(1)=xt(1,jj,kk)
      x3(2)=xt(2,jj,kk)
      x3(3)=xt(3,jj,kk)
      call angolon2(ggMat,x1,x2,x3,ang1)
      if(ang1.ge.pi1.and.ang1.le.pi2)itapp(jj)=itapp(jj)-1
 600  continue
 500  continue
      endif
 400  continue
      do 56 i=1,nats
      itappo(i)=itapp(i)
 56   continue
      do 200 i=1,nott
      itmax2=-9999999
      do 250 j=1,nott
      jj=notta(j)
      if(itapp(jj).gt.itmax2)then
      itmax2=itapp(jj)
      jjsav=jj
      jsav=j
      endif
 250  continue
      nottamax(i)=jjsav
      nottp(i)=jsav
      itapp(jjsav)=-9999999
 200  continue
      do 57 i=1,nats
      itapp(i)=itappo(i)
 57   continue
      endif
      if(ntetra.gt.0.and.nott.eq.0)then
      do 270 i=1,ntetra
      itrif=it(ntetrmax(i))
      if(itrif.lt.4)then
      k=ntetrap(i)
      call buildtetra(k,iarret)
      if (iarret.eq.-1) return
      endif
 270  continue
      elseif(ntetra.eq.0.and.nott.gt.0)then
      do 280 i=1,nott
      itrif=it(nottamax(i))
      if(itrif.lt.6)then
      k=nottp(i)
      call buildotta(k,iarret)
      if (iarret.eq.-1) return
      endif
 280  continue
      else
      do 299 ijk=1,ntetra+nott
      if(ijk.le.ntetra)then
      do 300 i=1,ntetra
      itt=it(ntetrmax(i))
      if(itt.ge.4)go to 300
      do 700 j=1,nott
      ito=itapp(nottamax(j))
      if(ito.ge.6)go to 700
      if(itt.ge.ito)then
      k=ntetrap(i)
      call buildtetra(k,iarret)
      if (iarret.eq.-1) return
      go to 300
      else
      k=nottp(j)
      call buildotta(k,iarret)
      if (iarret.eq.-1) return
      go to 300
      endif    
 700  continue
      k=ntetrap(i)
      call buildtetra(k,iarret)
      if (iarret.eq.-1) return
 300  continue
      else
      do 301 i=1,nott
      ito=itapp(nottamax(i))
      if(ito.ge.6)go to 301
      do 701 j=1,ntetra
      itt=it(ntetrmax(j))
      if(itt.ge.4)go to 701
      if(ito.ge.itt)then
      k=nottp(i)
      call buildotta(k,iarret)
      if (iarret.eq.-1) return
      go to 301
      else
      k=ntetrap(j)
      call buildtetra(k,iarret)
      if (iarret.eq.-1) return
      go to 301
      endif    
 701  continue
      k=nottp(i)
      call buildotta(k,iarret)
      if (iarret.eq.-1) return
 301  continue
      endif
 299  continue
      endif
      do 970 i=1,ntetra
      k=ntetrap(i)
      if(it(ntetr(k)).lt.4)then
      call buildtetra(k,iarret)
      if (iarret.eq.-1) return
      endif
 970  continue
      do 980 i=1,nott
      k=nottp(i)
      if(it(notta(k)).lt.6)then
      call buildotta(k,iarret)
      if (iarret.eq.-1) return
      endif
 980  continue
      iprier=1
      call calcolaerre(chi2,iprier)
      chisquared=chi2   
      ntrialmin=ntrial
CANNA
      iniat = 1
      call MakeLab(iniat,nats)
CANNA
      kdirect=1
      interp=0
      call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
      return
      end
c--------------------------------------------------------------
      subroutine statuslink(ier)
      Use Polpo
      USE Atomi
c
      USE General
      USE Symmetry
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/stampa/istampa
      common/connet/nvol,idem,jlsav,x22(3,500),isavsym(20),i1sav(20),
     *i2sav(20),savjj,istatus,ksavcen(20)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *             dotta1(500),notta(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/Gmatrix/ggMat(3,3)
      dimension x1(3),x2(3),xseq(3),ip(500),nlegatapp(500)
      dimension xsav(3,500)
      dimension nlinkas(20),dlinkas(20),xeqls(3,20),nsymls(20)
      dimension nyes(500),ication(500)
      dimension itrov(500)
c
      istatus=0
      do i=1,20
      isavsym(i)=0
      ksavcen(i)=0
      i1sav(i)=0
      i2sav(i)=0
      end do
      do i=1,nats
        nyes(i)=0
        do ii=1,ntetra
          if(i.eq.ntetr(ii))nyes(i)=1
        enddo   
        do ii=1,nott
          if(i.eq.notta(ii))nyes(i)=1
        enddo    
      enddo
      if(nmiss.gt.0)then
      nn0=0
      natsav=nats
      do 81 i=1,nats
      xsav(1,i)=xyzs(1,i)
      xsav(2,i)=xyzs(2,i)
      xsav(3,i)=xyzs(3,i)
c     nyes(i)=0
c     do 105 ii=1,ntetra
c     if(i.eq.ntetr(ii))nyes(i)=1
c105  continue
c     do 106 ii=1,nott
c     if(i.eq.notta(ii))nyes(i)=1
c106  continue
  81  continue
      do 91 i=1,nats
      if(nyes(i).gt.0)then
      nn0=nn0+1
      xyzs(1,nn0)=xsav(1,i)
      xyzs(2,nn0)=xsav(2,i)
      xyzs(3,nn0)=xsav(3,i)
      ication(nn0)=i
      endif
  91  continue
      nats=nn0
      endif
c
      coef=1.65
c     coef=1.5
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      distmin=2.5
c     distmin=2.0
      xseq(1)=xyzs(1,1)
      xseq(2)=xyzs(2,1)
      xseq(3)=xyzs(3,1)
CORO
cang  if(nmiss.eq.0)then
cang  x1(1)=xyzs(1,1)
cang  x1(2)=xyzs(2,1) 
cang  x1(3)=xyzs(3,1) 
cang  do 188 j=1,nats
cang  x2(1)=xyzs(1,j)
cang  x2(2)=xyzs(2,j)
cang  x2(3)=xyzs(3,j)
c
C----modifica le X solo per traslazione -----------
c
cang  do 289 kt=1,ncentr
cang  call distanzaeqag1(j,x1,x2,kt)
 
c289  continue
c188  continue
cang   interp = 1
cang  call frm15e(nats,interp)
 
c     do i=1,nats
c     write(6,*) 'COORDINATE',i,(xyzs(k,i),k=1,3)
c     end do
CORO
cang  endif
      do 90 i=1,nats
      if(nz(i).eq.0) go to 90
      if(nyes(i).eq.0) go to 90
      ip(i)=1
      x1(1)=xyzs(1,i)
      x1(2)=xyzs(2,i) 
      x1(3)=xyzs(3,i) 
      ii=1
      kt=1
      call equitt(x1,ii,kt)
      kz1=abs(nz(i)/100)
      do 190 j=1,nats
      if(nz(j).eq.0) go to 190
      if(nyes(j).eq.0) go to 190
      kz2=abs(nz(j)/100)
!corr      distmax=coef*(radii(kz1,1)+radii(kz2,1))
      distmax=coef*(celem(kz1)%c_radius+celem(kz2)%c_radius)
c      write (6,*) 'DISTANZE',i,j,kz1,kz2,radii(kz1,1),radii(kz2,1)
c    *,distmax,distmin,coef
      do 239 kt=1,spacegr%ncoper
      do 240 ii=1,nsym2
      x2(1)=xyzs(1,j)
      x2(2)=xyzs(2,j)
      x2(3)=xyzs(3,j)
      nvol=0
c     if(nmiss.eq.0)then
      call distanzaeqag(ii,kt,ggMat,x1,x2,dcal)
c     else
c     call distanzaa(ggMat,x1,x2,dcal)
c     endif
      if(dcal.ge.distmin.and.dcal.le.distmax)then
c     write(6,*) ' Atomo i,j, simmetria ii distanza',
c    *i,j,ii,distmin,DCAL,distmax
      if(j.eq.i)then
      ip(i)=0
      go to 191
      endif
      endif
 240  continue
 239  continue
 190  continue
 191  continue
  90  continue
CORO
      ntrov=0
      if(itet.ne.0) then
      do ll=1,ntetra
        ntrov=ntrov+1
        itrov(ntrov)=ntetr(ll)
      end do
      endif
      if(iott.ne.0) then
      do ll=1,nott
        ntrov=ntrov+1
        itrov(ntrov)=notta(ll)
      end do
      endif
CORO
      do 100 iii=1,nats*2
      iitrov=0
CORO  if(iii.lt.nats.and.ip(iii).eq.0)go to 100
      if(iii.le.nats.and.ip(iii).eq.0)go to 100
      i=iii
      if(iii.gt.nats)then
      i=iii-nats
      if(ip(i).eq.1)go to 100
      endif
      if(nz(i).eq.0) go to 100
      if(nyes(i).eq.0) go to 100
CORO
      do l=1,ntrov
        if(i.eq.itrov(l)) iitrov=1
      end do
      if(iitrov.ne.1) go to 100
CORO
      x1(1)=xyzs(1,i)
      x1(2)=xyzs(2,i) 
      x1(3)=xyzs(3,i) 
      ii=1
      kt=1
      call equitt(x1,ii,kt)
      ileg=1
      kz1=abs(nz(i)/100)
      do 200 jj=1,nats+1
      if(jj.eq.1)then
      j=i
      else
      if((jj-1).ne.i)then
      j=jj-1
      else
      go to 200
      endif
      endif
      if (nz(j).eq.0) go to 200
      if (nyes(j).eq.0) go to 200
      kz2=abs(nz(j)/100)
!corr      distmax=coef*(radii(kz1,1)+radii(kz2,1))
      distmax=coef*(celem(kz1)%c_radius+celem(kz2)%c_radius)
      nvol=1
      savjj=j
      do 249 kt=1,spacegr%ncoper
      do 250 ii=1,nsym2
      x2(1)=xyzs(1,j)
      x2(2)=xyzs(2,j)
      x2(3)=xyzs(3,j)
      idem=1
      istatus=1
CGIG
c     if(nmiss.eq.0)then
      call distanzaeqag(ii,kt,ggMat,x1,x2,dcal)
c     else
c     call distanzaa(ggMat,x1,x2,dcal)
c     endif
      istatus=0
      if(dcal.ge.distmin.and.dcal.le.distmax)then
c     write(6,*) ' ATOMO i,j, simmetria ii distanza',
c    *i,j,ii,DCAL,distmin,distmax
      if(idem.eq.1) then
      iisav=ii
      ktsav=kt
      if(ileg.eq.1)then
      ilinka=ilinka+1    
      endif
      ileg=ileg+1
      nlinka(1,ilinka)=i
      nlinka(ileg,ilinka)=j
      nlegat(ilinka)=ileg
      xeql(1,1,ilinka)=xyzs(1,i)
      xeql(2,1,ilinka)=xyzs(2,i)
      xeql(3,1,ilinka)=xyzs(3,i)
      xeql(1,ileg,ilinka)=x2(1)
      xeql(2,ileg,ilinka)=x2(2)
      xeql(3,ileg,ilinka)=x2(3)
      nsyml(ileg,ilinka)=iisav
      kcen(ileg,ilinka)=ktsav
CORO
      if(ileg.eq.2) then
       if(xeql(1,2,ilinka).ne.xyzs(1,j).or.xeql(2,2,ilinka).ne.xyzs(2,j) 
     *.or.xeql(3,2,ilinka).ne.xyzs(3,j)) then
         isavsym(ilinka)=iisav
         ksavcen(ilinka)=ktsav
         i1sav(ilinka)=i 
         i2sav(ilinka)=j 
       endif
      endif
CORO
      if(itet.eq.1) then
      do 300 k=1,ntetra 
      if(ntetr(k).eq.i)then
      dlinka(1,ilinka)=dtetra(k)
      nsyml(1,ilinka)=100
      do 302 l=1,ntetra
      if(ntetr(l).eq.j)then
      dlinka(ileg,ilinka)=dtetra(l)
      go to 303
      endif
 302  continue
      do 304 l=1,nott
      if(notta(l).eq.j)then
      dlinka(ileg,ilinka)=dotta1(l)
      go to 303
      endif
 304  continue
      dlinka(ileg,ilinka)=(dcal-dtetra(k))*1.1
 303  continue
      go to 301
      endif
 300  continue
      endif
      if(iott.eq.1) then
      do 400 k=1,nott 
      if(notta(k).eq.i)then
      dlinka(1,ilinka)=dotta1(k)
      nsyml(1,ilinka)=200
      do 402 l=1,nott
      if(notta(l).eq.j)then
      dlinka(ileg,ilinka)=dotta1(l)
      go to 403
      endif
 402  continue
      do 404 l=1,ntetra
      if(ntetr(l).eq.j)then
      dlinka(ileg,ilinka)=dtetra(l)
      go to 403
      endif
 404  continue
      dlinka(ileg,ilinka)=(dcal-dotta1(k))*1.1
 403  continue
      go to 401
      endif
 400  continue
      endif
      dlinka(1,ilinka)=dcal*0.5
      dlinka(ileg,ilinka)=dcal*0.5             
 401  continue
 301  continue
      endif
      endif
 250  continue
 249  continue
 200  continue
 100  continue
CORO
       if(ilinka.eq.0) then
        if(nmiss.eq.0)then
          write(6,*)
          write(6,*)
          write(6,*) '                  **** No Links ****'
          ier=-1
          return
        else
          go to 910
        endif
       endif
       if(ilinka.eq.0)go to 910
CORO
      do 800 i=1,ilinka
      nlegatapp(i)=nlegat(i)
      if(nlinka(1,i).eq.nlinka(2,i))nlegatapp(i)=nlegat(i)+1
 800  continue
      do 900 i=1,ilinka
      nlegatmax=-999999.0
      do 950 j=1,ilinka
      if(nlegatapp(j).gt.nlegatmax)then
      nlegatmax=nlegatapp(j)
      jsav=j
      endif
 950  continue
      nlegatapp(jsav)=-9999999
      iordcon(i)=jsav
 900  continue
 910  continue
      if(nmiss.gt.0)then
      nats=natsav
      do 1111 i=1,nats
      xyzs(1,i)=xsav(1,i)
      xyzs(2,i)=xsav(2,i)
      xyzs(3,i)=xsav(3,i)
 1111 continue
      if(ilinka.gt.0)then
      do 1001 kkk=1,ilinka
      i=iordcon(kkk)
      do 1002 k=1,nlegat(i)
      nlinka(k,i)=ication(nlinka(k,i))
 1002 continue
 1001 continue
      endif
      endif
      if(nmiss.eq.0.and.ilinka.ne.0)then
      write(lo,'(/,a,/)')'           CATION CONNECTIVITY TABLE'
      do 1000 kkk=1,ilinka
      i=iordcon(kkk)
      write(lo,'(a,5x,17i5)')'  cation number',
     *(nlinka(k,i),k=1,nlegat(i))
      write(lo,'(a,13x,16i5)')'  symmetry  ',(nsyml(k,i),k=2,nlegat(i))
      write(lo,'(a,15x,16(f5.2,1x))')'  distance  ',
     *                          (dlinka(k,i),k=2,nlegat(i))
 1000 continue
      endif
      return
      end
c-----------------------------------------------------------------
c-----------------------------------------------------------------
      subroutine distanzaeqag(ii,kt,ggMat,x1,x2,dcal)   
      Use Polpo
c--
      USE Symmetry
      common/stampa/istampa
!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)
      common/tetralink/ilinka,nlegat(500),iordcon(500)
c--
      common/connet/nvol,idem,jlsav,x22(3,500),isavsym(20),i1sav(20),
     *i2sav(20),savjj,istatus,ksavcen(20)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      dimension x1(3),x2(3),xeq(3)
      dimension r(3),r2(3),sottr(3),ggMat(3,3),diff(3)
      dimension xdif(3)
c---
CCAL
      zero=1.0E-5
      dmin = 9999999.
      distsogg=0.5
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
c
        xeq(1) = x2(1)
        xeq(2) = x2(2)
        xeq(3) = x2(3)
c     write(6,'(a,3f10.3)')'X1',x1
c     write(6,'(a,3f10.3)')'X2',x2
         call equitt(xeq,ii,kt)
         do 200 j=1,3
            diff(j)=xeq(j)-x1(j)
            sottr(j)=abs(diff(j))
            if (sottr(j).gt.distsogg) then
                if(nmiss.eq.0)diff(j)=xeq(j)+1.0-x1(j)
                sottr(j)=abs(diff(j))
                if (sottr(j).gt.distsogg) then
                    if(nmiss.eq.0)diff(j)=xeq(j)-1.0-x1(j)
                    sottr(j)=abs(diff(j))
CANNA
                    if (sottr(j).gt.distsogg) then
                        if(nmiss.eq.0)diff(j)=xeq(j)+2.0-x1(j)
                        sottr(j)=abs(diff(j))
                        if (sottr(j).gt.distsogg) then
                            if(nmiss.eq.0)diff(j)=xeq(j)-2.0-x1(j)
                            sottr(j)=abs(diff(j))
                        end if
                    end if
CANNA
                end if
            end if
      sottr(j)=diff(j)
      x2(j)=diff(j)+x1(j)
c-----
c     write(6,'(a,3f10.3)')'XEQ',xeq
c     write(6,*)'X2',x2
c     write(6,*)'X',j,xyzs(j,savjj)
c-----
 200     continue
CORO
        if(istatus.eq.1) then
         if(nvol.eq.0) go to 11
         if(nvol.eq.1) then
           do jk=1,3
           x22(jk,nvol)=x2(jk)
           end do
           go to 11
         endif
         do jk=1,3
         x22(jk,nvol)=x2(jk)
         end do
         do il=1,nvol-1
          if(savjj.eq.jlsav) then
            xdif(1)=abs(x2(1)-x22(1,il))
            xdif(2)=abs(x2(2)-x22(2,il))
            xdif(3)=abs(x2(3)-x22(3,il))
            if(xdif(1).le.zero.and.xdif(2).le.zero.and.
     *         xdif(3).le.zero) then
               idem=0 
               go to 11
            endif
          endif
         end do
 11     continue
         jlsav=savjj
         nvol=nvol+1
      endif
CORO
      do 69 k=1,3
      r(k)=0.0
 69   continue
      do 70 k=1,3
            do 80 jj=1,3
               r(k)=r(k)+sottr(jj)*ggMat(jj,k)
 80         continue
 70         continue
      v=0
      do 90 k=1,3
            v=v+sottr(k)*r(k)
 90   continue
      dcal=sqrt(v)
c     write(6,*)'DCAL',dcal
      return
      end
c------------------------------------------------
      subroutine metti(ksav,vetintsav,nzSavv,iarret)
      Use Polpo
      USE Atomi
      USE General
!corr      include 'rando.fi'
      USE randofi
      common/lievrot/iruotat
      common/stampa/istampa
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/chiquadro/chimin,chisquared,ntrialmin,chichi(150),
     *                 xchi(5,500,150),nzchi(500,150),natschi(150),
     *                 ntrialmn
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/tetrafree/ nats1(10),nats2(10),nate,k1(10),k2(10),iox(500)
     *,libt(10)
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/occtetra/it(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /matr/rmz(3,3),rmiz(3,3)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common /matr1/ rx(3,3),ry(3,3),rz(3,3)
      common/Gmatrix/ggMat(3,3)
      common/partenza/istart00,istart(500),natspa,istart0,isalva
      dimension x1(3),x2(3),x3(3),x4(3),xorig(3)
      dimension x11(3),xo(3),dp(500)
      dimension xx1(3),xp(3),xx2(3),xtet(4,6),xxt(3)
      dimension xoo(11),xn(11),key(10),xm(3),xotta(4,6)
c
CANG
      norot=0
      itcom=0
CORO
      ik1=nlinka(1,ksav)
      do 185 j=1,ntetra
      i3=ntetr(j)
      if(ik1.eq.i3) itcom=4
 185  continue
      do 122 j=1,nott
      i3=notta(j)
      if(ik1.eq.i3) itcom=6
 122  continue
      if(it(ik1).eq.itcom) return
CORO
      itcom=0
      if(it(ik1).eq.1)then
      do 99 k=2,nlegat(ksav)
      ik2=nlinka(k,ksav)
      if(ik2.eq.ik1)go to 99
      do 189 j=1,ntetra
      i3=ntetr(j)
      if(ik2.eq.i3)then
      itcom=4
      go to 190
      endif
 189  continue
      do 120 j=1,nott
      i3=notta(j)
      if(ik2.eq.i3)then
      itcom=6
      go to 121
      endif
 120  continue
 121  continue
 190  continue
      if(it(ik2).ne.itcom)go to 101
 99   continue     
      return
      endif
CANG
 101  continue
      ip1=nlinka(1,ksav)
*     if(ip1.eq.5) write(6,*) 'ROS.',(xt(j,ip1,1),j=1,3)
      dsog=0.6
      dsogok=0.6
      if(nsyml(1,ksav).eq.100)then
      alfa=109.47*dtor
      do 201 ij=1,4
      xtet(4,ij)=1.0
 201  continue
      dd=dlinka(1,ksav)
      ic=it(ip1)
      do 202 k=1,ic
      xtet(1,k)=xt(1,ip1,k)
      xtet(2,k)=xt(2,ip1,k)
      xtet(3,k)=xt(3,ip1,k)
      x2(1)=xtet(1,k)
      x2(2)=xtet(2,k)
      x2(3)=xtet(3,k)
      kc=k
      kc0=kc
      call checkequivtt(x2,ip1,kc,xtet)
*     if(ip1.eq.5) write(6,*) 'ROS1.',(xt(j,ip1,1),j=1,3)
      if(kc.gt.kc0)norot=1
 202  continue
      ic=it(ip1)
      if(ic.eq.4)return
      iok=0
 506  continue
      do 507 k=1,ic
      xtet(1,k)=xt(1,ip1,k)
      xtet(2,k)=xt(2,ip1,k)
      xtet(3,k)=xt(3,ip1,k)
 507  continue
      ic1=ic-1
      if(ic.eq.1)then
      x1(1)=xt(1,ip1,ic)-xeql(1,1,ksav)
      x1(2)=xt(2,ip1,ic)-xeql(2,1,ksav)
      x1(3)=xt(3,ip1,ic)-xeql(3,1,ksav)
      call molt1_rot(rmz, x1, x2)
      call generat1(x2,dd,alfa,x3,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x3, xo)
      xtet(1,2)=xo(1)+xeql(1,1,ksav)
      xtet(2,2)=xo(2)+xeql(2,1,ksav)
      xtet(3,2)=xo(3)+xeql(3,1,ksav)
      x2(1)=xtet(1,2)
      x2(2)=xtet(2,2)
      x2(3)=xtet(3,2)
c     x2(1)=0.666666
c     x2(2)=0.4394131
c     x2(3)=0.084927
      ic1=ic1+1
c---
      kc=2
      kc0=kc
      call checkequivtt(x2,ip1,kc,xtet)
      if(kc.gt.kc0)norot=1
      if (kc.gt.2) then
          ic1=kc-1
      endif
*     write(6,*)' IC1 dopo checkequivtt',ic1
      endif
c---
      do 295 k=ic1+2,4
      iok=0
 293  continue
      x1(1)=xtet(1,k-2)-xeql(1,1,ksav)
      x1(2)=xtet(2,k-2)-xeql(2,1,ksav)
      x1(3)=xtet(3,k-2)-xeql(3,1,ksav)
      call molt1_rot(rmz, x1, x2)
      x1(1)=xtet(1,k-1)-xeql(1,1,ksav)
      x1(2)=xtet(2,k-1)-xeql(2,1,ksav)
      x1(3)=xtet(3,k-1)-xeql(3,1,ksav)
      call molt1_rot(rmz, x1, x3)
      call generat2(x2,x3,dd,alfa,x1,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x1, xo)
      xtet(1,k)=xo(1)+xeql(1,1,ksav)
      xtet(2,k)=xo(2)+xeql(2,1,ksav)
      xtet(3,k)=xo(3)+xeql(3,1,ksav)
      x1(1)=xtet(1,k)
      x1(2)=xtet(2,k)
      x1(3)=xtet(3,k)
      do 522 ijk=1,k-1
      x2(1)=xtet(1,ijk)
      x2(2)=xtet(2,ijk)
      x2(3)=xtet(3,ijk)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      else
      iarret=-1
      return
      endif
      endif
 522  continue
 396  continue
      kc=k
      kc0=kc
      call checkequivtt(x1,ip1,kc,xtet)
      if(kc.gt.kc0)norot=1
      if(kc.ge.4) go to 296
 295  continue
 296  continue
      if(istampa.gt.0)then
      write(lo,998)
      do 999 kk=1,4
      write(lo,'(10x,3f10.3)')(xtet(k,kk),k=1,3)
 999  continue
      endif
 998  format(//,17x,'Polyhedron to rotate',//,17x,
     *'X         Y         Z',/)
      ipoly=1
      call Ruotapoly(xtet,ksav,irif,iarret,ipoly,norot)
      if (irif.eq.0) then
         iarret = -1
         return
      endif
c     if(iruotat.eq.0) then
c      ilr=2
c     else
c      ilr=1
c     endif
CANNA
      natss = nats-1
CANNA
      do 890 k=2,4
      x1(1)=xtet(1,k)
      x1(2)=xtet(2,k)
      x1(3)=xtet(3,k)
      do 891 kk=1,nats
      x2(1)=xyzs(1,kk)
      x2(2)=xyzs(2,kk)
      x2(3)=xyzs(3,kk)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
CANNA
        if (kk.gt.natss) go to  890
CANNA
      iarret=-1
      return
      endif
 891  continue
      if((it(ip1)+1).gt.4)go to 890
      it(ip1)=it(ip1)+1
c----
c----
c---- check posizioni speciali
c----
      xoo(1)=xtet(1,k)
      xoo(2)=xtet(2,k)
      xoo(3)=xtet(3,k)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
      xm(1)=xn(1)
      xm(2)=xn(2)
      xm(3)=xn(3)
c----
      xt(1,ip1,it(ip1))=xm(1)
      xt(2,ip1,it(ip1))=xm(2)
      xt(3,ip1,it(ip1))=xm(3)
      if(xtet(4,k).gt.0.0)then
      nats=nats+1
      natspa=nats
      ntt(ip1,it(ip1))=nats
      xyzs(1,nats)=xm(1)
      xyzs(2,nats)=xm(2)
      xyzs(3,nats)=xm(3)
      xyzs(4,nats)=vetintsav
c----
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.0*biso
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
c----------
      if(ntetra.gt.0)call checkequivt(xm,ip1,ip1)
      if(nott.gt.0)call checkequivo(xm,ip1,ip1)
c----------
      endif
 893  continue
 890  continue
      if(istampa.gt.0)then
      write(lo,'(/,a,/)')' Adding more atoms.....'
      do 1000 i=1,nats
      write(lo,'(5x,4f10.3)')(xyzs(k,i),k=1,3),bfac(i)      
 1000 continue
      endif
      elseif(nsyml(1,ksav).eq.200)then
      do 1201 ij=1,6
      xotta(4,ij)=1.0
 1201 continue
      alfa=90.0*dtor
      ip1=nlinka(1,ksav)
      dd=dlinka(1,ksav)
      ic=it(ip1)
      do 1202 k=1,ic
      xotta(1,k)=xt(1,ip1,k)
      xotta(2,k)=xt(2,ip1,k)
      xotta(3,k)=xt(3,ip1,k)
      x2(1)=xotta(1,k)
      x2(2)=xotta(2,k)
      x2(3)=xotta(3,k)
      kc=k
      kc0=kc
      call checkequivoo(x2,ip1,kc,xotta)
      if(kc.gt.kc0)norot=1
 1202 continue
      ic=it(ip1)
      if(ic.eq.6)return
      iok=0
 1506 continue
      do 1507 k=1,ic
      xotta(1,k)=xt(1,ip1,k)
      xotta(2,k)=xt(2,ip1,k)
      xotta(3,k)=xt(3,ip1,k)
 1507 continue
      ic1=ic-1
      if(ic.eq.1)then
      x1(1)=xt(1,ip1,ic)-xeql(1,1,ksav)
      x1(2)=xt(2,ip1,ic)-xeql(2,1,ksav)
      x1(3)=xt(3,ip1,ic)-xeql(3,1,ksav)
      call molt1_rot(rmz, x1, x2)
      call generat1_ott(x2,dd,alfa,x3,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x3, xo)
      xotta(1,2)=xo(1)+xeql(1,1,ksav)
      xotta(2,2)=xo(2)+xeql(2,1,ksav)
      xotta(3,2)=xo(3)+xeql(3,1,ksav)
CROX   
*     xotta(1,2)=0.426
*     xotta(2,2)=0.835
*     xotta(3,2)=0.049
CROX   
      x2(1)=xotta(1,2)
      x2(2)=xotta(2,2)
      x2(3)=xotta(3,2)
      ic1=ic1+1
c---
      kc=2
      kc0=kc
      call checkequivoo(x2,ip1,kc,xotta)
      if(kc.gt.kc0)norot=1
      if (kc.gt.2) then
          ic1=kc-1
      endif
      endif
c---
 1294 continue
      do 1295 k=ic1+2,6
      iok=0
 1293 continue
      x1(1)=xotta(1,k-2)-xeql(1,1,ksav)
      x1(2)=xotta(2,k-2)-xeql(2,1,ksav)
      x1(3)=xotta(3,k-2)-xeql(3,1,ksav)
      call molt1_rot(rmz, x1, x2)
      x1(1)=xotta(1,k-1)-xeql(1,1,ksav)
      x1(2)=xotta(2,k-1)-xeql(2,1,ksav)
      x1(3)=xotta(3,k-1)-xeql(3,1,ksav)
      call molt1_rot(rmz, x1, x3)
      call generat2_ott(x2,x3,dd,alfa,x1,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x1, xo)
      xotta(1,k)=xo(1)+xeql(1,1,ksav)
      xotta(2,k)=xo(2)+xeql(2,1,ksav)
      xotta(3,k)=xo(3)+xeql(3,1,ksav)
CROX   
*     if (k.eq.3) then
*     xotta(1,k)=0.911
*     xotta(2,k)=0.899
*     xotta(3,k)=0.057
*     endif
CROX   
      x1(1)=xotta(1,k)
      x1(2)=xotta(2,k)
      x1(3)=xotta(3,k)
      do 1522 ijk=1,k-1
      x2(1)=xotta(1,ijk)
      x2(2)=xotta(2,ijk)
      x2(3)=xotta(3,ijk)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  1293
      else
      iarret=-1
      return
      endif
      endif
 1522 continue
 1396 continue
      kc=k
      kc0=kc
      call checkequivoo(x1,ip1,kc,xotta)
      if(kc.gt.kc0)norot=1
      if (kc.gt.k) then
         ic1 = kc-1
         go to 1294
      endif
      if(kc.ge.6) go to 1296
c---
 1295 continue
 1296 continue
      if(istampa.gt.0)then
      write(lo,1998)
      do 1999 kk=1,6
      write(lo,'(10x,3f10.3)')(xotta(k,kk),k=1,3)
 1999 continue
      endif
 1998  format(//,17x,'Octahedron to rotate',//,17x,
     *'X         Y         Z',/)
      ipoly=2
      call Ruotapoly(xotta,ksav,irif,iarret,ipoly,norot)
      if(irif.eq.0)then
      iarret=-1
      return
      endif
CANNA
      natss = nats-1
CANNA
      do 1890 k=2,6
      x1(1)=xotta(1,k)
      x1(2)=xotta(2,k)
      x1(3)=xotta(3,k)
      do 1891 kk=1,nats
      x2(1)=xyzs(1,kk)
      x2(2)=xyzs(2,kk)
      x2(3)=xyzs(3,kk)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
CANNA
        if (kk.gt.natss) go to 1890
CANNA
      iarret=-1
      return
      endif
 1888 continue
 1891 continue
      if((it(ip1)+1).gt.6)go to 1890
      it(ip1)=it(ip1)+1
c----
c---- check posizioni speciali
c----
      xoo(1)=xotta(1,k)
      xoo(2)=xotta(2,k)
      xoo(3)=xotta(3,k)
      iser = nats
      iactn=1
      khead=0
      ksp=kspecb(newvet,xoo,xn,key,itype,iser,khead,iactn)
      xyzs(5,nats) = 1.0/float(key(10))
      xm(1)=xn(1)
      xm(2)=xn(2)
      xm(3)=xn(3)
      xt(1,ip1,it(ip1))=xm(1)
      xt(2,ip1,it(ip1))=xm(2)
      xt(3,ip1,it(ip1))=xm(3)
      if(xotta(4,k).gt.0.0)then
      nats=nats+1
      ntt(ip1,it(ip1))=nats
      natspa=nats
c----
      xyzs(1,nats)=xm(1)
      xyzs(2,nats)=xm(2)
      xyzs(3,nats)=xm(3)
      xyzs(4,nats)=vetintsav
c----
      nz(nats)=nzSavv
      iox(nats) = 1
      bfac(nats)=3.0*biso
      if(bfac(nats).lt.1.0)bfac(nats)=1.0
      if(bfac(nats).gt.5.0)bfac(nats)=5.0
c----------
      if(ntetra.gt.0)call checkequivt(xm,ip1,ip1)
      if(nott.gt.0)call checkequivo(xm,ip1,ip1)
c----------
      endif
 1893 continue
 1890 continue
      if(istampa.gt.0)then
      write(lo,'(/,a,/)')' Adding more atoms.....'
      do 1100 i=1,nats
      write(lo,'(5x,4f10.3)')(xyzs(k,i),k=1,3),bfac(i)
 1100 continue
      endif
      endif
      return
      end
c-----------------------------------------------------------------
      subroutine Ruotapoly(xtet,ksav,irif,iarret,ipoly,norot)
      Use Polpo
      USE Atomi
      USE General
*     include 'atoms.fi'
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common/lievrot/iruotat
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/conta/iconta
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
*      common/trig/sint(45000),pi,twopi,dtor,rtod
****  common /atoms/ x(5,500),nz(500),idumx(21)
c     common /atoms/ x(5,500),nz(500),bfac(500),idumx(4001)
!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)
!corr
!      common /constnats/ nats
!corr
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/partenza/istart00,istart(500),natspa,istart0,isalva
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/occtetra/it(500)
      dimension  xtet(4,6),x1(3),x2(3),xortet(4,8)
      dimension w(4,4),x11(4),x1t(4),x3(3),xa(3)
      dimension xortet_sav(4,6),xtet_sav(4,6),cfom(10001)
c--------
      if(ipoly.eq.1)then
      nmax=4
      nmax1=5
      else
      nmax=6
      nmax1=7
      endif
c     irif = 0
      irif = 1
      do 11 i=1,10001
         cfom(i) = 0.0
 11   continue
      w1 = 1.0
      w2 = 1.0
c--------
      do 10 i=1,nmax
      if(i.le.4)x1t(i)=0.0
      do 20 j=1,nmax
      if(i.le.4.and.j.le.4)w(i,j)=0.0
      if(i.le.4.and.j.le.4)rtot(i,j)=0.0
      if(i.le.4.and.j.le.4)rtoti(i,j)=0.0
 20   continue
 10   continue
c-----------------
      dsum=0.0
      asum=0.0
      cfo=0.0
c     do 15 ii= 2,nlegat(ksav)
      if(nlegat(ksav).le.2) go to 16
      do 15 ii= 3,nlegat(ksav)
      d=dlinka(ii,ksav)
      i2=nlinka(ii,ksav)
      do 200 j=1,ntetra
      i3=ntetr(j)
      if(i2.eq.i3)then
      dmin=d*(1.0-dtolt(j))
      dmax=d*(1.0+dtolt(j))
      angsog1 = 109.47*(1.0-atolt(j))
      angsog2 = 0.0                      
      angsog11 = 0.0                      
      angsog22 = 109.47*(1.0+atolt(j))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
      ango1=109.47*dtor
      ango2=109.47*dtor
      go to 201
      endif
 200  continue
      do 1200 j=1,nott
      i3=notta(j)
      if(i2.eq.i3)then
      dmin=d*(1.0-dtolo(j))
      dmax=d*(1.0+dtolo(j))
      angsog1 = 90.0*(1.0-atolo(j))
      angsog2 = 90.0*(1.0+atolo(j))
      angsog11 = 180.0*(1.0-atolo(j))
      angsog22 = 180.0*(1.0+atolo(j))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
      ango1=90.0*dtor  
      ango2=180.0*dtor  
      go to 1201
      endif
 1200 continue
 1201 continue
 201  continue
      xa(1)=xeql(1,ii,ksav)
      xa(2)=xeql(2,ii,ksav)
      xa(3)=xeql(3,ii,ksav)
      do 100 i=1,nmax
      x2(1)=xtet(1,i)
      x2(2)=xtet(2,i)
      x2(3)=xtet(3,i)
      call distanzap(ggMat,x2,xa,dcal)
      if(dcal.gt.dmin.and.dcal.lt.dmax)then
      dsum=dsum+d
c----------
      if(it(i2).gt.0)then
      nsymm = nsyml(ii,ksav)
      ncenn = kcen(ii,ksav)
c     cfo=0.0
      do 450 ij=1,it(i2)
      x1(1)=xt(1,i2,ij)
      x1(2)=xt(2,i2,ij)
      x1(3)=xt(3,i2,ij)
      if (nsymm.gt.1.or.ncenn.gt.1) call equitt(x1,nsymm,ncenn)
      call angolon2(ggMat,x1,xa,x2,ang1)
      if (((ang1.lt.angsog1).or.(ang1.gt.angsog2.and.
     *  ang1.lt.angsog11).or.(ang1.gt.angsog22)).
     *and.(abs(ang1).gt.0.001)) then
      go to 100
      endif
      a1=abs(ang1-ango1)
      a2=abs(ang1-ango2)
      if((a1.lt.a2).and.abs(ang1).gt.0.0001)then
      asum=asum+abs(ango1)
c     w2=1.0/ango1
      w2=1.0
      cfo=cfo+w2*a1*a1
c     cfo=cfo+w2*a1/float(it(i2))
      elseif((a1.ge.a2).and.abs(ang1).gt.0.0001)then
      asum=asum+abs(ango2)
c     w2=1.0/ango2
      w2=1.0
      cfo=cfo+w2*a2*a2
c     cfo=cfo+w2*a2/float(it(i2))
      endif
  450 continue
      endif
      irif=irif + 1
c     w1=1.0/d
      w1=1.0
c     w2=0.1
c     if(it(i2).gt.0)then
      cfom(1) = cfom(1) + w1* (dcal - d)*(dcal - d)
c    *+cfo/float(it(i2))
c     cfom(1) = cfom(1) + w1* abs(dcal - d) 
c    *+w2*cfo/float(it(i2))
c     else
c     cfom(1) = cfom(1) + w1* (dcal - d)*(dcal - d)
c     cfom(1) = cfom(1) + w1* abs(dcal - d) 
c    *+w2*cfo
c     endif
      go to 15
      endif
 100  continue
      go to 9
  15  continue
  16  continue
      if (irif.eq.nlegat(ksav)-1) then
      if(asum.gt.0.0)then
      scalad=dsum/asum
      else
      scalad=0.0
      endif
c     scalad=0.0
      cfom(1)=cfom(1)+scalad*cfo
CORO
c-----------
            do 301 l=1,nmax
               do 302 ll=1,3
                  xtet_sav(ll,l) = xtet(ll,l)
 302           continue
 301        continue
*     write(lo,'(/,a,f15.9,/)')' figure of merit',cfom(1)
c     if (nlinka(1,ksav).ne.nlinka(2,ksav))
c    *      call computefom(ksav,xtet,xtet_sav,nmax,nmax1,cfom,cfombest)
*     write(lo,'(/,a,f15.9,/)')' figure of merit',cfombest
 997  format(//,17x,' Rotated Polyhedron ',//,17x,
     *'X         Y         Z',/)
      if(istampa.gt.0)then
      write(lo,997)
      do 996 kk=1,nmax
      write(lo,'(10x,3f10.3)')(xtet_sav(k,kk),k=1,3)
 996  continue
      endif
             do 311 l=1,nmax
                do 312 ll=1,3
                   xtet(ll,l) = xtet_sav(ll,l)
 312            continue
 311         continue
c-----------
*     write(lo,'(/,a)')'located polyedron with no rotation'
      return 
      endif
   9  continue
   8  continue
c-------------------
c     if (nlinka(1,ksav).eq.nlinka(2,ksav)) then
c         irif=0
c         iarret = -1
c         return
c     endif 
      if (norot.eq.1)then
          irif=0
          iarret = -1
          return
      endif 
c-------------------
      x1(1)=xeql(1,1,ksav)
      x1(2)=xeql(2,1,ksav)
      x1(3)=xeql(3,1,ksav)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      do 250 k=1,nmax
      x1(1)=xtet(1,k)
      x1(2)=xtet(2,k)
      x1(3)=xtet(3,k)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1+k)=x2(1)
      xortet(2,1+k)=x2(2)
      xortet(3,1+k)=x2(3)
      xortet_sav(1,k)=x2(1)
      xortet_sav(2,k)=x2(2)
      xortet_sav(3,k)=x2(3)
 250  continue
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      do i=1,3
      x2(i)=xortet(i,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      do 300 jvolte=1,200
      cfom(1)=0.0
      cfo=0.0
      dsum=0.0
      asum=0.0
CANNA irif = 0
      irif = 1
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      yfl=twopi*yfl
*     write(6,*) ' JJ IIX,YFL',jvolte,iix,yfl
      call MatTott(x2,adif,bdif,cdif,ddif,yfl)
      call molt2_rott(rtoti, rtot, w)
        do i=2,nmax1       
          xortet(4,i)=1
         do j=1,4
           x11(j)=xortet(j,i)
         end do
          call molt1_rott(w, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
          do j=1,3
             xtet(j,i-1)=x1(j)
          end do
        end do
c     do 25 ii= 2,nlegat(ksav)
      if(nlegat(ksav).le.2) go to 26
      do 25 ii= 3,nlegat(ksav)
      d=dlinka(ii,ksav)
      i2=nlinka(ii,ksav)
      do 205 j=1,ntetra
      i3=ntetr(j)
      if(i2.eq.i3)then
      dmin=d*(1.0-dtolt(j))
      dmax=d*(1.0+dtolt(j))
      angsog1 = 109.47*(1.0-atolt(j))
      angsog2 = 0.0                      
      angsog11 = 0.0                      
      angsog22 = 109.47*(1.0+atolt(j))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
      ango1=109.47*dtor
      ango2=109.47*dtor
      go to 206
      endif
 205  continue
      do 1205 j=1,nott
      i3=notta(j)
      if(i2.eq.i3)then
      dmin=d*(1.0-dtolo(j))
      dmax=d*(1.0+dtolo(j))
      angsog1 = 90.0*(1.0-atolo(j))
      angsog2 = 90.0*(1.0+atolo(j))
      angsog11 = 180.0*(1.0-atolo(j))
      angsog22 = 180.0*(1.0+atolo(j))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
      ango1=90.0*dtor       
      ango2=180.0*dtor  
      go to 1206
      endif
 1205 continue
 1206 continue
 206  continue
      xa(1)=xeql(1,ii,ksav)
      xa(2)=xeql(2,ii,ksav)
      xa(3)=xeql(3,ii,ksav)
      do 500 i=1,nmax
      x3(1)=xtet(1,i)
      x3(2)=xtet(2,i)
      x3(3)=xtet(3,i)
      call distanzap(ggMat,x3,xa,dcal)
      if(dcal.gt.dmin.and.dcal.lt.dmax)then
      dsum=dsum+d
      if(it(i2).gt.0)then
      nsymm = nsyml(ii,ksav)
      kcenn = kcen(ii,ksav)
      do 460 ij=1,it(i2)
      x1(1)=xt(1,i2,ij)
      x1(2)=xt(2,i2,ij)
      x1(3)=xt(3,i2,ij)
      if (nsymm.gt.1.or.kcenn.gt.1) call equitt(x1,nsymm,kcenn)
c     if (nsymm.gt.1) call equitt(x2,nsymm)
      call angolon2(ggMat,x1,xa,x3,ang1)
      if (((ang1.lt.angsog1).or.(ang1.gt.angsog2.and.
     *  ang1.lt.angsog11).or.(ang1.gt.angsog22)).
     *and.(abs(ang1).gt.0.001)) then
      go to 500
      endif
      a1=abs(ang1-ango1)
      a2=abs(ang1-ango2)
      if((a1.lt.a2).and.abs(ang1).gt.0.0001)then
      asum=asum+abs(ango1)
c     w2=1.0/ango1
      w2=1.0
      cfo=cfo+w2*a1*a1
c     cfo=cfo+w2*a1/float(it(i2))
      elseif((a1.ge.a2).and.abs(ang1).gt.0.0001)then
      asum=asum+abs(ango2)
c     w2=1.0/ango2
      w2=1.0
      cfo=cfo+w2*a2*a2
c     cfo=cfo+w2*a2/float(it(i2))
      endif
  460 continue
      endif
      irif=irif+ 1
c     w1=1.0/d
      w1=1.0
      w2=0.1     
c     if(it(i2).gt.0)then
      cfom(1) = cfom(1) + w1* (dcal - d)*(dcal - d)
c    *+cfo/float(it(i2))
c     cfom(1) = cfom(1) + w1* abs(dcal - d)
c    *+w2*cfo/float(it(i2))
c     else
c     cfom(1) = cfom(1) + w1* (dcal - d)*(dcal - d)
c     cfom(1) = cfom(1) + w1* abs(dcal - d)
c    *+w2*cfo
c     endif
      go to 25
      endif
 500  continue
  25  continue
  26  continue
      if (irif.eq.nlegat(ksav)-1) then
      if(asum.gt.0.0)then
      scalad=dsum/asum
      else
      scalad=0.0
      endif
c     scalad=0.0
      cfom(1)=cfom(1)+scalad*cfo
      iconta=iconta+1
*     write(lo,*)'-------------------------'
*     write(lo,*)'    Successfully rotation #  ',jvolte
*     write(lo,*)'-------------------------'
c-----------
      do 303 l=1,nmax
         do 304 ll=1,4
            xtet_sav(ll,l) = xtet(ll,l)
 304     continue
 303  continue
*     do 999 kk=1,nmax
*     write(lo,'(a,3f12.7)')(xtet(k,kk),k=1,3)
*999  continue
*     write(lo,'(/,a,f15.9,/)')' figure of merit',cfom(1)
c     call computefom(ksav,xtet,xtet_sav,nmax,nmax1,cfom,cfombest)
*     write(lo,'(/,a,f15.9,/)')' figure of merit',cfombest
      do 313 l=1,nmax
          do 314 ll=1,3
             xtet(ll,l) = xtet_sav(ll,l)
 314      continue
 313   continue
      if (istampa.gt.0) then
      write(lo,997)
      do 989 kk=1,nmax
      write(lo,'(10x,3f10.3)')(xtet_sav(k,kk),k=1,3)
 989  continue
      endif

*     write(lo,*) ' Numero di atomi in Ruotapoly',nats
      interp=0
      call frm15e(nats,interp)
c-----------
          return 
      endif
 300  continue
c     irif = 0
      return
      end
c -------------------------------------------------------------------------
      subroutine whatbuild2(iarret)
      Use Polpo
      USE Atomi
      USE General
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/chiquadro/chimin,chisquared,ntrialmin,chichi(150),
     *                 xchi(5,500,150),nzchi(500,150),natschi(150),
     *                 ntrialmn
      common/ottafree/ nats1o(10),nats2o(10),nateo,k1o(10),k2o(10)
     *,libo(10)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/Gmatrix/ggMat(3,3)
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/occtetra/it(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /matr/rmz(3,3),rmiz(3,3)
      common/tetrafree/ nats1(10),nats2(10),nate,k1(10),k2(10),iox(500)
     *,libt(10)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common/priorita/ntetrap(500),nottp(500)
      dimension ntetrmax(500),nottamax(500),itapp(500),itappo(500)
      dimension x1(3),x2(3),x3(3)
c
 999  continue 
      nate=0
      nateo=0
      isumit = 0
      do 50 i=1,nats
      itappo(i)=it(i)
      itapp(i)=it(i)
      isumit = isumit + it(i)
 50   continue
      if(ntetra.gt.0)then
      do 100 i=1,ntetra
      itmax1=-9999999
      do 150 j=1,ntetra
      jj=ntetr(j)
      if(it(jj).gt.itmax1)then
      itmax1=it(jj)
      jjsav=jj
      jsav=j
      endif
 150  continue
      ntetrmax(i)=jjsav
      ntetrap(i)=jsav
      it(jjsav)=-9999999
 100  continue
      do 55 i=1,nats
      it(i)=itappo(i)
 55   continue
      endif
      if(nott.gt.0)then
      pi1=pi-0.1
      pi2=pi+0.1
      do 400 j=1,nott
      jj=notta(j)
      ito=it(jj)
      if(ito.eq.2)then
      do 500 k=1,ito-1
      do 600 kk=k+1,ito
      x1(1)=xt(1,jj,k)
      x1(2)=xt(2,jj,k)
      x1(3)=xt(3,jj,k)
      x2(1)=xyzs(1,jj)
      x2(2)=xyzs(2,jj)
      x2(3)=xyzs(3,jj)
      x3(1)=xt(1,jj,kk)
      x3(2)=xt(2,jj,kk)
      x3(3)=xt(3,jj,kk)
      call angolon2(ggMat,x1,x2,x3,ang1)
      if(ang1.ge.pi1.and.ang1.le.pi2)itapp(jj)=itapp(jj)-1
 600  continue
 500  continue
      endif
 400  continue
      do 56 i=1,nats
      itappo(i)=itapp(i)
 56   continue
      do 200 i=1,nott
      itmax2=-9999999
      do 250 j=1,nott
      jj=notta(j)
      if(itapp(jj).gt.itmax2)then
      itmax2=itapp(jj)
      jjsav=jj
      jsav=j
      endif
 250  continue
      nottamax(i)=jjsav
      nottp(i)=jsav
      itapp(jjsav)=-9999999
 200  continue
      do 57 i=1,nats
      itapp(i)=itappo(i)
 57   continue
      endif
      if(ntetra.gt.0.and.nott.eq.0)then
      do 270 i=1,ntetra
      itrif=it(ntetrmax(i))
      if(itrif.lt.4.and.itrif.gt.1)then
      k=ntetrap(i)
      call buildtetra(k,iarret)
      if (iarret.eq.-1) return        
      if(istampa.gt.0)then
      write(lo,'(/,a,/)')' Completing the polyhedron .....'
      do 1001 iii=1,nats
      write(lo,'(5x,4f10.3)')(xyzs(k,iii),k=1,3),bfac(iii)
 1001 continue
      endif
c---------------
      isumnew = 0
      do 799 ll=1,nats
         isumnew = isumnew + it(ll)
 799  continue
      if (isumnew.gt.isumit) go to 999
c---------------
      endif
 270  continue
      elseif(ntetra.eq.0.and.nott.gt.0)then
      do 280 i=1,nott
      itrif=it(nottamax(i))
      if(itrif.lt.6.and.itrif.gt.1)then
      k=nottp(i)
      call buildotta(k,iarret)
      if (iarret.eq.-1) return        
      if(istampa.gt.0)then
      write(lo,'(/,a,/)')' Completing the polyhedron .....'
      do 1002 ii=1,nats
      write(lo,'(5x,4f10.3)')(xyzs(k,ii),k=1,3),bfac(ii)
 1002 continue
      endif
c---------------
      isumnew = 0
      do 899 ll=1,nats
         isumnew = isumnew + it(ll)
 899  continue
      if (isumnew.gt.isumit) go to 999
c---------------
      endif
 280  continue
      else
      do 299 ijk=1,ntetra+nott
      if(ijk.le.ntetra)then
      do 300 i=1,ntetra
      itt=it(ntetrmax(i))
      if(itt.ge.4.or.itt.le.1)go to 300
      do 700 j=1,nott
      ito=itapp(nottamax(j))
      if(ito.ge.6.or.ito.le.1)go to 700
      if(itt.gt.ito)then
      k=ntetrap(i)
      call buildtetra(k,iarret)
      if (iarret.eq.-1) return        
      if(istampa.gt.0)then
      write(lo,'(/,a,/)')' Completing the polyhedron .....'
      do 1003 ii=1,nats
      write(lo,'(5x,4f10.3)')(xyzs(k,ii),k=1,3),bfac(ii)
 1003 continue
      endif
c---------------
      isumnew = 0
      do 1095 ll=1,nats
         isumnew = isumnew + it(ll)
 1095  continue
      if (isumnew.gt.isumit) go to 999
c---------------
      go to 300
      else
      k=nottp(j)
      call buildotta(k,iarret)
      if (iarret.eq.-1) return        
      if(istampa.gt.0)then
      write(lo,'(/,a,/)')' Completing the polyhedron .....'
      do 1004 ii=1,nats
      write(lo,'(5x,4f10.3)')(xyzs(k,ii),k=1,3),bfac(ii)
 1004 continue
      endif
c---------------
      isumnew = 0
      do 1085 ll=1,nats
         isumnew = isumnew + it(ll)
 1085  continue
      if (isumnew.gt.isumit) go to 999
c---------------
      go to 300
      endif    
 700  continue
      k=ntetrap(i)
      call buildtetra(k,iarret)
      if (iarret.eq.-1) return        
      if(istampa.gt.0)then
      write(lo,'(/,a,/)')' Completing the polyhedron .....'
      do 1005 ii=1,nats
      write(lo,'(5x,4f10.3)')(xyzs(k,ii),k=1,3),bfac(ii)
 1005 continue
      endif
c---------------
      isumnew = 0
      do 1185 ll=1,nats
         isumnew = isumnew + it(ll)
 1185  continue
      if (isumnew.gt.isumit) go to 999
c---------------
 300  continue
      else
      do 301 i=1,nott
      ito=itapp(nottamax(i))
      if(ito.ge.6.or.ito.le.1)go to 301
      do 701 j=1,ntetra
      itt=it(ntetrmax(j))
      if(itt.ge.4.or.itt.le.1)go to 701
      if(ito.gt.itt)then
      k=nottp(i)
      call buildotta(k,iarret)
      if (iarret.eq.-1) return        
      if(istampa.gt.0)then
      write(lo,'(/,a,/)')' Completing the polyhedron .....'
      do 1006 ii=1,nats
      write(lo,'(5x,4f10.3)')(xyzs(k,ii),k=1,3),bfac(ii)
 1006 continue
      endif
c---------------
      isumnew = 0
      do 1098 ll=1,nats
         isumnew = isumnew + it(ll)
 1098  continue
      if (isumnew.gt.isumit) go to 999
c---------------
      go to 301
      else
      k=ntetrap(j)
      call buildtetra(k,iarret)
      if (iarret.eq.-1) return        
      if(istampa.gt.0)then
      write(lo,'(/,a,/)')' Completing the polyhedron .....'
      do 1007 ii=1,nats
      write(lo,'(5x,4f10.3)')(xyzs(k,ii),k=1,3),bfac(ii)
 1007 continue
      endif
c---------------
      isumnew = 0
      do 1088 ll=1,nats
         isumnew = isumnew + it(ll)
 1088  continue
      if (isumnew.gt.isumit) go to 999
c---------------
      go to 301
      endif    
 701  continue
      k=nottp(i)
      call buildotta(k,iarret)
      if (iarret.eq.-1) return        
      if(istampa.gt.0)then
      write(lo,'(/,a,/)')' Completing the polyhedron .....'
      do 1008 ii=1,nats
      write(lo,'(5x,4f10.3,i5)')(xyzs(k,ii),k=1,3),bfac(ii)
 1008 continue
      endif
c---------------
      isumnew = 0
      do 1078 ll=1,nats
         isumnew = isumnew + it(ll)
 1078  continue
      if (isumnew.gt.isumit) go to 999
c---------------
 301  continue
      endif
 299  continue
      endif
*     write(6,*) 'ESCO WHATBUILD2',iarret
      do 970 i=1,ntetra
      k=ntetrap(i)
      if(it(ntetr(k)).lt.4)then
      call buildtetra(k,iarret)
      if (iarret.eq.-1) return
      endif
 970  continue
      do 980 i=1,nott
      k=nottp(i)
      if(it(notta(k)).lt.6)then
      call buildotta(k,iarret)
      if (iarret.eq.-1) return
      endif
 980  continue
      iprier=1
      call calcolaerre(chi2,iprier)
      chisquared=chi2   
      ntrialmin=ntrial
CANNA
      iniat = 1
      call MakeLab(iniat,nats)
CANNA
      kdirect=1
      interp=0
      call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
      return
      end
c--------------------------------------------------------------
      subroutine generat1_ott(x1,d,alfa,x2,iok,iarret)
      USE General
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/stampa/istampa
      dimension x1(3),x2(3)
c
      zero=1.0E-5
      a=x1(1)**2+x1(2)**2
      c=-(x1(1)**2)*(d**2)
      x2(3)=0.0
      r=-a*c
      if (r.lt.0.0) then
c         write(6,*) ' -------------------------------'
c         write(6,*) ' Radice negativa in generat1_ott'
c         write(6,*) ' -------------------------------'
          iarret = -1
          return
      endif
c----
      if (x1(1).eq.0.0) then 
         iarret = -1
*        write(6,*)' ----------------------------'
*        write(6,*)' X1(1) = 0 nella generat1_ott'
*        write(6,*)' ----------------------------'
         return
      endif
c----
      r=sqrt(r)
      if(iok.eq.0)then
      x2(2)=(r)/a
      else
      x2(2)=(-r)/a
      endif
      x2(1)=-x2(2)*x1(2)/x1(1)
      per=x1(1)*x2(2)-x2(1)*x1(2)
      if(abs(per).lt.zero.and.iok.eq.0)then
      x2(2)=(-r)/a
      x2(1)=-x2(2)*x1(2)/x1(1)
      elseif(abs(per).lt.zero.and.iok.eq.1)then
      x2(2)=(+r)/a
      x2(1)=-x2(2)*x1(2)/x1(1)
      endif 
      return
      end 
c--------------------------------------------------------------
      subroutine generat2_ott(x1,x2,d,alfa,x3,iok,iarret)
      USE General
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/stampa/istampa
      dimension x1(3),x2(3),x3(3)
      double precision a,dprimo,t,rr,xx1,xx2
c
      zero=1.0E-5
      zero1=1.0E-30
      d1a=sqrt(x1(1)**2+x1(2)**2+x1(3)**2)
      d2a=sqrt(x2(1)**2+x2(2)**2+x2(3)**2)
c----
      if (abs(x1(1)).lt.zero) then 
      if (x1(2).ne.0.0.and.x2(1).ne.0.0) then 
         aa=(x1(3)*x2(2))/(x1(2)*x2(1))-x2(3)/x2(1)
         aa=aa**2
         bb=-x1(3)/x1(2)
         bb=bb**2
         ee=(d**2)/(1.0+aa+bb)
         if(ee.lt.0.0)then
         iarret=-1
         return
         endif
         if(iok.eq.0)then
         x3(3)=sqrt(ee)
         else
         x3(3)=-sqrt(ee)
         endif
         x3(2)=-x3(3)*x1(3)/x1(2)
         fff=(x1(3)*x2(2))/(x1(2)*x2(1))-(x2(3)/x2(1))
         x3(1)=x3(3)*fff
         return
         endif
         iarret = -1
*        write(6,*)' ------------------------'
*        write(6,*)' X1(1) = 0 nella generat2'
*        write(6,*)' ------------------------'
         return
      endif
      if (abs(x2(1)).lt.zero) then 
      if (x2(2).ne.0.0.and.x1(1).ne.0.0) then 
         aa=(x2(3)*x1(2))/(x2(2)*x1(1))-x1(3)/x1(1)
         aa=aa**2
         bb=-x2(3)/x2(2)
         bb=bb**2
         ee=(d**2)/(1.0+aa+bb)
         if(ee.lt.0.0)then
         iarret=-1
         return
         endif
         if(iok.eq.0)then
         x3(3)=sqrt(ee)
         else
         x3(3)=-sqrt(ee)
         endif
         x3(2)=-x3(3)*x2(3)/x2(2)
         fff=(x2(3)*x1(2))/(x2(2)*x1(1))-(x1(3)/x1(1))
         x3(1)=x3(3)*fff
         return
         endif
         iarret = -1
*        write(6,*)' ------------------------'
*        write(6,*)' X1(1) = 0 nella generat2'
*        write(6,*)' ------------------------'
         return
      endif
c----
      xx1=(x2(1)*x1(3)-x1(1)*x2(3))
      xx2=(x1(1)*x2(2)-x2(1)*x1(2))
c----
      if (abs(xx2).lt.zero1) then 
      if (alfa.gt.1.570.and.alfa.lt.1.571)then
      a1=abs(x1(1)+x2(1))
      a2=abs(x1(2)+x2(2))
      a3=abs(x1(3)+x2(3))
      if(a1.lt.zero.and.a2.lt.zero.and.a3.lt.zero)then
      aa=(d**2)/(1.0+(x1(3)/x1(2))**2)
      if(aa.lt.0.0)then
      iarret=-1
      return
      endif
      if(iok.eq.0)then
      x3(3)=sqrt(aa)
      else
      x3(3)=-sqrt(aa)
      endif
      x3(1)=0.0
      x3(2)=-x3(3)*x1(3)/x1(2)
      return
      endif
      endif
         iarret = -1
*        write(6,*)' ----------------------------'
*        write(6,*)' denominatore = 0 nella generat2_ott'
*        write(6,*)' ----------------------------'
         return
      endif
c----
      a=xx1/xx2                                              
      dprimo=(x1(2)*a/x1(1))+x1(3)/x1(1)
      t=(dprimo**2)+(a**2)+1.0
      s=-d**2
      rr=-s*t
      if (rr.lt.0.0) then
c         write(6,*) ' -------------------------------'
c         write(6,*) ' Radice negativa in generat2_ott'
c         write(6,*) ' -------------------------------'
          iarret = -1
          return
      endif
      rr=sqrt(rr)
      if(iok.eq.0)then
      x3(3)=(rr)/t
      else
      x3(3)=(-rr)/t
      endif
      x3(2)=a*x3(3)
      x3(1)=-dprimo*x3(3)
      per=x2(1)*x3(2)-x3(1)*x2(2)
      if(abs(per).lt.zero.and.iok.eq.0)then
      x3(3)=(-rr)/t
      x3(2)=a*x3(3)
      x3(1)=-dprimo*x3(3)
      elseif(abs(per).lt.zero.and.iok.eq.1)then
      x3(3)=(rr)/t
      x3(2)=a*x3(3)
      x3(1)=-dprimo*x3(3)
      endif 
      return
      end
c--------------------------------------------------------------
      subroutine distanzap(ggMat,x1,x2,dcal)   
      dimension x1(3),x2(3)
      dimension r(3),r2(3),sottr(3),ggMat(3,3),diff(3)
c
      distsogg=0.5
         do 200 j=1,3
            diff(j)=x1(j)-x2(j)
            sottr(j)=abs(diff(j))
            if (sottr(j).gt.distsogg) then
                diff(j)=x1(j)+1.0-x2(j)
                sottr(j)=abs(diff(j))
                if (sottr(j).gt.distsogg) then
                    diff(j)=x1(j)-1.0-x2(j)
                    sottr(j)=abs(diff(j))
CANNA
                    if (sottr(j).gt.distsogg) then
                        diff(j)=x1(j)+2.0-x2(j)
                        sottr(j)=abs(diff(j))
                        if (sottr(j).gt.distsogg) then
                            diff(j)=x1(j)-2.0-x2(j)
                            sottr(j)=abs(diff(j))
                        end if
                    end if
CANNA
                end if
            end if
      sottr(j)=diff(j)
 200     continue
      do 69 k=1,3
      r(k)=0.0
 69   continue
      do 70 k=1,3
            do 80 jj=1,3
               r(k)=r(k)+sottr(jj)*ggMat(jj,k)
 80         continue
 70         continue
      v=0
      do 90 k=1,3
            v=v+sottr(k)*r(k)
 90   continue
      dcal=sqrt(v)
      return
      end
c------------------------------------------------
      subroutine angolon2(ggMat,x1,x2,x3,angcal)   
      USE General
      common/stampa/istampa
      dimension x1(3),x2(3),x3(3)
      dimension xa(3),xb(3),diff(3)
      dimension r(3),r2(3),sottr(3),ang(3),ggMat(3,3)
c
      distsogg=0.5
      xa(1)=(x1(1)-x2(1))
      xa(2)=(x1(2)-x2(2))
      xa(3)=(x1(3)-x2(3))
      xb(1)=(x3(1)-x2(1))
      xb(2)=(x3(2)-x2(2))
      xb(3)=(x3(3)-x2(3))
      do 200 j=1,3
            diff(j)=x1(j)-x2(j)
            sottr(j)=abs(diff(j))
            if (sottr(j).gt.distsogg) then
                diff(j)=x1(j)+1.0-x2(j)
                sottr(j)=abs(diff(j))
                if (sottr(j).gt.distsogg) then
                    diff(j)=x1(j)-1.0-x2(j)
                    sottr(j)=abs(diff(j))
CANNA
                    if (sottr(j).gt.distsogg) then
                        diff(j)=x1(j)+2.0-x2(j)
                        sottr(j)=abs(diff(j))
                        if (sottr(j).gt.distsogg) then
                            diff(j)=x1(j)-2.0-x2(j)
                            sottr(j)=abs(diff(j))
                        end if
                    end if
CANNA
                end if
            end if
      xa(j)=diff(j)
 200  continue
      do 210 j=1,3
            diff(j)=x3(j)-x2(j)
            sottr(j)=abs(diff(j))
            if (sottr(j).gt.distsogg) then
                diff(j)=x3(j)+1.0-x2(j)
                sottr(j)=abs(diff(j))
                if (sottr(j).gt.distsogg) then
                    diff(j)=x3(j)-1.0-x2(j)
                    sottr(j)=abs(diff(j))
CANNA
                    if (sottr(j).gt.distsogg) then
                        diff(j)=x3(j)+2.0-x2(j)
                        sottr(j)=abs(diff(j))
                        if (sottr(j).gt.distsogg) then
                            diff(j)=x3(j)-2.0-x2(j)
                            sottr(j)=abs(diff(j))
                        end if
                    end if
CANNA
                end if
            end if
      xb(j)=diff(j)
 210  continue
      call scalar(ggMat,xa,xb,xs1)
      call scalar(ggMat,xa,xa,xs2)
      call scalar(ggMat,xb,xb,xs3)
      if((abs(xs2).lt.0.00001).or.(abs(xs3).lt.0.00001))then
      cosang=1.0 
      else
      cosang=xs1/(sqrt(xs2)*sqrt(xs3))
      endif
      if (cosang .gt. 0.999999) cosang = 1.0            
      if (cosang .gt.-0.000001.and.cosang.lt.0.000001) cosang = 0.0            
      if (cosang .lt.-0.999999) cosang =-1.0            
      angcal=acos(cosang)
      return
      end
c------------------------------------------------
      subroutine RuotAtomi(yfl1,jj,n1,n2)
      USE Atomi
c
*     include 'atoms.fi' 
!corr      include 'rando.fi'
      USE randofi
****  common /atoms/ x(5,500),nz(500),idumx(21)
c     common /atoms/ x(5,500),nz(500),bfac(500),idumx(4001)
      common /matr/rmz(3,3),rmiz(3,3)
      common/stampa/istampa
      dimension x1(3),xo(3),xortet(3,8),x2(3),x11(3)
      dimension  b(3,3),yfl1(3)
c
      x1(1)=xyzs(1,jj)
      x1(2)=xyzs(2,jj)
      x1(3)=xyzs(3,jj)
      call molt1_rot(rmz, x1, xo)
      xortet(1,1)=0.0
      xortet(2,1)=0.0
      xortet(3,1)=0.0
      kk=0
      do 100 k=n1,n2
      kk=kk+1
      x1(1)=xyzs(1,k)
      x1(2)=xyzs(2,k)
      x1(3)=xyzs(3,k)
      call molt1_rot(rmz, x1, x2)
      xortet(1,kk+1)=x2(1)-xo(1)
      xortet(2,kk+1)=x2(2)-xo(2)
      xortet(3,kk+1)=x2(3)-xo(3)
 100  continue
c
      ang1=yfl1(1)
      ang2=yfl1(2)
      ang3=yfl1(3)
      call RotationOper(b,ang1,ang2,ang3)
      do 101 k=1,kk
       do 102 j=1,3
         x11(j) = xortet(j,k+1)
 102   continue
      call molt1_rot(b, x11, x1)
      do j=1,3
        x1(j) = x1(j)+xo(j)
      end do
      call molt1_rot(rmiz, x1, x11)
      do il=1,3
        xyzs(il,n1+k-1)=x11(il)
      end do
c     write(6,*) 'RUOTO',k,ang1,ang2,ang3,(xyzs(j,n1+k-1),j=1,3)
 101  continue
      return
      end
c---------------------------------------
      subroutine Ruotcatione2(ksav,nmax,xtet,ang1,ang2,ang3)
      Use Polpo
      USE General
!corr      include 'rando.fi'
      USE randofi
c
****  common /atoms/ x(5,500),nz(500),idumx(21)
c     common /atoms/ x(5,500),nz(500),bfac(500),idumx(4001)
      common/lievrot/iruotat
      common/stampa/istampa
      common /matr/rmz(3,3),rmiz(3,3)
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/tetralink/ilinka,nlegat(500),iordcon(500)
CORO  dimension x1(3),xo(3),xortet(3,7),x2(3),x11(3)
      dimension x1(3),xo(3),xortet(3,8),x2(3),x11(3)
      dimension  b(3,3),yfl1(3),xtet(4,6)
c
      ang1=ang1*dtor
      ang2=ang2*dtor
      ang3=ang3*dtor
      iruotat=1
      x1(1)=xeql(1,1,ksav)
      x1(2)=xeql(2,1,ksav)
      x1(3)=xeql(3,1,ksav)
      call molt1_rot(rmz, x1, xo)
      xortet(1,1)=0.0
      xortet(2,1)=0.0
      xortet(3,1)=0.0
      do 100 k=1,nmax
      x1(1)=xtet(1,k)
      x1(2)=xtet(2,k)
      x1(3)=xtet(3,k)
      call molt1_rot(rmz, x1, x2)
      xortet(1,k+1)=x2(1)-xo(1)
      xortet(2,k+1)=x2(2)-xo(2)
      xortet(3,k+1)=x2(3)-xo(3)
 100  continue
         call RotationOper(b,ang1,ang2,ang3)
         do 101 k=1,nmax
          do 102 j=1,3
            x11(j) = xortet(j,k+1)
 102      continue
         call molt1_rot(b, x11, x1)
         do j=1,3
           x1(j) = x1(j)+xo(j)
         end do
         call molt1_rot(rmiz, x1, x11)
         do il=1,3
           xtet(il,k)=x11(il)
         end do
c        write(6,*) 'RUOTO',k,ang1,ang2,ang3,(xtet(j,k),j=1,3)
 101     continue
 302    continue
 301   continue
 300  continue
      return
      end
c---------------------------------------
      subroutine RotationOper(b,teta1,teta2,teta3)

      USE General
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/stampa/istampa
      dimension  b(3,3)
c ---
c     Rotazione e3(teta1) + e1(teta2) + e3(teta3)
c ---
c ---
      st1=sin(teta1)
      st2=sin(teta2)
      st3=sin(teta3)
      ct1=cos(teta1)
      ct2=cos(teta2)
      ct3=cos(teta3)
cc
      b(1,1)=-st1*ct2*st3 + ct1*ct3
      b(1,2)=ct1*ct2*st3 + st1*ct3
      b(1,3)=st2*st3
      b(2,1)=-st1*ct2*ct3 - ct1*st3
      b(2,2)=ct1*ct2*ct3 - st1*st3
      b(2,3)=st2*ct3
      b(3,1)=st1*st2
      b(3,2)=-ct1*st2
      b(3,3)=ct2
      return
      end
c---------------------------------------------------------
      subroutine computefom(ksav,xtet,xtet_sav,nmax,nmax1,cfom,cfombest)
      Use Polpo
      USE General
!corr      include 'rando.fi'
      USE randofi
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/stampa/istampa
      common/conta/iconta
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
*      common/trig/sint(45000),pi,twopi,dtor,rtod
****  common /atoms/ x(5,500),nz(500),idumx(21)
c     common /atoms/ x(5,500),nz(500),bfac(500),idumx(4001)
!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/occtetra/it(500)
      common/partenza/istart00,istart(500),natspa,istart0,isalva
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      dimension  xtet(4,6),x1(3),x2(3),xortet(4,8)
      dimension w(4,4),x11(4),x1t(4),x3(3),xa(3)
      dimension xtet_sav(4,6),cfom(10001)
      dimension xteta(4,6)

c-----------------
c     cfom = sum(w1*(d-datteso)**2 + w2*(ang-angatteso)**2)
c-----------------
      w1 = 1.0
      w2 = 1.0
      cfombest=cfom(1)
c-----------------
      do  210 ij=1,nmax
      do 220 ijj=1,3
      xteta(ijj,ij)=xtet(ijj,ij)
 220  continue
 210  continue
      iang = 1
c     do 300 ang1=-0.2,0.2,0.05
c     if (ang1.eq.0.0) go to 300
c     do 301 ang2=-0.2,0.2,0.05
c     if (ang2.eq.0.0) go to 301
c     do 302 ang3=-0.2,0.2,0.05
c     if (ang3.eq.0.0) go to 301

!g    do 300 ang=-1.0,1.0,0.05     gianluca 11/03/2007

      ang = -1.5
      do 300 iiang=1,5
      ang = ang + 0.5
      if (ang.eq.0.0) go to 300
      do  211 ij=1,nmax
      do 221 ijj=1,3
      xtet(ijj,ij)=xteta(ijj,ij)
 221  continue
 211  continue
      iang = iang + 1
      cfom(iang)=0.0
      cfo=0.0
      asum=0.0
      dsum=0.0
      irif = 0
c     write(6,*)' ANG IANG=',ang1,ang2,ang3,iang
c     ang11=ang1
c     ang22=ang2
c     ang33=ang3
      ang11=ang
      call Ruotcatione1(ksav,nmax,nmax1,ang11,xtet)
c     call Ruotcatione2(ksav,nmax,xtet,ang11,ang22,ang33)
      do 25 ii= 2,nlegat(ksav)
      d=dlinka(ii,ksav)
      i2=nlinka(ii,ksav)
      do 205 j=1,ntetra
      i3=ntetr(j)
      if(i2.eq.i3)then
      dmin=d*(1.0-dtolt(j))
      dmax=d*(1.0+dtolt(j))
      angsog1 = 109.47*(1.0-atolt(j))
      angsog2 = 0.0                      
      angsog11 = 0.0                      
      angsog22 = 109.47*(1.0+atolt(j))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
      ango1=109.47*dtor
      ango2=109.47*dtor
      go to 206
      endif
 205  continue
      do 1205 j=1,nott
      i3=notta(j)
      if(i2.eq.i3)then
      dmin=d*(1.0-dtolo(j))
      dmax=d*(1.0+dtolo(j))
      angsog1 = 90.0*(1.0-atolo(j))
      angsog2 = 90.0*(1.0+atolo(j))
      angsog11 = 180.0*(1.0-atolo(j))
      angsog22 = 180.0*(1.0+atolo(j))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
      ango1=90.0*dtor
      ango2=180.0*dtor
      go to 1206
      endif
 1205 continue
 1206 continue
 206  continue
      xa(1)=xeql(1,ii,ksav)
      xa(2)=xeql(2,ii,ksav)
      xa(3)=xeql(3,ii,ksav)
      do 500 i=1,nmax
      x3(1)=xtet(1,i)
      x3(2)=xtet(2,i)
      x3(3)=xtet(3,i)
      call distanzap(ggMat,x3,xa,dcal)
      if(dcal.gt.dmin.and.dcal.lt.dmax)then
      dsum=dsum+d
      if(it(i2).gt.0)then
      nsymm = nsyml(ii,ksav)
      ncenn=kcen(ii,ksav)
      cfo=0.0
      do 460 ij=1,it(i2)
      x1(1)=xt(1,i2,ij)
      x1(2)=xt(2,i2,ij)
      x1(3)=xt(3,i2,ij)
      if (nsymm.gt.1.or.ncenn.gt.1) call equitt(x1,nsymm,ncenn)
      call angolon2(ggMat,x1,xa,x3,angg1)
      if (((angg1.lt.angsog1).or.(angg1.gt.angsog2.and.
     *  angg1.lt.angsog11).or.(angg1.gt.angsog22)).
     *and.(abs(angg1).gt.0.001)) go to 500
      a1=abs(angg1-ango1)
      a2=abs(angg1-ango2)
      if((a1.lt.a2).and.abs(angg1).gt.0.0001)then
      asum=asum+abs(ango1)
c     w2=1.0/ango1
      w2=1.0
      cfo=cfo+w2*a1*a1
c     cfo=cfo+w2*a1/float(it(i2))
      elseif((a1.ge.a2).and.abs(angg1).gt.0.0001)then
      asum=asum+abs(ango2)
c     w2=1.0/ango2
      w2=1.0
      cfo=cfo+w2*a2*a2
c     cfo=cfo+w2*a2/float(it(i2))
      endif
c-------- per quanto riguarda l'angolo a seconda che sia tetraedro o ottaedro
***** cfom(iang) = cfom(iang) + w2*ang1 -    angolo atteso      
  460 continue
      endif
      irif=irif+ 1
c     w1=1.0/d
      w1=1.0
c     w2=0.1
c     if(it(i2).gt.0)then
      cfom(iang) = cfom(iang) + w1* (dcal - d)*(dcal - d)
c    *+cfo/float(it(i2))
c     cfom(iang) = cfom(iang) + w1* abs(dcal - d)
c    *+w2*cfo/float(it(i2))
c     else
c     cfom(iang) = cfom(iang) + w1* (dcal - d)*(dcal - d)
c    *+w2*cfo
c     endif
      go to 25
      endif
 500  continue
  25  continue
      if (irif.eq.nlegat(ksav)-1) then
      if(asum.gt.0.0)then
      scalad=dsum/asum
      else
      scalad=0.0
      endif
c     scalad=0.0
      cfom(iang)=cfom(iang)+scalad*cfo
         if (cfom(iang).lt.0.98*cfom(iang-1) ) then
         write(lo,'(a,2f10.5)')' better configuration',ang,cfom(iang)
             do 311 l=1,6
                do 312 ll=1,3
                   xtet_sav(ll,l) = xtet(ll,l)
 312            continue
 311         continue
         cfombest=cfom(iang)
         else
         cfom(iang)=cfombest
         endif
      else
      cfom(iang)=cfombest          
      endif
 302  continue
 301  continue
 300  continue
c---
      return
      end
c -------------------------------------------------------------------------
      subroutine Ruotcatione1(ksav,nmax,nmax1,ang,xtet)
      Use Polpo
      USE General
!corr      include 'rando.fi'
      USE randofi
c
****  common /atoms/ x(5,500),nz(500),idumx(21)
c     common /atoms/ x(5,500),nz(500),bfac(500),idumx(4001)
      common/stampa/istampa
      common /matr/rmz(3,3),rmiz(3,3)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      dimension  xtet(4,6),x1(3),x2(3),xortet(4,8)
      dimension w(4,4),x11(4),x1t(4),x3(3),xa(3)
c
      do 10 i=1,nmax
      if(i.le.4)x1t(i)=0.0
      do 20 j=1,nmax
      if(i.le.4.and.j.le.4)w(i,j)=0.0
      if(i.le.4.and.j.le.4)rtot(i,j)=0.0
      if(i.le.4.and.j.le.4)rtoti(i,j)=0.0
 20   continue
 10   continue
      x1(1)=xeql(1,1,ksav)
      x1(2)=xeql(2,1,ksav)
      x1(3)=xeql(3,1,ksav)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      do 250 k=1,nmax
      x1(1)=xtet(1,k)
      x1(2)=xtet(2,k)
      x1(3)=xtet(3,k)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1+k)=x2(1)
      xortet(2,1+k)=x2(2)
      xortet(3,1+k)=x2(3)
 250  continue
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      do i=1,3
      x2(i)=xortet(i,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      yfl=ang*dtor
      call MatTott(x2,adif,bdif,cdif,ddif,yfl)
      call molt2_rott(rtoti, rtot, w)
        do i=2,nmax1
          xortet(4,i)=1
         do j=1,4
           x11(j)=xortet(j,i)
         end do
          call molt1_rott(w, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
          do j=1,3
             xtet(j,i-1)=x1(j)
          end do
        end do
      return
      end
c----------------------------------------------------------------
      subroutine checkequivtb(xo,i1,i2,iesit)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell
      common/stampa/istampa
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/occtetra/it(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/Gmatrix/ggMat(3,3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
c-    
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3)
      dimension x1(3),x2(3),xb2(3),s(3)
      dimension vet(2)
      real, dimension(3,3) :: gm
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
c     write(6,*) ' INIZIO IT in CHECKEQVTB',(it(kk),kk=1,4)
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
c-
c     do 10 ii=2,nsym2
c        xeq(1) = xo(1)
c        xeq(2) = xo(2)
c        xeq(3) = xo(3)
c        call equitt(xeq,ii)
c----------
c         call distanzan(ggMat,xo,xeq,dist)
c----------
      ifin=icent+1
        do 10 kt=1,spacegr%ncoper
        do 10 ifi=1,ifin
          coef=vet(ifi)
          do 10 k=1,nsym
            if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 10
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,k,coef,xeq,kt)
            !call xdist(xb2,xeq,dist,s)
            call xdisteqs(xb2,xeq,gm,dist,s)
            xeq(1)=xb2(1)+s(1)
            xeq(2)=xb2(2)+s(2)
            xeq(3)=xb2(3)+s(3)
          if (dist.gt.0.000001.and.dist.le.dmin) then
*            write(6,*)' CORDINATE X0 INIZIALI =',xo
             xo(1) = (xo(1) + xeq(1))/2.
             xo(2) = (xo(2) + xeq(2))/2.
             xo(3) = (xo(3) + xeq(3))/2.
c----
             xyzs(1,nats)=xo(1)
             xyzs(2,nats)=xo(2)
             xyzs(3,nats)=xo(3)
c----
             xt(1,i1,it(i1))=xyzs(1,nats)
             xt(2,i1,it(i1))=xyzs(2,nats)
             xt(3,i1,it(i1))=xyzs(3,nats)
             xt(1,i2,it(i2))=xyzs(1,nats)
             xt(2,i2,it(i2))=xyzs(2,nats)
             xt(3,i2,it(i2))=xyzs(3,nats)
*            write(6,*)' CORDINATE X0 MODIFICATE =',xo
             go to 11
           endif
   10    continue
c  10    continue
   11    continue
c--
c----- check se un equivalente di xo e' legato con i cationi
c--
      do 35 i = 1,ntetra
      angsog1 = 109.47*(1.0-atolt(i))
      angsog2 = 109.47*(1.0+atolt(i))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
        dist1=dtetra(i)*(1.0-dtolt(i)) 
        dist2=dtetra(i)*(1.0+dtolt(i))
        jj = ntetr(i)
CANG
        if(jj.ne.i1) go to 35
CANG
        xcat(1) = xyzs(1,jj) 
        xcat(2) = xyzs(2,jj) 
        xcat(3) = xyzs(3,jj) 
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c          call equitt(xeq,ii)
c-----------------
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 kj=1,nsym
c           if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
        iser=1
        iactn=1
        khead=0
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
*       if(1.0/float(key(10)).lt.1.) then
*          write(6,*)'OCCUPANZA=',1.0/float(key(10))
*          write(6,*)'xeq prima kspec in checkeqvtb',xo1
*          write(6,*)'xeq dopo kspec in checkeqvtb',xeq
*       endif
c---
c         call distanzan(ggMat,xcat,xeq,dist)
          !call xdist(xcat,xeq,dist,s)
          call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if (dist.ge.dist1.and.dist.le.dist2) then
             if (it(jj).eq.0) then
                 it(jj)=it(jj)+1
                 iesit = 1
                 xt(1,jj,it(jj))=xeq(1)       
                 xt(2,jj,it(jj))=xeq(2)       
                 xt(3,jj,it(jj))=xeq(3)       
                 ntt(jj,it(jj))=nats         
             elseif (it(jj).ge.1.and.it(jj).lt.4) then
c--
c-- accetto solo atomi che formano angolo (109+/-soglia) con gli altri del tetraedro
c--
                 iok = 1
                 do 40 k=1,it(jj)
                    xoo(1) = xt(1,jj,k)
                    xoo(2) = xt(2,jj,k)
                    xoo(3) = xt(3,jj,k)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if (ang1.lt.angsog1.or.ang1.gt.angsog2) then
CCCCCCC             if (ang1.gt.angsog2) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    do 110 k=1,it(jj)
                    x1(1)=xt(1,jj,k)
                    x1(2)=xt(2,jj,k)
                    x1(3)=xt(3,jj,k)
                    do 120 kk=k+1,it(jj)+1
                    if(kk.lt.it(jj)+1)then
                    x2(1)=xt(1,jj,kk)
                    x2(2)=xt(2,jj,kk)
                    x2(3)=xt(3,jj,kk)
                    else
                    x2(1)=xeq(1)
                    x2(2)=xeq(2)
                    x2(3)=xeq(3)
                    endif
c                   call distanzan(ggMat,x1,x2,dcal)
c                   call distanzaeq(ggMat,x1,x2,dcal)
                    call distanzaeq(x1,x2,dcal)
                    if(dcal.lt.0.6.and.dcal.gt.0.0)go to 130
 120                continue
 110                continue
                    it(jj)=it(jj)+1
                    iesit = 1
                    xt(1,jj,it(jj))=xeq(1)     
                    xt(2,jj,it(jj))=xeq(2)     
                    xt(3,jj,it(jj))=xeq(3)     
                    ntt(jj,it(jj))=nats       
 130                continue
                 endif
             endif 
          endif
 25   continue
 35   continue
c     write(6,*) ' FINE IT in CHECKEQVTB',(it(kk),kk=1,4)
      return
      end 
c-----------------------------------------------------------------
      subroutine checkequivob(xo,i1,i2,iesit)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry 
      USE cgeom
      USE unit_cell
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/occtetra/it(500)
      common/stampa/istampa
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/Gmatrix/ggMat(3,3)
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3)
      dimension x1(3),x2(3),xb2(3),s(3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
      dimension vet(2)
      real, dimension(3,3) :: gm
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c-    
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
c     write(6,*) ' inizio IT in CHECKEQVOB',(it(kk),kk=1,4)
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
c-
c     do 10 ii=2,nsym2
c        xeq(1) = xo(1)
c        xeq(2) = xo(2)
c        xeq(3) = xo(3)
c        call equitt(xeq,ii)
c----------
c         call distanzan(ggMat,xo,xeq,dist)
c----------
      ifin=icent+1
        do 10 kt=1,spacegr%ncoper
        do 10 ifi=1,ifin
          coef=vet(ifi)
          do 10 k=1,nsym
            if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 10
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,k,coef,xeq,kt)
            !call xdist(xb2,xeq,dist,s)
            call xdisteqs(xb2,xeq,gm,dist,s)
            xeq(1)=xb2(1)+s(1)
            xeq(2)=xb2(2)+s(2)
            xeq(3)=xb2(3)+s(3)
          if (dist.gt.0.000001.and.dist.le.dmin) then
*            write(6,*)' CORDINATE X0 INIZIALI =',xo
             xo(1) = (xo(1) + xeq(1))/2.
             xo(2) = (xo(2) + xeq(2))/2.
             xo(3) = (xo(3) + xeq(3))/2.
c----
             xyzs(1,nats)=xo(1)
             xyzs(2,nats)=xo(2)
             xyzs(3,nats)=xo(3)
c----
             xt(1,i1,it(i1))=xyzs(1,nats)
             xt(2,i1,it(i1))=xyzs(2,nats)
             xt(3,i1,it(i1))=xyzs(3,nats)
             xt(1,i2,it(i2))=xyzs(1,nats)
             xt(2,i2,it(i2))=xyzs(2,nats)
             xt(3,i2,it(i2))=xyzs(3,nats)
*            write(6,*)' CORDINATE X0 MODIFICATE =',xo
*            write(6,*)' CORDINATE X0 MODIFICATE =',xo
             go to 11
           endif
   10    continue
   11    continue
c-    
c----- check se un equivalente di xo e' legato con i cationi
c--
      do 35 i = 1,nott
      angsog1 = 90.0*(1.0-atolo(i))
      angsog2 = 90.0*(1.0+atolo(i))
      angsog11 = 180.0*(1.0-atolo(i))
      angsog22 = 180.0*(1.0+atolo(i))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
        dist1=dotta1(i)*(1.0-dtolo(i))
        dist2=dotta1(i)*(1.0+dtolo(i))
        dist3=dotta1(i)*(1.0-dtolo(i))
        dist4=dotta1(i)*(1.0+dtolo(i))
        jj = notta(i)
CANG
        if(jj.ne.i1) go to 35
CANG
c-
        xcat(1) = xyzs(1,jj) 
        xcat(2) = xyzs(2,jj) 
        xcat(3) = xyzs(3,jj) 
c-
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c---
c          call equitt(xeq,ii)
c-----------------
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 kj=1,nsym
c           if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
        iser=1
        iactn=1
        khead=0
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
*       if(1.0/float(key(10)).lt.1.) then
*          write(6,*)'OCCUPANZA=',1.0/float(key(10))
*          write(6,*)'xeq prima kspec in checkeqvob',xo1
*          write(6,*)'xeq dopo kspec in checkeqvob',xeq
*       endif
c---
c-----------------
c         call distanzan(ggMat,xcat,xeq,dist)
            !call xdist(xcat,xeq,dist,s)
            call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if ((dist.ge.dist1.and.dist.le.dist2)
     *    .or.(dist.ge.dist3.and.dist.le.dist4)) then
             if (it(jj).eq.0) then
                 it(jj)=it(jj)+1
                 iesit = 1
                 xt(1,jj,it(jj))=xeq(1)       
                 xt(2,jj,it(jj))=xeq(2)       
                 xt(3,jj,it(jj))=xeq(3)       
                 ntt(jj,it(jj))=nats         
CAN          elseif (it(jj).ge.1.and.it(jj).lt.4) then
             elseif (it(jj).ge.1.and.it(jj).lt.6) then
c--
c-- accetto solo atomi che formano angolo (90+/-soglia) con gli altri dell'ottaedro
c--
                 iok = 1
                 do 40 k=1,it(jj)
                    xoo(1) = xt(1,jj,k)
                    xoo(2) = xt(2,jj,k)
                    xoo(3) = xt(3,jj,k)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if ((ang1.lt.angsog1).or.(ang1.gt.angsog2.and. 
     *              ang1.lt.angsog11).or.(ang1.gt.angsog22)) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    do 110 k=1,it(jj)-1
                    x1(1)=xt(1,jj,k)
                    x1(2)=xt(2,jj,k)
                    x1(3)=xt(3,jj,k)
                    do 120 kk=k+1,it(jj)
                    x2(1)=xt(1,jj,kk)
                    x2(2)=xt(2,jj,kk)
                    x2(3)=xt(3,jj,kk)
c                   call distanzan(ggMat,x1,x2,dcal)
c                   call distanzaeq(ggMat,x1,x2,dcal)
                    call distanzaeq(x1,x2,dcal)
                    if(dcal.lt.0.6.and.dcal.gt.0.0)go to 130
 120                continue
 110                continue
                    it(jj)=it(jj)+1
                    iesit = 1
                    xt(1,jj,it(jj))=xeq(1)     
                    xt(2,jj,it(jj))=xeq(2)     
                    xt(3,jj,it(jj))=xeq(3)     
                    ntt(jj,it(jj))=nats       
 130                continue
                 endif
             endif 
          endif
 25   continue
 35   continue
c     write(6,*) ' FINE IT in checkeqvob',(it(kk),kk=1,4)
      return
      end 
c-----------------------------------------------------------------
      subroutine distanzaeqag1(jl,x1,x2,kt)   
      Use Polpo
      USE Atomi
c--
*     include 'atoms.fi'
      USE Symmetry
      common/stampa/istampa
      common/tetralink/ilinka,nlegat(500),iordcon(500)
c--
      common/connet/nvol,idem,jlsav,x22(3,500),isavsym(20),i1sav(20),
     *i2sav(20),savjj,istatus,ksavcen(20)
      dimension x1(3),x2(3),xeq(3)
      dimension r(3),r2(3),ggMat(3,3),diff1(3),diff2(3),diff3(3)
      dimension sottr(3),sottr1(3),sottr2(3),sottr3(3),sottrmin(3)
c---
c
        do 99 l=1,3
        ktl=(kt-1)*3+l
        xeq(l)=x2(l)+centrt(latt,ktl)
 99     continue
c     write(6,'(a,3f10.3)')'X1',x1
c     write(6,'(a,3f10.3)')'X2',x2
         do 200 j=1,3
            diff1(j)=xeq(j)-x1(j)
            sottr1(j)=abs(diff1(j))
            sottrmin(j)=sottr1(j)
            xyzs(j,jl)=diff1(j)+x1(j)
            diff2(j)=xeq(j)+1.0-x1(j)
            sottr2(j)=abs(diff2(j))
            diff3(j)=xeq(j)-1.0-x1(j)
            sottr3(j)=abs(diff3(j))
            if (sottr2(j).lt.sottrmin(j)) then
               sottrmin(j)=sottr2(j)
               xyzs(j,jl)=diff2(j)+x1(j)
            endif
            if (sottr3(j).lt.sottrmin(j)) then
               sottrmin(j)=sottr3(j)
               xyzs(j,jl)=diff3(j)+x1(j)
            endif
c           if(xyzs(j,jl).ge.1.0) xyzs(j,jl)=xyzs(j,jl)-1.0
c-----
c     write(6,'(a,3f10.3)')'XEQ',xeq
c     write(6,*)'X-FIN',jl,(xyzs(k,jl),k=1,3)
c-----
 200     continue
      return
      end
c------------------------------------------------
      subroutine equitt1(x,k,kt)
c
c-- calcola  la posizione equivalente per la matrice  k-esima
c
      USE Symmetry
      common/stampa/istampa

      integer a(3,3),v(3,3),det,alfa(3,3)
      dimension x(3),x1(3),kmat1(48,3,3)
c
      do 11 i=1,3
      do 11 j=1,3
   11 a(i,j)=kmat(k,i,j)
      call inv3(a,det,v)
      do 12 i=1,3
      do 12 j=1,3
   12 kmat1(k,i,j)=v(i,j)
      do 10 i=1,3
      x1(i)=0
      do 10 j=1,3
   10 x1(i)=x1(i)+x(j)*kmat1(k,i,j)
      do 20 i=1,3
   20 x(i)=x1(i)
      do 15 l=1,3
        x(l) = x(l) + tmat(k,l)
 15   continue
      do 99 l=1,3
      ktl=(kt-1)*3+l
      x(l)=x(l)+centrt(latt,ktl)
 99   continue
      return
      end
c----------------------------------------------------------------
      subroutine addcat(ier)      
      Use Polpo
      USE General
      USE Atomi, only:nats
!corr      include 'rando.fi'
      USE randofi
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/stampa/istampa
      common/tetralink/ilinka,nlegat(500),iordcon(500)
      common/occtetra/it(500)
      common/Gmatrix/ggMat(3,3)
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)
!corr
!     common /constnats/ nats
!corr
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      dimension ang(3)
c
      natsold=nats
      do 100 i=1,nmiss
      j1=nfound1(i)
      j2=nfound2(i)
      j1cod=0
      j2cod=0
      do 200 k=1,ntetra
      if(j1.eq.ntetr(k))then
      j1cod=1
      d1cod=dtetra(k)         
      go to 210 
      endif
 200  continue
 210  continue
      do 220 k=1,nott   
      if(j1.eq.notta(k))then
      j1cod=2
      d1cod=dotta1(k)         
      go to 230 
      endif
 220  continue
 230  continue
      do 300 k=1,ntetra
      if(j2.eq.ntetr(k))then
      j2cod=1
      d2cod=dtetra(k)         
      go to 310 
      endif
 300  continue
 310  continue
      do 320 k=1,nott   
      if(j2.eq.notta(k))then
      j2cod=2
      d2cod=dotta1(k)         
      go to 330 
      endif
 320  continue
 330  continue
      ico1=0
      ico2=0
      if(nats.gt.2.and.i.eq.1)then
      j1=0
      j2=0
      do 810 j=1,nats
      if(j.ne.nfound1(i).and.j.ne.nfound2(i))then
      do 940 k=1,ilinka
      ii=iordcon(k)
      if(nlinka(1,ii).eq.j)then
      do 920 kk=2,nlegat(ii)
      if(nlinka(kk,ii).eq.nfound1(i).and.j1cod.ne.0.
     *and.(nsyml(kk,ii).eq.1.or.kcen(kk,ii).eq.1))then
      ico2=1
      j2=j
      go to 941
      elseif(nlinka(kk,ii).eq.nfound2(i).and.j2cod.ne.0.
     *and.(nsyml(kk,ii).eq.1.or.kcen(kk,ii).eq.1))then
      ico1=1
      j1=j
      go to 941  
      endif
 920  continue
      endif
  940 continue
  941 continue
      endif
  810 continue
      endif
      if(i.gt.1)then
      do 700 k0=1,i-1
      if(nfound1(i).eq.nfound1(k0).and.nfound2(i).eq.nfound2(k0))then
             if(it(nfound1(i)).lt.1.and.it(nfound2(i)).gt.1
     *       .and.j2cod.gt.0)then
             jcod=2
             call loccat2a(i,natsold,
     *       jcod,j1cod,j2cod,d1cod,d2cod,ier)
             if(ier.lt.0)return
             elseif(it(nfound1(i)).eq.1.and.it(nfound2(i)).gt.1
     *       .and.j2cod.gt.0)then
             jcod=2
             call loccat3a(i,natsold,
     *       jcod,j1cod,j2cod,d1cod,d2cod,ier)
             if(ier.lt.0)return
             elseif(it(nfound1(i)).gt.1.and.it(nfound2(i)).lt.1
     *       .and.j1cod.gt.0)then
             jcod=1
             call loccat2a(i,natsold,
     *       jcod,j1cod,j2cod,d1cod,d2cod,ier)
             if(ier.lt.0)return
             elseif(it(nfound1(i)).gt.1.and.it(nfound2(i)).eq.1
     *       .and.j1cod.gt.0)then
             jcod=1
             call loccat2a(i,natsold,
     *       jcod,j1cod,j2cod,d1cod,d2cod,ier)
             if(ier.lt.0)return
             elseif(it(nfound1(i)).gt.1.and.it(nfound2(i)).gt.1
     *       .and.(j1cod.gt.0.or.j2cod.gt.0))then
             call loccat2b(i,natsold
     *       ,j1cod,j2cod,d1cod,d2cod,ier)
             if(ier.lt.0)return
             else
             call loccat2(i,natsold,
     *       j1cod,j2cod,k0,ier)
             if(ier.lt.0)return
             endif
      go to 710
      endif
 700  continue
      endif
c     if((ico1.ne.0.or.ico2.ne.0).and.i.eq.1)then
c     call loccat3(i,natsold,j1cod,j2cod,j1,j2,
c    *ico1,ico2,ier)
c     if(ier.lt.0)return
c     go to 812
c     endif
      if(it(nfound1(i)).lt.1.and.it(nfound2(i)).lt.1)then
      call loccat1(i,natsold,j1cod,j2cod,ier)
      if(ier.lt.0)return
      elseif(it(nfound1(i)).lt.1.and.it(nfound2(i)).eq.1)then
      jcod=2
      call loccat1a(i,natsold,jcod,ier)
      if(ier.lt.0)return
      elseif(it(nfound1(i)).lt.1.and.it(nfound2(i)).gt.1
     *.and.j2cod.gt.0)then
      jcod=2
      call loccat2a(i,natsold,jcod,
     *j1cod,j2cod,d1cod,d2cod,ier)
      if(ier.lt.0)return
      elseif(it(nfound1(i)).gt.1.and.it(nfound2(i)).lt.1
     *.and.j2cod.gt.0)then
      jcod=1
      call loccat2a(i,natsold,jcod,
     *j1cod,j2cod,d1cod,d2cod,ier)
      if(ier.lt.0)return
      elseif(it(nfound1(i)).eq.1.and.it(nfound2(i)).lt.1)then
      jcod=1
      call loccat1a(i,natsold,jcod,ier)
      if(ier.lt.0)return
      elseif(it(nfound1(i)).lt.1.and.it(nfound2(i)).gt.1
     *.and.j2cod.gt.0)then
      jcod=2
      call loccat2a(i,natsold,jcod,
     *j1cod,j2cod,d1cod,d2cod,ier)
      if(ier.lt.0)return
      elseif(it(nfound1(i)).eq.1.and.it(nfound2(i)).eq.1)then
      call loccat1b(i,natsold,ier)
      if(ier.lt.0)return
      elseif(it(nfound1(i)).eq.1.and.it(nfound2(i)).gt.1)then
      jcod=2
      call loccat3a(i,natsold,jcod,
     *j1cod,j2cod,d1cod,d2cod,ier)
      if(ier.lt.0)return
      elseif(it(nfound1(i)).gt.1.and.it(nfound2(i)).eq.1)then
      jcod=1
      call loccat3a(i,natsold,jcod,
     *j1cod,j2cod,d1cod,d2cod,ier)
      if(ier.lt.0)return
      elseif(it(nfound1(i)).gt.1.and.it(nfound2(i)).gt.1)then
      call loccat2b(i,natsold,
     *j1cod,j2cod,d1cod,d2cod,ier)
      if(ier.lt.0)return
      endif
 710  continue
  812 continue
 100  continue
corrado      ntrial=0
      return
      end
c----------------------------------------------------------------
      subroutine loccat1(i,natsold,j1cod,j2cod,ier)             
      Use Polpo
      USE Atomi
      USE General
      USE drawatoms
      USE elements, only: pxen_from_specie,numelem
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common/savx/xsavx(3,500)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/occtetra/it(500)
      dimension ang(3),x1(3),x2(3),x3(3)
      dimension wr(4,4),xortet(4,6)
      dimension x11(4),x1t(3),xo(3),xad(3,10),xadsav(3,10)
      dimension xtet(4,4),xotta(4,6)
      character oo*2                             
      character Buffer*80
c
      ierr=0 
      dsogok=0.8
      psis=0.0
      phis=0.0
      thetas=0.0
      chimin=1.0E+10
      iloccat1=0
      ntrialcat = 0
      ier=-1
      ierr=0
      oo(1:2)='o '
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      nkel = numelem(celem)
      do 150 j=1,nkel
!corr      if (kmiss(i).eq.nalf(j)) then
      if (kmiss(i) == celem(j)%ptab) then
          nzc=j
          nzSavc = j*100+1
          vetintsavc = nzSavc+j
          go to 160
      endif
  150 continue
  160 continue
      do 200 j=1,nkel
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nza=j
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          go to 203
      endif
  200 continue
  203 continue
      j=nfound1(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      j=nfound2(i)
      x2(1)=xyzs(1,j)
      x2(2)=xyzs(2,j)
      x2(3)=xyzs(3,j)                           
      call distanza(ggMat,x1,x2,dcal)
      d=dcal
      nats=natsold
      if(imiss(i).eq.1)then
      iadd=5                 
      else
      iadd=7               
      endif
      xyzs(1,nats+1)=0.0
      xyzs(2,nats+1)=0.0
      xyzs(3,nats+1)=0.0
      xyzs(4,nats+1)=vetintsavc
      nz(nats+1)=nzSavc
      do 61 kkk=2,iadd
      xyzs(1,nats+kkk)=0.0
      xyzs(2,nats+kkk)=0.0
      xyzs(3,nats+kkk)=0.0
      xyzs(4,nats+kkk)=vetintsav
      nz(nats+kkk)=nzSavv
  61  continue
      nzm=1
      iloc(nzm)=nats+2         
      xloc(1,nzm)=0.0
      xloc(2,nzm)=0.0
      xloc(3,nzm)=0.0
      nloc(1,nzm)=0
      nloc(2,nzm)=0
      nloc(3,nzm)=0
      nzm=2
      iloc(nzm)=nats+1
      nloc(1,nzm)=nats+2         
      xloc(1,nzm)=dmiss(i)      
      nloc(2,nzm)=0             
      xloc(2,nzm)=0.0
      nloc(3,nzm)=0      
      xloc(3,nzm)=0.0
      nzm=3
      iloc(nzm)=nats+3
      nloc(1,nzm)=nats+1     
      nloc(2,nzm)=nats+2     
      nloc(3,nzm)=0           
      xloc(1,nzm)=dmiss(i)
      if(imiss(i).eq.1)then
      n6=1
      else
      n6=2
      endif
      do 6000 k6=1,n6
      nzm=3 
      if(imiss(i).eq.1)then
      xloc(2,nzm)=109.47
      else
      if(k6.eq.1)then
      xloc(2,nzm)=90.0   
      else
      xloc(2,nzm)=180.0   
      endif
      endif
      xloc(3,nzm)=0.0
      nzm=4
      iloc(nzm)=nfound2(i)
      nloc(1,nzm)=nats+3   
      nloc(2,nzm)=nats+1     
      nloc(3,nzm)=nats+2         
      if(itimem.eq.0)then
      ntrial0=5
      ntrial1=5     
      ntrial2=8 
      ntrial3=1
      ntrial4=8
      ntrialr=1 
      elseif(itimem.eq.1)then
      ntrial0=3
      ntrial1=3     
      ntrial2=5 
      ntrial3=1
      ntrial4=5
      ntrialr=1 
      elseif(itimem.eq.2)then
      ntrial0=5
      ntrial1=5     
      ntrial2=8 
      ntrial3=1
      ntrial4=8
      ntrialr=1 
      endif
      iest=0
      do 100 j=1,ntetra
      if(nfound2(i).eq.ntetr(j))then
      jsav=j
      ntrial0=1
      iest=1
      go to 170
      endif
 100  continue
      iest=0
      do 101 j=1,nott   
      if(nfound2(i).eq.notta(j))then
      jsav=j
      ntrial0=1
      iest=2
      go to 170
      endif
 101  continue
 170  continue
      ntrial_totali=ntrial0*ntrial1*ntrial2*ntrial3*ntrial4*ntrialr*n6
      do 900 k0=1,ntrial0
      nats=natsold
      nzm=4
      if(iest.eq.1)then
      xloc(1,nzm)=dtetra(jsav)
      elseif(iest.eq.2)then
      xloc(1,nzm)=dotta1(jsav)
      else
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      dlim1=1.4                   
      dlim2=2.0                    
      dlim=yfl*(dlim2-dlim1)+dlim1
      xloc(1,nzm)=dlim               
      endif
      do 1000 k=1,ntrial1
      nats=natsold
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      anglim1=2.0*asin(0.60/xloc(1,nzm))
      anglim2=pi
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
      do 2000 kk=1,ntrial2
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=5
      iloc(nzm)=nfound1(i)
      nloc(1,nzm)=nfound2(i)
      nloc(2,nzm)=nats+3     
      nloc(3,nzm)=nats+1         
      xloc(1,nzm)=d                    
      do 3000 kkk=1,ntrial3
      nats=natsold
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=5
      anglim1=2.0*asin(0.60/xloc(1,nzm))
      anglim2=pi                
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
 3001 continue
      do 4000 kkkk=1,ntrial4
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=5
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      ango=twopi
      phis=ango*yfl*rtod          
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      thetas=ango*yfl*rtod          
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      psis=ango*yfl*rtod          
c     ntrial=ntrial+1
      ierr=0 
!
!     Manage progress-bar
!
      ntrialcat = ntrialcat + 1
      write(Buffer,102) ntrialcat,ntrial_totali
  102 format(' Adding the missing atoms. Trial ',i5,' / ',
     *i5)
      call scrper(Buffer,ntrialcat,ntrial_totali)
!
      call dainttocricat1(i,ierr)
      if(ierr.lt.0)then
      go to 4000
      endif
      dsogc=2.0
      x1(1)=xyzs(1,nfound1(i))         
      x1(2)=xyzs(2,nfound1(i))         
      x1(3)=xyzs(3,nfound1(i))         
      x2(1)=xadd(1,1)        
      x2(2)=xadd(2,1)        
      x2(3)=xadd(3,1)        
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 4000
      endif
      x1(1)=xyzs(1,nfound2(i))         
      x1(2)=xyzs(2,nfound2(i))         
      x1(3)=xyzs(3,nfound2(i))         
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 4000
      endif
      xyzs(1,natsold+1)=xadd(1,1)
      xyzs(2,natsold+1)=xadd(2,1)
      xyzs(3,natsold+1)=xadd(3,1)
      xyzs(1,natsold+2)=xadd(1,2)
      xyzs(2,natsold+2)=xadd(2,2)
      xyzs(3,natsold+2)=xadd(3,2)
      xyzs(1,natsold+3)=xadd(1,3)
      xyzs(2,natsold+3)=xadd(2,3)
      xyzs(3,natsold+3)=xadd(3,3)
      ntrialr=15
      do 9000 jt=1,ntrialr
      if(jt.eq.1)go to 8900
      kj=nfound1(i)
      x1(1)=xyzs(1,kj)
      x1(2)=xyzs(2,kj)
      x1(3)=xyzs(3,kj)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      kj=nfound2(i)
      x1(1)=xyzs(1,kj)
      x1(2)=xyzs(2,kj)
      x1(3)=xyzs(3,kj)
      call molt1_rot(rmz, x1, x2)
      xortet(1,2)=x2(1)
      xortet(2,2)=x2(2)
      xortet(3,2)=x2(3)
      kk0=2
      do 51 kl=1,3
      kk0=kk0+1
      x1(1)=xyzs(1,kl+natsold)
      x1(2)=xyzs(2,kl+natsold)
      x1(3)=xyzs(3,kl+natsold)
      call molt1_rot(rmz, x1, x2)
      xortet(1,kk0)=x2(1)
      xortet(2,kk0)=x2(2)
      xortet(3,kk0)=x2(3)
 51   continue
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      nmax=4
      do 10 ii=1,nmax
      do 20 j=1,nmax
      if(ii.le.4.and.j.le.4)wr(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtot(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtoti(ii,j)=0.0
 20   continue
 10   continue
      do ii=1,3
      x2(ii)=xortet(ii,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      angcal=twopi*yfl          
      ierr=0
      call MatTott(x2,adif,bdif,cdif,ddif,angcal)
      call molt2_rott(rtoti, rtot, wr)
        kk0=0
        do ii=1,5
          xortet(4,ii)=1
         do j=1,4
           x11(j)=xortet(j,ii)
         end do
          call molt1_rott(wr, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
          if(ii.ge.3)then
          kk0=kk0+1
          xyzs(1,natsold+kk0)=x1(1)
          xyzs(2,natsold+kk0)=x1(2)
          xyzs(3,natsold+kk0)=x1(3)
          endif
        end do
c     ntrial=ntrial+1
 8900 continue
      d1=dmiss(i)
      iok=0
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      else
      alfa=90.0*dtor
      endif
      kadd=0
      do 841 k1=1,natsold+3
      do 845 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 841
 845  continue
      do 846 k2=1,nott
      if(k1.eq.notta(k2))go to 841
 846  continue
      if(imiss(i).eq.1)then
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivtcat(xo,i,natsold,kadd,xad,k1)
      else
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivocat(xo,i,natsold,kadd,xad,k1)
      endif
 841  continue
      d1=dmiss(i)
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      kadd=min0(2,kadd)
      natsadd=5-kadd
      else
      alfa=90.0*dtor
      kadd=min0(4,kadd)
      natsadd=7-kadd
      endif
      ndiff=natsadd-3
      ik0=0
      ic1=2+kadd
      if(imiss(i).eq.1)then
      xtet(1,1)=xyzs(1,natsold+2)
      xtet(2,1)=xyzs(2,natsold+2)
      xtet(3,1)=xyzs(3,natsold+2)
      xtet(1,2)=xyzs(1,natsold+3)
      xtet(2,2)=xyzs(2,natsold+3)
      xtet(3,2)=xyzs(3,natsold+3)
      if(kadd.gt.0)then
      do 2222 il=1,kadd
      xtet(1,2+il)=xad(1,il)
      xtet(2,2+il)=xad(2,il)
      xtet(3,2+il)=xad(3,il)
 2222 continue
      endif
      else
      xotta(1,1)=xyzs(1,natsold+2)
      xotta(2,1)=xyzs(2,natsold+2)
      xotta(3,1)=xyzs(3,natsold+2)
      xotta(1,2)=xyzs(1,natsold+3)
      xotta(2,2)=xyzs(2,natsold+3)
      xotta(3,2)=xyzs(3,natsold+3)
      if(kadd.gt.0)then
      do 2223 il=1,kadd
      xotta(1,2+il)=xad(1,il)
      xotta(2,2+il)=xad(2,il)
      xotta(3,2+il)=xad(3,il)
 2223 continue
      endif
      endif
      jk0=2 
      iott180=0
      x1(1)=xyzs(1,natsold+jk0)
      x1(2)=xyzs(2,natsold+jk0)
      x1(3)=xyzs(3,natsold+jk0)
      x2(1)=xyzs(1,natsold+1)
      x2(2)=xyzs(2,natsold+1)
      x2(3)=xyzs(3,natsold+1)
      x3(1)=xyzs(1,natsold+jk0+1)
      x3(2)=xyzs(2,natsold+jk0+1)
      x3(3)=xyzs(3,natsold+jk0+1)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      do 861 ik=1,ndiff
      if(ik0.gt.0)then
      ik0=ik0-1
      go to 861
      endif
      jk=ik+1
      iok=0
 293  continue
      if(iott180.eq.1)then
      x1(1)=xyzs(1,natsold+jk0)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk0)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk0)-xyzs(3,natsold+1)
      else
      x1(1)=xyzs(1,natsold+jk)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk)-xyzs(3,natsold+1)
      endif
      call molt1_rot(rmz, x1, x2)
      x1(1)=xyzs(1,natsold+jk+1)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk+1)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk+1)-xyzs(3,natsold+1)
      call molt1_rot(rmz, x1, x3)
      iarret=0
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if(iarret.lt.0)go to 9000
      call molt1_rot(rmiz, x1, xo)
      if(iok.eq.0)then
      do 559 ijk=2,jk+1   
      x1(1)=xo(1)+xyzs(1,natsold+1)
      x1(2)=xo(2)+xyzs(2,natsold+1)
      x1(3)=xo(3)+xyzs(3,natsold+1)
      x2(1)=xyzs(1,natsold+ijk)
      x2(2)=xyzs(2,natsold+ijk)
      x2(3)=xyzs(3,natsold+ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      endif
      endif
 559  continue
      endif
      xyzs(1,natsold+jk+2)=xo(1)+xyzs(1,natsold+1)
      xyzs(2,natsold+jk+2)=xo(2)+xyzs(2,natsold+1)
      xyzs(3,natsold+jk+2)=xo(3)+xyzs(3,natsold+1)
      xo(1)=xyzs(1,natsold+jk+2)
      xo(2)=xyzs(2,natsold+jk+2)
      xo(3)=xyzs(3,natsold+jk+2)
      i1=natsold+1
      ic1=ic1+1
      if(imiss(i).eq.1)then
      xtet(1,ic1)=xyzs(1,natsold+jk+2)
      xtet(2,ic1)=xyzs(2,natsold+jk+2)
      xtet(3,ic1)=xyzs(3,natsold+jk+2)
      else
      xotta(1,ic1)=xyzs(1,natsold+jk+2)
      xotta(2,ic1)=xyzs(2,natsold+jk+2)
      xotta(3,ic1)=xyzs(3,natsold+jk+2)
      endif
      ic1sav=ic1
      if(imiss(i).eq.1.and.ic1.lt.4)then
      call checkequivtt2(xo,i,i1,ic1,ic1sav,xtet)
      xyzs(1,natsold+jk+2)=xtet(1,ic1sav)               
      xyzs(2,natsold+jk+2)=xtet(2,ic1sav)               
      xyzs(3,natsold+jk+2)=xtet(3,ic1sav)               
      if(ic1.gt.ic1sav.and.ic1.le.4)then
      iok=0
      do 862 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0)=xtet(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0)=xtet(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0)=xtet(3,ic1sav+iik0)               
      ik0=ik0+1
 862  continue
      endif
      elseif(imiss(i).eq.2.and.ic1.lt.6)then
      call checkequivoo2(xo,i,i1,ic1,ic1sav,xotta)
      xyzs(1,natsold+jk+2)=xotta(1,ic1sav)               
      xyzs(2,natsold+jk+2)=xotta(2,ic1sav)               
      xyzs(3,natsold+jk+2)=xotta(3,ic1sav)               
      if(ic1.gt.ic1sav.and.ic1.le.6)then
      iok=0
      do 863 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0)=xotta(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0)=xotta(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0)=xotta(3,ic1sav+iik0)               
      ik0=ik0+1
 863  continue
      endif
      endif
 861  continue
      dsog=0.6
c     dsog=1.2
  910 continue
      nats=natsold+natsadd
      do 8910 ijk=natsold+1,natsold+natsadd                 
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
      do 8920 ijk0=1,natsold                
      x1(1)=xyzs(1,ijk0)
      x1(2)=xyzs(2,ijk0)
      x1(3)=xyzs(3,ijk0)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
      nats=natsold
      ierr=-1
      go to 9000
      endif
 8920 continue
 8910 continue
      ier=0
      iloccat1=1
      nzmax=-99999999
      do 120 ii=1,nats
      if (nz(ii).ne.0) then
      nzz=iabs(nz(ii))/100
      if (nzz.gt.nzmax) nzmax=nzz
      endif
  120 continue
      do 121 il=1,nats
      if (nz(il).eq.0) go to 121
      nzz=iabs(nz(il))/100
      if (nzz.lt.nzmax)then
      zrap=float(nzmax)/float(nzz)
      bfac(il)=zrap*biso
      zrap=zrap**2
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      else
      bfac(il)=0.9*biso
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      endif
 121  continue
      iprier=0
      call calcolaerre(chi2,iprier)
c     kdirect=0
c     interp=0
c     iniat = 1
c     call MakeLab(iniat,nats)
c     call to_coord(1)
c     call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
      if(chi2.lt.chimin)then
c     kdirect=0
c     interp=0
c     iniat = 1
c     call MakeLab(iniat,nats)
c     call to_coord(1)
c     call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
CCCCC if(chi2.lt.chimin)then
      natsaddsav=natsadd
      natssav=natsold+natsadd
      kaddsav=kadd
      do 5001 jk=1,kadd
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
 5001 continue
      do 5200 jk=natsold+1,natsold+natsadd
      xsavx(1,jk)=xyzs(1,jk)
      xsavx(2,jk)=xyzs(2,jk)
      xsavx(3,jk)=xyzs(3,jk)
 5200 continue
      nzmsav=nzm
      do 5201 jk=1,nzmsav
      ilocsav(jk)=iloc(jk)
      xlocsav(1,jk)=xloc(1,jk)
      xlocsav(2,jk)=xloc(2,jk)
      xlocsav(3,jk)=xloc(3,jk)
      nlocsav(1,jk)=nloc(1,jk)
      nlocsav(2,jk)=nloc(2,jk)
      nlocsav(3,jk)=nloc(3,jk)
 5201 continue
      ntrialsav=ntrial
      chimin=chi2
      endif
 9000 continue    
c     nats=natsold
 4000 continue
 3000 continue
 2000 continue
 1000 continue
  900 continue
 6000 continue
 5002 continue
      if(iloccat1.eq.0)ier=-1
      if(ier.lt.0)return
      do 5300 k=natsold+1,natssav                
      xyzs(1,k)=xsavx(1,k)
      xyzs(2,k)=xsavx(2,k)
      xyzs(3,k)=xsavx(3,k)
 5300 continue
      call intcoordd(ier)
      if(ier.lt.0)return
      if(istampa.gt.0)then
      write(lo,'(/,a,i6,a)')' ***** Selected Z-matrix description *****'
      write(lo,'(a)')'                                                 '
      write(lo,'(a,a)')' atom nr.  type  nr.       dist          ang',
     *'          tors '
      do 800 ii=1,nzm
      if(nlocsav(1,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4)')
     *ilocsav(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),
     *ii,nlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.1.and.nlocsav(2,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4,f10.3)')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.2.and.nlocsav(3,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,2(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii)
      else
      write(lo,'(i4,8x,a2,i4,3(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii),
     *nlocsav(3,ii),xlocsav(3,ii)
      endif
 800  continue
      write(lo,'(a)')'                                                 '
      write(lo,'(a,/)')'  *********************************************'
      kt=nfound1(i)
      write(lo,'(a,3f10.3)')' input cation #1',(xyzs(kp,kt),kp=1,3)
      kt=nfound2(i)
      write(lo,'(a,3f10.3)')' input cation #2',(xyzs(kp,kt),kp=1,3)
      write(lo,'(a,3f10.3)')' located cation',
     *(xyzs(kp,natsold+1),kp=1,3)
      do 5022 jk=natsold+2,natsold+natsaddsav
      write(lo,'(a,3f10.3)')' located anion',(xyzs(kp,jk),kp=1,3)
 5022 continue
      write(lo,'(/,a,f10.3,a,i7)')' Minimum fom:',chimin,
     *' trial #',ntrial
      endif
      nats=natsold+natsaddsav
      kdirect=1
      interp=0
      iniat = 1
      call MakeLab(iniat,nats)
      call to_coord(1)
      call frm15e(nats,interp)
      rfac=chimin
      jpol=0
      kdirectsav=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      nats=natsold
      nats=natssav               
      do 550 k=natsold+1,natssav             
      xo(1)=xyzs(1,k)
      xo(2)=xyzs(2,k)
      xo(3)=xyzs(3,k)
      call checkequiv(xo)
      xyzs(1,k)=xo(1)
      xyzs(2,k)=xo(2)
      xyzs(3,k)=xo(3)
 550  continue
      j1=nfound1(i)
      it(j1)=it(j1)+1
      xt(1,j1,it(j1))=xyzs(1,natsold+2)
      xt(2,j1,it(j1))=xyzs(2,natsold+2)
      xt(3,j1,it(j1))=xyzs(3,natsold+2)
      ntt(j1,it(j1))=natsold+2
      j2=nfound2(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xyzs(1,natsold+3)
      xt(2,j2,it(j2))=xyzs(2,natsold+3)
      xt(3,j2,it(j2))=xyzs(3,natsold+3)
      ntt(j2,it(j2))=natsold+3
      j3=natsold+1
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+2)
      xt(2,j3,it(j3))=xyzs(2,natsold+2)
      xt(3,j3,it(j3))=xyzs(3,natsold+2)
      ntt(j3,it(j3))=natsold+2
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+3)
      xt(2,j3,it(j3))=xyzs(2,natsold+3)
      xt(3,j3,it(j3))=xyzs(3,natsold+3)
      ntt(j3,it(j3))=natsold+3
      kadd=kaddsav
      ndif=nats-natsold-3
c     do 811 il=1,ndif
c     it(j3)=it(j3)+1
c     xt(1,j3,it(j3))=xyzs(1,natsold+3+il)
c     xt(2,j3,it(j3))=xyzs(2,natsold+3+il)
c     xt(3,j3,it(j3))=xyzs(3,natsold+3+il)
c     ntt(j3,it(j3))=natsold+3+il
c811  continue
      if(imiss(i).eq.1)then
      itet=1
      ntetra=ntetra+1
      ntetr(ntetra)=natsold+1
      dtetra(ntetra)=dmiss(i)
      dtolt(ntetra)=dtolm(i)
      atolt(ntetra)=atolm(i)
      ktetra(ntetra)=kmiss(i)
      elseif(imiss(i).eq.2)then
      iott=1
      nott=nott+1
      notta(nott)=natsold+1
      dotta1(nott)=dmiss(i)
      dtolo(nott)=dtolm(i)
      atolo(nott)=atolm(i)
      kotta(nott)=kmiss(i)
      endif
      natmis(1,i)=natsold+1
      natmis(2,i)=natsold+2
      natmis(3,i)=natsold+3
      natsold=nats
      do 9100 k1=1,nats
      do 945 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 9100
 945  continue
      do 946 k2=1,nott
      if(k1.eq.notta(k2))go to 9100
 946  continue
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      if(ntetra.gt.0)call checkequivtcat2(xo)
      if(nott.gt.0)call checkequivocat2(xo)
 9100 continue
      return
      end
c----------------------------------------------------------------
      subroutine dainttocricat1(icat1,ier)
      USE Atomi
      USE General
*     include 'atoms.fi'
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/stampa/istampa
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common /matr/rmz(3,3),rmiz(3,3)
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/ annealcat/ ncate,nzcat(500),iloccat(500,500),
     *xloccat(500,3,500),nloccat(500,3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common /derrig0/rr(3,3),rrt(3,3),rrf(3,3),rrp(3,3),derah(6,500),
     *       derbh(6,500)
      common /fastcal/ hkle(3000,4,24),fsca(9,3000)
      common/Gmatrix/ggMat(3,3)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      dimension x11(4),x1(3),x2(3),xcri(3,500),
     *xortol(3,500)
      dimension amat(9,9),dmat(9),INDX(9),v(3,3)
      dimension aa(3,3),w(3),bb(3,3),ww(3,3),www(3)
      dimension ilocr(4),xcr(3,4),ang(3)
      dimension xz(3,5),x3(3),x4(3),x1t(3)
      dimension wr(4,4),xortet(4,6)
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
c
      ier=0
      do 200 i=1,6
      dmat(i)=0.0
      do 300 j=1,6
      amat(i,j)=0.0
 300  continue
 200  continue
c     a=cell(1)
c     b=cell(2)
c     c=cell(3)
c     alfa=cell(4)
c     beta=cell(5)
c     gamma=cell(6)
c     inv=0
c     call Orto_new(a, b, c, alfa, beta, gamma,inv)
c     inv=1
c     call Orto_new(a, b, c, alfa, beta, gamma,inv)
      nch=1
      il=iloc(nzm-1)
      xor(1,nch)=xyzs(1,il)
      xor(2,nch)=xyzs(2,il)
      xor(3,nch)=xyzs(3,il)
      xortol(1,nzm-1)=0.0
      xortol(2,nzm-1)=0.0
      xortol(3,nzm-1)=0.0
      k=nzm-1
      xortolocal(1,iloc(k))=xortol(1,k)
      xortolocal(2,iloc(k))=xortol(2,k)
      xortolocal(3,iloc(k))=xortol(3,k)
      xortol(1,nzm-2)=xloc(1,nzm-1)
      xortol(2,nzm-2)=0.0
      xortol(3,nzm-2)=0.0
      k=nzm-2
      xortolocal(1,iloc(k))=xortol(1,k)
      xortolocal(2,iloc(k))=xortol(2,k)
      xortolocal(3,iloc(k))=xortol(3,k)
      do 1000 k=1,nzm-3
      mmax=nzm-3
      xortol(1,k)=0.0
      xortol(2,k)=0.0
      xortol(3,k)=0.0
      do 1100 i=k,mmax
      w(1)=0.0
      w(2)=0.0
      w(3)=0.0
      j=nzm-3
      jrif=j
      fij=xloc(2,j+2)*dtor
      ppp=-1.0
      tij=ppp*(xloc(3,j+3))*dtor
      dij=xloc(1,i+1)
      aa(1,1)=-cos(fij)
      aa(1,2)=-sin(fij)
      aa(1,3)=0.0
      aa(2,1)=sin(fij)*cos(tij)
      aa(2,2)=-cos(fij)*cos(tij)
      aa(2,3)=sin(tij)
      aa(3,1)=-sin(fij)*sin(tij)
      aa(3,2)=cos(fij)*sin(tij)
      aa(3,3)=cos(tij)
      do 1200 j=nzm-4,i,-1
      fij=xloc(2,j+2)*dtor
      ppp=-1.0
      tij=ppp*(xloc(3,j+3))*dtor
      bb(1,1)=-cos(fij)
      bb(1,2)=-sin(fij)
      bb(1,3)=0.0
      bb(2,1)=sin(fij)*cos(tij)
      bb(2,2)=-cos(fij)*cos(tij)
      bb(2,3)=sin(tij)
      bb(3,1)=-sin(fij)*sin(tij)
      bb(3,2)=cos(fij)*sin(tij)
      bb(3,3)=cos(tij)
      call moltm(aa,bb,ww)
      do 1250 ik=1,3
      do 1260 jk=1,3
      aa(ik,jk)=ww(ik,jk)
 1260 continue
 1250 continue
 1200 continue
      www(1)=dij
      www(2)=0.0
      www(3)=0.0
      call moltv(aa,www,w)
      xortol(1,k)=xortol(1,k)+w(1)
      xortol(2,k)=xortol(2,k)+w(2)
      xortol(3,k)=xortol(3,k)+w(3)
 1100 continue
      xortol(1,k)=xortol(1,k)+xloc(1,nzm-1)
      xortolocal(1,iloc(k))=xortol(1,k)
      xortolocal(2,iloc(k))=xortol(2,k)
      xortolocal(3,iloc(k))=xortol(3,k)
 1000 continue
 2500 continue
      d=xloc(1,nzm)
      dd=1.8
      do 100 j=1,ntetra
      if(nfound1(icat1).eq.ntetr(j))then
      dd=dtetra(j)
      go to 170
      endif
 100  continue
      do 101 j=1,nott
      if(nfound1(icat1).eq.notta(j))then
      dd=dotta1(j)
      go to 170
      endif
 101  continue
 170  continue
      a=xortol(1,1)
      b=xortol(2,1)
      c=xortol(3,1)
      a1=2.0*a*d
      a2=-2.0*d*b
      a3=d**2+a**2+b**2+c**2-dd**2
      b1=a3-a2
      b2=a1
      b3=a3+a2
      delta=(b2**2-b1*b3)
      if(delta.lt.0.0)then
      ier=-1
      return
      endif
      delta=sqrt(delta)
      t=(-b2+delta)/b1
      at=atan(t)
      at=2.0*(at+(pi/4.0))
      xloc(2,nzm)=at*rtod
      dn=xloc(1,nzm)
      fn=(xloc(2,nzm)*dtor)-(pi/2.0)
      xortol(1,nzm)=-dn*sin(fn)
      xortol(2,nzm)=dn*cos(fn)
      xortol(3,nzm)=0.0
      k=nzm
      xortolocal(1,iloc(k))=xortol(1,k)
      xortolocal(2,iloc(k))=xortol(2,k)
      xortolocal(3,iloc(k))=xortol(3,k)
      sinphi=sin(phis*dtor)
      cosphi=cos(phis*dtor)
      sinpsi=sin(psis*dtor)
      cospsi=cos(psis*dtor)
      sintheta=sin(thetas*dtor)
      costheta=cos(thetas*dtor)
c     sinphi=sin(phis)
c     cosphi=cos(phis)
c     sinpsi=sin(psis)
c     cospsi=cos(psis)
c     sintheta=sin(thetas)
c     costheta=cos(thetas)
      rr(1,1)=cospsi*cosphi-costheta*sinphi*sinpsi
      rr(1,2)=cospsi*sinphi+costheta*cosphi*sinpsi
      rr(1,3)=sintheta*sinpsi
      rr(2,1)=-sinpsi*cosphi-costheta*sinphi*cospsi
      rr(2,2)=-sinpsi*sinphi+costheta*cosphi*cospsi
      rr(2,3)=cospsi*sintheta
      rr(3,1)=sintheta*sinphi
      rr(3,2)=-sintheta*cosphi
      rr(3,3)=costheta
      do 700 j=1,nzm          
      i=iloc(j)
      x11(1)=xortolocal(1,i)
      x11(2)=xortolocal(2,i)
      x11(3)=xortolocal(3,i)
      call molt1_rot(rr, x11, x1)
      call molt1_rot(rmiz, x1, x2)
      x1(1)=x2(1)+xor(1,nch)
      x1(2)=x2(2)+xor(2,nch)
      x1(3)=x2(3)+xor(3,nch)
      xz(1,j)=x1(1)
      xz(2,j)=x1(2)
      xz(3,j)=x1(3)
c     write(6,'(a,3f10.4)')'X1',x1
 700  continue
      jj=nfound2(icat1)
      jjj=nfound1(icat1)
      xa=xz(1,nzm)-xyzs(1,jj)
      ya=xz(2,nzm)-xyzs(2,jj)
      za=xz(3,nzm)-xyzs(3,jj)
      xc=xyzs(1,jjj)-xyzs(1,jj)
      yc=xyzs(2,jjj)-xyzs(2,jj)
      zc=xyzs(3,jjj)-xyzs(3,jj)
      g1=ggMat(1,1)*xc+ggMat(1,2)*yc+ggMat(1,3)*zc
      g2=ggMat(2,1)*xc+ggMat(2,2)*yc+ggMat(2,3)*zc
      g3=ggMat(3,1)*xc+ggMat(3,2)*yc+ggMat(3,3)*zc
      g4=ggMat(1,1)*xa+ggMat(1,2)*ya+ggMat(1,3)*za
      g5=ggMat(2,1)*xa+ggMat(2,2)*ya+ggMat(2,3)*za
      g6=ggMat(3,1)*xa+ggMat(3,2)*ya+ggMat(3,3)*za
      aaa=(g3*g4-g1*g6)/(g1*g5-g2*g4)
      bbb=(-g2*aaa-g3)/g1
      b2=bbb**2
      a2=aaa**2
      ab=aaa*bbb
      den=ggMat(1,1)*b2+ggMat(2,2)*a2+
     *    ggMat(3,3)+ab*(ggMat(1,2)+ggMat(2,1))+
     *   bbb*(ggMat(1,3)+ggMat(3,1))+aaa*(ggMat(2,3)+ggMat(3,2))
      x4(3)=sqrt(1.0/den)
      x4(1)=x4(3)*bbb
      x4(2)=x4(3)*aaa
      x4(1)=x4(1)+xyzs(1,jj)
      x4(2)=x4(2)+xyzs(2,jj)
      x4(3)=x4(3)+xyzs(3,jj)
      x1(1)=xyzs(1,jjj)
      x1(2)=xyzs(2,jjj)
      x1(3)=xyzs(3,jjj)
      x2(1)=xyzs(1,jj)
      x2(2)=xyzs(2,jj)
      x2(3)=xyzs(3,jj)
      x3(1)=xz(1,nzm)
      x3(2)=xz(2,nzm)
      x3(3)=xz(3,nzm)
      call angolo(ggMat,x1,x2,x3,angcal)
      angsav=angcal
      do 2505 knv=1,2
      if(knv.eq.1)then
      angcal=-angsav
      else
      angcal=-twopi+angsav
      endif
      k=nzm-1
      x1(1)=xz(1,k)
      x1(2)=xz(2,k)
      x1(3)=xz(3,k)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      x1(1)=x4(1)    
      x1(2)=x4(2)    
      x1(3)=x4(3)    
      call molt1_rot(rmz, x1, x2)
      xortet(1,2)=x2(1)
      xortet(2,2)=x2(2)
      xortet(3,2)=x2(3)
      k0=2
      do 51 k=1,nzm
      if(k.eq.(nzm-1))go to 51
      k0=k0+1
      x1(1)=xz(1,k)
      x1(2)=xz(2,k)
      x1(3)=xz(3,k)
      call molt1_rot(rmz, x1, x2)
      xortet(1,k0)=x2(1)
      xortet(2,k0)=x2(2)
      xortet(3,k0)=x2(3)
 51   continue
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      do i=1,3
      x2(i)=xortet(i,1)
      end do
      nmax=4
      do 10 i=1,nmax
      do 20 j=1,nmax
      if(i.le.4.and.j.le.4)wr(i,j)=0.0
      if(i.le.4.and.j.le.4)rtot(i,j)=0.0
      if(i.le.4.and.j.le.4)rtoti(i,j)=0.0
 20   continue
 10   continue
      call MatTotti(x2,adif,bdif,cdif,ddif)
      call MatTott(x2,adif,bdif,cdif,ddif,angcal)
      call molt2_rott(rtoti, rtot, wr)
        do i=1,6
          xortet(4,i)=1
         do j=1,4
           x11(j)=xortet(j,i)
         end do
          call molt1_rott(wr, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
          if(i.eq.4)then
          xadd(1,1)=x1(1)
          xadd(2,1)=x1(2)
          xadd(3,1)=x1(3)
          elseif(i.eq.3)then
          xadd(1,2)=x1(1)
          xadd(2,2)=x1(2)
          xadd(3,2)=x1(3)
          elseif(i.eq.5)then
          xadd(1,3)=x1(1)
          xadd(2,3)=x1(2)
          xadd(3,3)=x1(3)
          elseif(i.eq.6)then
          x2(1)=x1(1)
          x2(2)=x1(2)
          x2(3)=x1(3)
          endif
        end do
      x1(1)=xyzs(1,nfound1(icat1))
      x1(2)=xyzs(2,nfound1(icat1))
      x1(3)=xyzs(3,nfound1(icat1))
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.gt.0.1.and.knv.eq.1)then
      go to 2505
      elseif(dcal.gt.0.1.and.knv.eq.2)then
      ier=-1
      return
      else
      go to 2506
      endif
 2505 continue
 2506 continue
      do 3050 i=1,3
        iser=1
        iactn=1
        khead=0
        xo1(1) = xadd(1,i)
        xo1(2) = xadd(2,i)
        xo1(3) = xadd(3,i)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xadd(1,i)=xn(1)
        xadd(2,i)=xn(2)
        xadd(3,i)=xn(3)
 3050 continue
      return
      end
c -----------------------------------------------------------------
      subroutine checkequivtcat(xo,i,natsold,kadd,xad,k1)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell
      common/occtetra/it(500)
      common/stampa/istampa
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/Gmatrix/ggMat(3,3)
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3)
      dimension x1(3),x2(3),xad(3,10),xb2(3),s(3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
      dimension vet(2)
      real, dimension(3,3) :: gm
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c--
c----- check se un equivalente di xo e' legato con i cationi
c--
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      angsog1 = 109.47*(1.0-atolm(i))
      angsog2 = 109.47*(1.0+atolm(i))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
        dist1=dtetra(i)*(1.0-dtolm(i)) 
        dist2=dtetra(i)*(1.0+dtolm(i))
        jj = natsold+1
        xcat(1) = xyzs(1,natsold+1) 
        xcat(2) = xyzs(2,natsold+1) 
        xcat(3) = xyzs(3,natsold+1) 
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c          call equitt(xeq,ii)
c-----------------
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 kj=1,nsym
c           if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
        iser=1
        iactn=1
        khead=0
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
c         call distanzan(ggMat,xcat,xeq,dist)
            !call xdist(xcat,xeq,dist,s)
            call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if (dist.ge.dist1.and.dist.le.dist2) then
c--
c-- accetto solo atomi che formano angolo (109+/-soglia) con gli altri del tetraedro
c--
                 iok = 1
                 do 40 k=natsold+2,natsold+3
                    xoo(1) = xyzs(1,k)
                    xoo(2) = xyzs(2,k)
                    xoo(3) = xyzs(3,k)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if (ang1.lt.angsog1.or.ang1.gt.angsog2) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    do 110 k=natsold+2,natsold+3
                    x1(1)=xyzs(1,k)
                    x1(2)=xyzs(2,k)
                    x1(3)=xyzs(3,k)
                    x2(1)=xeq(1)            
                    x2(2)=xeq(2)            
                    x2(3)=xeq(3)            
c                   call distanzan(ggMat,x1,x2,dcal)
c                   call distanzaeq(ggMat,x1,x2,dcal)
                    call distanzaeq(x1,x2,dcal)
                    if(dcal.lt.0.6.and.dcal.gt.0.0)go to 130
 110                continue
                    kadd=kadd+1
                    xad(1,kadd)=xeq(1)     
                    xad(2,kadd)=xeq(2)     
                    xad(3,kadd)=xeq(3)     
c                   it(jj)=it(jj)+1
c                   xt(1,jj,it(jj))=xeq(1)       
c                   xt(2,jj,it(jj))=xeq(2)       
c                   xt(3,jj,it(jj))=xeq(3)       
c                   ntt(jj,it(jj))=k1         
 130                continue
                 endif
             endif 
 25   continue
      return
      end 
c-----------------------------------------------------------------
      subroutine checkequivocat(xo,i,natsold,kadd,xad,k1)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell
      common/occtetra/it(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/stampa/istampa
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/Gmatrix/ggMat(3,3)
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3)
      dimension x1(3),x2(3),xad(3,10),xb2(3),s(3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
      dimension vet(2)
      real, dimension(3,3) :: gm
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c-    
c----- check se un equivalente di xo e' legato con i cationi
c--
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      angsog1 = 90.0*(1.0-atolm(i))
      angsog2 = 90.0*(1.0+atolm(i))
      angsog11 = 180.0*(1.0-atolm(i))
      angsog22 = 180.0*(1.0+atolm(i))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
        dist1=dmiss(i)*(1.0-dtolm(i))
        dist2=dmiss(i)*(1.0+dtolm(i))
        dist3=dmiss(i)*(1.0-dtolm(i))
        dist4=dmiss(i)*(1.0+dtolm(i))
        jj = natsold+1
c-
        xcat(1) = xyzs(1,jj) 
        xcat(2) = xyzs(2,jj) 
        xcat(3) = xyzs(3,jj) 
c-
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c---
c          call equitt(xeq,ii)
c-----------------
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 kj=1,nsym
c           if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
        iser=1
        iactn=1
        khead=0
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
c         call distanzan(ggMat,xcat,xeq,dist)
            !call xdist(xcat,xeq,dist,s)
            call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if ((dist.ge.dist1.and.dist.le.dist2)
     *    .or.(dist.ge.dist3.and.dist.le.dist4)) then
c--
c-- accetto solo atomi che formano angolo (90+/-soglia) con gli altri dell'ottaedro
c--
                 iok = 1
                 do 40 k=natsold+2,natsold+3
                    xoo(1) = xyzs(1,k)
                    xoo(2) = xyzs(2,k)
                    xoo(3) = xyzs(3,k)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if ((ang1.lt.angsog1).or.(ang1.gt.angsog2.and. 
     *              ang1.lt.angsog11).or.(ang1.gt.angsog22)) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    do 110 k=natsold+2,natsold+3
                    x1(1)=xyzs(1,k)
                    x1(2)=xyzs(2,k)
                    x1(3)=xyzs(3,k)
                    x2(1)=xeq(1)            
                    x2(2)=xeq(2)            
                    x2(3)=xeq(3)            
c                   call distanzan(ggMat,x1,x2,dcal)
c                   call distanzaeq(ggMat,x1,x2,dcal)
                    call distanzaeq(x1,x2,dcal)
                    if(dcal.lt.0.6.and.dcal.gt.0.0)go to 130
 110                continue
                    kadd=kadd+1        
                    xad(1,kadd)=xeq(1)     
                    xad(2,kadd)=xeq(2)     
                    xad(3,kadd)=xeq(3)     
c                   it(jj)=it(jj)+1
c                   xt(1,jj,it(jj))=xeq(1)       
c                   xt(2,jj,it(jj))=xeq(2)       
c                   xt(3,jj,it(jj))=xeq(3)       
c                   ntt(jj,it(jj))=k1         
 130                continue
                 endif
             endif 
 25   continue
      return
      end 
c-----------------------------------------------------------------
      subroutine checkequiv(xo)
      Use Polpo
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell
c
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/occtetra/it(500)
      common/stampa/istampa
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/Gmatrix/ggMat(3,3)
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3)
      dimension x1(3),x2(3),xb2(3),s(3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
      dimension vet(2)
      real, dimension(3,3) :: gm
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
c-
c     do 10 ii=2,nsym2
c        xeq(1) = xo(1)
c        xeq(2) = xo(2)
c        xeq(3) = xo(3)
c        call equitt(xeq,ii)
c----------
c         call distanzan(ggMat,xo,xeq,dist)
c----------
      ifin=icent+1
        do 10 kt=1,spacegr%ncoper
        do 10 ifi=1,ifin
          coef=vet(ifi)
          do 10 k=1,nsym
            if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 10
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,k,coef,xeq,kt)
            !call xdist(xb2,xeq,dist,s)
            call xdisteqs(xb2,xeq,gm,dist,s)
            xeq(1)=xb2(1)+s(1)
            xeq(2)=xb2(2)+s(2)
            xeq(3)=xb2(3)+s(3)
          if (dist.gt.0.000001.and.dist.le.dmin) then
c            write(6,*)' CORDINATE X0 INIZIALI =',xo
             xo(1) = (xo(1) + xeq(1))/2.
             xo(2) = (xo(2) + xeq(2))/2.
             xo(3) = (xo(3) + xeq(3))/2.
             go to 11
           endif
   10    continue
   11    continue
         return
         end
c----------------------------------------------------------------
      subroutine checkequivtcat2(xo)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell
      common/occtetra/it(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/stampa/istampa
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/Gmatrix/ggMat(3,3)
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3)
      dimension x1(3),x2(3),xb2(3),s(3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
      dimension vet(2)
      real, dimension(3,3) :: gm
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
c     write(6,*) ' INIZIO IT in checkeqvt',(it(kk),kk=1,4)
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
c--
c----- check se un equivalente di xo e' legato con i cationi
c--
      do 35 i = 1,ntetra
      angsog1 = 109.47*(1.0-atolt(i))
      angsog2 = 109.47*(1.0+atolt(i))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
        dist1=dtetra(i)*(1.0-dtolt(i)) 
        dist2=dtetra(i)*(1.0+dtolt(i))
        jj = ntetr(i)
        xcat(1) = xyzs(1,jj) 
        xcat(2) = xyzs(2,jj) 
        xcat(3) = xyzs(3,jj) 
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c          call equitt(xeq,ii)
c-----------------
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 kj=1,nsym
c           if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
        iser=1
        iactn=1
        khead=0
*       write(6,*)'xeq prima kspec in checkeqvt',xeq
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
*       if(1.0/float(key(10)).lt.1.) then
*          write(6,*)'OCCUPANZA=',1.0/float(key(10))
*          write(6,*)'xeq prima kspec in checkeqvt',xo1
*          write(6,*)'xeq dopo kspec in checkeqvt',xeq
*       endif
c---
c         call distanzan(ggMat,xcat,xeq,dist)
            !call xdist(xcat,xeq,dist,s)
            call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if (dist.ge.dist1.and.dist.le.dist2) then
             if (it(jj).eq.0) then
                 it(jj)=it(jj)+1
                 xt(1,jj,it(jj))=xeq(1)       
                 xt(2,jj,it(jj))=xeq(2)       
                 xt(3,jj,it(jj))=xeq(3)       
                 ntt(jj,it(jj))=nats         
             elseif (it(jj).ge.1.and.it(jj).lt.4) then
c--
c-- accetto solo atomi che formano angolo (109+/-soglia) con gli altri del tetraedro
c--
                 iok = 1
                 do 40 k=1,it(jj)
                    xoo(1) = xt(1,jj,k)
                    xoo(2) = xt(2,jj,k)
                    xoo(3) = xt(3,jj,k)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if (ang1.lt.angsog1.or.ang1.gt.angsog2) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    do 110 k=1,it(jj)
                    x1(1)=xt(1,jj,k)
                    x1(2)=xt(2,jj,k)
                    x1(3)=xt(3,jj,k)
                    do 120 kk=k+1,it(jj)+1
                    if(kk.lt.it(jj)+1)then
                    x2(1)=xt(1,jj,kk)
                    x2(2)=xt(2,jj,kk)
                    x2(3)=xt(3,jj,kk)
                    else
                    x2(1)=xeq(1)            
                    x2(2)=xeq(2)            
                    x2(3)=xeq(3)            
                    endif
                    call distanzan(ggMat,x1,x2,dcal)
c                   call distanzaeq(ggMat,x1,x2,dcal)
c                   call distanzaeq(x1,x2,dcal)
                    if(dcal.lt.0.6.and.dcal.gt.0.0)go to 130
 120                continue
 110                continue
                    it(jj)=it(jj)+1
                    xt(1,jj,it(jj))=xeq(1)     
                    xt(2,jj,it(jj))=xeq(2)     
                    xt(3,jj,it(jj))=xeq(3)     
                    ntt(jj,it(jj))=nats       
 130                continue
                 endif
             endif 
          endif
 25   continue
 35   continue
c     write(6,*) ' FINE IT in checkeqvt',(it(kk),kk=1,4)
      return
      end 
c-----------------------------------------------------------------
      subroutine checkequivocat2(xo)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell

      common/occtetra/it(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/stampa/istampa
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/Gmatrix/ggMat(3,3)
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3)
      dimension x1(3),x2(3),xb2(3),s(3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
      dimension vet(2)
      real, dimension(3,3) :: gm
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c-    
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
c     write(6,*) ' inizio IT in checkeqvo',(it(kk),kk=1,4)
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
c-    
c----- check se un equivalente di xo e' legato con i cationi
c--
      do 35 i = 1,nott
      angsog1 = 90.0*(1.0-atolo(i))
      angsog2 = 90.0*(1.0+atolo(i))
      angsog11 = 180.0*(1.0-atolo(i))
      angsog22 = 180.0*(1.0+atolo(i))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
        dist1=dotta1(i)*(1.0-dtolo(i))
        dist2=dotta1(i)*(1.0+dtolo(i))
        dist3=dotta1(i)*(1.0-dtolo(i))
        dist4=dotta1(i)*(1.0+dtolo(i))
        jj = notta(i)
c-
        xcat(1) = xyzs(1,jj) 
        xcat(2) = xyzs(2,jj) 
        xcat(3) = xyzs(3,jj) 
c-
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c---
c          call equitt(xeq,ii)
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 kj=1,nsym
c           if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
c-----------------
        iser=1
        iactn=1
        khead=0
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
*       if(1.0/float(key(10)).lt.1.) then
*          write(6,*)'OCCUPANZA=',1.0/float(key(10))
*          write(6,*)'xeq prima kspec in checkeqvo',xo1
*          write(6,*)'xeq dopo kspec in checkeqvo',xeq
*       endif
c---
c-----------------
c         call distanzan(ggMat,xcat,xeq,dist)
            !call xdist(xcat,xeq,dist,s)
            call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if ((dist.ge.dist1.and.dist.le.dist2)
     *    .or.(dist.ge.dist3.and.dist.le.dist4)) then
             if (it(jj).eq.0) then
                 it(jj)=it(jj)+1
                 xt(1,jj,it(jj))=xeq(1)       
                 xt(2,jj,it(jj))=xeq(2)       
                 xt(3,jj,it(jj))=xeq(3)       
                 ntt(jj,it(jj))=nats         
CAN          elseif (it(jj).ge.1.and.it(jj).lt.4) then
             elseif (it(jj).ge.1.and.it(jj).lt.6) then
c--
c-- accetto solo atomi che formano angolo (90+/-soglia) con gli altri dell'ottaedro
c--
                 iok = 1
                 do 40 k=1,it(jj)
                    xoo(1) = xt(1,jj,k)
                    xoo(2) = xt(2,jj,k)
                    xoo(3) = xt(3,jj,k)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if ((ang1.lt.angsog1).or.(ang1.gt.angsog2.and. 
     *              ang1.lt.angsog11).or.(ang1.gt.angsog22)) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    do 110 k=1,it(jj)
                    x1(1)=xt(1,jj,k)
                    x1(2)=xt(2,jj,k)
                    x1(3)=xt(3,jj,k)
                    do 120 kk=k+1,it(jj)+1
                    if(kk.lt.it(jj)+1)then
                    x2(1)=xt(1,jj,kk)
                    x2(2)=xt(2,jj,kk)
                    x2(3)=xt(3,jj,kk)
                    else
                    x2(1)=xeq(1)            
                    x2(2)=xeq(2)            
                    x2(3)=xeq(3)            
                    endif
                    call distanzan(ggMat,x1,x2,dcal)
c                   call distanzaeq(ggMat,x1,x2,dcal)
c                   call distanzaeq(x1,x2,dcal)
                    if(dcal.lt.0.6.and.dcal.gt.0.0)go to 130
 120                continue
 110                continue
                    it(jj)=it(jj)+1
                    xt(1,jj,it(jj))=xeq(1)     
                    xt(2,jj,it(jj))=xeq(2)     
                    xt(3,jj,it(jj))=xeq(3)     
                    ntt(jj,it(jj))=nats       
 130                continue
                 endif
             endif 
          endif
 25   continue
 35   continue
c     write(6,*) ' FINE IT in checkeqvo',(it(kk),kk=1,4)
      return
      end 
c-----------------------------------------------------------------
      subroutine loccat2(i,natsold,j1cod,j2cod,k,ier)
      Use Polpo
      USE Atomi
      USE General
      USE drawatoms
      USE elements, only: pxen_from_specie,numelem
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common/savx/xsavx(3,500)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/occtetra/it(500)
      dimension x1(3),x2(3),x3(3)
      dimension wr(4,4),xortet(4,6),ggstar(3,3)
      dimension x11(4),x1t(3),xo(3),xad(3,10),xadsav(3,10)
      dimension xtet(4,4),xotta(4,6)
      character oo*2                             
      character Buffer*80
c
      ierr=0
      iloccat2=0
      ntrialcat = 0
      dsogok=0.8
      n1=natmis(2,k)
      n2=natmis(3,k)
      n0=natmis(1,k)
      chimin=1.0E+10
      ier=-1
      oo(1:2)='o '
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      nkel = numelem(celem)
      do 150 j=1,nkel
!corr      if (kmiss(i).eq.nalf(j)) then
      if (kmiss(i) == celem(j)%ptab) then
          nzc=j
          nzSavc = j*100+1
          vetintsavc = nzSavc+j
          go to 160
      endif
  150 continue
  160 continue
      do 200 j=1,nkel
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nza=j
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          go to 203
      endif
  200 continue
  203 continue
      nats=natsold
      if(imiss(i).eq.1)then
      iadd=5
      else
      iadd=7     
      endif
      xyzs(1,nats+1)=0.0
      xyzs(2,nats+1)=0.0
      xyzs(3,nats+1)=0.0
      xyzs(4,nats+1)=vetintsavc
      nz(nats+1)=nzSavc
      do 61 kkk=2,iadd
      xyzs(1,nats+kkk)=0.0
      xyzs(2,nats+kkk)=0.0
      xyzs(3,nats+kkk)=0.0
      xyzs(4,nats+kkk)=vetintsav
      nz(nats+kkk)=nzSavv
  61  continue
      nzm=1
      iloc(nzm)=nats+3     
      xloc(1,nzm)=0.0
      xloc(2,nzm)=0.0
      xloc(3,nzm)=0.0
      nloc(1,nzm)=0
      nloc(2,nzm)=0
      nloc(3,nzm)=0
      nzm=2
      iloc(nzm)=nats+1         
      xloc(1,nzm)=dmiss(i)
      xloc(2,nzm)=0.0
      xloc(3,nzm)=0.0
      nloc(1,nzm)=nats+3
      nloc(2,nzm)=0
      nloc(3,nzm)=0
      nzm=3
      iloc(nzm)=nats+2
      xloc(1,nzm)=dmiss(i)
      if(imiss(i).eq.1)then
      n7=1
      else
      n7=2
      endif
      do 7000 k7=1,n7
      nzm=3
      if(imiss(i).eq.1)then
      xloc(2,nzm)=109.47
      else
      if(k7.eq.1)then
      xloc(2,nzm)=90.0
      else
      xloc(2,nzm)=180.0
      endif
      endif
      xloc(3,nzm)=0.0
      nloc(1,nzm)=nats+1
      nloc(2,nzm)=nats+3
      nloc(3,nzm)=0
      if(itimem.eq.0)then
      ntrial1=6
      ntrial2=7
      ntrial3=6
      ntrial4=6
      ntrial5=6
      ntrial6=6
      elseif(itimem.eq.1)then
      ntrial1=3
      ntrial2=4
      ntrial3=3
      ntrial4=3
      ntrial5=3
      ntrial6=3
      elseif(itimem.eq.2)then
      ntrial1=6
      ntrial2=7
      ntrial3=6
      ntrial4=6
      ntrial5=6
      ntrial6=6
      endif
      nzm=4
      iloc(nzm)=nfound1(i)
      nloc(1,nzm)=nats+2          
      nloc(2,nzm)=nats+1
      nloc(3,nzm)=nats+3       
      iest=0
      do 100 j=1,ntetra
      if(nfound1(i).eq.ntetr(j))then
      jsav=j
      ntrial1=1
      iest=1
      go to 170
      endif
 100  continue
      iest=0
      do 101 j=1,nott
      if(nfound1(i).eq.notta(j))then
      jsav=j
      ntrial1=1
      iest=2
      go to 170
      endif
 101  continue
 170  continue
      ntrial_totali=ntrial1*ntrial2*ntrial3*ntrial4*ntrial5*ntrial6
      do 1000 k1=1,ntrial1
      nats=natsold
      nzm=4
      if(iest.eq.1)then
      xloc(1,nzm)=dtetra(jsav)
      elseif(iest.eq.2)then
      xloc(1,nzm)=dotta1(jsav)
      else 
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      dlim1=1.4                   
      dlim2=2.0                    
      dlim=yfl*(dlim2-dlim1)+dlim1
      xloc(1,nzm)=dlim               
      endif
      do 2000 k2=1,ntrial2
      nats=natsold
      nzm=4
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      anglim1=2.0*asin(0.60/xloc(1,nzm))
      anglim2=pi
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
      do 3000 k3=1,ntrial3
      nats=natsold
      nzm=4
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=5
      iloc(nzm)=n1                
      nloc(1,nzm)=nfound1(i)
      nloc(2,nzm)=nats+2         
      nloc(3,nzm)=nats+1         
      x1(1)=xyzs(1,n1)
      x1(2)=xyzs(2,n1)
      x1(3)=xyzs(3,n1)
      x2(1)=xyzs(1,nfound1(i))
      x2(2)=xyzs(2,nfound1(i))
      x2(3)=xyzs(3,nfound1(i))
      call distanza(ggMat,x1,x2,dcal)
      xloc(1,nzm)=dcal
      if(j1cod.eq.1)then
      n8=1
      elseif(j1cod.eq.2)then
      n8=2
      endif
      do 8000 k8=1,n8
      nzm=5
      if(j1cod.eq.1)then
      ntrial4=1
      xloc(2,nzm)=109.47
      elseif(j1cod.eq.2)then
      ntrial4=1
      if(k8.eq.1)then
      xloc(2,nzm)=90.0
      else
      xloc(2,nzm)=180.0
      endif
      endif
      do 4000 k4=1,ntrial4
      nats=natsold
      nzm=5
      if(j1cod.eq.0)then
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      anglim1=2.0*asin(0.60/dcal)
      anglim2=pi
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
      endif
      do 5000 k5=1,ntrial5
      nats=natsold
      nzm=5
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=6
      iloc(nzm)=n0            
      nloc(1,nzm)=n1          
      nloc(2,nzm)=nfound1(i) 
      nloc(3,nzm)=nats+2           
      x1(1)=xyzs(1,n0)
      x1(2)=xyzs(2,n0)
      x1(3)=xyzs(3,n0)
      x2(1)=xyzs(1,n1)
      x2(2)=xyzs(2,n1)
      x2(3)=xyzs(3,n1)
      call distanza(ggMat,x1,x2,dcal)
      xloc(1,nzm)=dcal         
      x3(1)=xyzs(1,nfound1(i))
      x3(2)=xyzs(2,nfound1(i))
      x3(3)=xyzs(3,nfound1(i))
      x2(1)=xyzs(1,n1)
      x2(2)=xyzs(2,n1)
      x2(3)=xyzs(3,n1)
      x1(1)=xyzs(1,n0)
      x1(2)=xyzs(2,n0)
      x1(3)=xyzs(3,n0)
      call angolo(ggMat,x1,x2,x3,angcal)
      angcal=angcal*rtod
      xloc(2,nzm)=angcal
      do 6000 k6=1,ntrial6
      nats=natsold
      nzm=6
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=7
      iloc(nzm)=n2               
      nloc(1,nzm)=n0          
      nloc(2,nzm)=n1         
      nloc(3,nzm)=nfound1(i)     
      x1(1)=xyzs(1,n2)
      x1(2)=xyzs(2,n2)
      x1(3)=xyzs(3,n2)
      x2(1)=xyzs(1,n0)
      x2(2)=xyzs(2,n0)
      x2(3)=xyzs(3,n0)
      call distanza(ggMat,x1,x2,dcal)
      xloc(1,nzm)=dcal
      x1(1)=xyzs(1,n2)
      x1(2)=xyzs(2,n2)
      x1(3)=xyzs(3,n2)
      x2(1)=xyzs(1,n0)
      x2(2)=xyzs(2,n0)
      x2(3)=xyzs(3,n0)
      x3(1)=xyzs(1,n1)
      x3(2)=xyzs(2,n1)
      x3(3)=xyzs(3,n1)
      call angolo(ggMat,x1,x2,x3,angcal)
      angcal=angcal*rtod
      xloc(2,nzm)=angcal
      x1(1)=(xyzs(1,n2)-xyzs(1,n0))
      x1(2)=(xyzs(2,n2)-xyzs(2,n0))
      x1(3)=(xyzs(3,n2)-xyzs(3,n0))
      x2(1)=(xyzs(1,n0)-xyzs(1,n1))
      x2(2)=(xyzs(2,n0)-xyzs(2,n1))
      x2(3)=(xyzs(3,n0)-xyzs(3,n1))
      x3(1)=(xyzs(1,n1)-xyzs(1,nfound1(i)))
      x3(2)=(xyzs(2,n1)-xyzs(2,nfound1(i)))
      x3(3)=(xyzs(3,n1)-xyzs(3,nfound1(i)))
      call torsion(ggMat,ggstar,x1,x2,x3,omega,vol)
      xloc(3,nzm)=omega*rtod
      nzm=8
      iloc(nzm)=nfound2(i)       
      nloc(1,nzm)=n2          
      nloc(2,nzm)=n0         
      nloc(3,nzm)=n1            
      x1(1)=xyzs(1,nfound2(i))
      x1(2)=xyzs(2,nfound2(i))
      x1(3)=xyzs(3,nfound2(i))
      x2(1)=xyzs(1,n2)
      x2(2)=xyzs(2,n2)
      x2(3)=xyzs(3,n2)
      call distanza(ggMat,x1,x2,dcal)
      xloc(1,nzm)=dcal
      x1(1)=xyzs(1,nfound2(i))
      x1(2)=xyzs(2,nfound2(i))
      x1(3)=xyzs(3,nfound2(i))
      x2(1)=xyzs(1,n2)
      x2(2)=xyzs(2,n2)
      x2(3)=xyzs(3,n2)
      x3(1)=xyzs(1,n0)
      x3(2)=xyzs(2,n0)
      x3(3)=xyzs(3,n0)
      call angolo(ggMat,x1,x2,x3,angcal)
      angcal=angcal*rtod
      xloc(2,nzm)=angcal
      x1(1)=(xyzs(1,nfound2(i))-xyzs(1,n2))
      x1(2)=(xyzs(2,nfound2(i))-xyzs(2,n2))
      x1(3)=(xyzs(3,nfound2(i))-xyzs(3,n2))
      x2(1)=(xyzs(1,n2)-xyzs(1,n0))
      x2(2)=(xyzs(2,n2)-xyzs(2,n0))
      x2(3)=(xyzs(3,n2)-xyzs(3,n0))
      x3(1)=(xyzs(1,n0)-xyzs(1,n1))
      x3(2)=(xyzs(2,n0)-xyzs(2,n1))
      x3(3)=(xyzs(3,n0)-xyzs(3,n1))
      call torsion(ggMat,ggstar,x1,x2,x3,omega,vol)
      xloc(3,nzm)=omega*rtod
c     ntrial=ntrial+1
!
!     Manage progress-bar
!
      ntrialcat = ntrialcat + 1
      write(Buffer,102) ntrialcat,ntrial_totali
  102 format(' Adding the missing atoms. Trial ',i5,' / ',i5)
      call scrper(Buffer,ntrialcat,ntrial_totali)
!
      call dainttocricat2(i,n2,j2cod,ierr)
      if(ierr.lt.0)then
      go to 6000
      endif
      ier=0
      dsogc=2.0
      x1(1)=xyzs(1,nfound1(i))
      x1(2)=xyzs(2,nfound1(i))
      x1(3)=xyzs(3,nfound1(i))
      x2(1)=xadd(1,1)
      x2(2)=xadd(2,1)
      x2(3)=xadd(3,1)
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)go to 6000
      x1(1)=xyzs(1,nfound2(i))         
      x1(2)=xyzs(2,nfound2(i))         
      x1(3)=xyzs(3,nfound2(i))         
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)go to 6000
      xyzs(1,natsold+1)=xadd(1,1)
      xyzs(2,natsold+1)=xadd(2,1)
      xyzs(3,natsold+1)=xadd(3,1)
      xyzs(1,natsold+2)=xadd(1,2)
      xyzs(2,natsold+2)=xadd(2,2)
      xyzs(3,natsold+2)=xadd(3,2)
      xyzs(1,natsold+3)=xadd(1,3)
      xyzs(2,natsold+3)=xadd(2,3)
      xyzs(3,natsold+3)=xadd(3,3)
      d1=dmiss(i)
      iok=0
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      else
      alfa=90.0*dtor
      endif
      kadd=0
      do 841 kk1=1,natsold+3
      do 845 kk2=1,ntetra
      if(kk1.eq.ntetr(kk2))go to 841
 845  continue
      do 846 kk2=1,nott
      if(kk1.eq.notta(kk2))go to 841
 846  continue
      if(imiss(i).eq.1)then
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivtcat(xo,i,natsold,kadd,xad,k1)
      else
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivocat(xo,i,natsold,kadd,xad,k1)
      endif
 841  continue
      d1=dmiss(i)
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      kadd=min0(2,kadd)
      natsadd=5-kadd
      else
      alfa=90.0*dtor
      kadd=min0(4,kadd)
      natsadd=7-kadd
      endif
      ndiff=natsadd-3
      ik0=0
      ic1=2+kadd
      if(imiss(i).eq.1)then
      xtet(1,1)=xyzs(1,natsold+2)
      xtet(2,1)=xyzs(2,natsold+2)
      xtet(3,1)=xyzs(3,natsold+2)
      xtet(1,2)=xyzs(1,natsold+3)
      xtet(2,2)=xyzs(2,natsold+3)
      xtet(3,2)=xyzs(3,natsold+3)
      if(kadd.gt.0)then
      do 2222 il=1,kadd
      xtet(1,2+il)=xad(1,il)
      xtet(2,2+il)=xad(2,il)
      xtet(3,2+il)=xad(3,il)
 2222 continue
      endif
      else
      xotta(1,1)=xyzs(1,natsold+2)
      xotta(2,1)=xyzs(2,natsold+2)
      xotta(3,1)=xyzs(3,natsold+2)
      xotta(1,2)=xyzs(1,natsold+3)
      xotta(2,2)=xyzs(2,natsold+3)
      xotta(3,2)=xyzs(3,natsold+3)
      if(kadd.gt.0)then
      do 2223 il=1,kadd
      xotta(1,2+il)=xad(1,il)
      xotta(2,2+il)=xad(2,il)
      xotta(3,2+il)=xad(3,il)
 2223 continue
      endif
      endif
      jk0=2
      iott180=0
      x1(1)=xyzs(1,natsold+jk0)
      x1(2)=xyzs(2,natsold+jk0)
      x1(3)=xyzs(3,natsold+jk0)
      x2(1)=xyzs(1,natsold+1)
      x2(2)=xyzs(2,natsold+1)
      x2(3)=xyzs(3,natsold+1)
      x3(1)=xyzs(1,natsold+jk0+1)
      x3(2)=xyzs(2,natsold+jk0+1)
      x3(3)=xyzs(3,natsold+jk0+1)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      do 861 ik=1,ndiff
      if(ik0.gt.0)then
      ik0=ik0-1
      go to 861
      endif
      jk=ik+1
      iok=0
 293  continue
      if(iott180.eq.1)then
      x1(1)=xyzs(1,natsold+jk0)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk0)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk0)-xyzs(3,natsold+1)
      else
      x1(1)=xyzs(1,natsold+jk)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk)-xyzs(3,natsold+1)
      endif
      call molt1_rot(rmz, x1, x2)
      x1(1)=xyzs(1,natsold+jk+1)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk+1)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk+1)-xyzs(3,natsold+1)
      call molt1_rot(rmz, x1, x3)
      iarret=0
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if(iarret.lt.0)go to 6000
      call molt1_rot(rmiz, x1, xo)
      if(iok.eq.0)then
      do 559 ijk=2,jk+1
      x1(1)=xo(1)+xyzs(1,natsold+1)
      x1(2)=xo(2)+xyzs(2,natsold+1)
      x1(3)=xo(3)+xyzs(3,natsold+1)
      x2(1)=xyzs(1,natsold+ijk)
      x2(2)=xyzs(2,natsold+ijk)
      x2(3)=xyzs(3,natsold+ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      endif
      endif
 559  continue
      endif
      xyzs(1,natsold+jk+2)=xo(1)+xyzs(1,natsold+1)
      xyzs(2,natsold+jk+2)=xo(2)+xyzs(2,natsold+1)
      xyzs(3,natsold+jk+2)=xo(3)+xyzs(3,natsold+1)
      xo(1)=xyzs(1,natsold+jk+2)
      xo(2)=xyzs(2,natsold+jk+2)
      xo(3)=xyzs(3,natsold+jk+2)
      i1=natsold+1
      ic1=ic1+1
      if(imiss(i).eq.1)then
      xtet(1,ic1)=xyzs(1,natsold+jk+2)
      xtet(2,ic1)=xyzs(2,natsold+jk+2)
      xtet(3,ic1)=xyzs(3,natsold+jk+2)
      else
      xotta(1,ic1)=xyzs(1,natsold+jk+2)
      xotta(2,ic1)=xyzs(2,natsold+jk+2)
      xotta(3,ic1)=xyzs(3,natsold+jk+2)
      endif
      ic1sav=ic1
      if(imiss(i).eq.1.and.ic1.lt.4)then
      call checkequivtt2(xo,i,i1,ic1,ic1sav,xtet)
      xyzs(1,natsold+jk+2)=xtet(1,ic1sav)
      xyzs(2,natsold+jk+2)=xtet(2,ic1sav)
      xyzs(3,natsold+jk+2)=xtet(3,ic1sav)
      if(ic1.gt.ic1sav.and.ic1.le.4)then
      iok=0
      do 862 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0)=xtet(1,ic1sav+iik0)
      xyzs(2,natsold+jk+2+iik0)=xtet(2,ic1sav+iik0)
      xyzs(3,natsold+jk+2+iik0)=xtet(3,ic1sav+iik0)
      ik0=ik0+1
 862  continue
      endif
      elseif(imiss(i).eq.2.and.ic1.lt.6)then
      call checkequivoo2(xo,i,i1,ic1,ic1sav,xotta)
      xyzs(1,natsold+jk+2)=xotta(1,ic1sav)
      xyzs(2,natsold+jk+2)=xotta(2,ic1sav)
      xyzs(3,natsold+jk+2)=xotta(3,ic1sav)
      if(ic1.gt.ic1sav.and.ic1.le.6)then
      iok=0
      do 863 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0)=xotta(1,ic1sav+iik0)
      xyzs(2,natsold+jk+2+iik0)=xotta(2,ic1sav+iik0)
      xyzs(3,natsold+jk+2+iik0)=xotta(3,ic1sav+iik0)
      ik0=ik0+1
 863  continue
      endif
      endif
 861  continue
      dsog=0.6
CCCC  dsog=1.2
  910 continue
      nats=natsold+natsadd
      nzmax=-9999999
      do 5100 jk=1,nats
      if(nz(jk).eq.0) go to 5100
      nzz=iabs(nz(jk)/100)
      if(nzz.gt.nzmax)nzmax=nzz
 5100 continue
      do 8910 ijk=natsold+1,natsold+natsadd                 
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
      do 8920 ijk0=1,natsold                
      x1(1)=xyzs(1,ijk0)
      x1(2)=xyzs(2,ijk0)
      x1(3)=xyzs(3,ijk0)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
      nats=natsold
      go to 6000
      endif
 8920 continue
 8910 continue
      iloccat2=1
      nzmax=-999999
      do 120 ii=1,nats
      if (nz(ii).ne.0) then
      nzz=iabs(nz(ii))/100
      if (nzz.gt.nzmax)nzmax=nzz
      endif
  120 continue
      do 121 il=1,nats
      if (nz(il).eq.0) go to 121
      nzz=iabs(nz(il))/100
      if (nzz.lt.nzmax)then
      zrap=float(nzmax)/float(nzz)
      zrap=zrap**2
      bfac(il)=zrap*biso
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      else
      bfac(il)=0.9*biso
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      endif
 121  continue
      iprier=0
      call calcolaerre(chi2,iprier)
      if(chi2.lt.chimin)then
c     kdirect=1
c     interp=0
c     iniat = 1
CANG  call MakeLab(iniat,nats)
c     call to_coord(1)
CANG  call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
CANG  if(chi2.lt.chimin)then
      natsaddsav=natsadd
      natssav=natsold+natsadd
      kaddsav=kadd
      do 5001 jk=1,kadd
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
 5001 continue
      do 5200 jk=natsold+1,natsold+natsadd
      xsavx(1,jk)=xyzs(1,jk)
      xsavx(2,jk)=xyzs(2,jk)
      xsavx(3,jk)=xyzs(3,jk)
 5200 continue
      nzmsav=nzm
      do 5201 jk=1,nzmsav
      ilocsav(jk)=iloc(jk)
      xlocsav(1,jk)=xloc(1,jk)
      xlocsav(2,jk)=xloc(2,jk)
      xlocsav(3,jk)=xloc(3,jk)
      nlocsav(1,jk)=nloc(1,jk)
      nlocsav(2,jk)=nloc(2,jk)
      nlocsav(3,jk)=nloc(3,jk)
 5201 continue
      ntrialsav=ntrial
      chimin=chi2
      endif
 6000 continue
 5000 continue
 4000 continue
 8000 continue
 3000 continue
 2000 continue
 1000 continue
 7000 continue
 5002 continue
      if(iloccat2.eq.0)ier=-1
      if(ier.lt.0) return
      do 5300 k=natsold+1,natssav                
      xyzs(1,k)=xsavx(1,k)
      xyzs(2,k)=xsavx(2,k)
      xyzs(3,k)=xsavx(3,k)
 5300 continue
      call intcoordd(ier)
      if(ier.lt.0)return
      if(istampa.gt.0)then
      write(lo,'(/,a,i6,a)')' ***** Selected Z-matrix description *****'
      write(lo,'(a)')'                                                 '
      write(lo,'(a,a)')' atom nr.  type  nr.       dist          ang',
     *'          tors '
      do 800 ii=1,nzm
      if(nlocsav(1,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4)')
     *ilocsav(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),
     *ii,nlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.1.and.nlocsav(2,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4,f10.3)')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.2.and.nlocsav(3,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,2(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii)
      else
      write(lo,'(i4,8x,a2,i4,3(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii),
     *nlocsav(3,ii),xlocsav(3,ii)
      endif
 800  continue
      write(lo,'(a)')'                                                 '
      write(lo,'(a,/)')'  *********************************************'
      kt=nfound1(i)
      write(lo,'(a,3f10.3)')' input cation #1',(xyzs(kp,kt),kp=1,3)
      kt=nfound2(i)
      write(lo,'(a,3f10.3)')' input cation #2',(xyzs(kp,kt),kp=1,3)
      write(lo,'(a,3f10.3)')' located cation',
     *(xyzs(kp,natsold+1),kp=1,3)
      do 5022 jk=natsold+2,natsold+natsaddsav
      write(lo,'(a,3f10.3)')' located anion',(xyzs(kp,jk),kp=1,3)
 5022 continue
      write(lo,'(/,a,f10.3,a,i7)')' Minimum fom:',chimin,
     *' trial #',ntrial
      endif
      nats=natsold+natsaddsav
      kdirect=1
      interp=0
      iniat = 1
      call MakeLab(iniat,nats)
      call to_coord(1)
      call frm15e(nats,interp)
      rfac=chimin
      jpol=0
      kdirectsav=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      nats=natsold
      nats=natssav               
      do 550 k=natsold+1,natssav             
      xo(1)=xyzs(1,k)
      xo(2)=xyzs(2,k)
      xo(3)=xyzs(3,k)
      call checkequiv(xo)
      xyzs(1,k)=xo(1)
      xyzs(2,k)=xo(2)
      xyzs(3,k)=xo(3)
 550  continue
      j1=nfound1(i)
      it(j1)=it(j1)+1
      xt(1,j1,it(j1))=xyzs(1,natsold+2)
      xt(2,j1,it(j1))=xyzs(2,natsold+2)
      xt(3,j1,it(j1))=xyzs(3,natsold+2)
      ntt(j1,it(j1))=natsold+2
      j2=nfound2(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xyzs(1,natsold+3)
      xt(2,j2,it(j2))=xyzs(2,natsold+3)
      xt(3,j2,it(j2))=xyzs(3,natsold+3)
      ntt(j2,it(j2))=natsold+3
      j3=natsold+1
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+2)
      xt(2,j3,it(j3))=xyzs(2,natsold+2)
      xt(3,j3,it(j3))=xyzs(3,natsold+2)
      ntt(j3,it(j3))=natsold+2
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+3)
      xt(2,j3,it(j3))=xyzs(2,natsold+3)
      xt(3,j3,it(j3))=xyzs(3,natsold+3)
      ntt(j3,it(j3))=natsold+3
      kadd=kaddsav
      ndif=nats-natsold-3
c     do 811 il=1,ndif
c     it(j3)=it(j3)+1
c     xt(1,j3,it(j3))=xyzs(1,natsold+3+il)
c     xt(2,j3,it(j3))=xyzs(2,natsold+3+il)
c     xt(3,j3,it(j3))=xyzs(3,natsold+3+il)
c     ntt(j3,it(j3))=natsold+3+il
c811  continue
      if(imiss(i).eq.1)then
      itet=1
      ntetra=ntetra+1
      ntetr(ntetra)=natsold+1
      dtetra(ntetra)=dmiss(i)
      dtolt(ntetra)=dtolm(i)
      atolt(ntetra)=atolm(i)
      ktetra(ntetra)=kmiss(i)
      elseif(imiss(i).eq.2)then
      iott=1
      nott=nott+1
      notta(nott)=natsold+1
      dotta1(nott)=dmiss(i)
      dtolo(nott)=dtolm(i)
      atolo(nott)=atolm(i)
      kotta(nott)=kmiss(i)
      endif
      natsold=nats
      do 9100 k1=1,nats
      do 945 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 9100
 945  continue
      do 946 k2=1,nott
      if(k1.eq.notta(k2))go to 9100
 946  continue
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      if(ntetra.gt.0)call checkequivtcat2(xo)
      if(nott.gt.0)call checkequivocat2(xo)
 9100 continue
      return
      end
c----------------------------------------------------------------
      subroutine dainttocricat2(icat,n2,j2cod,ier)
      USE Atomi
      USE General
*     include 'atoms.fi'
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/Gmatrix/ggMat(3,3)
      common/stampa/istampa
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/superandom/iix,iiy,ntrial,irandom,sograndom
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common /matr/rmz(3,3),rmiz(3,3)
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/ annealcat/ ncate,nzcat(500),iloccat(500,500),
     *xloccat(500,3,500),nloccat(500,3,500)
      common /fastcal/ hkle(3000,4,24),fsca(9,3000)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
****  common /atoms/ x(5,500),nz(500),idumx(21)
c     common /atoms/ x(5,500),nz(500),bfac(500),idumx(4001)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      dimension x11(3),x1(3),x2(3),xcri(3,500),
     *xortol(3,500),x12(4)
      dimension amat(9,9),dmat(9),INDX(9),v(3,3)
      dimension wr(4,4),xortet(4,6),ggstar(3,3)
      dimension aa(3,3),w(3),bb(3,3),ww(3,3),www(3),rr(3,3)
      dimension ilocr(4),xcr(3,4)
      dimension xz(3,3),x3(3),x4(3)
      dimension  xtet(3,4)
      dimension x1t(4),xa(3)
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
c
      nruota=40
      idist1=0
      idist2=0
      iang=0
      ier=0
      nch=1
      do 200 i=1,9
      dmat(i)=0.0
      do 300 j=1,9
      amat(i,j)=0.0
 300  continue
 200  continue
c     a=cell(1)
c     b=cell(2)
c     c=cell(3)
c     alfa=cell(4)
c     beta=cell(5)
c     gamma=cell(6)
c     inv=0
c     call Orto_new(a, b, c, alfa, beta, gamma,inv)
c     inv=1
c     call Orto_new(a, b, c, alfa, beta, gamma,inv)
      xor(1,nch)=xyzs(1,iloc(nzm-1))
      xor(2,nch)=xyzs(2,iloc(nzm-1))
      xor(3,nch)=xyzs(3,iloc(nzm-1))
      do 100 i=1,nzm
      j=iloc(i)
      if(j.le.nats)then
      x11(1)=xyzs(1,j)-xor(1,nch)
      x11(2)=xyzs(2,j)-xor(2,nch)
      x11(3)=xyzs(3,j)-xor(3,nch)
      call molt1_rot(rmz, x11, x1)
      if(abs(x1(1)).lt.0.0001)x1(1)=0.0
      if(abs(x1(2)).lt.0.0001)x1(2)=0.0
      if(abs(x1(3)).lt.0.0001)x1(3)=0.0
      xorto(1,i)=x1(1)
      xorto(2,i)=x1(2)
      xorto(3,i)=x1(3)
      else
      xorto(1,i)=0.0       
      xorto(2,i)=0.0       
      xorto(3,i)=0.0       
      endif
 100  continue
      xortol(1,nzm-1)=0.0
      xortol(2,nzm-1)=0.0
      xortol(3,nzm-1)=0.0
      k=nzm-1
      xortolocal(1,iloc(k))=xortol(1,k)
      xortolocal(2,iloc(k))=xortol(2,k)
      xortolocal(3,iloc(k))=xortol(3,k)
      dn=xloc(1,nzm)
      fn=(xloc(2,nzm)*dtor)-(pi/2.0)
      xortol(1,nzm)=-dn*sin(fn)      
      xortol(2,nzm)=dn*cos(fn)
      xortol(3,nzm)=0.0
      k=nzm
      xortolocal(1,iloc(k))=xortol(1,k)
      xortolocal(2,iloc(k))=xortol(2,k)
      xortolocal(3,iloc(k))=xortol(3,k)
      xortol(1,nzm-2)=xloc(1,nzm-1)
      xortol(2,nzm-2)=0.0
      xortol(3,nzm-2)=0.0
      k=nzm-2
      xortolocal(1,iloc(k))=xortol(1,k)
      xortolocal(2,iloc(k))=xortol(2,k)
      xortolocal(3,iloc(k))=xortol(3,k)
      do 1000 k=1,nzm-3
      mmax=nzm-3
      xortol(1,k)=0.0
      xortol(2,k)=0.0
      xortol(3,k)=0.0
      do 1100 i=k,mmax
      w(1)=0.0
      w(2)=0.0
      w(3)=0.0
      j=nzm-3
      jrif=j
      fij=xloc(2,j+2)*dtor
      ppp=-1.0
      tij=ppp*(xloc(3,j+3))*dtor
      dij=xloc(1,i+1)
      aa(1,1)=-cos(fij)
      aa(1,2)=-sin(fij)
      aa(1,3)=0.0             
      aa(2,1)=sin(fij)*cos(tij)
      aa(2,2)=-cos(fij)*cos(tij)
      aa(2,3)=sin(tij)
      aa(3,1)=-sin(fij)*sin(tij)
      aa(3,2)=cos(fij)*sin(tij)
      aa(3,3)=cos(tij)
      do 1200 j=nzm-4,i,-1
      fij=xloc(2,j+2)*dtor
      ppp=-1.0
      tij=ppp*(xloc(3,j+3))*dtor
      bb(1,1)=-cos(fij)
      bb(1,2)=-sin(fij)
      bb(1,3)=0.0             
      bb(2,1)=sin(fij)*cos(tij)
      bb(2,2)=-cos(fij)*cos(tij)
      bb(2,3)=sin(tij)
      bb(3,1)=-sin(fij)*sin(tij)
      bb(3,2)=cos(fij)*sin(tij)
      bb(3,3)=cos(tij)
      call moltm(aa,bb,ww)
      do 1250 ik=1,3
      do 1260 jk=1,3
      aa(ik,jk)=ww(ik,jk)
 1260 continue
 1250 continue
 1200 continue
      www(1)=dij
      www(2)=0.0
      www(3)=0.0
      call moltv(aa,www,w)
      xortol(1,k)=xortol(1,k)+w(1)
      xortol(2,k)=xortol(2,k)+w(2)
      xortol(3,k)=xortol(3,k)+w(3)
 1100 continue
      xortol(1,k)=xortol(1,k)+xloc(1,nzm-1)
      xortolocal(1,iloc(k))=xortol(1,k)
      xortolocal(2,iloc(k))=xortol(2,k)
      xortolocal(3,iloc(k))=xortol(3,k)
 1000 continue
 2500 continue
      if(abs(xortol(3,nzm-3)).lt.0.0000001)then
      ier=-1
      return
      endif
      amat(1,1)=xortol(1,nzm)
      amat(1,2)=xortol(2,nzm)
      amat(2,3)=xortol(1,nzm)
      amat(2,4)=xortol(2,nzm)
      amat(3,5)=xortol(1,nzm)
      amat(3,6)=xortol(2,nzm)
      amat(4,1)=xortol(1,nzm-4)-
     *xortol(3,nzm-4)*xortol(1,nzm-3)/xortol(3,nzm-3)
      amat(4,2)=xortol(2,nzm-4)-
     *xortol(3,nzm-4)*xortol(2,nzm-3)/xortol(3,nzm-3)
      amat(5,3)=xortol(1,nzm-4)-
     *xortol(3,nzm-4)*xortol(1,nzm-3)/xortol(3,nzm-3)
      amat(5,4)=xortol(2,nzm-4)-
     *xortol(3,nzm-4)*xortol(2,nzm-3)/xortol(3,nzm-3)
      amat(6,5)=xortol(1,nzm-4)-
     *xortol(3,nzm-4)*xortol(1,nzm-3)/xortol(3,nzm-3)
      amat(6,6)=xortol(2,nzm-4)-
     *xortol(3,nzm-4)*xortol(2,nzm-3)/xortol(3,nzm-3)
      dmat(1)=xorto(1,nzm)
      dmat(2)=xorto(2,nzm)
      dmat(3)=xorto(3,nzm)
      dmat(4)=xorto(1,nzm-4)-
     *xortol(3,nzm-4)*xorto(1,nzm-3)/xortol(3,nzm-3)
      dmat(5)=xorto(2,nzm-4)-
     *xortol(3,nzm-4)*xorto(2,nzm-3)/xortol(3,nzm-3)
      dmat(6)=xorto(3,nzm-4)-
     *xortol(3,nzm-4)*xorto(3,nzm-3)/xortol(3,nzm-3)
      np=9
      n=6
      mp=1
      m=1
      ising=0
      call gaussj2(amat,n,np,dmat,m,mp,ising)
      if(ising.eq.-1)then
      ier=-1
      return
      endif
      rr(1,1)=dmat(1)
      rr(1,2)=dmat(2)
      rr(2,1)=dmat(3)
      rr(2,2)=dmat(4)
      rr(3,1)=dmat(5)
      rr(3,2)=dmat(6)
      rr(1,3)=(xorto(1,nzm-3)-rr(1,1)*xortol(1,nzm-3)
     *-rr(1,2)*xortol(2,nzm-3))/xortol(3,nzm-3)
      rr(2,3)=(xorto(2,nzm-3)-rr(2,1)*xortol(1,nzm-3)
     *-rr(2,2)*xortol(2,nzm-3))/xortol(3,nzm-3)
      rr(3,3)=(xorto(3,nzm-3)-rr(3,1)*xortol(1,nzm-3)
     *-rr(3,2)*xortol(2,nzm-3))/xortol(3,nzm-3)
c     theta=acos(rr(3,3))
c     costheta=rr(3,3)
c     sintheta=-sqrt(1.0-rr(3,3)**2)
c     sinphi=rr(3,1)/sintheta                    
c     sinpsi=rr(1,3)/sintheta                    
c     cosphi=-rr(3,2)/sintheta                     
c     cospsi=rr(2,3)/sintheta                           
c     theta=atan2(sintheta,costheta)
c     phi=atan2(sinphi,cosphi)
c     psi=atan2(sinpsi,cospsi)
c     thetas=theta
c     phis=phi
c     psis=psi
c     sintheta=sin(thetas)
c     costheta=cos(thetas)
c     sinphi=sin(phis)
c     cosphi=cos(phis)
c     sinpsi=sin(psis)
c     cospsi=cos(psis)
c     write(6,'(/,a,3f15.5,/)') ' ----- Eulerian angles ----- ',
c    *thetas*rtod,phis*rtod,psis*rtod
c     rr(1,1)=cospsi*cosphi-costheta*sinphi*sinpsi
c     rr(1,2)=cospsi*sinphi+costheta*cosphi*sinpsi
c     rr(1,3)=sintheta*sinpsi
c     rr(2,1)=-sinpsi*cosphi-costheta*sinphi*cospsi
c     rr(2,2)=-sinpsi*sinphi+costheta*cosphi*cospsi
c     rr(2,3)=cospsi*sintheta
c     rr(3,1)=sintheta*sinphi
c     rr(3,2)=-sintheta*cosphi
c     rr(3,3)=costheta
      do 700 j=1,nzm 
      i=iloc(j)
      x11(1)=xortol(1,j)
      x11(2)=xortol(2,j)
      x11(3)=xortol(3,j)
      call molt1_rot(rr, x11, x1)
      call molt1_rot(rmiz, x1, x2)
      x1(1)=x2(1)+xor(1,nch)
      x1(2)=x2(2)+xor(2,nch)
      x1(3)=x2(3)+xor(3,nch)
      if(j.eq.1)then
      xz(1,3)=x1(1)
      xz(2,3)=x1(2)
      xz(3,3)=x1(3)
      elseif(j.eq.2)then
      xz(1,1)=x1(1)
      xz(2,1)=x1(2)
      xz(3,1)=x1(3)
      elseif(j.eq.3)then
      xz(1,2)=x1(1)
      xz(2,2)=x1(2)
      xz(3,2)=x1(3)
      endif
 700  continue
      x1(1)=xz(1,3)
      x1(2)=xz(2,3)
      x1(3)=xz(3,3)
      x2(1)=xyzs(1,nfound2(icat))
      x2(2)=xyzs(2,nfound2(icat))
      x2(3)=xyzs(3,nfound2(icat))
      call distanza(ggMat,x1,x2,dcal)
      d1=1.4
      d2=2.0
      if(dcal.lt.d1.or.dcal.gt.d2)then
      idist1=-1
      endif
      if(j2cod.ne.0)then
      if(j2cod.eq.1)then
      do 105 j=1,ntetra
      if(nfound2(icat).eq.ntetr(j))then
      jsav=j
      go to 170
      endif
 105  continue
 170  continue
      dist1=dtetra(jsav)*(1.0-dtolt(jsav))    
      dist2=dtetra(jsav)*(1.0+dtolt(jsav))     
c     dist1=dtetra(jsav)*0.9                    
c     dist2=dtetra(jsav)*1.1                       
      x1(1)=xz(1,3)             
      x1(2)=xz(2,3)             
      x1(3)=xz(3,3)             
      x2(1)=xyzs(1,nfound2(icat))
      x2(2)=xyzs(2,nfound2(icat))
      x2(3)=xyzs(3,nfound2(icat))
      x3(1)=xyzs(1,n2)
      x3(2)=xyzs(2,n2)
      x3(3)=xyzs(3,n2)
      call angolo(ggMat,x1,x2,x3,angcal)
      angcal=angcal*rtod
      angsog=109.47    
      angsog1 = angsog*(1.0-atolt(jsav))         
      angsog2 = angsog*(1.0+atolt(jsav))    
c     angsog1 = angsog*0.9                       
c     angsog2 = angsog*1.1                    
      else
      do 106 j=1,nott
      if(nfound2(icat).eq.notta(j))then
      jsav=j
      go to 171
      endif
 106  continue
 171  continue
      dist1=dotta1(jsav)*(1.0-dtolo(jsav))      
      dist2=dotta1(jsav)*(1.0+dtolo(jsav))
c     dist1=dotta1(jsav)*0.9                    
c     dist2=dotta1(jsav)*1.1                       
      x1(1)=xz(1,3)             
      x1(2)=xz(2,3)             
      x1(3)=xz(3,3)             
      x2(1)=xyzs(1,nfound2(icat))
      x2(2)=xyzs(2,nfound2(icat))
      x2(3)=xyzs(3,nfound2(icat))
      x3(1)=xyzs(1,n2)
      x3(2)=xyzs(2,n2)
      x3(3)=xyzs(3,n2)
      call angolo(ggMat,x1,x2,x3,angcal)
      angcal=angcal*rtod
      angsog=90.0      
      angsog1 = angsog*(1.0-atolo(jsav))      
      angsog2 = angsog*(1.0+atolo(jsav))       
c     angsog1 = angsog*0.9                    
c     angsog2 = angsog*1.1                         
      endif
      if(dcal.lt.dist1.or.dcal.gt.dist2)then
      idist2=-1
      endif
      if(angcal.lt.angsog1.or.angcal.gt.angsog2)then
      iang=-1
      endif
      endif
      if(idist1.eq.-1.or.idist2.eq.-1.or.iang.eq.-1)then
      do 801 jjj=1,nruota
      kj=iloc(nzm-3)
      x1(1)=xyzs(1,kj)
      x1(2)=xyzs(2,kj)
      x1(3)=xyzs(3,kj)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      kj=nfound1(icat)
      x1(1)=xyzs(1,kj)
      x1(2)=xyzs(2,kj)
      x1(3)=xyzs(3,kj)
      call molt1_rot(rmz, x1, x2)
      xortet(1,2)=x2(1)
      xortet(2,2)=x2(2)
      xortet(3,2)=x2(3)
      kk0=2
      do 51 kl=1,3
      kk0=kk0+1
      x1(1)=xz(1,kl)
      x1(2)=xz(2,kl)
      x1(3)=xz(3,kl)
      call molt1_rot(rmz, x1, x2)
      xortet(1,kk0)=x2(1)
      xortet(2,kk0)=x2(2)
      xortet(3,kk0)=x2(3)
 51   continue
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      nmax=4
      do 10 ii=1,nmax
      do 20 j=1,nmax
      if(ii.le.4.and.j.le.4)wr(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtot(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtoti(ii,j)=0.0
 20   continue
 10   continue
      do ii=1,3
      x2(ii)=xortet(ii,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      angcal=twopi*yfl
      call MatTott(x2,adif,bdif,cdif,ddif,angcal)
      call molt2_rott(rtoti, rtot, wr)
        kk0=0
        do ii=1,5
          xortet(4,ii)=1
         do j=1,4
           x12(j)=xortet(j,ii)
         end do
          call molt1_rott(wr, x12, x1t)
          do j=1,3
             x12(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x12, x1)
          if(ii.ge.3)then
          kk0=kk0+1
          xz(1,kk0)=x1(1)
          xz(2,kk0)=x1(2)
          xz(3,kk0)=x1(3)
          endif
        end do
      x1(1)=xz(1,3)
      x1(2)=xz(2,3)
      x1(3)=xz(3,3)
      x2(1)=xyzs(1,nfound2(icat))
      x2(2)=xyzs(2,nfound2(icat))
      x2(3)=xyzs(3,nfound2(icat))
      call distanza(ggMat,x1,x2,dcal)
      x1(1)=xz(1,3)             
      x1(2)=xz(2,3)             
      x1(3)=xz(3,3)             
      x2(1)=xyzs(1,nfound2(icat))
      x2(2)=xyzs(2,nfound2(icat))
      x2(3)=xyzs(3,nfound2(icat))
      x3(1)=xyzs(1,n2)
      x3(2)=xyzs(2,n2)
      x3(3)=xyzs(3,n2)
      call angolo(ggMat,x1,x2,x3,angcal)
      angcal=angcal*rtod
      if(dcal.lt.d1.or.dcal.gt.d2)then
      ier=-1
      go to 801
      endif
      if(j2cod.ne.0)then
      if(dcal.lt.dist1.or.dcal.gt.dist2)then
      ier=-1
      go to 801
      endif
      if(angcal.lt.angsog1.or.angcal.gt.angsog2)then
      ier=-1
      go to 801
      endif
      endif
      ier=0
      go to 802
 801  continue
 802  continue
      endif
      if(ier.eq.-1)return
      xadd(1,1)=xz(1,1)
      xadd(2,1)=xz(2,1)
      xadd(3,1)=xz(3,1)
      xadd(1,2)=xz(1,2)
      xadd(2,2)=xz(2,2)
      xadd(3,2)=xz(3,2)
      xadd(1,3)=xz(1,3)
      xadd(2,3)=xz(2,3)
      xadd(3,3)=xz(3,3)
      do 3050 i=1,3
        iser=1
        iactn=1
        khead=0
        xo1(1) = xadd(1,i)
        xo1(2) = xadd(2,i)
        xo1(3) = xadd(3,i)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xadd(1,i)=xn(1)
        xadd(2,i)=xn(2)
        xadd(3,i)=xn(3)
 3050 continue
      return
      end
c -----------------------------------------------------------------
      subroutine checkequivtt2(xo,i,i1,ic1,ic1sav,xtet)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell
      common/occtetra/it(500)
      common/stampa/istampa
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/Gmatrix/ggMat(3,3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
c-    
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3),xtet(4,4),xb2(3),s(3)
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
c     write(6,*) ' INIZIO IT in checkeqvtt',(it(kk),kk=1,4)
      dimension vet(2)
      real, dimension(3,3) :: gm
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
      xtet(1,ic1)=xo(1)
      xtet(2,ic1)=xo(2)
      xtet(3,ic1)=xo(3)
c     do 10 ii=2,nsym2
c        xeq(1) = xo(1)
c        xeq(2) = xo(2)
c        xeq(3) = xo(3)
c        call equitt(xeq,ii)
c----------
c         call distanzan(ggMat,xo,xeq,dist)
      ifin=icent+1
        do 10 kt=1,spacegr%ncoper
        do 10 ifi=1,ifin
          coef=vet(ifi)
          do 10 k=1,nsym
            if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 10
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,k,coef,xeq,kt)
            !call xdist(xb2,xeq,dist,s)
            call xdisteqs(xb2,xeq,gm,dist,s)
            xeq(1)=xb2(1)+s(1)
            xeq(2)=xb2(2)+s(2)
            xeq(3)=xb2(3)+s(3)
c----------
          if (dist.gt.0.000001.and.dist.le.dmin) then
c            write(6,*)' CORDINATE X0 INIZIALI =',xo
             xo(1) = (xo(1) + xeq(1))/2.
             xo(2) = (xo(2) + xeq(2))/2.
             xo(3) = (xo(3) + xeq(3))/2.
             xtet(1,ic1)=xo(1)
             xtet(2,ic1)=xo(2)
             xtet(3,ic1)=xo(3)
             go to 11
           endif
   10    continue
   11    continue
c--
c----- check se un equivalente di xo e' legato con i cationi
c--
      angsog1 = 109.47*(1.0-atolm(i))
      angsog2 = 109.47*(1.0+atolm(i))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
c--
        dist1=dmiss(i)*(1.0-dtolm(i))
        dist2=dmiss(i)*(1.0+dtolm(i))
c-
        xcat(1) = xyzs(1,i1) 
        xcat(2) = xyzs(2,i1) 
        xcat(3) = xyzs(3,i1) 
c-
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c---
c          call equitt(xeq,ii)
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 kj=1,nsym
c           if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
c-----------------
        iser=1
        iactn=1
        khead=0
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
c         call distanzan(ggMat,xcat,xeq,dist)
            !call xdist(xcat,xeq,dist,s)
            call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if (dist.ge.dist1.and.dist.le.dist2) then
c--
c-- accetto solo atomi equiv. che formano angolo (109+/-soglia) con gli altri 
c-- dello stesso tetraedro
c--
                 iok = 1
                 do 40 k=1,ic1
                    xoo(1) = xtet(1,k)
                    xoo(2) = xtet(2,k)
                    xoo(3) = xtet(3,k)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if (ang1.lt.angsog1.or.ang1.gt.angsog2) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    ic1=ic1 + 1
                    if (ic1.le.4) then
                        xtet(1,ic1)=xeq(1)     
                        xtet(2,ic1)=xeq(2)     
                        xtet(3,ic1)=xeq(3)     
                        xtet(4,ic1)=0.0        
                    endif
                 endif
          endif
 25   continue
      return
      end 
c-----------------------------------------------------------------
      subroutine checkequivoo2(xo,i,i1,ic1,ic1sav,xotta)
      Use Polpo
      USE Atomi
      USE General
      USE Symmetry
      USE cgeom
      USE unit_cell
      common/occtetra/it(500)
      common/stampa/istampa
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *         ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/Gmatrix/ggMat(3,3)
c-    
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
c-    
c---
      dimension xo(3),xeq(3),xoo(3),xcat(3),xotta(4,6),xb2(3),s(3)
      dimension vet(2)
      real, dimension(3,3) :: gm
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
c--
c-    
c----- check se l' atomo e' troppo vicino ad un suo equivalente per simmetria
c-    
c     write(6,*) ' INIZIO IT in checkeqvoo',(it(kk),kk=1,4)
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      dmin = 0.6
      xotta(1,ic1)=xo(1)
      xotta(2,ic1)=xo(2)
      xotta(3,ic1)=xo(3)
c     do 10 ii=2,nsym2
c        xeq(1) = xo(1)
c        xeq(2) = xo(2)
c        xeq(3) = xo(3)
c        call equitt(xeq,ii)
      ifin=icent+1
        do 10 kt=1,spacegr%ncoper
        do 10 ifi=1,ifin
          coef=vet(ifi)
          do 10 k=1,nsym
            if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 10
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,k,coef,xeq,kt)
c----------
c         call distanzan(ggMat,xo,xeq,dist)
            !call xdist(xb2,xeq,dist,s)
            call xdisteqs(xb2,xeq,gm,dist,s)
            xeq(1)=xb2(1)+s(1)
            xeq(2)=xb2(2)+s(2)
            xeq(3)=xb2(3)+s(3)
c----------
          if (dist.gt.0.000001.and.dist.le.dmin) then
c            write(6,*)' CORDINATE X0 INIZIALI =',xo
             xo(1) = (xo(1) + xeq(1))/2.
             xo(2) = (xo(2) + xeq(2))/2.
             xo(3) = (xo(3) + xeq(3))/2.
             xotta(1,ic1)=xo(1)
             xotta(2,ic1)=xo(2)
             xotta(3,ic1)=xo(3)
             go to 11
           endif
   10    continue
   11    continue
c--
c----- check se un equivalente di xo e' legato con i cationi
c--
      angsog1 = 90.0*(1.0-atolm(i))
      angsog2 = 90.0*(1.0+atolm(i))
      angsog11 = 180.0*(1.0-atolm(i))
      angsog22 = 180.0*(1.0+atolm(i))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
c--
        dist1=dmiss(i)*(1.0-dtolm(i))
        dist2=dmiss(i)*(1.0+dtolm(i))
        dist3=dmiss(i)*(1.0-dtolm(i))
        dist4=dmiss(i)*(1.0+dtolm(i))
c-
        xcat(1) = xyzs(1,i1) 
        xcat(2) = xyzs(2,i1) 
        xcat(3) = xyzs(3,i1) 
c-
c       do 25 ii=1,nsym2
c          xeq(1) = xo(1)
c          xeq(2) = xo(2)
c          xeq(3) = xo(3)
c---
c          call equitt(xeq,ii)
      ifin=icent+1
        do 25 kt=1,spacegr%ncoper
        do 25 ifi=1,ifin
          coef=vet(ifi)
          do 25 kj=1,nsym
c           if (kj.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 25
            xb2(1) = xo(1)
            xb2(2) = xo(2)
            xb2(3) = xo(3)
            call xequi(xb2,kj,coef,xeq,kt)
c-----------------
        iser=1
        iactn=1
        khead=0
        xo1(1) = xeq(1)
        xo1(2) = xeq(2)
        xo1(3) = xeq(3)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xm(1)=xn(1)
        xm(2)=xn(2)
        xm(3)=xn(3)
        xeq(1)=xm(1)
        xeq(2)=xm(2)
        xeq(3)=xm(3)
c---
c         call distanzan(ggMat,xcat,xeq,dist)
            !call xdist(xcat,xeq,dist,s)
            call xdisteqs(xcat,xeq,gm,dist,s)
          xeq(1)=xcat(1)+s(1)
          xeq(2)=xcat(2)+s(2)
          xeq(3)=xcat(3)+s(3)
          if ((dist.ge.dist1.and.dist.le.dist2)
     *    .or.(dist.ge.dist3.and.dist.le.dist4)) then
c--
c-- accetto solo atomi equiv. che formano angolo (90+/-soglia) con gli altri 
c-- dello stesso ottaedro
c--
                 iok = 1
                 do 40 k=1,ic1
                    xoo(1) = xotta(1,k)
                    xoo(2) = xotta(2,k)
                    xoo(3) = xotta(3,k)
                    call angolon2(ggMat,xoo,xcat,xeq,ang1)
                    if ((ang1.lt.angsog1).or.(ang1.gt.angsog2.and. 
     *              ang1.lt.angsog11).or.(ang1.gt.angsog22)) then
                       iok = 0
                       go to 31
                    endif
 40              continue
 31              continue
                 if (iok.eq.1) then
                    ic1=ic1 + 1
                    if (ic1.le.6) then
                        xotta(1,ic1)=xeq(1)     
                        xotta(2,ic1)=xeq(2)     
                        xotta(3,ic1)=xeq(3)     
                        xotta(4,ic1)=0.0        
                    endif
                 endif
          endif
 25   continue
      return
      end 
c-----------------------------------------------------------------
      subroutine loccat3(i,natsold,
     *j1cod,j2cod,kcat1,kcat2,ico1,ico2,ier)             
      Use Polpo
      USE Atomi
      USE General
      USE drawatoms
      USE elements, only: pxen_from_specie,numelem
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common/savx/xsavx(3,500)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/occtetra/it(500)
      dimension ang(3),x1(3),x2(3),x3(3)
      dimension wr(4,4),xortet(4,6)
      dimension x11(4),x1t(3),xo(3),xad(3,10),xadsav(3,10)
      dimension xtet(4,4),xotta(4,6),xanio(3,2),xaniosav(3,2)
      character oo*2                             
      character Buffer*80
c
      ico1sav=ico1
      ico2sav=ico2
      dsogok=0.8
      psis=0.0
      phis=0.0
      thetas=0.0
      chimin=1.0E+10
      iloccat1=0
      ntrialcat = 0
      ier=-1
      ierr=0
      oo(1:2)='o '
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      nkel = numelem(celem)
      do 150 j=1,nkel
!corr      if (kmiss(i).eq.nalf(j)) then
      if (kmiss(i) == celem(j)%ptab) then
          nzc=j
          nzSavc = j*100+1
          vetintsavc = nzSavc+j
          go to 160
      endif
  150 continue
  160 continue
      do 200 j=1,nkel
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nza=j
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          go to 203
      endif
  200 continue
  203 continue
      j=nfound1(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      j=nfound2(i)
      x2(1)=xyzs(1,j)
      x2(2)=xyzs(2,j)
      x2(3)=xyzs(3,j)                           
      call distanza(ggMat,x1,x2,dcal)
      d=dcal
      nats=natsold
      if(imiss(i).eq.1)then
      iadd=5                 
      if(ico1.eq.1.and.ico2.eq.1)iadd=6         
      else
      iadd=7               
      if(ico1.eq.1.and.ico2.eq.1)iadd=8             
      endif
      xyzs(1,nats+1)=0.0
      xyzs(2,nats+1)=0.0
      xyzs(3,nats+1)=0.0
      xyzs(4,nats+1)=vetintsavc
      nz(nats+1)=nzSavc
      do 61 kkk=2,iadd
      xyzs(1,nats+kkk)=0.0
      xyzs(2,nats+kkk)=0.0
      xyzs(3,nats+kkk)=0.0
      xyzs(4,nats+kkk)=vetintsav
      nz(nats+kkk)=nzSavv
  61  continue
      xyzs(1,nats+iadd+1)=0.0
      xyzs(2,nats+iadd+1)=0.0
      xyzs(3,nats+iadd+1)=0.0
      xyzs(4,nats+iadd+1)=vetintsav
      nz(nats+iadd+1)=nzSavv
      nzm=1
      iloc(nzm)=nats+2         
      xloc(1,nzm)=0.0
      xloc(2,nzm)=0.0
      xloc(3,nzm)=0.0
      nloc(1,nzm)=0
      nloc(2,nzm)=0
      nloc(3,nzm)=0
      nzm=2
      iloc(nzm)=nats+1
      nloc(1,nzm)=nats+2         
      xloc(1,nzm)=dmiss(i)      
      nloc(2,nzm)=0             
      xloc(2,nzm)=0.0
      nloc(3,nzm)=0      
      xloc(3,nzm)=0.0
      nzm=3
      iloc(nzm)=nats+3
      nloc(1,nzm)=nats+1     
      nloc(2,nzm)=nats+2     
      nloc(3,nzm)=0           
      xloc(1,nzm)=dmiss(i)
      if(imiss(i).eq.1)then
      n6=1
      else
      n6=2
      endif
      do 6000 k6=1,n6
      nzm=3
      if(imiss(i).eq.1)then
      xloc(2,nzm)=109.47
      else
      if(k6.eq.1)then
      xloc(2,nzm)=90.0   
      else
      xloc(2,nzm)=180.0   
      endif
      endif
      xloc(3,nzm)=0.0
      nzm=4
      iloc(nzm)=nfound2(i)
      nloc(1,nzm)=nats+3   
      nloc(2,nzm)=nats+1     
      nloc(3,nzm)=nats+2         
      if(itimem.eq.0)then
      ntrial0=5
      ntrial1=5
      ntrial2=8
      ntrial3=1
      ntrial4=8
      ntrialr=1 
      elseif(itimem.eq.1)then
      ntrial0=3
      ntrial1=3
      ntrial2=5
      ntrial3=1
      ntrial4=5
      ntrialr=1 
      elseif(itimem.eq.2)then
      ntrial0=5
      ntrial1=5
      ntrial2=8
      ntrial3=1
      ntrial4=8
      ntrialr=1 
      endif
      iest=0
      do 100 j=1,ntetra
      if(nfound2(i).eq.ntetr(j))then
      jsav=j
      ntrial0=1
      iest=1
      go to 170
      endif
 100  continue
      iest=0
      do 101 j=1,nott   
      if(nfound2(i).eq.notta(j))then
      jsav=j
      ntrial0=1
      iest=2
      go to 170
      endif
 101  continue
 170  continue
      ntrial_totali=ntrial0*ntrial1*ntrial2*ntrial3*ntrial4*ntrialr*n6
      do 900 k0=1,ntrial0
      nzm=4
      if(iest.eq.1)then
      xloc(1,nzm)=dtetra(jsav)
      elseif(iest.eq.2)then
      xloc(1,nzm)=dotta1(jsav)
      else
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      dlim1=1.4                   
      dlim2=2.0                    
      dlim=yfl*(dlim2-dlim1)+dlim1
      xloc(1,nzm)=dlim               
      endif
      do 1000 k=1,ntrial1
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      ango=twopi
      anglim1=2.0*asin(1.00/dmiss(i))
      anglim2=pi                     
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
      do 2000 kk=1,ntrial2
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=5
      iloc(nzm)=nfound1(i)
      nloc(1,nzm)=nfound2(i)
      nloc(2,nzm)=nats+3     
      nloc(3,nzm)=nats+1         
      xloc(1,nzm)=d                    
      do 3000 kkk=1,ntrial3
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=5
      anglim1=2.0*asin(1.00/dmiss(i))
      anglim2=pi
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
 3001 continue
      do 4000 kkkk=1,ntrial4
      ico1=ico1sav
      ico2=ico2sav
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=5
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      ango=twopi
      phis=ango*yfl*rtod          
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      thetas=ango*yfl*rtod          
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      psis=ango*yfl*rtod          
c     ntrial=ntrial+1
!
!     Manage progress-bar
!
      ntrialcat = ntrialcat + 1
      write(Buffer,102) ntrialcat,ntrial_totali
  102 format(' Adding the missing atoms. Trial ',i5,' / ',i5)
      call scrper(Buffer,ntrialcat,ntrial_totali)
!
      call dainttocricat1(i,ierr)
      if(ierr.lt.0)then
      go to 4000
      endif
      ier=0
      dsogc=2.0
      x1(1)=xyzs(1,nfound1(i))         
      x1(2)=xyzs(2,nfound1(i))         
      x1(3)=xyzs(3,nfound1(i))         
      x2(1)=xadd(1,1)        
      x2(2)=xadd(2,1)        
      x2(3)=xadd(3,1)        
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)go to 4000
      x1(1)=xyzs(1,nfound2(i))         
      x1(2)=xyzs(2,nfound2(i))         
      x1(3)=xyzs(3,nfound2(i))         
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)go to 4000
      xyzs(1,natsold+1)=xadd(1,1)
      xyzs(2,natsold+1)=xadd(2,1)
      xyzs(3,natsold+1)=xadd(3,1)
      xyzs(1,natsold+2)=xadd(1,2)
      xyzs(2,natsold+2)=xadd(2,2)
      xyzs(3,natsold+2)=xadd(3,2)
      xyzs(1,natsold+3)=xadd(1,3)
      xyzs(2,natsold+3)=xadd(2,3)
      xyzs(3,natsold+3)=xadd(3,3)
      nats=natsold
      ntrialr=15
      do 9000 jt=1,ntrialr
      ico1=ico1sav
      ico2=ico2sav
      if(jt.eq.1)go to 8900
      kj=nfound1(i)
      x1(1)=xyzs(1,kj)
      x1(2)=xyzs(2,kj)
      x1(3)=xyzs(3,kj)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      kj=nfound2(i)
      x1(1)=xyzs(1,kj)
      x1(2)=xyzs(2,kj)
      x1(3)=xyzs(3,kj)
      call molt1_rot(rmz, x1, x2)
      xortet(1,2)=x2(1)
      xortet(2,2)=x2(2)
      xortet(3,2)=x2(3)
      kk0=2
      do 51 kl=1,3
      kk0=kk0+1
      x1(1)=xyzs(1,kl+natsold)
      x1(2)=xyzs(2,kl+natsold)
      x1(3)=xyzs(3,kl+natsold)
      call molt1_rot(rmz, x1, x2)
      xortet(1,kk0)=x2(1)
      xortet(2,kk0)=x2(2)
      xortet(3,kk0)=x2(3)
 51   continue
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      nmax=4
      do 10 ii=1,nmax
      do 20 j=1,nmax
      if(ii.le.4.and.j.le.4)wr(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtot(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtoti(ii,j)=0.0
 20   continue
 10   continue
      do ii=1,3
      x2(ii)=xortet(ii,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      angcal=twopi*yfl          
c     angcal=angstep*float(jt-1)
      call MatTott(x2,adif,bdif,cdif,ddif,angcal)
      call molt2_rott(rtoti, rtot, wr)
        kk0=0
        do ii=1,5
          xortet(4,ii)=1
         do j=1,4
           x11(j)=xortet(j,ii)
         end do
          call molt1_rott(wr, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
          if(ii.ge.3)then
          kk0=kk0+1
          xyzs(1,natsold+kk0)=x1(1)
          xyzs(2,natsold+kk0)=x1(2)
          xyzs(3,natsold+kk0)=x1(3)
          endif
        end do
c     ntrial=ntrial+1
 8900 continue
      iang=0
      if(ico1.eq.1.and.ico2.eq.1)then
      icoo=2
      else
      icoo=1
      endif
      ico1=ico1sav
      ico2=ico2sav
      do 8905 ico=1,icoo
      if(ico1.eq.1)then
      icon1=nfound2(i)
      icon2=natsold+3     
      kcat=kcat1
      if(j2cod.eq.1)then
      do 171 j=1,ntetra
      if(nfound2(i).eq.ntetr(j))then
      d1=dtetra(j)
      go to 155
      endif
 171  continue
 155  continue
      iang=1
      alfa =109.47*dtor
      elseif(j2cod.eq.2)then
      do 151 j=1,nott   
      if(nfound2(i).eq.notta(j))then
      d1=dotta1(j)
      go to 152
      endif
 152  continue
 151  continue
      iang=2
      alfa=90.0*dtor
      endif
      ico1=0
      go to 252
      endif
      if(ico2.eq.1)then
      icon1=nfound1(i)
      icon2=natsold+2     
      kcat=kcat2
      if(j1cod.eq.1)then
      do 161 j=1,ntetra
      if(nfound1(i).eq.ntetr(j))then
      d1=dtetra(j)
      go to 165
      endif
 161  continue
 165  continue
      alfa =109.47*dtor
      iang=1
      elseif(j1cod.eq.2)then
      do 162 j=1,nott   
      if(nfound1(i).eq.notta(j))then
      d1=dotta1(j)
      go to 163
      endif
 162  continue
 163  continue
      alfa=90.0*dtor
      iang=2
      ico2=0
      endif
      endif
 252  continue
      if(iang.eq.1)then
      nruo=4
      angstep2=twopi/3.0
      elseif(iang.eq.2)then
      nruo=5
      angstep2=twopi/4.0
      endif
      x1(1)=xyzs(1,icon2)-xyzs(1,icon1)
      x1(2)=xyzs(2,icon2)-xyzs(2,icon1)
      x1(3)=xyzs(3,icon2)-xyzs(3,icon1)
      i253=0
 253  continue
      call molt1_rot(rmz, x1, x2)
      iarret=0
      ioko=0
      call generat1(x2,d1,alfa,x3,ioko,iarret)
      if(iarret.lt.0)go to 9000
      call molt1_rot(rmiz, x3, xo)
      x2(1)=xo(1)+xyzs(1,icon1)
      x2(2)=xo(2)+xyzs(2,icon1)
      x2(3)=xo(3)+xyzs(3,icon1)
      xo(1)=x2(1)
      xo(2)=x2(2)
      xo(3)=x2(3)
      x1(1)=xyzs(1,icon2) 
      x1(2)=xyzs(2,icon2) 
      x1(3)=xyzs(3,icon2) 
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      x1(1)=xyzs(1,icon1) 
      x1(2)=xyzs(2,icon1) 
      x1(3)=xyzs(3,icon1) 
      call molt1_rot(rmz, x1, x2)
      xortet(1,2)=x2(1)
      xortet(2,2)=x2(2)
      xortet(3,2)=x2(3)
      x1(1)=xo(1) 
      x1(2)=xo(2) 
      x1(3)=xo(3) 
      call molt1_rot(rmz, x1, x2)
      xortet(1,3)=x2(1)
      xortet(2,3)=x2(2)
      xortet(3,3)=x2(3)
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      do 1110 ia=1,nruo
      nmax=4
      do 80 ii=1,nmax
      do 90 j=1,nmax
      if(ii.le.4.and.j.le.4)wr(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtot(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtoti(ii,j)=0.0
 90   continue
 80   continue
      do ii=1,3
      x2(ii)=xortet(ii,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      angcal2=float(ia-1)*angstep2
      call MatTott(x2,adif,bdif,cdif,ddif,angcal2)
      call molt2_rott(rtoti, rtot, wr)
        kk0=0
          xortet(4,3)=1
         do j=1,4
           x11(j)=xortet(j,3)
         end do
          call molt1_rott(wr, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
      x2(1)=xyzs(1,kcat)
      x2(2)=xyzs(2,kcat)
      x2(3)=xyzs(3,kcat)
      dd1=1.4
      dd2=1.9
      do 600 j=1,ntetra
      if(kcat.eq.ntetr(j))then
      dd1=dtetra(j)*(1.0-dtolt(j))
      dd2=dtetra(j)*(1.0+dtolt(j))
      go to 670
      endif
 600  continue
      do 601 j=1,nott   
      if(kcat.eq.notta(j))then
      dd1=dotta1(j)*(1.0-dtolo(j))
      dd2=dotta1(j)*(1.0+dtolo(j))
      go to 670
      endif
 601  continue
 670  continue
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.ge.dd1.and.dcal.le.dd2)then
      xanio(1,ico)=x1(1)
      xanio(2,ico)=x1(2)
      xanio(3,ico)=x1(3)
      go to 1201
      endif
 1110 continue
      if(iang.eq.2)then
      nruo=1
      angstep2=0.0       
      x1(1)=xo(1)-xyzs(1,icon1)
      x1(2)=xo(2)-xyzs(2,icon1)
      x1(3)=xo(3)-xyzs(3,icon1)
      if(i253.eq.0)then
      i253=1
      go to 253
      endif
      endif
      go to 9000
c
 1201 continue
 8905 continue
      d1=dmiss(i)
      iok=0
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      else
      alfa=90.0*dtor
      endif
      kadd=0
CANGE if(i.gt.1)then
      do 841 k1=1,natsold+3
      do 845 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 841
 845  continue
      do 846 k2=1,nott
      if(k1.eq.notta(k2))go to 841
 846  continue
      if(imiss(i).eq.1)then
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivtcat(xo,i,natsold,kadd,xad,k1)
      else
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivocat(xo,i,natsold,kadd,xad,k1)
      endif
 841  continue
CANGE endif
      d1=dmiss(i)
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      kadd=min0(2,kadd)
      natsadd=5-kadd
      else
      alfa=90.0*dtor
      kadd=min0(4,kadd)
      natsadd=7-kadd
      endif
      ndiff=natsadd-3
      ik0=0
      ic1=2+kadd
      if(imiss(i).eq.1)then
      xtet(1,1)=xyzs(1,natsold+2)
      xtet(2,1)=xyzs(2,natsold+2)
      xtet(3,1)=xyzs(3,natsold+2)
      xtet(1,2)=xyzs(1,natsold+3)
      xtet(2,2)=xyzs(2,natsold+3)
      xtet(3,2)=xyzs(3,natsold+3)
      if(kadd.gt.0)then
      do 2222 il=1,kadd
      xtet(1,2+il)=xad(1,il)
      xtet(2,2+il)=xad(2,il)
      xtet(3,2+il)=xad(3,il)
 2222 continue
      endif
      else
      xotta(1,1)=xyzs(1,natsold+2)
      xotta(2,1)=xyzs(2,natsold+2)
      xotta(3,1)=xyzs(3,natsold+2)
      xotta(1,2)=xyzs(1,natsold+3)
      xotta(2,2)=xyzs(2,natsold+3)
      xotta(3,2)=xyzs(3,natsold+3)
      if(kadd.gt.0)then
      do 2223 il=1,kadd
      xotta(1,2+il)=xad(1,il)
      xotta(2,2+il)=xad(2,il)
      xotta(3,2+il)=xad(3,il)
 2223 continue
      endif
      endif
      iott180=0
      jk0=2
      x1(1)=xyzs(1,natsold+jk0)
      x1(2)=xyzs(2,natsold+jk0)
      x1(3)=xyzs(3,natsold+jk0)
      x2(1)=xyzs(1,natsold+1)
      x2(2)=xyzs(2,natsold+1)
      x2(3)=xyzs(3,natsold+1)
      x3(1)=xyzs(1,natsold+jk0+1)
      x3(2)=xyzs(2,natsold+jk0+1)
      x3(3)=xyzs(3,natsold+jk0+1)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      do 861 ik=1,ndiff
      if(ik0.gt.0)then
      ik0=ik0-1
      go to 861
      endif
      jk=ik+1
      iok=0
 293  continue
      if(iott180.eq.1)then
      x1(1)=xyzs(1,natsold+jk0)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk0)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk0)-xyzs(3,natsold+1)
      else
      x1(1)=xyzs(1,natsold+jk)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk)-xyzs(3,natsold+1)
      endif
      call molt1_rot(rmz, x1, x2)
      x1(1)=xyzs(1,natsold+jk+1)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk+1)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk+1)-xyzs(3,natsold+1)
      call molt1_rot(rmz, x1, x3)
      iarret=0
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if(iarret.lt.0)go to 9000
      call molt1_rot(rmiz, x1, xo)
      if(iok.eq.0)then
      do 559 ijk=2,jk+1   
      x1(1)=xo(1)+xyzs(1,natsold+1)
      x1(2)=xo(2)+xyzs(2,natsold+1)
      x1(3)=xo(3)+xyzs(3,natsold+1)
      x2(1)=xyzs(1,natsold+ijk)
      x2(2)=xyzs(2,natsold+ijk)
      x2(3)=xyzs(3,natsold+ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      endif
      endif
 559  continue
      endif
      xyzs(1,natsold+jk+2)=xo(1)+xyzs(1,natsold+1)
      xyzs(2,natsold+jk+2)=xo(2)+xyzs(2,natsold+1)
      xyzs(3,natsold+jk+2)=xo(3)+xyzs(3,natsold+1)
      xo(1)=xyzs(1,natsold+jk+2)
      xo(2)=xyzs(2,natsold+jk+2)
      xo(3)=xyzs(3,natsold+jk+2)
      i1=natsold+1
      ic1=ic1+1
      if(imiss(i).eq.1)then
      xtet(1,ic1)=xyzs(1,natsold+jk+2)
      xtet(2,ic1)=xyzs(2,natsold+jk+2)
      xtet(3,ic1)=xyzs(3,natsold+jk+2)
      else
      xotta(1,ic1)=xyzs(1,natsold+jk+2)
      xotta(2,ic1)=xyzs(2,natsold+jk+2)
      xotta(3,ic1)=xyzs(3,natsold+jk+2)
      endif
      ic1sav=ic1
      if(imiss(i).eq.1.and.ic1.lt.4)then
      call checkequivtt2(xo,i,i1,ic1,ic1sav,xtet)
      xyzs(1,natsold+jk+2)=xtet(1,ic1sav)               
      xyzs(2,natsold+jk+2)=xtet(2,ic1sav)               
      xyzs(3,natsold+jk+2)=xtet(3,ic1sav)               
      if(ic1.gt.ic1sav.and.ic1.le.4)then
      iok=0
      do 862 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0)=xtet(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0)=xtet(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0)=xtet(3,ic1sav+iik0)               
      ik0=ik0+1
 862  continue
      endif
      elseif(imiss(i).eq.2.and.ic1.lt.6)then
      call checkequivoo2(xo,i,i1,ic1,ic1sav,xotta)
      xyzs(1,natsold+jk+2)=xotta(1,ic1sav)               
      xyzs(2,natsold+jk+2)=xotta(2,ic1sav)               
      xyzs(3,natsold+jk+2)=xotta(3,ic1sav)               
      if(ic1.gt.ic1sav.and.ic1.le.6)then
      iok=0
      do 863 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0)=xotta(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0)=xotta(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0)=xotta(3,ic1sav+iik0)               
      ik0=ik0+1
 863  continue
      endif
      endif
 861  continue
      dsog=0.6
CCCC  dsog=1.2
  910 continue
      if(icoo.eq.1)then
      natsadd=natsadd+1
      xyzs(1,natsold+natsadd)=xanio(1,1)
      xyzs(2,natsold+natsadd)=xanio(2,1)
      xyzs(3,natsold+natsadd)=xanio(3,1)
      else
      natsadd=natsadd+1
      xyzs(1,natsold+natsadd)=xanio(1,1)
      xyzs(2,natsold+natsadd)=xanio(2,1)
      xyzs(3,natsold+natsadd)=xanio(3,1)
      natsadd=natsadd+1
      xyzs(1,natsold+natsadd)=xanio(1,2)
      xyzs(2,natsold+natsadd)=xanio(2,2)
      xyzs(3,natsold+natsadd)=xanio(3,2)
      endif
      nats=natsold+natsadd
      nzmax=-999999
      do 5100 jk=1,nats
      if(nz(jk).eq.0) go to 5100
      nzz=iabs(nz(jk)/100)
      if(nzz.gt.nzmax)nzmax=nzz
 5100 continue
      do 8910 ijk=natsold+1,natsold+natsadd                 
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
      do 8920 ijk0=1,natsold                
      x1(1)=xyzs(1,ijk0)
      x1(2)=xyzs(2,ijk0)
      x1(3)=xyzs(3,ijk0)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
      nats=natsold
      go to 9000
      endif
 8920 continue
 8910 continue
      iloccat1=1
      nzmax=-99999999
      do 120 ii=1,nats
      if (nz(ii).ne.0) then
      nzz=iabs(nz(ii))/100
      if (nzz.gt.nzmax) nzmax=nzz
      endif
  120 continue
      do 121 il=1,nats
      if (nz(il).eq.0) go to 121
      nzz=iabs(nz(il))/100
      if (nzz.lt.nzmax)then
      zrap=float(nzmax)/float(nzz)
      zrap=zrap**2
      bfac(il)=zrap*biso
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      else
      bfac(il)=0.9*biso
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      endif
 121  continue
      iprier=0
      call calcolaerre(chi2,iprier)
c     call to_coord(1)
c     if(chi2.lt.chimin)then
c     kdirect=1
c     interp=0
c     iniat = 1
c     call MakeLab(iniat,nats)
c     call to_coord(1)
cc    iconn(1)=-1
c     jab=3
c     call molplo()
      if(chi2.lt.chimin)then
      natssav=natsold+natsadd
      natsaddsav=natsadd
      call frm15e(nats,interp)
      kaddsav=kadd
      do 5001 jk=1,kadd
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
 5001 continue
      do 5200 jk=natsold+1,natsold+natsadd
      xsavx(1,jk)=xyzs(1,jk)
      xsavx(2,jk)=xyzs(2,jk)
      xsavx(3,jk)=xyzs(3,jk)
 5200 continue
      nzmsav=nzm
      do 5201 jk=1,nzmsav
      ilocsav(jk)=iloc(jk)
      xlocsav(1,jk)=xloc(1,jk)
      xlocsav(2,jk)=xloc(2,jk)
      xlocsav(3,jk)=xloc(3,jk)
      nlocsav(1,jk)=nloc(1,jk)
      nlocsav(2,jk)=nloc(2,jk)
      nlocsav(3,jk)=nloc(3,jk)
 5201 continue
      xaniosav(1,1)=xanio(1,1)
      xaniosav(2,1)=xanio(2,1)
      xaniosav(3,1)=xanio(3,1)
      if(icoo.eq.2)then
      xaniosav(1,2)=xanio(1,2)
      xaniosav(2,2)=xanio(2,2)
      xaniosav(3,2)=xanio(3,2)
      endif
      ntrialsav=ntrial
      chimin=chi2
      endif
 9000 continue    
c     nats=natsold
 4000 continue
 3000 continue
 2000 continue
 1000 continue
  900 continue
 6000 continue
      if(iloccat1.eq.0)ier=-1
      if(ier.lt.0)return
      do 5300 k=natsold+1,natssav                
      xyzs(1,k)=xsavx(1,k)
      xyzs(2,k)=xsavx(2,k)
      xyzs(3,k)=xsavx(3,k)
 5300 continue
      call intcoordd(ier)
      if(ier.lt.0)return
      if(istampa.gt.0)then
      write(lo,'(/,a,i6,a)')' ***** Selected Z-matrix description *****'
      write(lo,'(a)')'                                                 '
      write(lo,'(a,a)')' atom nr.  type  nr.       dist          ang',
     *'          tors '
      do 800 ii=1,nzm
      if(nlocsav(1,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4)')
     *ilocsav(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),
     *ii,nlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.1.and.nlocsav(2,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4,f10.3)')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.2.and.nlocsav(3,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,2(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii)
      else
      write(lo,'(i4,8x,a2,i4,3(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii),
     *nlocsav(3,ii),xlocsav(3,ii)
      endif
 800  continue
      write(lo,'(a)')'                                                 '
      write(lo,'(a,/)')'  *********************************************'
      kt=nfound1(i)
      write(lo,'(a,3f10.3)')' input cation #1',(xyzs(kp,kt),kp=1,3)
      kt=nfound2(i)
      write(lo,'(a,3f10.3)')' input cation #2',(xyzs(kp,kt),kp=1,3)
      write(lo,'(a,3f10.3)')' located cation',
     *(xyzs(kp,natsold+1),kp=1,3)
      do 5022 jk=natsold+2,natsold+natsaddsav
      write(lo,'(a,3f10.3)')' located anion',(xyzs(kp,jk),kp=1,3)
 5022 continue
      write(lo,'(/,a,f10.3,a,i7)')' Minimum fom:',chimin,
     *' trial #',ntrial
      endif
      nats=natsold+natsaddsav
      kdirect=1
      interp=0
      iniat = 1
      call MakeLab(iniat,nats)
      call to_coord(1)
      call frm15e(nats,interp)
      rfac=chimin
      jpol=0
      kdirectsav=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      nats=natsold
      nats=natssav               
      do 550 k=natsold+1,natssav             
      xo(1)=xyzs(1,k)
      xo(2)=xyzs(2,k)
      xo(3)=xyzs(3,k)
      call checkequiv(xo)
      xyzs(1,k)=xo(1)
      xyzs(2,k)=xo(2)
      xyzs(3,k)=xo(3)
 550  continue
      j1=nfound1(i)
      it(j1)=it(j1)+1
      xt(1,j1,it(j1))=xyzs(1,natsold+2)
      xt(2,j1,it(j1))=xyzs(2,natsold+2)
      xt(3,j1,it(j1))=xyzs(3,natsold+2)
      ntt(j1,it(j1))=natsold+2
      j2=nfound2(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xyzs(1,natsold+3)
      xt(2,j2,it(j2))=xyzs(2,natsold+3)
      xt(3,j2,it(j2))=xyzs(3,natsold+3)
      ntt(j2,it(j2))=natsold+3
      j3=natsold+1
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+2)
      xt(2,j3,it(j3))=xyzs(2,natsold+2)
      xt(3,j3,it(j3))=xyzs(3,natsold+2)
      ntt(j3,it(j3))=natsold+2
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+3)
      xt(2,j3,it(j3))=xyzs(2,natsold+3)
      xt(3,j3,it(j3))=xyzs(3,natsold+3)
      ntt(j3,it(j3))=natsold+3
      kadd=kaddsav
      ndif=nats-natsold-3
c     do 811 il=1,ndif
c     do 811 il=1,kadd
c     it(j3)=it(j3)+1
c     xt(1,j3,it(j3))=xyzs(1,natsold+3+il)
c     xt(2,j3,it(j3))=xyzs(2,natsold+3+il)
c     xt(3,j3,it(j3))=xyzs(3,natsold+3+il)
c     xt(1,j3,it(j3))=xadd(1,il)
c     xt(2,j3,it(j3))=xadd(2,il)
c     xt(3,j3,it(j3))=xadd(3,il)
c     ntt(j3,it(j3))=natsold+3+il
c811  continue
      if(imiss(i).eq.1)then
      itet=1
      ntetra=ntetra+1
      ntetr(ntetra)=natsold+1
      dtetra(ntetra)=dmiss(i)
      dtolt(ntetra)=dtolm(i)
      atolt(ntetra)=atolm(i)
      ktetra(ntetra)=kmiss(i)
      elseif(imiss(i).eq.2)then
      iott=1
      nott=nott+1
      notta(nott)=natsold+1
      dotta1(nott)=dmiss(i)
      dtolo(nott)=dtolm(i)
      atolo(nott)=atolm(i)
      kotta(nott)=kmiss(i)
      endif
      if(ico1sav.eq.1.and.ico2sav.eq.0)then
      j2=nfound2(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xaniosav(1,1)
      xt(2,j2,it(j2))=xaniosav(2,1)
      xt(3,j2,it(j2))=xaniosav(3,1)
      ntt(j2,it(j2))=natsold+7       
      ico1=0
      j2=kcat1           
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xaniosav(1,1)
      xt(2,j2,it(j2))=xaniosav(2,1)
      xt(3,j2,it(j2))=xaniosav(3,1)
      ntt(j2,it(j2))=natsold+7       
      elseif(ico1sav.eq.1.and.ico2sav.eq.1)then
      j2=nfound2(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xaniosav(1,1)
      xt(2,j2,it(j2))=xaniosav(2,1)
      xt(3,j2,it(j2))=xaniosav(3,1)
      ntt(j2,it(j2))=natsold+7       
      j2=kcat1           
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xaniosav(1,1)
      xt(2,j2,it(j2))=xaniosav(2,1)
      xt(3,j2,it(j2))=xaniosav(3,1)
      ntt(j2,it(j2))=natsold+7       
      ico1=0
      j2=nfound1(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xaniosav(1,2)
      xt(2,j2,it(j2))=xaniosav(2,2)
      xt(3,j2,it(j2))=xaniosav(3,2)
      ntt(j2,it(j2))=natsold+8       
      j2=kcat2           
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xaniosav(1,2)
      xt(2,j2,it(j2))=xaniosav(2,2)
      xt(3,j2,it(j2))=xaniosav(3,2)
      ntt(j2,it(j2))=natsold+8       
      ico2=0
      elseif(ico2sav.eq.1.and.ico1sav.eq.0)then
      j2=nfound1(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xaniosav(1,1)
      xt(2,j2,it(j2))=xaniosav(2,1)
      xt(3,j2,it(j2))=xaniosav(3,1)
      ntt(j2,it(j2))=natsold+7       
      j2=kcat2           
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xaniosav(1,1)
      xt(2,j2,it(j2))=xaniosav(2,1)
      xt(3,j2,it(j2))=xaniosav(3,1)
      ntt(j2,it(j2))=natsold+7       
      ico2=0
      endif
      natmis(1,i)=natsold+1
      natmis(2,i)=natsold+2
      natmis(3,i)=natsold+3
      natsold=nats
      do 9100 k1=1,nats
      do 945 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 9100
 945  continue
      do 946 k2=1,nott
      if(k1.eq.notta(k2))go to 9100
 946  continue
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      if(ntetra.gt.0)call checkequivtcat2(xo)
      if(nott.gt.0)call checkequivocat2(xo)
 9100 continue
      return
      end
c ---------------------------------------------------------------
      subroutine loccat1a(i,natsold,jcod,ier)
      Use Polpo
      USE Atomi
      USE General
      USE drawatoms
      USE elements, only: pxen_from_specie,numelem
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common/savx/xsavx(3,500)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/occtetra/it(500)
      dimension ang(3),x1(3),x2(3),x3(3)
      dimension wr(4,4),xortet(4,6)
      dimension x11(4),x1t(3),xo(3),xad(3,10),xadsav(3,10)
      dimension xtet(4,4),xotta(4,6)
      character oo*2                             
      character Buffer*80
c
      ierr=0 
      dsogok=0.8
      psis=0.0
      phis=0.0
      thetas=0.0
      chimin=1.0E+10
      iloccat1=0
      ntrialcat = 0
      ier=-1
      ierr=0
      oo(1:2)='o '
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      nkel = numelem(celem)
      do 150 j=1,nkel
!corr      if (kmiss(i).eq.nalf(j)) then
      if (kmiss(i) == celem(j)%ptab) then
          nzc=j
          nzSavc = j*100+1
          vetintsavc = nzSavc+j
          go to 160
      endif
  150 continue
  160 continue
      do 200 j=1,nkel
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nza=j
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          go to 203
      endif
  200 continue
  203 continue
      if(jcod.eq.2)then
      j=nfound2(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound2(i),it(nfound2(i)))
      x2(2)=xt(2,nfound2(i),it(nfound2(i)))
      x2(3)=xt(3,nfound2(i),it(nfound2(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      d=dcal
      j=nfound1(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound2(i),it(nfound2(i)))
      x2(2)=xt(2,nfound2(i),it(nfound2(i)))
      x2(3)=xt(3,nfound2(i),it(nfound2(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      dd=dcal
      else
      j=nfound1(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound1(i),it(nfound1(i)))
      x2(2)=xt(2,nfound1(i),it(nfound1(i)))
      x2(3)=xt(3,nfound1(i),it(nfound1(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      d=dcal
      j=nfound2(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound1(i),it(nfound1(i)))
      x2(2)=xt(2,nfound1(i),it(nfound1(i)))
      x2(3)=xt(3,nfound1(i),it(nfound1(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      dd=dcal
      endif
      nats=natsold
      if(imiss(i).eq.1)then
      iadd=5                 
      else
      iadd=7               
      endif
      xyzs(1,nats+1)=0.0
      xyzs(2,nats+1)=0.0
      xyzs(3,nats+1)=0.0
      xyzs(4,nats+1)=vetintsavc
      nz(nats+1)=nzSavc
      do 61 kkk=2,iadd
      xyzs(1,nats+kkk)=0.0
      xyzs(2,nats+kkk)=0.0
      xyzs(3,nats+kkk)=0.0
      xyzs(4,nats+kkk)=vetintsav
      nz(nats+kkk)=nzSavv
  61  continue
      nzm=1
      if(jcod.eq.2)then
      iloc(nzm)=nats+2         
      else
      iloc(nzm)=nats+3         
      endif
      xloc(1,nzm)=0.0
      xloc(2,nzm)=0.0
      xloc(3,nzm)=0.0
      nloc(1,nzm)=0
      nloc(2,nzm)=0
      nloc(3,nzm)=0
      nzm=2
      iloc(nzm)=nats+1
      if(jcod.eq.2)then
      nloc(1,nzm)=nats+2         
      else
      nloc(1,nzm)=nats+3         
      endif
      xloc(1,nzm)=dmiss(i)      
      nloc(2,nzm)=0             
      xloc(2,nzm)=0.0
      nloc(3,nzm)=0      
      xloc(3,nzm)=0.0
      nzm=3
      if(jcod.eq.2)then
      iloc(nzm)=nats+3
      nloc(1,nzm)=nats+1     
      nloc(2,nzm)=nats+2     
      else
      iloc(nzm)=nats+2
      nloc(1,nzm)=nats+1     
      nloc(2,nzm)=nats+3     
      endif
      nloc(3,nzm)=0           
      xloc(1,nzm)=dmiss(i)
      if(imiss(i).eq.1)then
      n6=1
      else
      n6=2
      endif
      do 6000 k6=1,n6
      nzm=3 
      if(imiss(i).eq.1)then
      xloc(2,nzm)=109.47
      else
      if(k6.eq.1)then
      xloc(2,nzm)=90.0   
      else
      xloc(2,nzm)=180.0   
      endif
      endif
      xloc(3,nzm)=0.0
      nzm=4
      if(jcod.eq.2)then
      iloc(nzm)=nfound2(i)
      nloc(1,nzm)=nats+3   
      nloc(2,nzm)=nats+1     
      nloc(3,nzm)=nats+2         
      nrif=nfound2(i)
      else
      iloc(nzm)=nfound1(i)
      nloc(1,nzm)=nats+2   
      nloc(2,nzm)=nats+1     
      nloc(3,nzm)=nats+3         
      nrif=nfound1(i)
      endif
      if(itimem.eq.0)then
      ntrial0=5
      ntrial1=5
      ntrial2=5
      ntrial3=5
      ntrial4=5
      ntrial5=5
      ntrialr=1 
      elseif(itimem.eq.1)then
      ntrial0=3
      ntrial1=3
      ntrial2=3
      ntrial3=3
      ntrial4=3
      ntrial5=3
      ntrialr=1 
      elseif(itimem.eq.2)then
      ntrial0=5
      ntrial1=5
      ntrial2=5
      ntrial3=5
      ntrial4=5
      ntrial5=5
      ntrialr=1 
      endif
      iest=0
      do 100 j=1,ntetra
      if(nrif.eq.ntetr(j))then
      jsav=j
      ntrial0=1
      iest=1
      go to 170
      endif
 100  continue
      iest=0
      do 101 j=1,nott   
      if(nrif.eq.notta(j))then
      jsav=j
      ntrial0=1
      iest=2
      go to 170
      endif
 101  continue
 170  continue
      ntrial_totali=ntrial0*ntrial1*ntrial2*ntrial3*ntrial4*
     *              ntrial5*ntrialr*n6
      do 900 k0=1,ntrial0
      nats=natsold
      nzm=4
      if(iest.eq.1)then
      xloc(1,nzm)=dtetra(jsav)
      elseif(iest.eq.2)then
      xloc(1,nzm)=dotta1(jsav)
      else
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      dlim1=1.4                   
      dlim2=2.0                    
      dlim=yfl*(dlim2-dlim1)+dlim1
      xloc(1,nzm)=dlim               
      endif
      do 1000 k=1,ntrial1
      nats=natsold
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      anglim1=2.0*asin(1.00/xloc(1,nzm))
      anglim2=pi
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
      do 2000 kk=1,ntrial2
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=5
      if(jcod.eq.2)then
      iloc(nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(1,nzm)=nfound2(i)
      nloc(2,nzm)=nats+3     
      nloc(3,nzm)=nats+1         
      nrif=nfound2(i)
      else
      iloc(nzm)=ntt(nfound1(i),it(nfound1(i)))
      nloc(1,nzm)=nfound1(i)
      nloc(2,nzm)=nats+2     
      nloc(3,nzm)=nats+1         
      nrif=nfound1(i)
      endif
      xloc(1,nzm)=d                    
      iest=0
      do 103 j=1,ntetra
      if(nrif.eq.ntetr(j))then
      jsav=j
      ntrial3=1
      iest=1
      go to 173
      endif
 103  continue
      iest=0
      do 104 j=1,nott   
      if(nrif.eq.notta(j))then
      jsav=j
      ntrial3=1
      iest=2
      go to 173
      endif
 104  continue
 173  continue
      nzm=5
      nats=natsold
      if(iest.eq.1)then
      k4=1
      ntrial3=1
      elseif(iest.eq.2)then
      k4=2
      ntrial3=1
      else
      k4=1
      endif
      do 3500 kkkb=1,k4               
      do 3000 kkk=1,ntrial3
      nats=natsold
      nzm=5
      if(iest.eq.1)then
      xloc(2,nzm)=109.47      
      elseif(iest.eq.2)then
      if(kkkb.eq.1)then
      xloc(2,nzm)=90.0           
      else
      xloc(2,nzm)=180.0
      endif
      else
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=5
      anglim1=2.0*asin(1.00/xloc(1,nzm))
      anglim2=pi                
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
      endif
      do 4000 kkkk=1,ntrial4
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=5
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=6
      if(jcod.eq.2)then
      iloc(nzm)=nfound1(i)
      nloc(1,nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(2,nzm)=nfound2(i) 
      nloc(3,nzm)=nats+3         
      j1=nfound1(i)
      x1(1)=xyzs(1,j1)
      x1(2)=xyzs(2,j1)
      x1(3)=xyzs(3,j1)
      x2(1)=xt(1,nfound2(i),it(nfound2(i)))
      x2(2)=xt(2,nfound2(i),it(nfound2(i)))
      x2(3)=xt(3,nfound2(i),it(nfound2(i)))
      call distanza(ggMat,x1,x2,dcal)
      d1=dcal
      j3=nfound2(i)
      x3(1)=xyzs(1,j3)
      x3(2)=xyzs(2,j3)
      x3(3)=xyzs(3,j3)
      call angolo(ggMat,x1,x2,x3,angg)
      ang1=angg*rtod
      else
      iloc(nzm)=nfound2(i)                          
      nloc(1,nzm)=ntt(nfound1(i),it(nfound1(i)))
      nloc(2,nzm)=nfound1(i) 
      nloc(3,nzm)=nats+2         
      j1=nfound2(i)
      x1(1)=xyzs(1,j1)
      x1(2)=xyzs(2,j1)
      x1(3)=xyzs(3,j1)
      x2(1)=xt(1,nfound1(i),it(nfound1(i)))
      x2(2)=xt(2,nfound1(i),it(nfound1(i)))
      x2(3)=xt(3,nfound1(i),it(nfound1(i)))
      call distanza(ggMat,x1,x2,dcal)
      d1=dcal
      j3=nfound1(i)
      x3(1)=xyzs(1,j3)
      x3(2)=xyzs(2,j3)
      x3(3)=xyzs(3,j3)
      call angolo(ggMat,x1,x2,x3,angg)
      ang1=angg*rtod
      endif
      xloc(1,nzm)=d1                      
      xloc(2,nzm)=ang1                    
      do 5000 kkkkk=1,ntrial5
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=6
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      ango=twopi
      phis=ango*yfl*rtod          
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      thetas=ango*yfl*rtod          
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      psis=ango*yfl*rtod          
c     ntrial=ntrial+1
!
!     Manage progress-bar
!
      ntrialcat = ntrialcat + 1
      write(Buffer,102) ntrialcat,ntrial_totali
  102 format(' Adding the missing atoms. Trial ',i5,' / ',i5)
      call scrper(Buffer,ntrialcat,ntrial_totali)
!
      ierr=0 
      call dainttocricat1a(i,jcod,ierr)
      if(ierr.lt.0)then
      go to 5000
      endif
CATTE dsogc=2.5
      dsogc=2.0
      x1(1)=xyzs(1,nfound1(i))         
      x1(2)=xyzs(2,nfound1(i))         
      x1(3)=xyzs(3,nfound1(i))         
      x2(1)=xadd(1,1)        
      x2(2)=xadd(2,1)        
      x2(3)=xadd(3,1)        
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 5000
      endif
      x1(1)=xyzs(1,nfound2(i))         
      x1(2)=xyzs(2,nfound2(i))         
      x1(3)=xyzs(3,nfound2(i))         
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 5000
      endif
      xyzs(1,natsold+1)=xadd(1,1)
      xyzs(2,natsold+1)=xadd(2,1)
      xyzs(3,natsold+1)=xadd(3,1)
      xyzs(1,natsold+2)=xadd(1,2)
      xyzs(2,natsold+2)=xadd(2,2)
      xyzs(3,natsold+2)=xadd(3,2)
      xyzs(1,natsold+3)=xadd(1,3)
      xyzs(2,natsold+3)=xadd(2,3)
      xyzs(3,natsold+3)=xadd(3,3)
      d1=dmiss(i)
      iok=0
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      else
      alfa=90.0*dtor
      endif
      kadd=0
CANGE if(i.gt.1)then
      do 841 k1=1,natsold+3
      do 845 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 841
 845  continue
      do 846 k2=1,nott
      if(k1.eq.notta(k2))go to 841
 846  continue
      if(imiss(i).eq.1)then
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivtcat(xo,i,natsold,kadd,xad,k1)
      else
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivocat(xo,i,natsold,kadd,xad,k1)
      endif
 841  continue
CANGE endif
      d1=dmiss(i)
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      kadd=min0(2,kadd)
      natsadd=5-kadd
      else
      alfa=90.0*dtor
      kadd=min0(4,kadd)
      natsadd=7-kadd
      endif
      ndiff=natsadd-3
      ik0=0
      ic1=2+kadd
      if(imiss(i).eq.1)then
      xtet(1,1)=xyzs(1,natsold+2)
      xtet(2,1)=xyzs(2,natsold+2)
      xtet(3,1)=xyzs(3,natsold+2)
      xtet(1,2)=xyzs(1,natsold+3)
      xtet(2,2)=xyzs(2,natsold+3)
      xtet(3,2)=xyzs(3,natsold+3)
      if(kadd.gt.0)then
      do 2222 il=1,kadd
      xtet(1,2+il)=xad(1,il)
      xtet(2,2+il)=xad(2,il)
      xtet(3,2+il)=xad(3,il)
 2222 continue
      endif
      else
      xotta(1,1)=xyzs(1,natsold+2)
      xotta(2,1)=xyzs(2,natsold+2)
      xotta(3,1)=xyzs(3,natsold+2)
      xotta(1,2)=xyzs(1,natsold+3)
      xotta(2,2)=xyzs(2,natsold+3)
      xotta(3,2)=xyzs(3,natsold+3)
      if(kadd.gt.0)then
      do 2223 il=1,kadd
      xotta(1,2+il)=xad(1,il)
      xotta(2,2+il)=xad(2,il)
      xotta(3,2+il)=xad(3,il)
 2223 continue
      endif
      endif
      iott180=0
      jk0=2
      x1(1)=xyzs(1,natsold+jk0)
      x1(2)=xyzs(2,natsold+jk0)
      x1(3)=xyzs(3,natsold+jk0)
      x2(1)=xyzs(1,natsold+1)
      x2(2)=xyzs(2,natsold+1)
      x2(3)=xyzs(3,natsold+1)
      x3(1)=xyzs(1,natsold+jk0+1)
      x3(2)=xyzs(2,natsold+jk0+1)
      x3(3)=xyzs(3,natsold+jk0+1)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      do 861 ik=1,ndiff
      if(ik0.gt.0)then
      ik0=ik0-1
      go to 861
      endif
      jk=ik+1
      iok=0
 293  continue
      if(iott180.eq.1)then
      x1(1)=xyzs(1,natsold+jk0)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk0)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk0)-xyzs(3,natsold+1)
      else
      x1(1)=xyzs(1,natsold+jk)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk)-xyzs(3,natsold+1)
      endif
      call molt1_rot(rmz, x1, x2)
      x1(1)=xyzs(1,natsold+jk+1)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk+1)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk+1)-xyzs(3,natsold+1)
      call molt1_rot(rmz, x1, x3)
      iarret=0
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if(iarret.lt.0)go to 5000
      call molt1_rot(rmiz, x1, xo)
      if(iok.eq.0)then
      do 559 ijk=2,jk+1   
      x1(1)=xo(1)+xyzs(1,natsold+1)
      x1(2)=xo(2)+xyzs(2,natsold+1)
      x1(3)=xo(3)+xyzs(3,natsold+1)
      x2(1)=xyzs(1,natsold+ijk)
      x2(2)=xyzs(2,natsold+ijk)
      x2(3)=xyzs(3,natsold+ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      endif
      endif
 559  continue
      endif
      xyzs(1,natsold+jk+2)=xo(1)+xyzs(1,natsold+1)
      xyzs(2,natsold+jk+2)=xo(2)+xyzs(2,natsold+1)
      xyzs(3,natsold+jk+2)=xo(3)+xyzs(3,natsold+1)
      xo(1)=xyzs(1,natsold+jk+2)
      xo(2)=xyzs(2,natsold+jk+2)
      xo(3)=xyzs(3,natsold+jk+2)
      i1=natsold+1
      ic1=ic1+1
      if(imiss(i).eq.1)then
      xtet(1,ic1)=xyzs(1,natsold+jk+2)
      xtet(2,ic1)=xyzs(2,natsold+jk+2)
      xtet(3,ic1)=xyzs(3,natsold+jk+2)
      else
      xotta(1,ic1)=xyzs(1,natsold+jk+2)
      xotta(2,ic1)=xyzs(2,natsold+jk+2)
      xotta(3,ic1)=xyzs(3,natsold+jk+2)
      endif
      ic1sav=ic1
      if(imiss(i).eq.1.and.ic1.lt.4)then
      call checkequivtt2(xo,i,i1,ic1,ic1sav,xtet)
      xyzs(1,natsold+jk+2)=xtet(1,ic1sav)               
      xyzs(2,natsold+jk+2)=xtet(2,ic1sav)               
      xyzs(3,natsold+jk+2)=xtet(3,ic1sav)               
      if(ic1.gt.ic1sav.and.ic1.le.4)then
      iok=0
      do 862 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0)=xtet(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0)=xtet(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0)=xtet(3,ic1sav+iik0)               
      ik0=ik0+1
 862  continue
      endif
      elseif(imiss(i).eq.2.and.ic1.lt.6)then
      call checkequivoo2(xo,i,i1,ic1,ic1sav,xotta)
      xyzs(1,natsold+jk+2)=xotta(1,ic1sav)               
      xyzs(2,natsold+jk+2)=xotta(2,ic1sav)               
      xyzs(3,natsold+jk+2)=xotta(3,ic1sav)               
      if(ic1.gt.ic1sav.and.ic1.le.6)then
      iok=0
      do 863 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0)=xotta(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0)=xotta(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0)=xotta(3,ic1sav+iik0)               
      ik0=ik0+1
 863  continue
      endif
      endif
 861  continue
      dsog=0.6
CCCC  dsog=1.2
  910 continue
      nats=natsold+natsadd
      do 8910 ijk=natsold+1,natsold+natsadd                 
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
      do 8920 ijk0=1,natsold                
      x1(1)=xyzs(1,ijk0)
      x1(2)=xyzs(2,ijk0)
      x1(3)=xyzs(3,ijk0)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
      nats=natsold
      ierr=-1
      go to 5000
      endif
 8920 continue
 8910 continue
      ier=0
      iloccat1=1
      nzmax=-99999999
      do 120 ii=1,nats
      if (nz(ii).ne.0) then
      nzz=iabs(nz(ii))/100
      if (nzz.gt.nzmax) nzmax=nzz
      endif
  120 continue
      do 121 il=1,nats
      if (nz(il).eq.0) go to 121
      nzz=iabs(nz(il))/100
      if (nzz.lt.nzmax)then
      zrap=float(nzmax)/float(nzz)
      bfac(il)=zrap*biso
      zrap=zrap**2
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      else
      bfac(il)=0.9*biso
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      endif
 121  continue
      iprier=0
      call calcolaerre(chi2,iprier)
CCCCCCif(chi2.lt.chimin)then
c     kdirect=0
CCCC  interp=0
CCCC  iniat = 1
CANG  call MakeLab(iniat,nats)
c     call to_coord(1)
c     call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
      if(chi2.lt.chimin)then
      natssav=natsold+natsadd
      natsaddsav=natsadd
      kaddsav=kadd
      do 5001 jk=1,kadd
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
 5001 continue
      do 5200 jk=natsold+1,natsold+natsadd
      xsavx(1,jk)=xyzs(1,jk)
      xsavx(2,jk)=xyzs(2,jk)
      xsavx(3,jk)=xyzs(3,jk)
 5200 continue
      nzmsav=nzm
      do 5201 jk=1,nzmsav
      ilocsav(jk)=iloc(jk)
      xlocsav(1,jk)=xloc(1,jk)
      xlocsav(2,jk)=xloc(2,jk)
      xlocsav(3,jk)=xloc(3,jk)
      nlocsav(1,jk)=nloc(1,jk)
      nlocsav(2,jk)=nloc(2,jk)
      nlocsav(3,jk)=nloc(3,jk)
 5201 continue
      ntrialsav=ntrial
      chimin=chi2
      endif
c     nats=natsold
 5000 continue
 4000 continue
 3000 continue
 3500 continue
 2000 continue
 1000 continue
  900 continue
 6000 continue
 5002 continue
      if(iloccat1.eq.0)ier=-1
      if(ier.lt.0)return
      do 5300 k=natsold+1,natssav                
      xyzs(1,k)=xsavx(1,k)
      xyzs(2,k)=xsavx(2,k)
      xyzs(3,k)=xsavx(3,k)
 5300 continue
      call intcoordd(ier)
      if(ier.lt.0)return
      if(istampa.gt.0)then
      write(lo,'(/,a,i6,a)')' ***** Selected Z-matrix description *****'
      write(lo,'(a)')'                                                 '
      write(lo,'(a,a)')' atom nr.  type  nr.       dist          ang',
     *'          tors '
      do 800 ii=1,nzm
      if(nlocsav(1,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4)')
     *ilocsav(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),
     *ii,nlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.1.and.nlocsav(2,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4,f10.3)')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.2.and.nlocsav(3,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,2(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii)
      else
      write(lo,'(i4,8x,a2,i4,3(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii),
     *nlocsav(3,ii),xlocsav(3,ii)
      endif
 800  continue
      write(lo,'(a)')'                                                 '
      write(lo,'(a,/)')'  *********************************************'
      kt=nfound1(i)
      write(lo,'(a,3f10.3)')' input cation #1',(xyzs(kp,kt),kp=1,3)
      kt=nfound2(i)
      write(lo,'(a,3f10.3)')' input cation #2',(xyzs(kp,kt),kp=1,3)
      write(lo,'(a,3f10.3)')' located cation',
     *(xyzs(kp,natsold+1),kp=1,3)
      do 5022 jk=natsold+2,natsold+natsaddsav
      write(lo,'(a,3f10.3)')' located anion',(xyzs(kp,jk),kp=1,3)
 5022 continue
      write(lo,'(/,a,f10.3,a,i7)')' Minimum fom:',chimin,
     *' trial #',ntrial
      endif
      nats=natsold+natsaddsav
      kdirect=1
      kdirectsav=3
      interp=0
      iniat = 1
      call MakeLab(iniat,nats)
      call to_coord(1)
      call frm15e(nats,interp)
      rfac=chimin
      jpol=0
      kdirectsav=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      nats=natsold
      nats=natssav               
      do 550 k=natsold+1,natssav             
      xo(1)=xyzs(1,k)
      xo(2)=xyzs(2,k)
      xo(3)=xyzs(3,k)
      call checkequiv(xo)
      xyzs(1,k)=xo(1)
      xyzs(2,k)=xo(2)
      xyzs(3,k)=xo(3)
 550  continue
      j1=nfound1(i)
      it(j1)=it(j1)+1
      xt(1,j1,it(j1))=xyzs(1,natsold+2)
      xt(2,j1,it(j1))=xyzs(2,natsold+2)
      xt(3,j1,it(j1))=xyzs(3,natsold+2)
      ntt(j1,it(j1))=natsold+2
      j2=nfound2(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xyzs(1,natsold+3)
      xt(2,j2,it(j2))=xyzs(2,natsold+3)
      xt(3,j2,it(j2))=xyzs(3,natsold+3)
      ntt(j2,it(j2))=natsold+3
      j3=natsold+1
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+2)
      xt(2,j3,it(j3))=xyzs(2,natsold+2)
      xt(3,j3,it(j3))=xyzs(3,natsold+2)
      ntt(j3,it(j3))=natsold+2
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+3)
      xt(2,j3,it(j3))=xyzs(2,natsold+3)
      xt(3,j3,it(j3))=xyzs(3,natsold+3)
      ntt(j3,it(j3))=natsold+3
      kadd=kaddsav
      ndif=nats-natsold-3
c     do 811 il=1,ndif
c     do 811 il=1,kadd
c     it(j3)=it(j3)+1
c     xt(1,j3,it(j3))=xyzs(1,natsold+3+il)
c     xt(2,j3,it(j3))=xyzs(2,natsold+3+il)
c     xt(3,j3,it(j3))=xyzs(3,natsold+3+il)
c     xt(1,j3,it(j3))=xadd(1,il)
c     xt(2,j3,it(j3))=xadd(2,il)
c     xt(3,j3,it(j3))=xadd(3,il)
c     ntt(j3,it(j3))=natsold+3+il
c811  continue
      if(imiss(i).eq.1)then
      itet=1
      ntetra=ntetra+1
      ntetr(ntetra)=natsold+1
      dtetra(ntetra)=dmiss(i)
      dtolt(ntetra)=dtolm(i)
      atolt(ntetra)=atolm(i)
      ktetra(ntetra)=kmiss(i)
      elseif(imiss(i).eq.2)then
      iott=1
      nott=nott+1
      notta(nott)=natsold+1
      dotta1(nott)=dmiss(i)
      dtolo(nott)=dtolm(i)
      atolo(nott)=atolm(i)
      kotta(nott)=kmiss(i)
      endif
      natmis(1,i)=natsold+1
      natmis(2,i)=natsold+2
      natmis(3,i)=natsold+3
      natsold=nats
      do 9100 k1=1,nats
      do 945 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 9100
 945  continue
      do 946 k2=1,nott
      if(k1.eq.notta(k2))go to 9100
 946  continue
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      if(ntetra.gt.0)call checkequivtcat2(xo)
      if(nott.gt.0)call checkequivocat2(xo)
 9100 continue
      return
      end
c----------------------------------------------------------------
      subroutine dainttocricat1a(icat1,jcod,ier)
      Use Polpo
      USE Atomi
      USE General
*     include 'atoms.fi'
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/stampa/istampa
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/occtetra/it(500)
      common/superandom/iix,iiy,ntrial,irandom,sograndom
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common /matr/rmz(3,3),rmiz(3,3)
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/ annealcat/ ncate,nzcat(500),iloccat(500,500),
     *xloccat(500,3,500),nloccat(500,3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common /derrig0/rr(3,3),rrt(3,3),rrf(3,3),rrp(3,3),derah(6,500),
     *       derbh(6,500)
      common /fastcal/ hkle(3000,4,24),fsca(9,3000)
      common/Gmatrix/ggMat(3,3)
****  common /atoms/ x(5,500),nz(500),idumx(21)
c     common /atoms/ x(5,500),nz(500),bfac(500),idumx(4001)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      dimension x11(4),x1(3),x2(3),xcri(3,500),
     *xortol(3,500)
      dimension amat(9,9),dmat(9),INDX(9),v(3,3)
      dimension aa(3,3),w(3),bb(3,3),ww(3,3),www(3)
      dimension ilocr(4),xcr(3,4),ang(3)
      dimension xz(3,50),x3(3),x4(3),x1t(3),xzr(3,50)
      dimension wr(4,4),xortet(4,10),rrr(3,3)
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
      dimension rreu(3,2)
c
      ier=0
      do 200 i=1,6
      dmat(i)=0.0
      do 300 j=1,6
      amat(i,j)=0.0
 300  continue
 200  continue
      nch=1
      if(jcod.eq.2)then
      xor(1,nch)=xt(1,nfound2(icat1),it(nfound2(icat1)))
      xor(2,nch)=xt(2,nfound2(icat1),it(nfound2(icat1)))
      xor(3,nch)=xt(3,nfound2(icat1),it(nfound2(icat1)))
      elseif(jcod.eq.1)then
      xor(1,nch)=xt(1,nfound1(icat1),it(nfound1(icat1)))
      xor(2,nch)=xt(2,nfound1(icat1),it(nfound1(icat1)))
      xor(3,nch)=xt(3,nfound1(icat1),it(nfound1(icat1)))
      else
      xor(1,nch)=xt(1,nfound1(icat1),it(nfound1(icat1)))
      xor(2,nch)=xt(2,nfound1(icat1),it(nfound1(icat1)))
      xor(3,nch)=xt(3,nfound1(icat1),it(nfound1(icat1)))
      endif
      do 100 i=1,nzm
c     write(6,*)'XLOCCAT',xloc(1,i),xloc(2,i),xloc(3,i)
      j=iloc(i)
      if(j.le.nats)then
c     write(6,*)j,xyzs(1,j),xyzs(2,j),xyzs(3,j)
      x11(1)=xyzs(1,j)-xor(1,nch)
      x11(2)=xyzs(2,j)-xor(2,nch)
      x11(3)=xyzs(3,j)-xor(3,nch)
      if(jcod.eq.2.and.i.eq.5)then
      x11(1)=xt(1,nfound2(icat1),it(nfound2(icat1)))-xor(1,nch)
      x11(2)=xt(2,nfound2(icat1),it(nfound2(icat1)))-xor(2,nch)
      x11(3)=xt(3,nfound2(icat1),it(nfound2(icat1)))-xor(3,nch)
      elseif(jcod.eq.1.and.i.eq.5)then
      x11(1)=xt(1,nfound1(icat1),it(nfound1(icat1)))-xor(1,nch)
      x11(2)=xt(2,nfound1(icat1),it(nfound1(icat1)))-xor(2,nch)
      x11(3)=xt(3,nfound1(icat1),it(nfound1(icat1)))-xor(3,nch)
      elseif(jcod.eq.3.and.i.eq.5)then
      x11(1)=xt(1,nfound2(icat1),it(nfound2(icat1)))-xor(1,nch)
      x11(2)=xt(2,nfound2(icat1),it(nfound2(icat1)))-xor(2,nch)
      x11(3)=xt(3,nfound2(icat1),it(nfound2(icat1)))-xor(3,nch)
      elseif(jcod.eq.3.and.i.eq.6)then
      x11(1)=xt(1,nfound1(icat1),it(nfound1(icat1)))-xor(1,nch)
      x11(2)=xt(2,nfound1(icat1),it(nfound1(icat1)))-xor(2,nch)
      x11(3)=xt(3,nfound1(icat1),it(nfound1(icat1)))-xor(3,nch)
      endif
      call molt1_rot(rmz, x11, x1)
      if(abs(x1(1)).lt.0.0001)x1(1)=0.0
      if(abs(x1(2)).lt.0.0001)x1(2)=0.0
      if(abs(x1(3)).lt.0.0001)x1(3)=0.0
      xorto(1,i)=x1(1)
      xorto(2,i)=x1(2)
      xorto(3,i)=x1(3)
      else
      xorto(1,i)=0.0       
      xorto(2,i)=0.0       
      xorto(3,i)=0.0       
      endif
 100  continue
c     a=cell(1)
c     b=cell(2)
c     c=cell(3)
c     alfa=cell(4)
c     beta=cell(5)
c     gamma=cell(6)
c     inv=0
c     call Orto_new(a, b, c, alfa, beta, gamma,inv)
c     inv=1
c     call Orto_new(a, b, c, alfa, beta, gamma,inv)
      nch=1
      il=iloc(nzm-1)
      xortol(1,nzm-1)=0.0
      xortol(2,nzm-1)=0.0
      xortol(3,nzm-1)=0.0
      xortol(1,nzm-2)=xloc(1,nzm-1)
      xortol(2,nzm-2)=0.0
      xortol(3,nzm-2)=0.0
      do 1000 k=1,nzm-3
      mmax=nzm-3
      xortol(1,k)=0.0
      xortol(2,k)=0.0
      xortol(3,k)=0.0
      do 1100 i=k,mmax
      w(1)=0.0
      w(2)=0.0
      w(3)=0.0
      j=nzm-3
      jrif=j
      fij=xloc(2,j+2)*dtor
      ppp=-1.0
      tij=ppp*(xloc(3,j+3))*dtor
      dij=xloc(1,i+1)
      aa(1,1)=-cos(fij)
      aa(1,2)=-sin(fij)
      aa(1,3)=0.0
      aa(2,1)=sin(fij)*cos(tij)
      aa(2,2)=-cos(fij)*cos(tij)
      aa(2,3)=sin(tij)
      aa(3,1)=-sin(fij)*sin(tij)
      aa(3,2)=cos(fij)*sin(tij)
      aa(3,3)=cos(tij)
      do 1200 j=nzm-4,i,-1
      fij=xloc(2,j+2)*dtor
      ppp=-1.0
      tij=ppp*(xloc(3,j+3))*dtor
      bb(1,1)=-cos(fij)
      bb(1,2)=-sin(fij)
      bb(1,3)=0.0
      bb(2,1)=sin(fij)*cos(tij)
      bb(2,2)=-cos(fij)*cos(tij)
      bb(2,3)=sin(tij)
      bb(3,1)=-sin(fij)*sin(tij)
      bb(3,2)=cos(fij)*sin(tij)
      bb(3,3)=cos(tij)
      call moltm(aa,bb,ww)
      do 1250 ik=1,3
      do 1260 jk=1,3
      aa(ik,jk)=ww(ik,jk)
 1260 continue
 1250 continue
 1200 continue
      www(1)=dij
      www(2)=0.0
      www(3)=0.0
      call moltv(aa,www,w)
      xortol(1,k)=xortol(1,k)+w(1)
      xortol(2,k)=xortol(2,k)+w(2)
      xortol(3,k)=xortol(3,k)+w(3)
 1100 continue
      xortol(1,k)=xortol(1,k)+xloc(1,nzm-1)
 1000 continue
 2500 continue
      dn=xloc(1,nzm)
      fn=(xloc(2,nzm)*dtor)-(pi/2.0)
      xortol(1,nzm)=-dn*sin(fn)      
      xortol(2,nzm)=dn*cos(fn)
      xortol(3,nzm)=0.0
      if(abs(xortol(1,nzm-2)).lt.0.0001)then
      ier=-1
      return
      endif
      rr(1,1)=xorto(1,nzm-2)/xortol(1,nzm-2)
      rr(2,1)=xorto(2,nzm-2)/xortol(1,nzm-2)
      rr(3,1)=xorto(3,nzm-2)/xortol(1,nzm-2)
      delta1=rr(1,1)**2+rr(2,1)**2+rr(3,1)**2
      delta1=abs(delta1-1.0)
      if(delta1.gt.0.1)then
      ier=-1
      return
      endif
      rr(1,2)=(xorto(1,nzm)-rr(1,1)*xortol(1,nzm))/xortol(2,nzm)
      rr(2,2)=(xorto(2,nzm)-rr(2,1)*xortol(1,nzm))/xortol(2,nzm)
      rr(3,2)=(xorto(3,nzm)-rr(3,1)*xortol(1,nzm))/xortol(2,nzm)
      delta1=rr(1,2)**2+rr(2,2)**2+rr(3,2)**2
      delta1=abs(delta1-1.0)
      if(delta1.gt.0.1)then
      ier=-1
      return
      endif
      if(jcod.eq.3.and.(abs(xortol(3,nzm-3)).gt.0.0001))then
      rr(1,3)=(xorto(1,nzm-3)-rr(1,1)*xortol(1,nzm-3)-
     *rr(1,2)*xortol(2,nzm-3))/xortol(3,nzm-3)
      rr(2,3)=(xorto(2,nzm-3)-rr(2,1)*xortol(1,nzm-3)-
     *rr(2,2)*xortol(2,nzm-3))/xortol(3,nzm-3)
      rr(3,3)=(xorto(3,nzm-3)-rr(3,1)*xortol(1,nzm-3)-
     *rr(3,2)*xortol(2,nzm-3))/xortol(3,nzm-3)
      else
      delta1=1.0-rr(1,1)**2-rr(1,2)**2
      if(delta1.lt.0.0)then
      ier=-1
      return
      endif
      rr(1,3)=sqrt(delta1)
      rreu(1,1)=sqrt(delta1)
      rreu(1,2)=-sqrt(delta1)
      delta2=1.0-rr(2,1)**2-rr(2,2)**2
      if(delta2.lt.0.0)then
      ier=-1
      return
      endif
      rr(2,3)=sqrt(delta2)
      rreu(2,1)=sqrt(delta2)
      rreu(2,2)=-sqrt(delta2)
      delta3=1.0-rr(3,1)**2-rr(3,2)**2
      if(delta3.lt.0.0)then
      ier=-1
      return
      endif
      rr(3,3)=sqrt(delta3)
      rreu(3,1)=sqrt(delta3)
      rreu(3,2)=-sqrt(delta3)
      do  555 i=1,2
      rr(1,3)=rreu(1,i)
      do  556 j=1,2
      rr(2,3)=rreu(2,j)
      do  557 k=1,2
      rr(3,3)=rreu(3,k)
      costheta=rr(3,3)
      sintheta=sqrt(1.0-rr(3,3)**2)
      sinphi=rr(3,1)/sintheta
      sinpsi=rr(1,3)/sintheta
      cosphi=-rr(3,2)/sintheta
      cospsi=rr(2,3)/sintheta
      rrr(1,1)=cospsi*cosphi-costheta*sinphi*sinpsi
      dif1=abs(rrr(1,1)-rr(1,1))
      if(dif1.gt.0.1)go to 557
      rrr(1,2)=cospsi*sinphi+costheta*cosphi*sinpsi
      dif1=abs(rrr(1,2)-rr(1,2))
      if(dif1.gt.0.1)go to 557
      rrr(1,3)=sintheta*sinpsi
      dif1=abs(rrr(1,3)-rr(1,3))
      if(dif1.gt.0.1)go to 557
      rrr(2,1)=-sinpsi*cosphi-costheta*sinphi*cospsi
      dif1=abs(rrr(2,1)-rr(2,1))
      if(dif1.gt.0.1)go to 557
      rrr(2,2)=-sinpsi*sinphi+costheta*cosphi*cospsi
      dif1=abs(rrr(2,2)-rr(2,2))
      if(dif1.gt.0.1)go to 557
      rrr(2,3)=cospsi*sintheta
      dif1=abs(rrr(2,3)-rr(2,3))
      if(dif1.gt.0.1)go to 557
      rrr(3,1)=sintheta*sinphi
      dif1=abs(rrr(3,1)-rr(3,1))
      if(dif1.gt.0.1)go to 557
      rrr(3,2)=-sintheta*cosphi
      dif1=abs(rrr(3,2)-rr(3,2))
      if(dif1.gt.0.1)go to 557
      rrr(3,3)=costheta
      dif1=abs(rrr(3,3)-rr(3,3))
      if(dif1.gt.0.1)go to 557
      go to 558
 557  continue
 556  continue
 555  continue
 558  continue
      do 661 i=1,3
      do 662 j=1,3
      rr(i,j)=rrr(i,j)
 662  continue
 661  continue
      endif
      do 700 j=1,nzm          
      i=iloc(j)
      x11(1)=xortol(1,j)
      x11(2)=xortol(2,j)
      x11(3)=xortol(3,j)
      call molt1_rot(rr, x11, x1)
      call molt1_rot(rmiz, x1, x2)
      x1(1)=x2(1)+xor(1,nch)
      x1(2)=x2(2)+xor(2,nch)
      x1(3)=x2(3)+xor(3,nch)
      xz(1,j)=x1(1)
      xz(2,j)=x1(2)
      xz(3,j)=x1(3)
 700  continue
      if(jcod.eq.1)then
      nrif=nfound2(icat1)
      elseif(jcod.eq.2.or.jcod.eq.3)then
      nrif=nfound1(icat1)
      endif
      dd1=1.4
      dd2=1.9
      iyest=0
      iyeso=0
      do 111 j=1,ntetra
      if(nrif.eq.ntetr(j))then
      dd1=dtetra(j)*(1.0-dtolt(j))
      dd2=dtetra(j)*(1.0+dtolt(j))
c     dd1=dtetra(j)*0.9               
c     dd2=dtetra(j)*1.1                         
      if(it(nrif).ge.1)iyest=1
      jrif=j
      go to 170
      endif
 111  continue
      do 101 j=1,nott
      if(nrif.eq.notta(j))then
      dd1=dotta1(j)*(1.0-dtolo(j))
      dd2=dotta1(j)*(1.0+dtolo(j))
c     dd1=dotta1(j)*0.9                
c     dd2=dotta1(j)*1.1                    
      if(it(nrif).ge.1)iyeso=1
      jrif=j
      go to 170
      endif
 101  continue
 170  continue
      x1(1)=xz(1,1)
      x1(2)=xz(2,1)
      x1(3)=xz(3,1)
      x2(1)=xz(1,nzm)
      x2(2)=xz(2,nzm)
      x2(3)=xz(3,nzm)
      call distanza(ggMat,x1,x2,dcal)
CCCCCCCCCC
      if(iyest.gt.0.or.iyeso.gt.0)then
      x3(1)=xt(1,nrif,it(nrif))
      x3(2)=xt(2,nrif,it(nrif))
      x3(3)=xt(3,nrif,it(nrif))
      call angolo(ggMat,x1,x2,x3,angg)
      endif
      if(iyest.eq.1)then
      angsog1 = 109.47*(1.0-atolt(jrif))
      angsog2 = 109.47*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog1
      angsog22=angsog2
      elseif(iyeso.eq.1)then
      angsog1 = 90.00*(1.0-atolt(jrif))
      angsog2 = 90.00*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11 = 180.00*(1.0-atolt(jrif))
      angsog22 = 180.00*(1.0+atolt(jrif))
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
      elseif(iyeso.eq.0.and.iyest.eq.0)then
      angsog1=1.0
      angsog2=1.0
      angsog11=angsog1
      angsog22=angsog2
      angg=1.0
      endif
CCCCCCCCCCCC
c     if(dcal.lt.dd1.or.dcal.gt.dd2)then
      if((dcal.lt.dd1.or.dcal.gt.dd2).or
     *.((angg.lt.angsog1.or.angg.gt.angsog2)
     *.and.(angg.lt.angsog11.or.angg.gt.angsog22)))then
      nru=20
      angstep=18.0*dtor
      do 9000 jt=1,nru          
      x1(1)=xz(1,4)
      x1(2)=xz(2,4)
      x1(3)=xz(3,4)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      x1(1)=xz(1,5)
      x1(2)=xz(2,5)
      x1(3)=xz(3,5)
      call molt1_rot(rmz, x1, x2)
      xortet(1,2)=x2(1)
      xortet(2,2)=x2(2)
      xortet(3,2)=x2(3)
      kk0=2
      do 51 kl=1,3
      if(kl.eq.4.or.kl.eq.5)go to 51
      kk0=kk0+1
      x1(1)=xz(1,kl)
      x1(2)=xz(2,kl)
      x1(3)=xz(3,kl)
      call molt1_rot(rmz, x1, x2)
      xortet(1,kk0)=x2(1)
      xortet(2,kk0)=x2(2)
      xortet(3,kk0)=x2(3)
 51   continue
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      nmax=4
      do 10 ii=1,nmax
      do 20 j=1,nmax
      if(ii.le.4.and.j.le.4)wr(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtot(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtoti(ii,j)=0.0
 20   continue
 10   continue
      do ii=1,3
      x2(ii)=xortet(ii,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      angcal=float(jt-1)*angstep
      ierr=0
      call MatTott(x2,adif,bdif,cdif,ddif,angcal)
      call molt2_rott(rtoti, rtot, wr)
        kk0=0
        do ii=1,5
          xortet(4,ii)=1
         do j=1,4
           x11(j)=xortet(j,ii)
         end do
          call molt1_rott(wr, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
          kk0=kk0+1
          xzr(1,kk0)=x1(1)
          xzr(2,kk0)=x1(2)
          xzr(3,kk0)=x1(3)
        end do
      x1(1)=xzr(1,3)
      x1(2)=xzr(2,3)
      x1(3)=xzr(3,3)
      x2(1)=xz(1,nzm)
      x2(2)=xz(2,nzm)
      x2(3)=xz(3,nzm)
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.gt.dd1.and.dcal.lt.dd2)then
      if(iyest.gt.0.or.iyeso.gt.0)then
      x3(1)=xt(1,nrif,it(nrif))
      x3(2)=xt(2,nrif,it(nrif))
      x3(3)=xt(3,nrif,it(nrif))
      call angolo(ggMat,x1,x2,x3,angg)
      endif
      if(iyest.eq.1)then
      angsog1 = 109.47*(1.0-atolt(jrif))
      angsog2 = 109.47*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      if(angg.gt.angsog1.and.angg.lt.angsog2)go to 9001
      elseif(iyeso.eq.1)then
      angsog1 = 90.00*(1.0-atolt(jrif))
      angsog2 = 90.00*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      if(angg.gt.angsog1.and.angg.lt.angsog2)go to 9001
      angsog1 = 180.00*(1.0-atolt(jrif))
      angsog2 = 180.00*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      if(angg.gt.angsog1.and.angg.lt.angsog2)go to 9001
      elseif(iyeso.eq.0.and.iyest.eq.0)then
      go to 9001
      endif
      endif
 9000 continue
      ier=-1
      return
 9001 continue
      xadd(1,1)=xzr(1,4)
      xadd(2,1)=xzr(2,4)
      xadd(3,1)=xzr(3,4)
      if(jcod.eq.2)then
      xadd(1,3)=xzr(1,5)
      xadd(2,3)=xzr(2,5)
      xadd(3,3)=xzr(3,5)
      xadd(1,2)=xzr(1,3)
      xadd(2,2)=xzr(2,3)
      xadd(3,2)=xzr(3,3)
      else
      xadd(1,2)=xzr(1,5)
      xadd(2,2)=xzr(2,5)
      xadd(3,2)=xzr(3,5)
      xadd(1,3)=xzr(1,3)
      xadd(2,3)=xzr(2,3)
      xadd(3,3)=xzr(3,3)
      endif
      else
      xadd(1,1)=xz(1,2)
      xadd(2,1)=xz(2,2)
      xadd(3,1)=xz(3,2)
      if(jcod.eq.2)then
      xadd(1,3)=xz(1,3)
      xadd(2,3)=xz(2,3)
      xadd(3,3)=xz(3,3)
      xadd(1,2)=xz(1,1)
      xadd(2,2)=xz(2,1)
      xadd(3,2)=xz(3,1)
      else
      xadd(1,2)=xz(1,3)
      xadd(2,2)=xz(2,3)
      xadd(3,2)=xz(3,3)
      xadd(1,3)=xz(1,1)
      xadd(2,3)=xz(2,1)
      xadd(3,3)=xz(3,1)
      endif
      endif
      do 3050 i=1,3
        iser=1
        iactn=1
        khead=0
        xo1(1) = xadd(1,i)
        xo1(2) = xadd(2,i)
        xo1(3) = xadd(3,i)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xadd(1,i)=xn(1)
        xadd(2,i)=xn(2)
        xadd(3,i)=xn(3)
 3050 continue
      return
      end
c -----------------------------------------------------------------
      subroutine loccat1b(i,natsold,ier)            
      Use Polpo
      USE Atomi
      USE General
      USE drawatoms
      USE elements, only: pxen_from_specie,numelem
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common/savx/xsavx(3,500)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/occtetra/it(500)
      dimension ang(3),x1(3),x2(3),x3(3)
      dimension wr(4,4),xortet(4,6)
      dimension x11(4),x1t(3),xo(3),xad(3,10),xadsav(3,10)
      dimension xtet(4,4),xotta(4,6),ggstar(3,3)
      character oo*2                             
      character Buffer*80
c
      jcod=2
      ierr=0 
      dsogok=0.8
      psis=0.0
      phis=0.0
      thetas=0.0
      chimin=1.0E+10
      iloccat1=0
      ntrialcat = 0
      ier=-1
      ierr=0
      oo(1:2)='o '
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      nkel = numelem(celem)
      do 150 j=1,nkel
!corr      if (kmiss(i).eq.nalf(j)) then
      if (kmiss(i) == celem(j)%ptab) then
          nzc=j
          nzSavc = j*100+1
          vetintsavc = nzSavc+j
          go to 160
      endif
  150 continue
  160 continue
      do 200 j=1,nkel
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nza=j
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          go to 203
      endif
  200 continue
  203 continue
      nats=natsold
      if(imiss(i).eq.1)then
      iadd=5                 
      else
      iadd=7               
      endif
      xyzs(1,nats+1)=0.0
      xyzs(2,nats+1)=0.0
      xyzs(3,nats+1)=0.0
      xyzs(4,nats+1)=vetintsavc
      nz(nats+1)=nzSavc
      do 61 kkk=2,iadd
      xyzs(1,nats+kkk)=0.0
      xyzs(2,nats+kkk)=0.0
      xyzs(3,nats+kkk)=0.0
      xyzs(4,nats+kkk)=vetintsav
      nz(nats+kkk)=nzSavv
  61  continue
      nzm=1
      iloc(nzm)=nats+2         
      xloc(1,nzm)=0.0
      xloc(2,nzm)=0.0
      xloc(3,nzm)=0.0
      nloc(1,nzm)=0
      nloc(2,nzm)=0
      nloc(3,nzm)=0
      nzm=2
      iloc(nzm)=nats+1
      nloc(1,nzm)=nats+2         
      xloc(1,nzm)=dmiss(i)      
      nloc(2,nzm)=0             
      xloc(2,nzm)=0.0
      nloc(3,nzm)=0      
      xloc(3,nzm)=0.0
      nzm=3
      iloc(nzm)=nats+3
      nloc(1,nzm)=nats+1     
      nloc(2,nzm)=nats+2     
      nloc(3,nzm)=0           
      xloc(1,nzm)=dmiss(i)
      if(imiss(i).eq.1)then
      n6=1
      else
      n6=2
      endif
      do 6000 k6=1,n6
      nzm=3 
      if(imiss(i).eq.1)then
      xloc(2,nzm)=109.47
      else
      if(k6.eq.1)then
      xloc(2,nzm)=90.0   
      else
      xloc(2,nzm)=180.0   
      endif
      endif
      xloc(3,nzm)=0.0
      nzm=4
      iloc(nzm)=nfound2(i)
      nloc(1,nzm)=nats+3   
      nloc(2,nzm)=nats+1     
      nloc(3,nzm)=nats+2         
      nrif=nfound2(i)
      if(itimem.eq.0)then
      ntrial0=7
      ntrial1=7
      ntrial2=7
      ntrial3=7
      ntrial4=7
      ntrial5=7
      elseif(itimem.eq.1)then
      ntrial0=3
      ntrial1=3
      ntrial2=3
      ntrial3=3
      ntrial4=3
      ntrial5=3
      elseif(itimem.eq.2)then
      ntrial0=7
      ntrial1=7
      ntrial2=7
      ntrial3=7
      ntrial4=7
      ntrial5=7
      endif
      iest=0
      ntrial_totali=ntrial0*ntrial1*ntrial2*ntrial3*ntrial4*ntrial5*n6
      do 100 j=1,ntetra
      if(nrif.eq.ntetr(j))then
      jsav=j
      ntrial0=1
      iest=1
      go to 170
      endif
 100  continue
      iest=0
      do 101 j=1,nott   
      if(nrif.eq.notta(j))then
      jsav=j
      ntrial0=1
      iest=2
      go to 170
      endif
 101  continue
 170  continue
      do 900 k0=1,ntrial0
      nats=natsold
      nzm=4
      if(iest.eq.1)then
      xloc(1,nzm)=dtetra(jsav)
      elseif(iest.eq.2)then
      xloc(1,nzm)=dotta1(jsav)
      else
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      dlim1=1.4                   
      dlim2=2.0                    
      dlim=yfl*(dlim2-dlim1)+dlim1
      xloc(1,nzm)=dlim               
      endif
      do 1000 k=1,ntrial1
      nats=natsold
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      anglim1=2.0*asin(1.00/xloc(1,nzm))
      anglim2=pi
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
      do 2000 kk=1,ntrial2
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=5
      iloc(nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(1,nzm)=nfound2(i)
      nloc(2,nzm)=nats+3     
      nloc(3,nzm)=nats+1         
      nrif=nfound2(i)
      j=nfound2(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound2(i),it(nfound2(i)))
      x2(2)=xt(2,nfound2(i),it(nfound2(i)))
      x2(3)=xt(3,nfound2(i),it(nfound2(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      d=dcal
      xloc(1,nzm)=d                    
      iest=0
      do 103 j=1,ntetra
      if(nrif.eq.ntetr(j))then
      jsav=j
      ntrial3=1
      iest=1
      go to 173
      endif
 103  continue
      iest=0
      do 104 j=1,nott   
      if(nrif.eq.notta(j))then
      jsav=j
      ntrial3=1
      iest=2
      go to 173
      endif
 104  continue
 173  continue
      nzm=5
      nats=natsold
      if(iest.eq.1)then
      k4=1
      ntrial3=1
      elseif(iest.eq.2)then
      k4=2
      ntrial3=1
      else
      k4=1
      endif
      do 3500 kkkb=1,k4               
      do 3000 kkk=1,ntrial3
      nats=natsold
      nzm=5
      if(iest.eq.1)then
      xloc(2,nzm)=109.47      
      elseif(iest.eq.2)then
      if(kkkb.eq.1)then
      xloc(2,nzm)=90.0           
      else
      xloc(2,nzm)=180.0
      endif
      else
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=5
      anglim1=2.0*asin(1.00/xloc(1,nzm))
      anglim2=pi                
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
      endif
      do 4000 kkkk=1,ntrial4
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=5
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=6
      iloc(nzm)=ntt(nfound1(i),it(nfound1(i)))
      nloc(1,nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(2,nzm)=nfound2(i) 
      nloc(3,nzm)=nats+3         
      x1(1)=xt(1,nfound1(i),it(nfound1(i)))
      x1(2)=xt(2,nfound1(i),it(nfound1(i)))
      x1(3)=xt(3,nfound1(i),it(nfound1(i)))
      x2(1)=xt(1,nfound2(i),it(nfound2(i)))
      x2(2)=xt(2,nfound2(i),it(nfound2(i)))
      x2(3)=xt(3,nfound2(i),it(nfound2(i)))
      call distanza(ggMat,x1,x2,dcal)
      d1=dcal
      j3=nfound2(i)
      x3(1)=xyzs(1,j3)
      x3(2)=xyzs(2,j3)
      x3(3)=xyzs(3,j3)
      call angolo(ggMat,x1,x2,x3,angg)
      ang1=angg*rtod
      xloc(1,nzm)=d1                      
      xloc(2,nzm)=ang1                    
      do 5000 kkkkk=1,ntrial5
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=6
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=7
      iloc(nzm)=nfound1(i)
      nloc(1,nzm)=ntt(nfound1(i),it(nfound1(i)))
      nloc(2,nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(3,nzm)=nfound2(i) 
      j1=nfound1(i)
      x1(1)=xyzs(1,j1)
      x1(2)=xyzs(2,j1)
      x1(3)=xyzs(3,j1)
      x2(1)=xt(1,nfound1(i),it(nfound1(i)))
      x2(2)=xt(2,nfound1(i),it(nfound1(i)))
      x2(3)=xt(3,nfound1(i),it(nfound1(i)))
      call distanza(ggMat,x1,x2,dcal)
      xloc(1,nzm)=dcal
      x3(1)=xt(1,nfound2(i),it(nfound2(i)))
      x3(2)=xt(2,nfound2(i),it(nfound2(i)))
      x3(3)=xt(3,nfound2(i),it(nfound2(i)))
      call angolo(ggMat,x1,x2,x3,angg)
      xloc(2,nzm)=angg*rtod
      j2=nfound1(i)
      x1(1)=(xyzs(1,nfound1(i))-xt(1,nfound1(i),it(nfound1(i))))
      x1(2)=(xyzs(2,nfound1(i))-xt(2,nfound1(i),it(nfound1(i))))
      x1(3)=(xyzs(3,nfound1(i))-xt(3,nfound1(i),it(nfound1(i))))
      x2(1)=xt(1,nfound1(i),it(nfound1(i)))- 
     *xt(1,nfound2(i),it(nfound2(i)))
      x2(2)=xt(2,nfound1(i),it(nfound1(i)))- 
     *xt(2,nfound2(i),it(nfound2(i)))
      x2(3)=xt(3,nfound1(i),it(nfound1(i)))- 
     *xt(3,nfound2(i),it(nfound2(i)))
      x3(1)=xt(1,nfound2(i),it(nfound2(i)))- xyzs(1,nfound2(i))                       
      x3(2)=xt(2,nfound2(i),it(nfound2(i)))- xyzs(2,nfound2(i))                       
      x3(3)=xt(3,nfound2(i),it(nfound2(i)))- xyzs(3,nfound2(i))                       
      call torsion(ggMat,ggstar,x1,x2,x3,omega,vol)
      xloc(3,nzm)=omega*rtod
c     call SirRandom(iix,iiy,yfl)
c     iix=iiy
c     ango=twopi
c     phis=ango*yfl*rtod          
c     call SirRandom(iix,iiy,yfl)
c     iix=iiy
c     thetas=ango*yfl*rtod          
c     call SirRandom(iix,iiy,yfl)
c     iix=iiy
c     psis=ango*yfl*rtod          
c     ntrial=ntrial+1
      ierr=0 
      jcod=3
!
!     Manage progress-bar
!
      ntrialcat = ntrialcat + 1
      write(Buffer,102) ntrialcat,ntrial_totali
  102 format(' Adding the missing atoms. Trial ',i5,' / ',i5)
      call scrper(Buffer,ntrialcat,ntrial_totali)
!
      call dainttocricat1a(i,jcod,ierr)
      jcod=2
      if(ierr.lt.0)then
      go to 5000
      endif
CATTE dsogc=2.5
      dsogc=2.0
      x1(1)=xyzs(1,nfound1(i))         
      x1(2)=xyzs(2,nfound1(i))         
      x1(3)=xyzs(3,nfound1(i))         
      x2(1)=xadd(1,1)        
      x2(2)=xadd(2,1)        
      x2(3)=xadd(3,1)        
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 5000
      endif
      x1(1)=xyzs(1,nfound2(i))         
      x1(2)=xyzs(2,nfound2(i))         
      x1(3)=xyzs(3,nfound2(i))         
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 5000
      endif
      xyzs(1,natsold+1)=xadd(1,1)
      xyzs(2,natsold+1)=xadd(2,1)
      xyzs(3,natsold+1)=xadd(3,1)
      xyzs(1,natsold+2)=xadd(1,2)
      xyzs(2,natsold+2)=xadd(2,2)
      xyzs(3,natsold+2)=xadd(3,2)
      xyzs(1,natsold+3)=xadd(1,3)
      xyzs(2,natsold+3)=xadd(2,3)
      xyzs(3,natsold+3)=xadd(3,3)
      d1=dmiss(i)
      iok=0
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      else
      alfa=90.0*dtor
      endif
      kadd=0
CANGE if(i.gt.1)then
      do 841 k1=1,natsold+3
      do 845 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 841
 845  continue
      do 846 k2=1,nott
      if(k1.eq.notta(k2))go to 841
 846  continue
      if(imiss(i).eq.1)then
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivtcat(xo,i,natsold,kadd,xad,k1)
      else
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivocat(xo,i,natsold,kadd,xad,k1)
      endif
 841  continue
CANGE endif
      d1=dmiss(i)
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      kadd=min0(2,kadd)
      natsadd=5-kadd
      else
      alfa=90.0*dtor
      kadd=min0(4,kadd)
      natsadd=7-kadd
      endif
      ndiff=natsadd-3
      ik0=0
      ic1=2+kadd
      if(imiss(i).eq.1)then
      xtet(1,1)=xyzs(1,natsold+2)
      xtet(2,1)=xyzs(2,natsold+2)
      xtet(3,1)=xyzs(3,natsold+2)
      xtet(1,2)=xyzs(1,natsold+3)
      xtet(2,2)=xyzs(2,natsold+3)
      xtet(3,2)=xyzs(3,natsold+3)
      if(kadd.gt.0)then
      do 2222 il=1,kadd
      xtet(1,2+il)=xad(1,il)
      xtet(2,2+il)=xad(2,il)
      xtet(3,2+il)=xad(3,il)
 2222 continue
      endif
      else
      xotta(1,1)=xyzs(1,natsold+2)
      xotta(2,1)=xyzs(2,natsold+2)
      xotta(3,1)=xyzs(3,natsold+2)
      xotta(1,2)=xyzs(1,natsold+3)
      xotta(2,2)=xyzs(2,natsold+3)
      xotta(3,2)=xyzs(3,natsold+3)
      if(kadd.gt.0)then
      do 2223 il=1,kadd
      xotta(1,2+il)=xad(1,il)
      xotta(2,2+il)=xad(2,il)
      xotta(3,2+il)=xad(3,il)
 2223 continue
      endif
      endif
      iott180=0
      jk0=2
      x1(1)=xyzs(1,natsold+jk0)
      x1(2)=xyzs(2,natsold+jk0)
      x1(3)=xyzs(3,natsold+jk0)
      x2(1)=xyzs(1,natsold+1)
      x2(2)=xyzs(2,natsold+1)
      x2(3)=xyzs(3,natsold+1)
      x3(1)=xyzs(1,natsold+jk0+1)
      x3(2)=xyzs(2,natsold+jk0+1)
      x3(3)=xyzs(3,natsold+jk0+1)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      do 861 ik=1,ndiff
      if(ik0.gt.0)then
      ik0=ik0-1
      go to 861
      endif
      jk=ik+1
      iok=0
 293  continue
      if(iott180.eq.1)then
      x1(1)=xyzs(1,natsold+jk0)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk0)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk0)-xyzs(3,natsold+1)
      else
      x1(1)=xyzs(1,natsold+jk)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk)-xyzs(3,natsold+1)
      endif
      call molt1_rot(rmz, x1, x2)
      x1(1)=xyzs(1,natsold+jk+1)-xyzs(1,natsold+1)
      x1(2)=xyzs(2,natsold+jk+1)-xyzs(2,natsold+1)
      x1(3)=xyzs(3,natsold+jk+1)-xyzs(3,natsold+1)
      call molt1_rot(rmz, x1, x3)
      iarret=0
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if(iarret.lt.0)go to 5000
      call molt1_rot(rmiz, x1, xo)
      if(iok.eq.0)then
      do 559 ijk=2,jk+1   
      x1(1)=xo(1)+xyzs(1,natsold+1)
      x1(2)=xo(2)+xyzs(2,natsold+1)
      x1(3)=xo(3)+xyzs(3,natsold+1)
      x2(1)=xyzs(1,natsold+ijk)
      x2(2)=xyzs(2,natsold+ijk)
      x2(3)=xyzs(3,natsold+ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      endif
      endif
 559  continue
      endif
      xyzs(1,natsold+jk+2)=xo(1)+xyzs(1,natsold+1)
      xyzs(2,natsold+jk+2)=xo(2)+xyzs(2,natsold+1)
      xyzs(3,natsold+jk+2)=xo(3)+xyzs(3,natsold+1)
      xo(1)=xyzs(1,natsold+jk+2)
      xo(2)=xyzs(2,natsold+jk+2)
      xo(3)=xyzs(3,natsold+jk+2)
      i1=natsold+1
      ic1=ic1+1
      if(imiss(i).eq.1)then
      xtet(1,ic1)=xyzs(1,natsold+jk+2)
      xtet(2,ic1)=xyzs(2,natsold+jk+2)
      xtet(3,ic1)=xyzs(3,natsold+jk+2)
      else
      xotta(1,ic1)=xyzs(1,natsold+jk+2)
      xotta(2,ic1)=xyzs(2,natsold+jk+2)
      xotta(3,ic1)=xyzs(3,natsold+jk+2)
      endif
      ic1sav=ic1
      if(imiss(i).eq.1.and.ic1.lt.4)then
      call checkequivtt2(xo,i,i1,ic1,ic1sav,xtet)
      xyzs(1,natsold+jk+2)=xtet(1,ic1sav)               
      xyzs(2,natsold+jk+2)=xtet(2,ic1sav)               
      xyzs(3,natsold+jk+2)=xtet(3,ic1sav)               
      if(ic1.gt.ic1sav.and.ic1.le.4)then
      iok=0
      do 862 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0)=xtet(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0)=xtet(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0)=xtet(3,ic1sav+iik0)               
      ik0=ik0+1
 862  continue
      endif
      elseif(imiss(i).eq.2.and.ic1.lt.6)then
      call checkequivoo2(xo,i,i1,ic1,ic1sav,xotta)
      xyzs(1,natsold+jk+2)=xotta(1,ic1sav)               
      xyzs(2,natsold+jk+2)=xotta(2,ic1sav)               
      xyzs(3,natsold+jk+2)=xotta(3,ic1sav)               
      if(ic1.gt.ic1sav.and.ic1.le.6)then
      iok=0
      do 863 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0)=xotta(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0)=xotta(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0)=xotta(3,ic1sav+iik0)               
      ik0=ik0+1
 863  continue
      endif
      endif
 861  continue
      dsog=0.6
CATT  dsog=1.2
  910 continue
      nats=natsold+natsadd
      do 8910 ijk=natsold+1,natsold+natsadd                 
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
      do 8920 ijk0=1,natsold                
      x1(1)=xyzs(1,ijk0)
      x1(2)=xyzs(2,ijk0)
      x1(3)=xyzs(3,ijk0)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
      nats=natsold
      ierr=-1
      go to 5000
      endif
 8920 continue
 8910 continue
      ier=0
      iloccat1=1
      nzmax=-9999999
      do 120 ii=1,nats
      if (nz(ii).ne.0) then
      nzz=iabs(nz(ii))/100
      if (nzz.gt.nzmax) nzmax=nzz
      endif
  120 continue
      do 121 il=1,nats
      if (nz(il).eq.0) go to 121
      nzz=iabs(nz(il))/100
      if (nzz.lt.nzmax)then
      zrap=float(nzmax)/float(nzz)
      bfac(il)=zrap*biso
      zrap=zrap**2
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      else
      bfac(il)=0.9*biso
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      endif
 121  continue
      iprier=0
      call calcolaerre(chi2,iprier)
c     call to_coord(1)
      if(chi2.lt.chimin)then
c     kdirect=0
c     interp=0
c     iniat = 1
c     call MakeLab(iniat,nats)
c     call to_coord(1)
c     call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
CCCCC if(chi2.lt.chimin)then
      natssav=natsold+natsadd
      natsaddsav=natsadd
      kaddsav=kadd
      do 5001 jk=1,kadd
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
 5001 continue
      do 5200 jk=natsold+1,natsold+natsadd
      xsavx(1,jk)=xyzs(1,jk)
      xsavx(2,jk)=xyzs(2,jk)
      xsavx(3,jk)=xyzs(3,jk)
 5200 continue
      nzmsav=nzm
      do 5201 jk=1,nzmsav
      ilocsav(jk)=iloc(jk)
      xlocsav(1,jk)=xloc(1,jk)
      xlocsav(2,jk)=xloc(2,jk)
      xlocsav(3,jk)=xloc(3,jk)
      nlocsav(1,jk)=nloc(1,jk)
      nlocsav(2,jk)=nloc(2,jk)
      nlocsav(3,jk)=nloc(3,jk)
 5201 continue
      ntrialsav=ntrial
      chimin=chi2
      endif
c     nats=natsold
 5000 continue
 4000 continue
 3000 continue
 3500 continue
 2000 continue
 1000 continue
  900 continue
 6000 continue
 5002 continue
      if(iloccat1.eq.0)ier=-1
      if(ier.lt.0)return
      do 5300 k=natsold+1,natssav                
      xyzs(1,k)=xsavx(1,k)
      xyzs(2,k)=xsavx(2,k)
      xyzs(3,k)=xsavx(3,k)
 5300 continue
      call intcoordd(ier)
      if(ier.lt.0)return
      if(istampa.gt.0)then
      write(lo,'(/,a,i6,a)')' ***** Selected Z-matrix description *****'
      write(lo,'(a)')'                                                 '
      write(lo,'(a,a)')' atom nr.  type  nr.       dist          ang',
     *'          tors '
      do 800 ii=1,nzm
      if(nlocsav(1,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4)')
     *ilocsav(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),
     *ii,nlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.1.and.nlocsav(2,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4,f10.3)')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.2.and.nlocsav(3,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,2(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii)
      else
      write(lo,'(i4,8x,a2,i4,3(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii),
     *nlocsav(3,ii),xlocsav(3,ii)
      endif
 800  continue
      write(lo,'(a)')'                                                 '
      write(lo,'(a,/)')'  *********************************************'
      kt=nfound1(i)
      write(lo,'(a,3f10.3)')' input cation #1',(xyzs(kp,kt),kp=1,3)
      kt=nfound2(i)
      write(lo,'(a,3f10.3)')' input cation #2',(xyzs(kp,kt),kp=1,3)
      write(lo,'(a,3f10.3)')' located cation',
     *(xyzs(kp,natsold+1),kp=1,3)
      do 5022 jk=natsold+2,natsold+natsaddsav
      write(lo,'(a,3f10.3)')' located anion',(xyzs(kp,jk),kp=1,3)
 5022 continue
      write(lo,'(/,a,f10.3,a,i7)')' Minimum fom:',chimin,
     *' trial #',ntrial
      endif
      nats=natsold+natsaddsav
      kdirect=1
      kdirectsav=3
      interp=0
      iniat = 1
      call MakeLab(iniat,nats)
      call to_coord(1)
      call frm15e(nats,interp)
      rfac=chimin
      jpol=0
      kdirectsav=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      nats=natsold
      nats=natssav               
      do 550 k=natsold+1,natssav             
      xo(1)=xyzs(1,k)
      xo(2)=xyzs(2,k)
      xo(3)=xyzs(3,k)
      call checkequiv(xo)
      xyzs(1,k)=xo(1)
      xyzs(2,k)=xo(2)
      xyzs(3,k)=xo(3)
 550  continue
      j1=nfound1(i)
      it(j1)=it(j1)+1
      xt(1,j1,it(j1))=xyzs(1,natsold+3)
      xt(2,j1,it(j1))=xyzs(2,natsold+3)
      xt(3,j1,it(j1))=xyzs(3,natsold+3)
      ntt(j1,it(j1))=natsold+2
      j2=nfound2(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xyzs(1,natsold+2)
      xt(2,j2,it(j2))=xyzs(2,natsold+2)
      xt(3,j2,it(j2))=xyzs(3,natsold+2)
      ntt(j2,it(j2))=natsold+3
      j3=natsold+1
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+2)
      xt(2,j3,it(j3))=xyzs(2,natsold+2)
      xt(3,j3,it(j3))=xyzs(3,natsold+2)
      ntt(j3,it(j3))=natsold+2
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+3)
      xt(2,j3,it(j3))=xyzs(2,natsold+3)
      xt(3,j3,it(j3))=xyzs(3,natsold+3)
      ntt(j3,it(j3))=natsold+3
      kadd=kaddsav
      ndif=nats-natsold-3
c     do 811 il=1,ndif
c     do 811 il=1,kadd
c     it(j3)=it(j3)+1
c     xt(1,j3,it(j3))=xyzs(1,natsold+3+il)
c     xt(2,j3,it(j3))=xyzs(2,natsold+3+il)
c     xt(3,j3,it(j3))=xyzs(3,natsold+3+il)
c     xt(1,j3,it(j3))=xadd(1,il)
c     xt(2,j3,it(j3))=xadd(2,il)
c     xt(3,j3,it(j3))=xadd(3,il)
c     ntt(j3,it(j3))=natsold+3+il
c811  continue
      if(imiss(i).eq.1)then
      itet=1
      ntetra=ntetra+1
      ntetr(ntetra)=natsold+1
      dtetra(ntetra)=dmiss(i)
      dtolt(ntetra)=dtolm(i)
      atolt(ntetra)=atolm(i)
      ktetra(ntetra)=kmiss(i)
      elseif(imiss(i).eq.2)then
      iott=1
      nott=nott+1
      notta(nott)=natsold+1
      dotta1(nott)=dmiss(i)
      dtolo(nott)=dtolm(i)
      atolo(nott)=atolm(i)
      kotta(nott)=kmiss(i)
      endif
      natmis(1,i)=natsold+1
      natmis(2,i)=natsold+2
      natmis(3,i)=natsold+3
      natsold=nats
      do 9100 k1=1,nats
      do 945 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 9100
 945  continue
      do 946 k2=1,nott
      if(k1.eq.notta(k2))go to 9100
 946  continue
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      if(ntetra.gt.0)call checkequivtcat2(xo)
      if(nott.gt.0)call checkequivocat2(xo)
 9100 continue
      return
      end
c----------------------------------------------------------------
      subroutine loccat2a(i,natsold,jcod,
     *j1cod,j2cod,d1cod,d2cod,ier)
      Use Polpo
      USE Atomi
      USE General
      USE drawatoms
      USE elements, only: pxen_from_specie,numelem
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common/savx/xsavx(3,500)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/occtetra/it(500)
      dimension ang(3),x1(3),x2(3),x3(3)
      dimension wr(4,4),xortet(4,6),ggstar(3,3)
      dimension x11(4),x1t(3),xo(3),xad(3,10),xadsav(3,10)
      dimension xtet(4,4),xotta(4,6),xag(3,10),xfix(3),xlin(3)
      dimension itake(500)
      character oo*2                             
      character Buffer*80
c
      ierr=0 
      dsogok=0.8
      psis=0.0
      phis=0.0
      thetas=0.0
      chimin=1.0E+10
      iloccat1=0
      ntrialcat = 0
      ier=-1
      ierr=0
      oo(1:2)='o '
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      nkel = numelem(celem)
      do 150 j=1,nkel
!corr      if (kmiss(i).eq.nalf(j)) then
      if (kmiss(i) == celem(j)%ptab) then
          nzc=j
          nzSavc = j*100+1
          vetintsavc = nzSavc+j
          go to 160
      endif
  150 continue
  160 continue
      do 200 j=1,nkel
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nza=j
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          go to 203
      endif
  200 continue
  203 continue
      if(jcod.eq.2)then
      j=nfound2(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound2(i),it(nfound2(i)))
      x2(2)=xt(2,nfound2(i),it(nfound2(i)))
      x2(3)=xt(3,nfound2(i),it(nfound2(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      d=dcal
      j=nfound1(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound2(i),it(nfound2(i)))
      x2(2)=xt(2,nfound2(i),it(nfound2(i)))
      x2(3)=xt(3,nfound2(i),it(nfound2(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      dd=dcal
      else
      j=nfound1(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound1(i),it(nfound1(i)))
      x2(2)=xt(2,nfound1(i),it(nfound1(i)))
      x2(3)=xt(3,nfound1(i),it(nfound1(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      d=dcal
      j=nfound2(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound1(i),it(nfound1(i)))
      x2(2)=xt(2,nfound1(i),it(nfound1(i)))
      x2(3)=xt(3,nfound1(i),it(nfound1(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      dd=dcal
      endif
      nats=natsold
      if(imiss(i).eq.1)then
      iadd=5                 
      else
      iadd=7               
      endif
      xyzs(1,nats+1)=0.0
      xyzs(2,nats+1)=0.0
      xyzs(3,nats+1)=0.0
      xyzs(4,nats+1)=vetintsavc
      nz(nats+1)=nzSavc
      do 61 kkk=2,iadd
      xyzs(1,nats+kkk)=0.0
      xyzs(2,nats+kkk)=0.0
      xyzs(3,nats+kkk)=0.0
      xyzs(4,nats+kkk)=vetintsav
      nz(nats+kkk)=nzSavv
  61  continue
      if(jcod.eq.2)then
      jj=nfound2(i)
      dloc=d2cod
      if(abs(dloc).lt.0.0001)then
      aa=1.0
      endif
      if(j2cod.eq.1)then
      ndif=4-it(jj)
      alfaloc=109.47*dtor
      else
      ndif=6-it(jj)
      alfaloc=90.0*dtor
      endif
      else
      jj=nfound1(i)
      dloc=d1cod
      if(j1cod.eq.1)then
      ndif=4-it(jj)
      alfaloc=109.47*dtor
      else
      ndif=6-it(jj)
      alfaloc=90.0*dtor
      endif
      endif
      iott180=0
      do 65 kkk=1,it(jj)
      xag(1,kkk)=xt(1,jj,kkk)
      xag(2,kkk)=xt(2,jj,kkk)
      xag(3,kkk)=xt(3,jj,kkk)
 65   continue
      if(j1cod.eq.2.or.j2cod.eq.2)then
      jk0=2
      x1(1)=xt(1,jj,it(jj))
      x1(2)=xt(2,jj,it(jj))
      x1(3)=xt(3,jj,it(jj))
      x2(1)=xyzs(1,jj)
      x2(2)=xyzs(2,jj)
      x2(3)=xyzs(3,jj)
      x3(1)=xt(1,jj,it(jj)-1)
      x3(2)=xt(2,jj,it(jj)-1)
      x3(3)=xt(3,jj,it(jj)-1)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      endif
      jk0=it(jj)-1
      do 111 k=1,ndif
      iok=0
 295  continue
      if(iott180.eq.1)then
      x1(1)=xt(1,jj,jk0)-xyzs(1,jj)
      x1(2)=xt(2,jj,jk0)-xyzs(2,jj)
      x1(3)=xt(3,jj,jk0)-xyzs(3,jj)
      else
      x1(1)=xt(1,jj,jk0+k-1)-xyzs(1,jj)
      x1(2)=xt(2,jj,jk0+k-1)-xyzs(2,jj)
      x1(3)=xt(3,jj,jk0+k-1)-xyzs(3,jj)
      endif
      call molt1_rot(rmz, x1, x2)
      x1(1)=xt(1,jj,jk0+k)-xyzs(1,jj)
      x1(2)=xt(2,jj,jk0+k)-xyzs(2,jj)
      x1(3)=xt(3,jj,jk0+k)-xyzs(3,jj)
      call molt1_rot(rmz, x1, x3)
      iarret=0
      call generat2(x2,x3,dloc,alfaloc,x1,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x1, xo)
      do 519 ijk=1,it(jj)+k-1
      x1(1)=xo(1)+xyzs(1,jj)
      x1(2)=xo(2)+xyzs(2,jj)
      x1(3)=xo(3)+xyzs(3,jj)
      x2(1)=xt(1,jj,ijk)
      x2(2)=xt(2,jj,ijk)
      x2(3)=xt(3,jj,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  295
      endif
      endif
 519  continue
      x1(1)=xo(1)+xyzs(1,jj)
      x1(2)=xo(2)+xyzs(2,jj)
      x1(3)=xo(3)+xyzs(3,jj)
      xt(1,jj,jk0+k+1)=x1(1)   
      xt(2,jj,jk0+k+1)=x1(2)   
      xt(3,jj,jk0+k+1)=x1(3)   
      xag(1,it(jj)+k)=x1(1)
      xag(2,it(jj)+k)=x1(2)
      xag(3,it(jj)+k)=x1(3)
 111  continue
      ndif=it(jj)+ndif
c     do 9999 iijj=1,ndif
      do 9999 iijj=it(jj)+1,ndif
      nats=natsold
      nzm=1
      if(jcod.eq.2)then
      iloc(nzm)=nats+2         
      else
      iloc(nzm)=nats+3         
      endif
      xloc(1,nzm)=0.0
      xloc(2,nzm)=0.0
      xloc(3,nzm)=0.0
      nloc(1,nzm)=0
      nloc(2,nzm)=0
      nloc(3,nzm)=0
      nzm=2
      iloc(nzm)=nats+1
      if(jcod.eq.2)then
      nloc(1,nzm)=nats+2         
      else
      nloc(1,nzm)=nats+3         
      endif
      xloc(1,nzm)=dmiss(i)      
      nloc(2,nzm)=0             
      xloc(2,nzm)=0.0
      nloc(3,nzm)=0      
      xloc(3,nzm)=0.0
      nzm=3
      if(jcod.eq.2)then
      iloc(nzm)=nats+3
      nloc(1,nzm)=nats+1     
      nloc(2,nzm)=nats+2     
      else
      iloc(nzm)=nats+2
      nloc(1,nzm)=nats+1     
      nloc(2,nzm)=nats+3     
      endif
      nloc(3,nzm)=0           
      xloc(1,nzm)=dmiss(i)
      if(imiss(i).eq.1)then
      n6=1
      else
      n6=2
      endif
      do 6000 k6=1,n6
      nzm=3 
      if(imiss(i).eq.1)then
      xloc(2,nzm)=109.47
      else
      if(k6.eq.1)then
      xloc(2,nzm)=90.0   
      else
      xloc(2,nzm)=180.0   
      endif
      endif
      xloc(3,nzm)=0.0
      nzm=4
      if(jcod.eq.2)then
      iloc(nzm)=nfound2(i)
      nloc(1,nzm)=nats+3   
      nloc(2,nzm)=nats+1     
      nloc(3,nzm)=nats+2         
      x1(1)=xag(1,iijj)
      x1(2)=xag(2,iijj)
      x1(3)=xag(3,iijj)
      xfix(1)=x1(1)
      xfix(2)=x1(2)
      xfix(3)=x1(3)
      x2(1)=xyzs(1,nfound2(i))
      x2(2)=xyzs(2,nfound2(i))
      x2(3)=xyzs(3,nfound2(i))
      call distanza(ggMat,x1,x2,dcal)
      xloc(1,nzm)=dcal              
      else
      iloc(nzm)=nfound1(i)
      nloc(1,nzm)=nats+2   
      nloc(2,nzm)=nats+1     
      nloc(3,nzm)=nats+3         
      x1(1)=xag(1,iijj)
      x1(2)=xag(2,iijj)
      x1(3)=xag(3,iijj)
      xfix(1)=x1(1)
      xfix(2)=x1(2)
      xfix(3)=x1(3)
      x2(1)=xyzs(1,nfound1(i))
      x2(2)=xyzs(2,nfound1(i))
      x2(3)=xyzs(3,nfound1(i))
      call distanza(ggMat,x1,x2,dcal)
      xloc(1,nzm)=dcal              
      endif
      if(itimem.eq.0)then
      ntrial1=5
      ntrial2=5
      ntrial3=5
      ntrial4=5
      ntrial5=5
      ntrialr=1 
      elseif(itimem.eq.1)then
      ntrial1=3
      ntrial2=3
      ntrial3=3
      ntrial4=3
      ntrial5=3
      ntrialr=1 
      elseif(itimem.eq.2)then
      ntrial1=5
      ntrial2=5
      ntrial3=5
      ntrial4=5
      ntrial5=5
      ntrialr=1 
      endif
      nats=natsold
      nzm=4
      ntrial_totali=ntrial1*ntrial2*ntrial3*ntrial4*ntrial5*ntrialr*n6
      do 1000 k=1,ntrial1
      nats=natsold
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      anglim1=2.0*asin(1.00/xloc(1,nzm))
      anglim2=pi
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
      do 2000 kk=1,ntrial2
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=5
      if(jcod.eq.2)then
      iloc(nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(1,nzm)=nfound2(i)
      nloc(2,nzm)=nats+3     
      nloc(3,nzm)=nats+1         
      nrif=nfound2(i)
      else
      iloc(nzm)=ntt(nfound1(i),it(nfound1(i)))
      nloc(1,nzm)=nfound1(i)
      nloc(2,nzm)=nats+2     
      nloc(3,nzm)=nats+1         
      nrif=nfound1(i)
      endif
      x1(1)=xyzs(1,nrif)
      x1(2)=xyzs(2,nrif)
      x1(3)=xyzs(3,nrif)
      do 5555 il=1,ndif
      if(il.ne.iijj)then
      x2(1)=xag(1,il)
      x2(2)=xag(2,il)
      x2(3)=xag(3,il)
      xlin(1)=x2(1)
      xlin(2)=x2(2)
      xlin(3)=x2(3)
      call distanza(ggMat,x1,x2,dcal)
      go to 5556
      endif
 5555 continue
 5556 continue
      xloc(1,nzm)=dcal                 
      x3(1)=xfix(1)
      x3(2)=xfix(2)
      x3(3)=xfix(3)
      call angolo(ggMat,x3,x1,x2,anglo)
      nats=natsold
      nzm=5
      xloc(2,nzm)=anglo*rtod  
      do 4000 kkkk=1,ntrial4
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=5
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=6
      if(jcod.eq.2)then
      iloc(nzm)=nfound1(i)
      nloc(1,nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(2,nzm)=nfound2(i) 
      nloc(3,nzm)=nats+3         
      j1=nfound1(i)
      x1(1)=xyzs(1,j1)
      x1(2)=xyzs(2,j1)
      x1(3)=xyzs(3,j1)
      x2(1)=xlin(1)                           
      x2(2)=xlin(2)                           
      x2(3)=xlin(3)                           
      call distanza(ggMat,x1,x2,dcal)
      d1=dcal
      j3=nfound2(i)
      x3(1)=xyzs(1,j3)
      x3(2)=xyzs(2,j3)
      x3(3)=xyzs(3,j3)
      call angolo(ggMat,x3,x2,x1,angg)
      ang1=angg*rtod
      x1(1)=xyzs(1,j1)-xlin(1)
      x1(2)=xyzs(2,j1)-xlin(2)
      x1(3)=xyzs(3,j1)-xlin(3)
      x2(1)=xlin(1)-xyzs(1,j3)
      x2(2)=xlin(2)-xyzs(2,j3)
      x2(3)=xlin(3)-xyzs(3,j3)
      x3(1)=xyzs(1,j3)-xfix(1)
      x3(2)=xyzs(2,j3)-xfix(2)
      x3(3)=xyzs(3,j3)-xfix(3)
      call torsion(ggMat,ggstar,x1,x2,x3,omega,vol)
      omega1=omega*rtod
      else
      iloc(nzm)=nfound2(i)                          
      nloc(1,nzm)=ntt(nfound1(i),it(nfound1(i)))
      nloc(2,nzm)=nfound1(i) 
      nloc(3,nzm)=nats+2         
      j1=nfound2(i)
      x1(1)=xyzs(1,j1)
      x1(2)=xyzs(2,j1)
      x1(3)=xyzs(3,j1)
      x2(1)=xlin(1)                           
      x2(2)=xlin(2)                           
      x2(3)=xlin(3)                           
      call distanza(ggMat,x1,x2,dcal)
      d1=dcal
      j3=nfound1(i)
      x3(1)=xyzs(1,j3)
      x3(2)=xyzs(2,j3)
      x3(3)=xyzs(3,j3)
      call angolo(ggMat,x1,x2,x3,angg)
      ang1=angg*rtod
      x1(1)=xyzs(1,j1)-xlin(1)
      x1(2)=xyzs(2,j1)-xlin(2)
      x1(3)=xyzs(3,j1)-xlin(3)
      x2(1)=xlin(1)-xyzs(1,j3)
      x2(2)=xlin(2)-xyzs(2,j3)
      x2(3)=xlin(3)-xyzs(3,j3)
      x3(1)=xyzs(1,j3)-xfix(1)
      x3(2)=xyzs(2,j3)-xfix(2)
      x3(3)=xyzs(3,j3)-xfix(3)
      call torsion(ggMat,ggstar,x1,x2,x3,omega,vol)
      omega1=omega*rtod
      endif
      nzm=6
      nats=natsold
      xloc(1,nzm)=d1                      
      xloc(2,nzm)=ang1                    
      xloc(3,nzm)=omega1                  
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      thetas=ango*yfl*rtod          
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      psis=ango*yfl*rtod          
c     ntrial=ntrial+1
      ierr=0 
!
!     Manage progress-bar
!
      ntrialcat = ntrialcat + 1
      write(Buffer,102) ntrialcat,ntrial_totali
  102 format(' Adding the missing atoms. Trial ',i5,' / ',i5)
      call scrper(Buffer,ntrialcat,ntrial_totali)
!
      call dainttocricat2a(i,jcod,xfix,xlin,ierr)
      if(ierr.lt.0)then
      go to 5000
      endif
CATTE dsogc=2.5
      dsogc=2.0
      x1(1)=xyzs(1,nfound1(i))         
      x1(2)=xyzs(2,nfound1(i))         
      x1(3)=xyzs(3,nfound1(i))         
      x2(1)=xadd(1,1)        
      x2(2)=xadd(2,1)        
      x2(3)=xadd(3,1)        
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 5000
      endif
      x1(1)=xyzs(1,nfound2(i))         
      x1(2)=xyzs(2,nfound2(i))         
      x1(3)=xyzs(3,nfound2(i))         
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 5000
      endif
c     xyzs(1,natsold+1)=xadd(1,1)
c     xyzs(2,natsold+1)=xadd(2,1)
c     xyzs(3,natsold+1)=xadd(3,1)
c     xyzs(1,natsold+2)=xadd(1,2)
c     xyzs(2,natsold+2)=xadd(2,2)
c     xyzs(3,natsold+2)=xadd(3,2)
c     xyzs(1,natsold+3)=xadd(1,3)
c     xyzs(2,natsold+3)=xadd(2,3)
c     xyzs(3,natsold+3)=xadd(3,3)
      nadd=0
      do 5122 iik=1,natsold
      itake(iik)=0
 5122 continue
      do 5102 iik=1,natsold
      x1(1)=xyzs(1,iik)
      x1(2)=xyzs(2,iik)
      x1(3)=xyzs(3,iik)
      x2(1)=xadd(1,2)
      x2(2)=xadd(2,2)
      x2(3)=xadd(3,2)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.0.00001)then
      itake(iik)=1
      nadd=nadd+1
      go to 5003
      endif
 5102 continue
      xyzs(1,natsold+2-nadd)=xadd(1,2)
      xyzs(2,natsold+2-nadd)=xadd(2,2)
      xyzs(3,natsold+2-nadd)=xadd(3,2)
 5003 continue
      do 5004 iik=1,natsold
      x1(1)=xyzs(1,iik)
      x1(2)=xyzs(2,iik)
      x1(3)=xyzs(3,iik)
      x2(1)=xadd(1,3)
      x2(2)=xadd(2,3)
      x2(3)=xadd(3,3)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.0.00001)then
      itake(iik)=1
      nadd=nadd+1
      go to 5005
      endif
 5004 continue
      xyzs(1,natsold+3-nadd)=xadd(1,3)
      xyzs(2,natsold+3-nadd)=xadd(2,3)
      xyzs(3,natsold+3-nadd)=xadd(3,3)
 5005 continue
      xyzs(1,natsold+1)=xadd(1,1)
      xyzs(2,natsold+1)=xadd(2,1)
      xyzs(3,natsold+1)=xadd(3,1)
      d1=dmiss(i)
      iok=0
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      else
      alfa=90.0*dtor
      endif
      kadd=0
CANGE if(i.gt.1)then
      do 841 k1=1,natsold+3-nadd
      if(itake(k1).eq.1)go to 841
      do 845 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 841
 845  continue
      do 846 k2=1,nott
      if(k1.eq.notta(k2))go to 841
 846  continue
      if(imiss(i).eq.1)then
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivtcat(xo,i,natsold,kadd,xad,k1)
      if (kadd.gt.0)then
      do 866 k3=1,kadd
      xadd(1,3+k3)=xad(1,k3)
      xadd(2,3+k3)=xad(2,k3)
      xadd(3,3+k3)=xad(3,k3)
 866  continue
      endif
      else
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivocat(xo,i,natsold,kadd,xad,k1)
      if (kadd.gt.0)then
      do 867 k3=1,kadd
      xadd(1,3+k3)=xad(1,k3)
      xadd(2,3+k3)=xad(2,k3)
      xadd(3,3+k3)=xad(3,k3)
 867  continue
      endif
      endif
 841  continue
CANGE endif
      d1=dmiss(i)
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      kadd=min0(2,kadd)
      natsadd=5-kadd-nadd
      else
      alfa=90.0*dtor
      kadd=min0(4,kadd)
      natsadd=7-kadd-nadd
      endif
      ndiff=natsadd-(3-nadd)
      ik0=0
      ic1=2+kadd
      if(imiss(i).eq.1)then
c     xtet(1,1)=xyzs(1,natsold+2)
c     xtet(2,1)=xyzs(2,natsold+2)
c     xtet(3,1)=xyzs(3,natsold+2)
c     xtet(1,2)=xyzs(1,natsold+3)
c     xtet(2,2)=xyzs(2,natsold+3)
c     xtet(3,2)=xyzs(3,natsold+3)
      xtet(1,1)=xadd(1,2)
      xtet(2,1)=xadd(2,2)
      xtet(3,1)=xadd(3,2)
      xtet(1,2)=xadd(1,3)
      xtet(2,2)=xadd(2,3)
      xtet(3,2)=xadd(3,3)
      if(kadd.gt.0)then
      do 2222 il=1,kadd
      xtet(1,2+il)=xad(1,il)
      xtet(2,2+il)=xad(2,il)
      xtet(3,2+il)=xad(3,il)
 2222 continue
      endif
      else
c     xotta(1,1)=xyzs(1,natsold+2)
c     xotta(2,1)=xyzs(2,natsold+2)
c     xotta(3,1)=xyzs(3,natsold+2)
c     xotta(1,2)=xyzs(1,natsold+3)
c     xotta(2,2)=xyzs(2,natsold+3)
c     xotta(3,2)=xyzs(3,natsold+3)
      xotta(1,1)=xadd(1,2)
      xotta(2,1)=xadd(2,2)
      xotta(3,1)=xadd(3,2)
      xotta(1,2)=xadd(1,3)
      xotta(2,2)=xadd(2,3)
      xotta(3,2)=xadd(3,3)
      if(kadd.gt.0)then
      do 2223 il=1,kadd
      xotta(1,2+il)=xad(1,il)
      xotta(2,2+il)=xad(2,il)
      xotta(3,2+il)=xad(3,il)
 2223 continue
      endif
      endif
      iott180=0
      jk0=2-nadd
c     x1(1)=xyzs(1,natsold+jk0)
c     x1(2)=xyzs(2,natsold+jk0)
c     x1(3)=xyzs(3,natsold+jk0)
c     x2(1)=xyzs(1,natsold+1)
c     x2(2)=xyzs(2,natsold+1)
c     x2(3)=xyzs(3,natsold+1)
c     x3(1)=xyzs(1,natsold+jk0+1)
c     x3(2)=xyzs(2,natsold+jk0+1)
c     x3(3)=xyzs(3,natsold+jk0+1)
      x1(1)=xadd(1,2)
      x1(2)=xadd(2,2)
      x1(3)=xadd(3,2)
      x2(1)=xadd(1,1)
      x2(2)=xadd(2,1)
      x2(3)=xadd(3,1)
      x3(1)=xadd(1,3)
      x3(2)=xadd(2,3)
      x3(3)=xadd(3,3)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      do 861 ik=1,ndiff
      if(ik0.gt.0)then
      ik0=ik0-1
      go to 861
      endif
c     jk=ik+1
      jk=ik+1+kadd
      iok=0
 293  continue
      if(iott180.eq.1)then
c     x1(1)=xyzs(1,natsold+jk0)-xyzs(1,natsold+1)
c     x1(2)=xyzs(2,natsold+jk0)-xyzs(2,natsold+1)
c     x1(3)=xyzs(3,natsold+jk0)-xyzs(3,natsold+1)
      x1(1)=xadd(1,2)-xadd(1,1)
      x1(2)=xadd(2,2)-xadd(2,1)
      x1(3)=xadd(3,2)-xadd(3,1)
      else
c     x1(1)=xyzs(1,natsold+jk)-xyzs(1,natsold+1)
c     x1(2)=xyzs(2,natsold+jk)-xyzs(2,natsold+1)
c     x1(3)=xyzs(3,natsold+jk)-xyzs(3,natsold+1)
      x1(1)=xadd(1,jk)-xadd(1,1)
      x1(2)=xadd(2,jk)-xadd(2,1)
      x1(3)=xadd(3,jk)-xadd(3,1)
      endif
      call molt1_rot(rmz, x1, x2)
c     x1(1)=xyzs(1,natsold+jk+1)-xyzs(1,natsold+1)
c     x1(2)=xyzs(2,natsold+jk+1)-xyzs(2,natsold+1)
c     x1(3)=xyzs(3,natsold+jk+1)-xyzs(3,natsold+1)
      x1(1)=xadd(1,jk+1)-xadd(1,1)
      x1(2)=xadd(2,jk+1)-xadd(2,1)
      x1(3)=xadd(3,jk+1)-xadd(3,1)
      call molt1_rot(rmz, x1, x3)
      iarret=0
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if(iarret.lt.0)go to 5000
      call molt1_rot(rmiz, x1, xo)
      if(iok.eq.0)then
c     do 559 ijk=1,jk+1   
      do 559 ijk=2,jk+1   
      x1(1)=xo(1)+xyzs(1,natsold+1)
      x1(2)=xo(2)+xyzs(2,natsold+1)
      x1(3)=xo(3)+xyzs(3,natsold+1)
c     x2(1)=xyzs(1,natsold+ijk)
c     x2(2)=xyzs(2,natsold+ijk)
c     x2(3)=xyzs(3,natsold+ijk)
      x2(1)=xadd(1,ijk)
      x2(2)=xadd(2,ijk)
      x2(3)=xadd(3,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      endif
      endif
 559  continue
      endif
      xyzs(1,natsold+jk+2-nadd-kadd)=xo(1)+xyzs(1,natsold+1)
      xyzs(2,natsold+jk+2-nadd-kadd)=xo(2)+xyzs(2,natsold+1)
      xyzs(3,natsold+jk+2-nadd-kadd)=xo(3)+xyzs(3,natsold+1)
      xadd(1,jk+2)=xo(1)+xyzs(1,natsold+1)
      xadd(2,jk+2)=xo(2)+xyzs(2,natsold+1)
      xadd(3,jk+2)=xo(3)+xyzs(3,natsold+1)
      xo(1)=xyzs(1,natsold+jk+2-nadd-kadd)
      xo(2)=xyzs(2,natsold+jk+2-nadd-kadd)
      xo(3)=xyzs(3,natsold+jk+2-nadd-kadd)
      i1=natsold+1
      ic1=ic1+1
      if(imiss(i).eq.1)then
      xtet(1,ic1)=xyzs(1,natsold+jk+2-nadd-kadd)
      xtet(2,ic1)=xyzs(2,natsold+jk+2-nadd-kadd)
      xtet(3,ic1)=xyzs(3,natsold+jk+2-nadd-kadd)
      else
      xotta(1,ic1)=xyzs(1,natsold+jk+2-nadd-kadd)
      xotta(2,ic1)=xyzs(2,natsold+jk+2-nadd-kadd)
      xotta(3,ic1)=xyzs(3,natsold+jk+2-nadd-kadd)
      endif
      ic1sav=ic1
      if(imiss(i).eq.1.and.ic1.lt.4)then
      call checkequivtt2(xo,i,i1,ic1,ic1sav,xtet)
      xyzs(1,natsold+jk+2-nadd-kadd)=xtet(1,ic1sav)               
      xyzs(2,natsold+jk+2-nadd-kadd)=xtet(2,ic1sav)               
      xyzs(3,natsold+jk+2-nadd-kadd)=xtet(3,ic1sav)               
      xadd(1,jk+2)=xtet(1,ic1sav)
      xadd(2,jk+2)=xtet(2,ic1sav)
      xadd(3,jk+2)=xtet(3,ic1sav)
      if(ic1.gt.ic1sav.and.ic1.le.4)then
      iok=0
      do 862 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0-nadd-kadd)=xtet(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0-nadd-kadd)=xtet(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0-nadd-kadd)=xtet(3,ic1sav+iik0)               
      xadd(1,jk+2+iik0)=xtet(1,ic1sav+iik0)
      xadd(2,jk+2+iik0)=xtet(2,ic1sav+iik0)
      xadd(3,jk+2+iik0)=xtet(3,ic1sav+iik0)
      ik0=ik0+1
 862  continue
      endif
      elseif(imiss(i).eq.2.and.ic1.lt.6)then
      call checkequivoo2(xo,i,i1,ic1,ic1sav,xotta)
      xyzs(1,natsold+jk+2-nadd-kadd)=xotta(1,ic1sav)               
      xyzs(2,natsold+jk+2-nadd-kadd)=xotta(2,ic1sav)               
      xyzs(3,natsold+jk+2-nadd-kadd)=xotta(3,ic1sav)               
      xadd(1,jk+2)=xotta(1,ic1sav)
      xadd(2,jk+2)=xotta(2,ic1sav)
      xadd(3,jk+2)=xotta(3,ic1sav)
      if(ic1.gt.ic1sav.and.ic1.le.6)then
      iok=0
      do 863 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0-nadd-kadd)=xotta(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0-nadd-kadd)=xotta(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0-nadd-kadd)=xotta(3,ic1sav+iik0)               
      xadd(1,jk+2+iik0)=xotta(1,ic1sav+iik0)
      xadd(2,jk+2+iik0)=xotta(2,ic1sav+iik0)
      xadd(3,jk+2+iik0)=xotta(3,ic1sav+iik0)
      ik0=ik0+1
 863  continue
      endif
      endif
 861  continue
      dsog=0.6
CAT   dsog=1.2
  910 continue
      nats=natsold+natsadd
      do 8910 ijk=natsold+1,natsold+natsadd                 
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
      do 8920 ijk0=1,natsold                
      x1(1)=xyzs(1,ijk0)
      x1(2)=xyzs(2,ijk0)
      x1(3)=xyzs(3,ijk0)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
      nats=natsold
      ierr=-1
      go to 5000
      endif
 8920 continue
 8910 continue
      ier=0
      iloccat1=1
      nzmax=-99999999
      do 120 ii=1,nats
      if (nz(ii).ne.0) then
      nzz=iabs(nz(ii))/100
      if (nzz.gt.nzmax) nzmax=nzz
      endif
  120 continue
      do 121 il=1,nats
      if (nz(il).eq.0) go to 121
      nzz=iabs(nz(il))/100
      if (nzz.lt.nzmax)then
      zrap=float(nzmax)/float(nzz)
      bfac(il)=zrap*biso
      zrap=zrap**2
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      else
      bfac(il)=0.9*biso
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      endif
 121  continue
      iprier=0
      call calcolaerre(chi2,iprier)
c     call to_coord(1)
c     kdirect=0
c     interp=0
c     iniat = 1
c     call MakeLab(iniat,nats)
c     call to_coord(1)
c     call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
      if(chi2.lt.chimin)then
c     kdirect=0
c     interp=0
c     iniat = 1
c     call MakeLab(iniat,nats)
c     call to_coord(1)
c     call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
CCCCC if(chi2.lt.chimin)then
      natssav=natsold+natsadd
      natsaddsav=natsadd
      kaddsav=kadd
      do 5001 jk=1,kadd
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
 5001 continue
      do 5200 jk=natsold+1,natsold+natsadd
      xsavx(1,jk)=xyzs(1,jk)
      xsavx(2,jk)=xyzs(2,jk)
      xsavx(3,jk)=xyzs(3,jk)
 5200 continue
      nzmsav=nzm
      do 5201 jk=1,nzmsav
      ilocsav(jk)=iloc(jk)
      xlocsav(1,jk)=xloc(1,jk)
      xlocsav(2,jk)=xloc(2,jk)
      xlocsav(3,jk)=xloc(3,jk)
      nlocsav(1,jk)=nloc(1,jk)
      nlocsav(2,jk)=nloc(2,jk)
      nlocsav(3,jk)=nloc(3,jk)
 5201 continue
      ntrialsav=ntrial
      chimin=chi2
      endif
c     nats=natsold
 5000 continue
 4000 continue
 3000 continue
 3500 continue
 2000 continue
 1000 continue
  900 continue
 6000 continue
 5002 continue
 9999 continue
      if(iloccat1.eq.0)ier=-1
      if(ier.lt.0)return
      do 5300 k=natsold+1,natssav                
      xyzs(1,k)=xsavx(1,k)
      xyzs(2,k)=xsavx(2,k)
      xyzs(3,k)=xsavx(3,k)
 5300 continue
      call intcoordd(ier)
      if(ier.lt.0)return
      if(istampa.gt.0)then
      write(lo,'(/,a,i6,a)')' ***** Selected Z-matrix description *****'
      write(lo,'(a)')'                                                 '
      write(lo,'(a,a)')' atom nr.  type  nr.       dist          ang',
     *'          tors '
      do 800 ii=1,nzm
      if(nlocsav(1,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4)')
     *ilocsav(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),
     *ii,nlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.1.and.nlocsav(2,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4,f10.3)')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.2.and.nlocsav(3,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,2(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii)
      else
      write(lo,'(i4,8x,a2,i4,3(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii),
     *nlocsav(3,ii),xlocsav(3,ii)
      endif
 800  continue
      write(lo,'(a)')'                                                 '
      write(lo,'(a,/)')'  *********************************************'
      kt=nfound1(i)
      write(lo,'(a,3f10.3)')' input cation #1',(xyzs(kp,kt),kp=1,3)
      kt=nfound2(i)
      write(lo,'(a,3f10.3)')' input cation #2',(xyzs(kp,kt),kp=1,3)
      write(lo,'(a,3f10.3)')' located cation',
     *(xyzs(kp,natsold+1),kp=1,3)
      do 5022 jk=natsold+2,natsold+natsaddsav
      write(lo,'(a,3f10.3)')' located anion',(xyzs(kp,jk),kp=1,3)
 5022 continue
      write(lo,'(/,a,f10.3,a,i7)')' Minimum fom:',chimin,
     *' trial #',ntrial
      endif
      nats=natsold+natsaddsav
      kdirect=1
      kdirectsav=3
      interp=0
      iniat = 1
      call MakeLab(iniat,nats)
      call to_coord(1)
      call frm15e(nats,interp)
      rfac=chimin
      jpol=0
      kdirectsav=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      nats=natsold
      nats=natssav               
      do 550 k=natsold+1,natssav             
      xo(1)=xyzs(1,k)
      xo(2)=xyzs(2,k)
      xo(3)=xyzs(3,k)
      call checkequiv(xo)
      xyzs(1,k)=xo(1)
      xyzs(2,k)=xo(2)
      xyzs(3,k)=xo(3)
 550  continue
      j1=nfound1(i)
      it(j1)=it(j1)+1
      xt(1,j1,it(j1))=xyzs(1,natsold+2)
      xt(2,j1,it(j1))=xyzs(2,natsold+2)
      xt(3,j1,it(j1))=xyzs(3,natsold+2)
      ntt(j1,it(j1))=natsold+2
      j2=nfound2(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xyzs(1,natsold+3)
      xt(2,j2,it(j2))=xyzs(2,natsold+3)
      xt(3,j2,it(j2))=xyzs(3,natsold+3)
      ntt(j2,it(j2))=natsold+3
      j3=natsold+1
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+2)
      xt(2,j3,it(j3))=xyzs(2,natsold+2)
      xt(3,j3,it(j3))=xyzs(3,natsold+2)
      ntt(j3,it(j3))=natsold+2
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+3)
      xt(2,j3,it(j3))=xyzs(2,natsold+3)
      xt(3,j3,it(j3))=xyzs(3,natsold+3)
      ntt(j3,it(j3))=natsold+3
      kadd=kaddsav
      ndif=nats-natsold-3
c     do 811 il=1,ndif
c     do 811 il=1,kadd
c     it(j3)=it(j3)+1
c     xt(1,j3,it(j3))=xyzs(1,natsold+3+il)
c     xt(2,j3,it(j3))=xyzs(2,natsold+3+il)
c     xt(3,j3,it(j3))=xyzs(3,natsold+3+il)
c     xt(1,j3,it(j3))=xadd(1,il)
c     xt(2,j3,it(j3))=xadd(2,il)
c     xt(3,j3,it(j3))=xadd(3,il)
c     ntt(j3,it(j3))=natsold+3+il
c811  continue
      if(imiss(i).eq.1)then
      itet=1
      ntetra=ntetra+1
      ntetr(ntetra)=natsold+1
      dtetra(ntetra)=dmiss(i)
      dtolt(ntetra)=dtolm(i)
      atolt(ntetra)=atolm(i)
      ktetra(ntetra)=kmiss(i)
      elseif(imiss(i).eq.2)then
      iott=1
      nott=nott+1
      notta(nott)=natsold+1
      dotta1(nott)=dmiss(i)
      dtolo(nott)=dtolm(i)
      atolo(nott)=atolm(i)
      kotta(nott)=kmiss(i)
      endif
      natmis(1,i)=natsold+1
      natmis(2,i)=natsold+2
      natmis(3,i)=natsold+3
      natsold=nats
      do 9100 k1=1,nats
      do 945 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 9100
 945  continue
      do 946 k2=1,nott
      if(k1.eq.notta(k2))go to 9100
 946  continue
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      if(ntetra.gt.0)call checkequivtcat2(xo)
      if(nott.gt.0)call checkequivocat2(xo)
 9100 continue
      return
      end
c----------------------------------------------------------------
      subroutine dainttocricat2a(icat1,jcod,xfix,xlin,ier)
      Use Polpo
      USE Atomi
      USE General
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/occtetra/it(500)
      common/superandom/iix,iiy,ntrial,irandom,sograndom
      common/stampa/istampa
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common /matr/rmz(3,3),rmiz(3,3)
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/ annealcat/ ncate,nzcat(500),iloccat(500,500),
     *xloccat(500,3,500),nloccat(500,3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common /derrig0/rr(3,3),rrt(3,3),rrf(3,3),rrp(3,3),derah(6,500),
     *       derbh(6,500)
      common /fastcal/ hkle(3000,4,24),fsca(9,3000)
      common/Gmatrix/ggMat(3,3)
****  common /atoms/ x(5,500),nz(500),idumx(21)
c     common /atoms/ x(5,500),nz(500),bfac(500),idumx(4001)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      dimension x11(4),x1(3),x2(3),xcri(3,500),
     *xortol(3,500),xfix(3)
      dimension amat(9,9),dmat(9),INDX(9),v(3,3)
      dimension aa(3,3),w(3),bb(3,3),ww(3,3),www(3)
      dimension ilocr(4),xcr(3,4),ang(3)
      dimension xz(3,50),x3(3),x4(3),x1t(3),xzr(3,50)
      dimension wr(4,4),xortet(4,10),rrr(3,3),xlin(3)
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
c
      ier=0
      do 200 i=1,6
      dmat(i)=0.0
      do 300 j=1,6
      amat(i,j)=0.0
 300  continue
 200  continue
      nch=1
      xor(1,nch)=xlin(1)                                     
      xor(2,nch)=xlin(2)                                     
      xor(3,nch)=xlin(3)                                     
      do 100 i=1,nzm
      x11(1)=0.0       
      x11(2)=0.0       
      x11(3)=0.0       
      j=iloc(i)
      if(j.le.nats)then
      x11(1)=xyzs(1,j)-xor(1,nch)
      x11(2)=xyzs(2,j)-xor(2,nch)
      x11(3)=xyzs(3,j)-xor(3,nch)
      endif
      if(i.eq.3)then
      x11(1)=xfix(1)-xor(1,nch)
      x11(2)=xfix(2)-xor(2,nch)
      x11(3)=xfix(3)-xor(3,nch)
      go to 99
      endif
      if(i.eq.5)then
      x11(1)=xlin(1)-xor(1,nch)
      x11(2)=xlin(2)-xor(2,nch)
      x11(3)=xlin(3)-xor(3,nch)
      endif
c     if(jcod.eq.2.and.i.eq.5)then
c     x11(1)=xt(1,nfound2(icat1),it(nfound2(icat1)))-xor(1,nch)
c     x11(2)=xt(2,nfound2(icat1),it(nfound2(icat1)))-xor(2,nch)
c     x11(3)=xt(3,nfound2(icat1),it(nfound2(icat1)))-xor(3,nch)
c     elseif(jcod.eq.1.and.i.eq.5)then
c     x11(1)=xt(1,nfound1(icat1),it(nfound1(icat1)))-xor(1,nch)
c     x11(2)=xt(2,nfound1(icat1),it(nfound1(icat1)))-xor(2,nch)
c     x11(3)=xt(3,nfound1(icat1),it(nfound1(icat1)))-xor(3,nch)
c     elseif(jcod.eq.3.and.i.eq.5)then
c     x11(1)=xt(1,nfound2(icat1),it(nfound2(icat1)))-xor(1,nch)
c     x11(2)=xt(2,nfound2(icat1),it(nfound2(icat1)))-xor(2,nch)
c     x11(3)=xt(3,nfound2(icat1),it(nfound2(icat1)))-xor(3,nch)
c     elseif(jcod.eq.3.and.i.eq.6)then
c     x11(1)=xt(1,nfound1(icat1),it(nfound1(icat1)))-xor(1,nch)
c     x11(2)=xt(2,nfound1(icat1),it(nfound1(icat1)))-xor(2,nch)
c     x11(3)=xt(3,nfound1(icat1),it(nfound1(icat1)))-xor(3,nch)
c     endif
 99   continue
      call molt1_rot(rmz, x11, x1)
      if(abs(x1(1)).lt.0.0001)x1(1)=0.0
      if(abs(x1(2)).lt.0.0001)x1(2)=0.0
      if(abs(x1(3)).lt.0.0001)x1(3)=0.0
      xorto(1,i)=x1(1)
      xorto(2,i)=x1(2)
      xorto(3,i)=x1(3)
 100  continue
c     a=cell(1)
c     b=cell(2)
c     c=cell(3)
c     alfa=cell(4)
c     beta=cell(5)
c     gamma=cell(6)
c     inv=0
c     call Orto_new(a, b, c, alfa, beta, gamma,inv)
c     inv=1
c     call Orto_new(a, b, c, alfa, beta, gamma,inv)
      nch=1
      il=iloc(nzm-1)
      xortol(1,nzm-1)=0.0
      xortol(2,nzm-1)=0.0
      xortol(3,nzm-1)=0.0
      xortol(1,nzm-2)=xloc(1,nzm-1)
      xortol(2,nzm-2)=0.0
      xortol(3,nzm-2)=0.0
      do 1000 k=1,nzm-3
      mmax=nzm-3
      xortol(1,k)=0.0
      xortol(2,k)=0.0
      xortol(3,k)=0.0
      do 1100 i=k,mmax
      w(1)=0.0
      w(2)=0.0
      w(3)=0.0
      j=nzm-3
      jrif=j
      fij=xloc(2,j+2)*dtor
      ppp=-1.0
      tij=ppp*(xloc(3,j+3))*dtor
      dij=xloc(1,i+1)
      aa(1,1)=-cos(fij)
      aa(1,2)=-sin(fij)
      aa(1,3)=0.0
      aa(2,1)=sin(fij)*cos(tij)
      aa(2,2)=-cos(fij)*cos(tij)
      aa(2,3)=sin(tij)
      aa(3,1)=-sin(fij)*sin(tij)
      aa(3,2)=cos(fij)*sin(tij)
      aa(3,3)=cos(tij)
      do 1200 j=nzm-4,i,-1
      fij=xloc(2,j+2)*dtor
      ppp=-1.0
      tij=ppp*(xloc(3,j+3))*dtor
      bb(1,1)=-cos(fij)
      bb(1,2)=-sin(fij)
      bb(1,3)=0.0
      bb(2,1)=sin(fij)*cos(tij)
      bb(2,2)=-cos(fij)*cos(tij)
      bb(2,3)=sin(tij)
      bb(3,1)=-sin(fij)*sin(tij)
      bb(3,2)=cos(fij)*sin(tij)
      bb(3,3)=cos(tij)
      call moltm(aa,bb,ww)
      do 1250 ik=1,3
      do 1260 jk=1,3
      aa(ik,jk)=ww(ik,jk)
 1260 continue
 1250 continue
 1200 continue
      www(1)=dij
      www(2)=0.0
      www(3)=0.0
      call moltv(aa,www,w)
      xortol(1,k)=xortol(1,k)+w(1)
      xortol(2,k)=xortol(2,k)+w(2)
      xortol(3,k)=xortol(3,k)+w(3)
 1100 continue
      xortol(1,k)=xortol(1,k)+xloc(1,nzm-1)
 1000 continue
 2500 continue
      dn=xloc(1,nzm)
      fn=(xloc(2,nzm)*dtor)-(pi/2.0)
      xortol(1,nzm)=-dn*sin(fn)      
      xortol(2,nzm)=dn*cos(fn)
      xortol(3,nzm)=0.0
      rr(1,1)=xorto(1,nzm-2)/xortol(1,nzm-2)
      rr(2,1)=xorto(2,nzm-2)/xortol(1,nzm-2)
      rr(3,1)=xorto(3,nzm-2)/xortol(1,nzm-2)
      rr(1,2)=(xorto(1,nzm)-rr(1,1)*xortol(1,nzm))/xortol(2,nzm)
      rr(2,2)=(xorto(2,nzm)-rr(2,1)*xortol(1,nzm))/xortol(2,nzm)
      rr(3,2)=(xorto(3,nzm)-rr(3,1)*xortol(1,nzm))/xortol(2,nzm)
      if(xortol(3,3).gt.-0.000001.and.xortol(3,3).lt.0.000001)then
      ier=-1
      return
      endif
      rr(1,3)=(xorto(1,3)-rr(1,1)*xortol(1,3)-
     *rr(1,2)*xortol(2,3))/xortol(3,3)
      rr(2,3)=(xorto(2,3)-rr(2,1)*xortol(1,3)-
     *rr(2,2)*xortol(2,3))/xortol(3,3)
      rr(3,3)=(xorto(3,3)-rr(3,1)*xortol(1,3)-
     *rr(3,2)*xortol(2,3))/xortol(3,3)
      do 700 j=1,nzm          
      i=iloc(j)
      x11(1)=xortol(1,j)
      x11(2)=xortol(2,j)
      x11(3)=xortol(3,j)
      call molt1_rot(rr, x11, x1)
      call molt1_rot(rmiz, x1, x2)
      x1(1)=x2(1)+xor(1,nch)
      x1(2)=x2(2)+xor(2,nch)
      x1(3)=x2(3)+xor(3,nch)
      xz(1,j)=x1(1)
      xz(2,j)=x1(2)
      xz(3,j)=x1(3)
 700  continue
      if(jcod.eq.1)then
      nrif=nfound2(icat1)
      elseif(jcod.eq.2)then
      nrif=nfound1(icat1)
      endif
      dd1=1.4
      dd2=1.9
      iyest=0
      iyeso=0
      do 111 j=1,ntetra
      if(nrif.eq.ntetr(j))then
      dd=dtetra(j)
      dd1=dtetra(j)*(1.0-dtolt(j))
      dd2=dtetra(j)*(1.0+dtolt(j))
      if(it(nrif).ge.1)iyest=1
      jrif=j
      go to 170
      endif
 111  continue
      do 101 j=1,nott
      if(nrif.eq.notta(j))then
      dd=dotta1(j)
      dd1=dotta1(j)*(1.0-dtolo(j))
      dd2=dotta1(j)*(1.0+dtolo(j))
      if(it(nrif).ge.1)iyeso=1
      jrif=j
      go to 170
      endif
 101  continue
 170  continue
      x1(1)=xz(1,1)
      x1(2)=xz(2,1)
      x1(3)=xz(3,1)
      x2(1)=xz(1,nzm)
      x2(2)=xz(2,nzm)
      x2(3)=xz(3,nzm)
      call distanza(ggMat,x1,x2,dcal)
c     if(dcal.lt.0.8*dd.or.dcal.gt.1.2*dd)then
c     if(dcal.lt.0.9*dd.or.dcal.gt.1.1*dd)then
CCCCCCCCCC
      if(iyest.gt.0.or.iyeso.gt.0)then
      x3(1)=xt(1,nrif,it(nrif))
      x3(2)=xt(2,nrif,it(nrif))
      x3(3)=xt(3,nrif,it(nrif))
      call angolo(ggMat,x1,x2,x3,angg)
      endif
      if(iyest.eq.1)then
      angsog1 = 109.47*(1.0-atolt(jrif))
      angsog2 = 109.47*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog1
      angsog22=angsog2
      elseif(iyeso.eq.1)then
      angsog1 = 90.00*(1.0-atolt(jrif))
      angsog2 = 90.00*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11 = 180.00*(1.0-atolt(jrif))
      angsog22 = 180.00*(1.0+atolt(jrif))
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
      elseif(iyeso.eq.0.and.iyest.eq.0)then
      angsog1=1.0
      angsog2=1.0
      angsog11=angsog1
      angsog22=angsog2
      angg=1.0
      endif
CCCCCCCCCCCC
c     if(dcal.lt.dd1.or.dcal.gt.dd2)then
      if((dcal.lt.dd1.or.dcal.gt.dd2).or
     *.((angg.lt.angsog1.or.angg.gt.angsog2)
     *.and.(angg.lt.angsog11.or.angg.gt.angsog22)))then
      nru=20
      angstep=18.0*dtor
      do 9000 jt=1,nru          
      x1(1)=xz(1,3)
      x1(2)=xz(2,3)
      x1(3)=xz(3,3)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      x1(1)=xz(1,4)
      x1(2)=xz(2,4)
      x1(3)=xz(3,4)
      call molt1_rot(rmz, x1, x2)
      xortet(1,2)=x2(1)
      xortet(2,2)=x2(2)
      xortet(3,2)=x2(3)
      kk0=2
      do 51 kl=1,2
      if(kl.eq.4.or.kl.eq.5)go to 51
      kk0=kk0+1
      x1(1)=xz(1,kl)
      x1(2)=xz(2,kl)
      x1(3)=xz(3,kl)
      call molt1_rot(rmz, x1, x2)
      xortet(1,kk0)=x2(1)
      xortet(2,kk0)=x2(2)
      xortet(3,kk0)=x2(3)
 51   continue
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      nmax=4
      do 10 ii=1,nmax
      do 20 j=1,nmax
      if(ii.le.4.and.j.le.4)wr(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtot(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtoti(ii,j)=0.0
 20   continue
 10   continue
      do ii=1,3
      x2(ii)=xortet(ii,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      angcal=float(jt-1)*angstep
      ierr=0
      call MatTott(x2,adif,bdif,cdif,ddif,angcal)
      call molt2_rott(rtoti, rtot, wr)
        kk0=0
        do ii=1,4
          xortet(4,ii)=1
         do j=1,4
           x11(j)=xortet(j,ii)
         end do
          call molt1_rott(wr, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
          kk0=kk0+1
          xzr(1,kk0)=x1(1)
          xzr(2,kk0)=x1(2)
          xzr(3,kk0)=x1(3)
        end do
      x1(1)=xzr(1,3)
      x1(2)=xzr(2,3)
      x1(3)=xzr(3,3)
      x2(1)=xz(1,nzm)
      x2(2)=xz(2,nzm)
      x2(3)=xz(3,nzm)
      call distanza(ggMat,x1,x2,dcal)
c     if(dcal.lt.dd1.or.dcal.gt.dd2)then
      if(dcal.gt.dd1.and.dcal.lt.dd2)then
      if(iyest.gt.0.or.iyeso.gt.0)then
      x3(1)=xt(1,nrif,it(nrif))
      x3(2)=xt(2,nrif,it(nrif))
      x3(3)=xt(3,nrif,it(nrif))
      call angolo(ggMat,x1,x2,x3,angg)
      endif
      if(iyest.eq.1)then
      angsog1 = 109.47*(1.0-atolt(jrif))
      angsog2 = 109.47*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      if(angg.gt.angsog1.and.angg.lt.angsog2)go to 9001
      elseif(iyeso.eq.1)then
      angsog1 = 90.00*(1.0-atolt(jrif))
      angsog2 = 90.00*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      if(angg.gt.angsog1.and.angg.lt.angsog2)go to 9001
      angsog1 = 180.00*(1.0-atolt(jrif))
      angsog2 = 180.00*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      if(angg.gt.angsog1.and.angg.lt.angsog2)go to 9001
      elseif(iyeso.eq.0.and.iyest.eq.0)then
      go to 9001
      endif
      endif
 9000 continue
      ier=-1
      return
 9001 continue
      xadd(1,1)=xzr(1,4)
      xadd(2,1)=xzr(2,4)
      xadd(3,1)=xzr(3,4)
      if(jcod.eq.2)then
      xadd(1,3)=xzr(1,1)
      xadd(2,3)=xzr(2,1)
      xadd(3,3)=xzr(3,1)
      xadd(1,2)=xzr(1,3)
      xadd(2,2)=xzr(2,3)
      xadd(3,2)=xzr(3,3)
      else
      xadd(1,2)=xzr(1,1)
      xadd(2,2)=xzr(2,1)
      xadd(3,2)=xzr(3,1)
      xadd(1,3)=xzr(1,3)
      xadd(2,3)=xzr(2,3)
      xadd(3,3)=xzr(3,3)
      endif
      else
      xadd(1,1)=xz(1,2)
      xadd(2,1)=xz(2,2)
      xadd(3,1)=xz(3,2)
      if(jcod.eq.2)then
      xadd(1,3)=xz(1,3)
      xadd(2,3)=xz(2,3)
      xadd(3,3)=xz(3,3)
      xadd(1,2)=xz(1,1)
      xadd(2,2)=xz(2,1)
      xadd(3,2)=xz(3,1)
      else
      xadd(1,2)=xz(1,3)
      xadd(2,2)=xz(2,3)
      xadd(3,2)=xz(3,3)
      xadd(1,3)=xz(1,1)
      xadd(2,3)=xz(2,1)
      xadd(3,3)=xz(3,1)
      endif
      endif
      do 3050 i=1,3
        iser=1
        iactn=1
        khead=0
        xo1(1) = xadd(1,i)
        xo1(2) = xadd(2,i)
        xo1(3) = xadd(3,i)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xadd(1,i)=xn(1)
        xadd(2,i)=xn(2)
        xadd(3,i)=xn(3)
 3050 continue
      return
      end
c -----------------------------------------------------------------
      subroutine loccat2b(i,natsold,
     *j1cod,j2cod,d1cod,d2cod,ier)            
      Use Polpo
      USE Atomi
      USE General
      USE drawatoms
      USE elements, only: pxen_from_specie,numelem
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common /matr1/ rx(3,3),ry(3,3),rz(3,3)
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common/savx/xsavx(3,500)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/occtetra/it(500)
      dimension ang(3),x1(3),x2(3),x3(3)
      dimension wr(4,4),xortet(4,6)
      dimension x11(4),x1t(3),xo(3),xad(3,10),xadsav(3,10)
      dimension xtet(4,4),xotta(4,6),ggstar(3,3)
      dimension xagg1(3,6),xagg2(3,6),xfix1(3),xfix2(3)
      dimension xlin(3,2),x4(3)
      dimension itake(500)
      character oo*2                             
c
      zero=1.0E-5
      ierr=0 
      dsogok=0.8
      psis=0.0
      phis=0.0
      thetas=0.0
      chimin=1.0E+10
      iloccat1=0
      ier=-1
      ierr=0
      oo(1:2)='o '
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      nkel = numelem(celem)
      do 150 j=1,nkel
!corr      if (kmiss(i).eq.nalf(j)) then
      if (kmiss(i) == celem(j)%ptab) then
          nzc=j
          nzSavc = j*100+1
          vetintsavc = nzSavc+j
          go to 160
      endif
  150 continue
  160 continue
      do 200 j=1,nkel
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nza=j
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          go to 203
      endif
  200 continue
  203 continue
      nats=natsold
      if(imiss(i).eq.1)then
      iadd=5                 
      else
      iadd=7               
      endif
      xyzs(1,nats+1)=0.0
      xyzs(2,nats+1)=0.0
      xyzs(3,nats+1)=0.0
      xyzs(4,nats+1)=vetintsavc
      nz(nats+1)=nzSavc
      do 61 kkk=2,iadd
      xyzs(1,nats+kkk)=0.0
      xyzs(2,nats+kkk)=0.0
      xyzs(3,nats+kkk)=0.0
      xyzs(4,nats+kkk)=vetintsav
      nz(nats+kkk)=nzSavv
  61  continue
      nagg1=0
      nagg2=0
      do 59 jcod=1,2
      if(jcod.eq.2)then
      jj=nfound2(i)
      dloc=d2cod
      if(j2cod.eq.1)then
      ndif=4-it(jj)
      alfaloc=109.47*dtor
      else
      ndif=6-it(jj)
      alfaloc=90.0*dtor
      endif
      else
      jj=nfound1(i)
      dloc=d1cod
      if(j1cod.eq.1)then
      ndif=4-it(jj)
      alfaloc=109.47*dtor
      else
      ndif=6-it(jj)
      alfaloc=90.0*dtor
      endif
      endif
      iott180=0
      if(jcod.eq.1)then
      do 65 kkk=1,it(jj)
      xagg1(1,kkk)=xt(1,jj,kkk)
      xagg1(2,kkk)=xt(2,jj,kkk)
      xagg1(3,kkk)=xt(3,jj,kkk)
 65   continue
      else
      do 66 kkk=1,it(jj)
      xagg2(1,kkk)=xt(1,jj,kkk)
      xagg2(2,kkk)=xt(2,jj,kkk)
      xagg2(3,kkk)=xt(3,jj,kkk)
 66   continue
      endif
      if(j1cod.eq.2.or.j2cod.eq.2)then
      jk0=2
      x1(1)=xt(1,jj,it(jj))
      x1(2)=xt(2,jj,it(jj))
      x1(3)=xt(3,jj,it(jj))
      x2(1)=xyzs(1,jj)
      x2(2)=xyzs(2,jj)
      x2(3)=xyzs(3,jj)
      x3(1)=xt(1,jj,it(jj)-1)
      x3(2)=xt(2,jj,it(jj)-1)
      x3(3)=xt(3,jj,it(jj)-1)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      endif
      jk0=it(jj)-1
      do 111 k=1,ndif
      iok=0
 295  continue
      if(iott180.eq.1)then
      x1(1)=xt(1,jj,jk0)-xyzs(1,jj)
      x1(2)=xt(2,jj,jk0)-xyzs(2,jj)
      x1(3)=xt(3,jj,jk0)-xyzs(3,jj)
      else
      x1(1)=xt(1,jj,jk0+k-1)-xyzs(1,jj)
      x1(2)=xt(2,jj,jk0+k-1)-xyzs(2,jj)
      x1(3)=xt(3,jj,jk0+k-1)-xyzs(3,jj)
      endif
      call molt1_rot(rmz, x1, x2)
      x1(1)=xt(1,jj,jk0+k)-xyzs(1,jj)
      x1(2)=xt(2,jj,jk0+k)-xyzs(2,jj)
      x1(3)=xt(3,jj,jk0+k)-xyzs(3,jj)
      call molt1_rot(rmz, x1, x3)
      iarret=0
      call generat2(x2,x3,dloc,alfaloc,x1,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x1, xo)
      do 519 ijk=1,it(jj)+k-1
      x1(1)=xo(1)+xyzs(1,jj)
      x1(2)=xo(2)+xyzs(2,jj)
      x1(3)=xo(3)+xyzs(3,jj)
      x2(1)=xt(1,jj,ijk)
      x2(2)=xt(2,jj,ijk)
      x2(3)=xt(3,jj,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  295
      endif
      endif
 519  continue
      x1(1)=xo(1)+xyzs(1,jj)
      x1(2)=xo(2)+xyzs(2,jj)
      x1(3)=xo(3)+xyzs(3,jj)
      xt(1,jj,jk0+k+1)=x1(1)    
      xt(2,jj,jk0+k+1)=x1(2)    
      xt(3,jj,jk0+k+1)=x1(3)    
      if(jcod.eq.1)then
      nagg1=nagg1+1
      xagg1(1,it(jj)+nagg1)=x1(1)
      xagg1(2,it(jj)+nagg1)=x1(2)
      xagg1(3,it(jj)+nagg1)=x1(3)
      else
      nagg2=nagg2+1
      xagg2(1,it(jj)+nagg2)=x1(1)
      xagg2(2,it(jj)+nagg2)=x1(2)
      xagg2(3,it(jj)+nagg2)=x1(3)
      endif
 111  continue
      if(jcod.eq.1)then
      nagg1=nagg1+it(jj)
      else
      nagg2=nagg2+it(jj)
      endif
  59  continue
c     do 9998 iijj1=1,nagg1
      do 9998 iijj1=it(jj)+1,nagg1
      nats=natsold
      xfix1(1)=xagg1(1,iijj1)
      xfix1(2)=xagg1(2,iijj1)
      xfix1(3)=xagg1(3,iijj1)
      do 9999 iijj2=1,nagg2
c     do 9999 iijj2=it(jj)+1,nagg2
      nats=natsold
      xfix2(1)=xagg2(1,iijj2)
      xfix2(2)=xagg2(2,iijj2)
      xfix2(3)=xagg2(3,iijj2)
      jcod=2
      x1(1)=xfix1(1)
      x1(2)=xfix1(2)
      x1(3)=xfix1(3)
      x2(1)=xfix2(1)
      x2(2)=xfix2(2)
      x2(3)=xfix2(3)
      call distanza(ggMat,x1,x2,dcal)
      if(imiss(i).eq.1)then
c     dcat=2.0*dmiss(i)*sin(109.5*dtor*0.5)
      dcat0=dcal/(2.0*sin(109.5*dtor*0.5))
c     dcat0=dcat0*1.02
      else
c     dcat1=2.0*dmiss(i)*sin(90.0*dtor)
c     dcat2=2.0*dmiss(i)*sin(180.0*dtor)
c     dcat=amin1(dcat1,dcat2)
      dcat01=dcal/(2.0*sin(90.0*dtor*0.5))
      dcat02=dcal/(2.0*sin(180.0*dtor*0.5))
      dcat0=amax1(dcat01,dcat02)
c     dcat0=dcat0*1.02
      endif
      if(dcat0.gt.dmiss(i)*(1.0+dtolm(i)))go to 9999
      xadd(1,2)=xfix1(1)
      xadd(2,2)=xfix1(2)
      xadd(3,2)=xfix1(3)
      xadd(1,3)=xfix2(1)
      xadd(2,3)=xfix2(2)
      xadd(3,3)=xfix2(3)
      if(imiss(i).eq.1)then
      n6=1
      else
      n6=2
      endif
      do 6000 k6=1,n6
      x1(1)=xfix2(1)-xfix1(1)
      x1(2)=xfix2(2)-xfix1(2)
      x1(3)=xfix2(3)-xfix1(3)
      call molt1_rot(rmz, x1, x2)
      dis=sqrt(x2(3)**2+x2(2)**2)
      if(abs(dis).lt.0.001)go to 6000
      tet=acos(x2(2)/dis)
      coss=x2(2)/dis
      sinn=x2(3)/dis
      do 89 k=1,2
      call MatRx(tet)
      do j=1,3
       x11(j)=x2(j)
      end do
      call molt1_rot(rx, x11, x4)
c     if(imiss(i).eq.1)then
c     d1=dcat0 
c     d2=dcat0 
c     else
c     if(k6.eq.1)then
c     d1=dcat1 
c     d2=dcat1 
c     else
c     d1=dcat2 
c     d2=dcat2 
c     endif
c     endif
      d1=dcat0 
      d2=dcat0 
      if(abs(x4(3)).gt.zero)then
      tet=-tet
      else
      go to 90
      endif
 89   continue
 90   continue
      ier=0
      ii1=0
      ii2=0
      call genera0(ii1,ii2,x4,d1,d2,x3,iok,ier)
      if (ier.eq.-1) return
      tet=-tet
      call MatRx(tet)
      do j=1,3
        x11(j)=x3(j)
      end do
      call molt1_rot(rx, x11, x3)
      call molt1_rot(rmiz, x3, xo)
      x2(1)=xo(1)+xfix1(1)
      x2(2)=xo(2)+xfix1(2)
      x2(3)=xo(3)+xfix1(3)
      xadd(1,1)=x2(1)
      xadd(2,1)=x2(2)
      xadd(3,1)=x2(3)
      ntrialr=20
      do 1000 jt=1,ntrialr
      x1(1)=xfix1(1)
      x1(2)=xfix1(2)
      x1(3)=xfix1(3)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      x1(1)=xfix2(1)
      x1(2)=xfix2(2)
      x1(3)=xfix2(3)
      call molt1_rot(rmz, x1, x2)
      xortet(1,2)=x2(1)
      xortet(2,2)=x2(2)
      xortet(3,2)=x2(3)
      kk0=3
      x1(1)=xadd(1,1)              
      x1(2)=xadd(2,1)              
      x1(3)=xadd(3,1)              
      call molt1_rot(rmz, x1, x2)
      xortet(1,kk0)=x2(1)
      xortet(2,kk0)=x2(2)
      xortet(3,kk0)=x2(3)
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      nmax=4
      do 10 ii=1,nmax
      do 20 j=1,nmax
      if(ii.le.4.and.j.le.4)wr(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtot(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtoti(ii,j)=0.0
 20   continue
 10   continue
      do ii=1,3
      x2(ii)=xortet(ii,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      angcal=twopi*yfl
      ierr=0
      call MatTott(x2,adif,bdif,cdif,ddif,angcal)
      call molt2_rott(rtoti, rtot, wr)
        kk0=0
        do ii=1,3
          xortet(4,ii)=1
         do j=1,4
           x11(j)=xortet(j,ii)
         end do
          call molt1_rott(wr, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
          if(ii.eq.3)then
          xadd(1,1)=x1(1)
          xadd(2,1)=x1(2)
          xadd(3,1)=x1(3)
          endif
        end do
c     ntrial=ntrial+1
 8900 continue
      dsogc=2.0
      x1(1)=xyzs(1,nfound1(i))         
      x1(2)=xyzs(2,nfound1(i))         
      x1(3)=xyzs(3,nfound1(i))         
      x2(1)=xadd(1,1)        
      x2(2)=xadd(2,1)        
      x2(3)=xadd(3,1)        
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 5000
      endif
      x1(1)=xyzs(1,nfound2(i))         
      x1(2)=xyzs(2,nfound2(i))         
      x1(3)=xyzs(3,nfound2(i))         
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 5000
      endif
c     xyzs(1,natsold+1)=xadd(1,1)
c     xyzs(2,natsold+1)=xadd(2,1)
c     xyzs(3,natsold+1)=xadd(3,1)
c     xyzs(1,natsold+2)=xadd(1,2)
c     xyzs(2,natsold+2)=xadd(2,2)
c     xyzs(3,natsold+2)=xadd(3,2)
c     xyzs(1,natsold+3)=xadd(1,3)
c     xyzs(2,natsold+3)=xadd(2,3)
c     xyzs(3,natsold+3)=xadd(3,3)
      nadd=0
      do 5122 iik=1,natsold
      itake(iik)=0
 5122 continue
      do 5102 iik=1,natsold
      x1(1)=xyzs(1,iik)         
      x1(2)=xyzs(2,iik)         
      x1(3)=xyzs(3,iik)         
      x2(1)=xadd(1,2)
      x2(2)=xadd(2,2)
      x2(3)=xadd(3,2)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.0.00001)then
      itake(iik)=1
      nadd=nadd+1
      go to 5003
      endif
 5102 continue
      xyzs(1,natsold+2-nadd)=xadd(1,2)
      xyzs(2,natsold+2-nadd)=xadd(2,2)
      xyzs(3,natsold+2-nadd)=xadd(3,2)
 5003 continue
      do 5004 iik=1,natsold
      x1(1)=xyzs(1,iik)         
      x1(2)=xyzs(2,iik)         
      x1(3)=xyzs(3,iik)         
      x2(1)=xadd(1,3)
      x2(2)=xadd(2,3)
      x2(3)=xadd(3,3)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.0.00001)then
      itake(iik)=1
      nadd=nadd+1
      go to 5005
      endif
 5004 continue
      xyzs(1,natsold+3-nadd)=xadd(1,3)
      xyzs(2,natsold+3-nadd)=xadd(2,3)
      xyzs(3,natsold+3-nadd)=xadd(3,3)
 5005 continue
      xyzs(1,natsold+1)=xadd(1,1)
      xyzs(2,natsold+1)=xadd(2,1)
      xyzs(3,natsold+1)=xadd(3,1)
      d1=dmiss(i)
      iok=0
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      else
      alfa=90.0*dtor
      endif
      kadd=0
CANGE if(i.gt.1)then
      do 841 k1=1,natsold+3-nadd
      if(itake(k1).eq.1)go to 841
      do 845 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 841
 845  continue
      do 846 k2=1,nott
      if(k1.eq.notta(k2))go to 841
 846  continue
      if(imiss(i).eq.1)then
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivtcat(xo,i,natsold,kadd,xad,k1)
      if (kadd.gt.0)then
      do 866 k3=1,kadd
      xadd(1,3+k3)=xad(1,k3)
      xadd(2,3+k3)=xad(2,k3)
      xadd(3,3+k3)=xad(3,k3)
 866  continue
      endif
      else
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivocat(xo,i,natsold,kadd,xad,k1)
      if (kadd.gt.0)then
      do 876 k3=1,kadd
      xadd(1,3+k3)=xad(1,k3)
      xadd(2,3+k3)=xad(2,k3)
      xadd(3,3+k3)=xad(3,k3)
 876  continue
      endif
      endif
 841  continue
CANGE endif
      d1=dmiss(i)
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      kadd=min0(2,kadd)
      natsadd=5-kadd-nadd
      else
      alfa=90.0*dtor
      kadd=min0(4,kadd)
      natsadd=7-kadd-nadd
      endif
      ndiff=natsadd-(3-nadd)
      ik0=0
      ic1=2+kadd
      if(imiss(i).eq.1)then
c     xtet(1,1)=xyzs(1,natsold+2)
c     xtet(2,1)=xyzs(2,natsold+2)
c     xtet(3,1)=xyzs(3,natsold+2)
c     xtet(1,2)=xyzs(1,natsold+3)
c     xtet(2,2)=xyzs(2,natsold+3)
c     xtet(3,2)=xyzs(3,natsold+3)
      xtet(1,1)=xadd(1,2)
      xtet(2,1)=xadd(2,2)
      xtet(3,1)=xadd(3,2)
      xtet(1,2)=xadd(1,3)
      xtet(2,2)=xadd(2,3)
      xtet(3,2)=xadd(3,3)
      if(kadd.gt.0)then
      do 2222 il=1,kadd
      xtet(1,2+il)=xad(1,il)
      xtet(2,2+il)=xad(2,il)
      xtet(3,2+il)=xad(3,il)
 2222 continue
      endif
      else
c     xotta(1,1)=xyzs(1,natsold+2)
c     xotta(2,1)=xyzs(2,natsold+2)
c     xotta(3,1)=xyzs(3,natsold+2)
c     xotta(1,2)=xyzs(1,natsold+3)
c     xotta(2,2)=xyzs(2,natsold+3)
c     xotta(3,2)=xyzs(3,natsold+3)
      xotta(1,1)=xadd(1,2)
      xotta(2,1)=xadd(2,2)
      xotta(3,1)=xadd(3,2)
      xotta(1,2)=xadd(1,3)
      xotta(2,2)=xadd(2,3)
      xotta(3,2)=xadd(3,3)
      if(kadd.gt.0)then
      do 2223 il=1,kadd
      xotta(1,2+il)=xad(1,il)
      xotta(2,2+il)=xad(2,il)
      xotta(3,2+il)=xad(3,il)
 2223 continue
      endif
      endif
      iott180=0
      jk0=2
c     x1(1)=xyzs(1,natsold+jk0)
c     x1(2)=xyzs(2,natsold+jk0)
c     x1(3)=xyzs(3,natsold+jk0)
c     x2(1)=xyzs(1,natsold+1)
c     x2(2)=xyzs(2,natsold+1)
c     x2(3)=xyzs(3,natsold+1)
c     x3(1)=xyzs(1,natsold+jk0+1)
c     x3(2)=xyzs(2,natsold+jk0+1)
c     x3(3)=xyzs(3,natsold+jk0+1)
      x1(1)=xadd(1,2)
      x1(2)=xadd(2,2)
      x1(3)=xadd(3,2)
      x2(1)=xadd(1,1)
      x2(2)=xadd(2,1)
      x2(3)=xadd(3,1)
      x3(1)=xadd(1,3)
      x3(2)=xadd(2,3)
      x3(3)=xadd(3,3)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      do 861 ik=1,ndiff
      if(ik0.gt.0)then
      ik0=ik0-1
      go to 861
      endif
      jk=ik+1-kadd
      iok=0
 293  continue
      if(iott180.eq.1)then
      x1(1)=xadd(1,2)-xadd(1,1)
      x1(2)=xadd(2,2)-xadd(2,1)
      x1(3)=xadd(3,2)-xadd(3,1)
      else
      x1(1)=xadd(1,jk)-xadd(1,1)
      x1(2)=xadd(2,jk)-xadd(2,1)
      x1(3)=xadd(3,jk)-xadd(3,1)
      endif
      call molt1_rot(rmz, x1, x2)
      x1(1)=xadd(1,jk+1)-xadd(1,1)
      x1(2)=xadd(2,jk+1)-xadd(2,1)
      x1(3)=xadd(3,jk+1)-xadd(3,1)
      call molt1_rot(rmz, x1, x3)
      iarret=0
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if(iarret.lt.0)go to 5000
      call molt1_rot(rmiz, x1, xo)
      if(iok.eq.0)then
c     do 559 ijk=2,jk+1   
      do 559 ijk=1,jk+1   
      x1(1)=xo(1)+xadd(1,1)
      x1(2)=xo(2)+xadd(2,1)
      x1(3)=xo(3)+xadd(3,1)
      x2(1)=xadd(1,ijk)
      x2(2)=xadd(2,ijk)
      x2(3)=xadd(3,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      endif
      endif
 559  continue
      endif
      xyzs(1,natsold+jk+2-nadd-kadd)=xo(1)+xyzs(1,natsold+1)
      xyzs(2,natsold+jk+2-nadd-kadd)=xo(2)+xyzs(2,natsold+1)
      xyzs(3,natsold+jk+2-nadd-kadd)=xo(3)+xyzs(3,natsold+1)
      xadd(1,jk+2)=xo(1)+xyzs(1,natsold+1)
      xadd(2,jk+2)=xo(2)+xyzs(2,natsold+1)
      xadd(3,jk+2)=xo(3)+xyzs(3,natsold+1)
      xo(1)=xyzs(1,natsold+jk+2-nadd-kadd)
      xo(2)=xyzs(2,natsold+jk+2-nadd-kadd)
      xo(3)=xyzs(3,natsold+jk+2-nadd-kadd)
      i1=natsold+1
      ic1=ic1+1
      if(imiss(i).eq.1)then
      xtet(1,ic1)=xyzs(1,natsold+jk+2-nadd-kadd)
      xtet(2,ic1)=xyzs(2,natsold+jk+2-nadd-kadd)
      xtet(3,ic1)=xyzs(3,natsold+jk+2-nadd-kadd)
      else
      xotta(1,ic1)=xyzs(1,natsold+jk+2-nadd-kadd)
      xotta(2,ic1)=xyzs(2,natsold+jk+2-nadd-kadd)
      xotta(3,ic1)=xyzs(3,natsold+jk+2-nadd-kadd)
      endif
      ic1sav=ic1
      if(imiss(i).eq.1.and.ic1.lt.4)then
      call checkequivtt2(xo,i,i1,ic1,ic1sav,xtet)
      xyzs(1,natsold+jk+2-nadd-kadd)=xtet(1,ic1sav)               
      xyzs(2,natsold+jk+2-nadd-kadd)=xtet(2,ic1sav)               
      xyzs(3,natsold+jk+2-nadd-kadd)=xtet(3,ic1sav)               
      xadd(1,jk+2)=xtet(1,ic1sav)               
      xadd(2,jk+2)=xtet(2,ic1sav)               
      xadd(3,jk+2)=xtet(3,ic1sav)               
      if(ic1.gt.ic1sav.and.ic1.le.4)then
      iok=0
      do 862 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0-nadd-kadd)=xtet(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0-nadd-kadd)=xtet(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0-nadd-kadd)=xtet(3,ic1sav+iik0)               
      xadd(1,jk+2+iik0)=xtet(1,ic1sav+iik0)               
      xadd(2,jk+2+iik0)=xtet(2,ic1sav+iik0)               
      xadd(3,jk+2+iik0)=xtet(3,ic1sav+iik0)               
      ik0=ik0+1
 862  continue
      endif
      elseif(imiss(i).eq.2.and.ic1.lt.6)then
      call checkequivoo2(xo,i,i1,ic1,ic1sav,xotta)
      xyzs(1,natsold+jk+2-kadd)=xotta(1,ic1sav)               
      xyzs(2,natsold+jk+2-kadd)=xotta(2,ic1sav)               
      xyzs(3,natsold+jk+2-kadd)=xotta(3,ic1sav)               
      xadd(1,jk+2)=xotta(1,ic1sav)               
      xadd(2,jk+2)=xotta(2,ic1sav)               
      xadd(3,jk+2)=xotta(3,ic1sav)               
      if(ic1.gt.ic1sav.and.ic1.le.6)then
      iok=0
      do 863 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0-kadd)=xotta(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0-kadd)=xotta(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0-kadd)=xotta(3,ic1sav+iik0)               
      xadd(1,jk+2+iik0)=xotta(1,ic1sav+iik0)               
      xadd(2,jk+2+iik0)=xotta(2,ic1sav+iik0)               
      xadd(3,jk+2+iik0)=xotta(3,ic1sav+iik0)               
      ik0=ik0+1
 863  continue
      endif
      endif
 861  continue
      dsog=0.6
c     dsog=1.2
  910 continue
      nats=natsold+natsadd
      do 8910 ijk=natsold+1,natsold+natsadd                 
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
      do 8920 ijk0=1,natsold                
      x1(1)=xyzs(1,ijk0)
      x1(2)=xyzs(2,ijk0)
      x1(3)=xyzs(3,ijk0)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
      nats=natsold
      ierr=-1
      go to 5000
      endif
 8920 continue
 8910 continue
      ier=0
      iloccat1=1
      nzmax=-9999999
      do 120 ii=1,nats
      if (nz(ii).ne.0) then
      nzz=iabs(nz(ii))/100
      if (nzz.gt.nzmax) nzmax=nzz
      endif
  120 continue
      do 121 il=1,nats
      if (nz(il).eq.0) go to 121
      nzz=iabs(nz(il))/100
      if (nzz.lt.nzmax)then
      zrap=float(nzmax)/float(nzz)
      bfac(il)=zrap*biso
      zrap=zrap**2
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      else
      bfac(il)=0.9*biso
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      endif
 121  continue
      iprier=0
      call calcolaerre(chi2,iprier)
c     call to_coord(1)
      if(chi2.lt.chimin)then
c     kdirect=0
c     interp=0
c     iniat = 1
c     call MakeLab(iniat,nats)
c     call to_coord(1)
c     call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
CCCCC if(chi2.lt.chimin)then
      natssav=natsold+natsadd
      natsaddsav=natsadd
      kaddsav=kadd
      do 5001 jk=1,kadd
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
 5001 continue
      do 5200 jk=natsold+1,natsold+natsadd
      xsavx(1,jk)=xyzs(1,jk)
      xsavx(2,jk)=xyzs(2,jk)
      xsavx(3,jk)=xyzs(3,jk)
 5200 continue
      nzmsav=nzm
      do 5201 jk=1,nzmsav
      ilocsav(jk)=iloc(jk)
      xlocsav(1,jk)=xloc(1,jk)
      xlocsav(2,jk)=xloc(2,jk)
      xlocsav(3,jk)=xloc(3,jk)
      nlocsav(1,jk)=nloc(1,jk)
      nlocsav(2,jk)=nloc(2,jk)
      nlocsav(3,jk)=nloc(3,jk)
 5201 continue
      ntrialsav=ntrial
      chimin=chi2
      endif
c     nats=natsold
 5000 continue
 1000 continue
 6000 continue
 5002 continue
 9999 continue
 9998 continue
      if(iloccat1.eq.0)ier=-1
      if(ier.lt.0)return
      do 5300 k=natsold+1,natssav                
      xyzs(1,k)=xsavx(1,k)
      xyzs(2,k)=xsavx(2,k)
      xyzs(3,k)=xsavx(3,k)
 5300 continue
      call intcoordd(ier)
      if(ier.lt.0)return
      if(istampa.gt.0)then
      write(lo,'(/,a,i6,a)')' ***** Selected Z-matrix description *****'
      write(lo,'(a)')'                                                 '
      write(lo,'(a,a)')' atom nr.  type  nr.       dist          ang',
     *'          tors '
      do 800 ii=1,nzm
      if(nlocsav(1,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4)')
     *ilocsav(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),
     *ii,nlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.1.and.nlocsav(2,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4,f10.3)')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii)
      elseif(nlocsav(1,ii).eq.2.and.nlocsav(3,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,2(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii)
      else
      write(lo,'(i4,8x,a2,i4,3(i4,f10.3))')
     *ilocsav(ii),celem(iabs(nz(ilocsav(ii))/100))%lab(1:2),ii,
     *nlocsav(1,ii),xlocsav(1,ii),
     *nlocsav(2,ii),xlocsav(2,ii),
     *nlocsav(3,ii),xlocsav(3,ii)
      endif
 800  continue
      write(lo,'(a)')'                                                 '
      write(lo,'(a,/)')'  *********************************************'
      kt=nfound1(i)
      write(lo,'(a,3f10.3)')' input cation #1',(xyzs(kp,kt),kp=1,3)
      kt=nfound2(i)
      write(lo,'(a,3f10.3)')' input cation #2',(xyzs(kp,kt),kp=1,3)
      write(lo,'(a,3f10.3)')' located cation',
     *(xyzs(kp,natsold+1),kp=1,3)
      do 5022 jk=natsold+2,natsold+natsaddsav
      write(lo,'(a,3f10.3)')' located anion',(xyzs(kp,jk),kp=1,3)
 5022 continue
      write(lo,'(/,a,f10.3,a,i7)')' Minimum fom:',chimin,
     *' trial #',ntrial
      endif
      nats=natsold+natsaddsav
      kdirect=1
      kdirectsav=3
      interp=0
      iniat = 1
      call MakeLab(iniat,nats)
      call to_coord(1)
      call frm15e(nats,interp)
      rfac=chimin
      jpol=0
      kdirectsav=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      nats=natsold
      nats=natssav               
      do 550 k=natsold+1,natssav             
      xo(1)=xyzs(1,k)
      xo(2)=xyzs(2,k)
      xo(3)=xyzs(3,k)
      call checkequiv(xo)
      xyzs(1,k)=xo(1)
      xyzs(2,k)=xo(2)
      xyzs(3,k)=xo(3)
 550  continue
      j1=nfound1(i)
      it(j1)=it(j1)+1
      xt(1,j1,it(j1))=xyzs(1,natsold+2)
      xt(2,j1,it(j1))=xyzs(2,natsold+2)
      xt(3,j1,it(j1))=xyzs(3,natsold+2)
      ntt(j1,it(j1))=natsold+2
      j2=nfound2(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xyzs(1,natsold+3)
      xt(2,j2,it(j2))=xyzs(2,natsold+3)
      xt(3,j2,it(j2))=xyzs(3,natsold+3)
      ntt(j2,it(j2))=natsold+3
      j3=natsold+1
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+2)
      xt(2,j3,it(j3))=xyzs(2,natsold+2)
      xt(3,j3,it(j3))=xyzs(3,natsold+2)
      ntt(j3,it(j3))=natsold+2
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+3)
      xt(2,j3,it(j3))=xyzs(2,natsold+3)
      xt(3,j3,it(j3))=xyzs(3,natsold+3)
      ntt(j3,it(j3))=natsold+3
      kadd=kaddsav
      ndif=nats-natsold-3
c     do 811 il=1,ndif
c     do 811 il=1,kadd
c     it(j3)=it(j3)+1
c     xt(1,j3,it(j3))=xyzs(1,natsold+3+il)
c     xt(2,j3,it(j3))=xyzs(2,natsold+3+il)
c     xt(3,j3,it(j3))=xyzs(3,natsold+3+il)
c     xt(1,j3,it(j3))=xadd(1,il)
c     xt(2,j3,it(j3))=xadd(2,il)
c     xt(3,j3,it(j3))=xadd(3,il)
c     ntt(j3,it(j3))=natsold+3+il
c811  continue
      if(imiss(i).eq.1)then
      itet=1
      ntetra=ntetra+1
      ntetr(ntetra)=natsold+1
      dtetra(ntetra)=dmiss(i)
      dtolt(ntetra)=dtolm(i)
      atolt(ntetra)=atolm(i)
      ktetra(ntetra)=kmiss(i)
      elseif(imiss(i).eq.2)then
      iott=1
      nott=nott+1
      notta(nott)=natsold+1
      dotta1(nott)=dmiss(i)
      dtolo(nott)=dtolm(i)
      atolo(nott)=atolm(i)
      kotta(nott)=kmiss(i)
      endif
      natmis(1,i)=natsold+1
      natmis(2,i)=natsold+2
      natmis(3,i)=natsold+3
      natsold=nats
      do 9100 k1=1,nats
      do 945 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 9100
 945  continue
      do 946 k2=1,nott
      if(k1.eq.notta(k2))go to 9100
 946  continue
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      if(ntetra.gt.0)call checkequivtcat2(xo)
      if(nott.gt.0)call checkequivocat2(xo)
 9100 continue
      return
      end
c----------------------------------------------------------------
      SUBROUTINE GAUSSJ2(A,N,NP,B,M,MP,ising)
      PARAMETER (NMAX=3006)
C     PARAMETER (NMAX=50)
      DIMENSION A(NP,NP),B(NP,MP),IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
c               PAUSE 'Singular matrix'
                ising=-1
                return
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
c       IF (A(ICOL,ICOL).EQ.0.) PAUSE 'Singular matrix.'
        IF (A(ICOL,ICOL).EQ.0.)then
        ising=-1
        return
        endif
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=1.
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=0.
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine loccat3a(i,natsold,jcod,
     *j1cod,j2cod,d1cod,d2cod,ier)
      Use Polpo
      USE Atomi
      USE General
      USE Conteggi, only:npunti
      USE drawatoms
      USE elements, only: pxen_from_specie,numelem
!corr      include 'rando.fi'
      USE randofi
      common/stampa/istampa
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      common/Gmatrix/ggMat(3,3)
      common /matr/rmz(3,3),rmiz(3,3)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common/savx/xsavx(3,500)
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/occtetra/it(500)
      dimension ang(3),x1(3),x2(3),x3(3)
      dimension wr(4,4),xortet(4,6),ggstar(3,3)
      dimension x11(4),x1t(3),xo(3),xad(3,10),xadsav(3,10)
      dimension xtet(4,4),xotta(4,6),xag(3,10),xfix(3),xlin(3)
      dimension itake(500)
      character oo*2                             
      character Buffer*80
c
      ierr=0 
      dsogok=0.8
      psis=0.0
      phis=0.0
      thetas=0.0
      chimin=1.0E+10
      iloccat1=0
      ntrialcat = 0
      ier=-1
      ierr=0
      oo(1:2)='o '
      nkel = numelem(celem)
!corr      read(oo,'(a2)') llinka
      llinka = pxen_from_specie(oo)
      do 150 j=1,nkel
!corr      if (kmiss(i).eq.nalf(j)) then
      if (kmiss(i) == celem(j)%ptab) then
          nzc=j
          nzSavc = j*100+1
          vetintsavc = nzSavc+j
          go to 160
      endif
  150 continue
  160 continue
      do 200 j=1,nkel
!corr      if (llinka.eq.nalf(j)) then
      if (llinka == celem(j)%ptab) then
          nza=j
          nzSavv = j*100+1
          vetintsav = nzSavv+j
          go to 203
      endif
  200 continue
  203 continue
      if(jcod.eq.2)then
      j=nfound2(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound2(i),it(nfound2(i)))
      x2(2)=xt(2,nfound2(i),it(nfound2(i)))
      x2(3)=xt(3,nfound2(i),it(nfound2(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      d=dcal
      j=nfound1(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound2(i),it(nfound2(i)))
      x2(2)=xt(2,nfound2(i),it(nfound2(i)))
      x2(3)=xt(3,nfound2(i),it(nfound2(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      dd=dcal
      else
      j=nfound1(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound1(i),it(nfound1(i)))
      x2(2)=xt(2,nfound1(i),it(nfound1(i)))
      x2(3)=xt(3,nfound1(i),it(nfound1(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      d=dcal
      j=nfound2(i)
      x1(1)=xyzs(1,j)
      x1(2)=xyzs(2,j)
      x1(3)=xyzs(3,j)                           
      x2(1)=xt(1,nfound1(i),it(nfound1(i)))
      x2(2)=xt(2,nfound1(i),it(nfound1(i)))
      x2(3)=xt(3,nfound1(i),it(nfound1(i)))                           
      call distanza(ggMat,x1,x2,dcal)
      dd=dcal
      endif
      nats=natsold
      if(imiss(i).eq.1)then
      iadd=5                 
      else
      iadd=7               
      endif
      xyzs(1,nats+1)=0.0
      xyzs(2,nats+1)=0.0
      xyzs(3,nats+1)=0.0
      xyzs(4,nats+1)=vetintsavc
      nz(nats+1)=nzSavc
      do 61 kkk=2,iadd
      xyzs(1,nats+kkk)=0.0
      xyzs(2,nats+kkk)=0.0
      xyzs(3,nats+kkk)=0.0
      xyzs(4,nats+kkk)=vetintsav
      nz(nats+kkk)=nzSavv
  61  continue
      if(jcod.eq.2)then
      jj=nfound2(i)
      dloc=d2cod
      if(abs(dloc).lt.0.0001)then
      aa=1.0
      endif
      if(j2cod.eq.1)then
      ndif=4-it(jj)
      alfaloc=109.47*dtor
      else
      ndif=6-it(jj)
      alfaloc=90.0*dtor
      endif
      else
      jj=nfound1(i)
      dloc=d1cod
      if(j1cod.eq.1)then
      ndif=4-it(jj)
      alfaloc=109.47*dtor
      else
      ndif=6-it(jj)
      alfaloc=90.0*dtor
      endif
      endif
      iott180=0
      do 65 kkk=1,it(jj)
      xag(1,kkk)=xt(1,jj,kkk)
      xag(2,kkk)=xt(2,jj,kkk)
      xag(3,kkk)=xt(3,jj,kkk)
 65   continue
      if(j1cod.eq.2.or.j2cod.eq.2)then
      jk0=2
      x1(1)=xt(1,jj,it(jj))
      x1(2)=xt(2,jj,it(jj))
      x1(3)=xt(3,jj,it(jj))
      x2(1)=xyzs(1,jj)
      x2(2)=xyzs(2,jj)
      x2(3)=xyzs(3,jj)
      x3(1)=xt(1,jj,it(jj)-1)
      x3(2)=xt(2,jj,it(jj)-1)
      x3(3)=xt(3,jj,it(jj)-1)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      endif
      jk0=it(jj)-1
      do 111 k=1,ndif
      iok=0
 295  continue
      if(iott180.eq.1)then
      x1(1)=xt(1,jj,jk0)-xyzs(1,jj)
      x1(2)=xt(2,jj,jk0)-xyzs(2,jj)
      x1(3)=xt(3,jj,jk0)-xyzs(3,jj)
      else
      x1(1)=xt(1,jj,jk0+k-1)-xyzs(1,jj)
      x1(2)=xt(2,jj,jk0+k-1)-xyzs(2,jj)
      x1(3)=xt(3,jj,jk0+k-1)-xyzs(3,jj)
      endif
      call molt1_rot(rmz, x1, x2)
      x1(1)=xt(1,jj,jk0+k)-xyzs(1,jj)
      x1(2)=xt(2,jj,jk0+k)-xyzs(2,jj)
      x1(3)=xt(3,jj,jk0+k)-xyzs(3,jj)
      call molt1_rot(rmz, x1, x3)
      call generat2(x2,x3,dloc,alfaloc,x1,iok,iarret)
      if (iarret.eq.-1) return
      call molt1_rot(rmiz, x1, xo)
      do 519 ijk=1,it(jj)+k-1
      x1(1)=xo(1)+xyzs(1,jj)
      x1(2)=xo(2)+xyzs(2,jj)
      x1(3)=xo(3)+xyzs(3,jj)
      x2(1)=xt(1,jj,ijk)
      x2(2)=xt(2,jj,ijk)
      x2(3)=xt(3,jj,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  295
      endif
      endif
 519  continue
      x1(1)=xo(1)+xyzs(1,jj)
      x1(2)=xo(2)+xyzs(2,jj)
      x1(3)=xo(3)+xyzs(3,jj)
      xt(1,jj,jk0+k+1)=x1(1)   
      xt(2,jj,jk0+k+1)=x1(2)   
      xt(3,jj,jk0+k+1)=x1(3)   
      xag(1,it(jj)+k)=x1(1)
      xag(2,it(jj)+k)=x1(2)
      xag(3,it(jj)+k)=x1(3)
 111  continue
      ndif=it(jj)+ndif
      do 9999 iijj=1,ndif
c     do 9999 iijj=it(jj)+1,ndif
      nats=natsold
      nzm=1
      if(jcod.eq.2)then
      iloc(nzm)=nats+2         
      else
      iloc(nzm)=nats+3         
      endif
      xloc(1,nzm)=0.0
      xloc(2,nzm)=0.0
      xloc(3,nzm)=0.0
      nloc(1,nzm)=0
      nloc(2,nzm)=0
      nloc(3,nzm)=0
      nzm=2
      iloc(nzm)=nats+1
      if(jcod.eq.2)then
      nloc(1,nzm)=nats+2         
      else
      nloc(1,nzm)=nats+3         
      endif
      xloc(1,nzm)=dmiss(i)      
      nloc(2,nzm)=0             
      xloc(2,nzm)=0.0
      nloc(3,nzm)=0      
      xloc(3,nzm)=0.0
      nzm=3
      if(jcod.eq.2)then
      iloc(nzm)=nats+3
      nloc(1,nzm)=nats+1     
      nloc(2,nzm)=nats+2     
      else
      iloc(nzm)=nats+2
      nloc(1,nzm)=nats+1     
      nloc(2,nzm)=nats+3     
      endif
      nloc(3,nzm)=0           
      xloc(1,nzm)=dmiss(i)
      if(imiss(i).eq.1)then
      n6=1
      else
      n6=2
      endif
      do 6000 k6=1,n6
      nzm=3 
      if(imiss(i).eq.1)then
      xloc(2,nzm)=109.47
      else
      if(k6.eq.1)then
      xloc(2,nzm)=90.0   
      else
      xloc(2,nzm)=180.0   
      endif
      endif
      xloc(3,nzm)=0.0
      nzm=4
      if(jcod.eq.2)then
      iloc(nzm)=nfound2(i)
      nloc(1,nzm)=nats+3   
      nloc(2,nzm)=nats+1     
      nloc(3,nzm)=nats+2         
      x1(1)=xag(1,iijj)
      x1(2)=xag(2,iijj)
      x1(3)=xag(3,iijj)
      xfix(1)=x1(1)
      xfix(2)=x1(2)
      xfix(3)=x1(3)
      x2(1)=xyzs(1,nfound2(i))
      x2(2)=xyzs(2,nfound2(i))
      x2(3)=xyzs(3,nfound2(i))
      call distanza(ggMat,x1,x2,dcal)
      xloc(1,nzm)=dcal              
      else
      iloc(nzm)=nfound1(i)
      nloc(1,nzm)=nats+2   
      nloc(2,nzm)=nats+1     
      nloc(3,nzm)=nats+3         
      x1(1)=xag(1,iijj)
      x1(2)=xag(2,iijj)
      x1(3)=xag(3,iijj)
      xfix(1)=x1(1)
      xfix(2)=x1(2)
      xfix(3)=x1(3)
      x2(1)=xyzs(1,nfound1(i))
      x2(2)=xyzs(2,nfound1(i))
      x2(3)=xyzs(3,nfound1(i))
      call distanza(ggMat,x1,x2,dcal)
      xloc(1,nzm)=dcal              
      endif
      ntrial1=5
      ntrial2=5
      ntrial3=5
      ntrial4=5
      ntrial5=5
      ntrialr=1 
      nats=natsold
      ntrial_totali=ntrial1*ntrial2*ntrial3*ntrial4*ntrial5*ntrialr*n6
      nzm=4
      do 1000 k=1,ntrial1
      nats=natsold
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      anglim1=2.0*asin(1.00/xloc(1,nzm))
      anglim2=pi
      ango=yfl*(anglim2-anglim1)+anglim1
      xloc(2,nzm)=ango*rtod          
      do 2000 kk=1,ntrial2
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=4
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=5
      if(jcod.eq.2)then
      iloc(nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(1,nzm)=nfound2(i)
      nloc(2,nzm)=nats+3     
      nloc(3,nzm)=nats+1         
      nrif=nfound2(i)
      else
      iloc(nzm)=ntt(nfound1(i),it(nfound1(i)))
      nloc(1,nzm)=nfound1(i)
      nloc(2,nzm)=nats+2     
      nloc(3,nzm)=nats+1         
      nrif=nfound1(i)
      endif
      x1(1)=xyzs(1,nrif)
      x1(2)=xyzs(2,nrif)
      x1(3)=xyzs(3,nrif)
      do 5555 il=1,ndif
      if(il.ne.iijj)then
      x2(1)=xag(1,il)
      x2(2)=xag(2,il)
      x2(3)=xag(3,il)
      xlin(1)=x2(1)
      xlin(2)=x2(2)
      xlin(3)=x2(3)
      call distanza(ggMat,x1,x2,dcal)
      go to 5556
      endif
 5555 continue
 5556 continue
      xloc(1,nzm)=dcal                 
      x3(1)=xfix(1)
      x3(2)=xfix(2)
      x3(3)=xfix(3)
      call angolo(ggMat,x3,x1,x2,anglo)
      nats=natsold
      nzm=5
      xloc(2,nzm)=anglo*rtod  
      do 4000 kkkk=1,ntrial4
      nats=natsold
      call SirRandom(iix,iiy,yfl0)
      iix=iiy
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      nzm=5
      ango=pi
      if(yfl0.gt.0.5)then
      xloc(3,nzm)=ango*yfl*rtod          
      else
      xloc(3,nzm)=-ango*yfl*rtod          
      endif
      nzm=6
      if(jcod.eq.2)then
      j1=nfound1(i)
      iloc(nzm)=ntt(i,it(i))
      nloc(1,nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(2,nzm)=nfound2(i) 
      nloc(3,nzm)=nats+3         
      x1(1)=xt(1,j1,it(j1))
      x1(2)=xt(2,j1,it(j1))
      x1(3)=xt(3,j1,it(j1))
      x2(1)=xlin(1)                           
      x2(2)=xlin(2)                           
      x2(3)=xlin(3)                           
      call distanza(ggMat,x1,x2,dcal)
      d1=dcal
      j3=nfound2(i)
      x3(1)=xyzs(1,j3)
      x3(2)=xyzs(2,j3)
      x3(3)=xyzs(3,j3)
      call angolo(ggMat,x3,x2,x1,angg)
      ang1=angg*rtod
      x1(1)=xt(1,j1,it(j1))-xlin(1)
      x1(2)=xt(2,j1,it(j1))-xlin(2)
      x1(3)=xt(3,j1,it(j1))-xlin(3)
      x2(1)=xlin(1)-xyzs(1,j3)
      x2(2)=xlin(2)-xyzs(2,j3)
      x2(3)=xlin(3)-xyzs(3,j3)
      x3(1)=xyzs(1,j3)-xfix(1)
      x3(2)=xyzs(2,j3)-xfix(2)
      x3(3)=xyzs(3,j3)-xfix(3)
      call torsion(ggMat,ggstar,x1,x2,x3,omega,vol)
      omega1=omega*rtod
      else
      j1=nfound2(i)
      iloc(nzm)=ntt(i,it(i))                        
      nloc(1,nzm)=ntt(nfound1(i),it(nfound1(i)))
      nloc(2,nzm)=nfound1(i) 
      nloc(3,nzm)=nats+2         
      x1(1)=xt(1,j1,it(j1))
      x1(2)=xt(2,j1,it(j1))
      x1(3)=xt(3,j1,it(j1))
      x2(1)=xlin(1)                           
      x2(2)=xlin(2)                           
      x2(3)=xlin(3)                           
      call distanza(ggMat,x1,x2,dcal)
      d1=dcal
      j3=nfound1(i)
      x3(1)=xyzs(1,j3)
      x3(2)=xyzs(2,j3)
      x3(3)=xyzs(3,j3)
      call angolo(ggMat,x1,x2,x3,angg)
      ang1=angg*rtod
      x1(1)=xt(1,j1,it(j1))-xlin(1)
      x1(2)=xt(2,j1,it(j1))-xlin(2)
      x1(3)=xt(3,j1,it(j1))-xlin(3)
      x2(1)=xlin(1)-xyzs(1,j3)
      x2(2)=xlin(2)-xyzs(2,j3)
      x2(3)=xlin(3)-xyzs(3,j3)
      x3(1)=xyzs(1,j3)-xfix(1)
      x3(2)=xyzs(2,j3)-xfix(2)
      x3(3)=xyzs(3,j3)-xfix(3)
      call torsion(ggMat,ggstar,x1,x2,x3,omega,vol)
      omega1=omega*rtod
      endif
      nzm=6
      nats=natsold
      xloc(1,nzm)=d1                      
      xloc(2,nzm)=ang1                    
      xloc(3,nzm)=omega1                  
      nzm=7
      if(jcod.eq.2)then
      iloc(nzm)=nfound1(i)
      nloc(1,nzm)=ntt(nfound1(i),it(nfound1(i)))
      nloc(2,nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(3,nzm)=nfound2(i) 
      j1=nfound1(i)
      x1(1)=xyzs(1,j1)
      x1(2)=xyzs(2,j1)
      x1(3)=xyzs(3,j1)
      x2(1)=xt(1,j1,it(j1))                   
      x2(2)=xt(2,j1,it(j1))                   
      x2(3)=xt(3,j1,it(j1))                   
      call distanza(ggMat,x1,x2,dcal)
      d1=dcal
      j3=nfound2(i)
      x3(1)=xlin(1)
      x3(2)=xlin(2)
      x3(3)=xlin(3)
      call angolo(ggMat,x3,x2,x1,angg)
      ang1=angg*rtod
      x1(1)=xyzs(1,j1)-xt(1,j1,it(j1))
      x1(2)=xyzs(2,j1)-xt(2,j1,it(j1))
      x1(3)=xyzs(3,j1)-xt(3,j1,it(j1))
      x2(1)=xt(1,j1,it(j1))-xlin(1)
      x2(2)=xt(2,j1,it(j1))-xlin(2)
      x2(3)=xt(3,j1,it(j1))-xlin(3)
      x3(1)=xlin(1)-xyzs(1,j3)
      x3(2)=xlin(2)-xyzs(2,j3)
      x3(3)=xlin(3)-xyzs(3,j3)
      call torsion(ggMat,ggstar,x1,x2,x3,omega,vol)
      omega1=omega*rtod
      else
      iloc(nzm)=nfound2(i)                          
      nloc(1,nzm)=ntt(nfound2(i),it(nfound2(i)))
      nloc(2,nzm)=ntt(nfound1(i),it(nfound1(i)))
      nloc(3,nzm)=nfound1(i)     
      j1=nfound2(i)
      x1(1)=xyzs(1,j1)
      x1(2)=xyzs(2,j1)
      x1(3)=xyzs(3,j1)
      x2(1)=xt(1,j1,it(j1))
      x2(2)=xt(2,j1,it(j1))                    
      x2(3)=xt(3,j1,it(j1))                   
      call distanza(ggMat,x1,x2,dcal)
      d1=dcal
      j3=nfound1(i)
      x3(1)=xlin(1)  
      x3(2)=xlin(2)  
      x3(3)=xlin(3)  
      call angolo(ggMat,x1,x2,x3,angg)
      ang1=angg*rtod
      x1(1)=xyzs(1,j1)-xt(1,j1,it(j1))
      x1(2)=xyzs(2,j1)-xt(2,j1,it(j1))
      x1(3)=xyzs(3,j1)-xt(3,j1,it(j1))
      x2(1)=xt(1,j1,it(j1))-xlin(1)
      x2(2)=xt(2,j1,it(j1))-xlin(2)
      x2(3)=xt(3,j1,it(j1))-xlin(3)
      x3(1)=xlin(1)-xyzs(1,j3)
      x3(2)=xlin(2)-xyzs(2,j3)
      x3(3)=xlin(3)-xyzs(3,j3)
      call torsion(ggMat,ggstar,x1,x2,x3,omega,vol)
      omega1=omega*rtod
      endif
      nzm=7
      nats=natsold
      xloc(1,nzm)=d1                      
      xloc(2,nzm)=ang1                    
      xloc(3,nzm)=omega1                  
c     ntrial=ntrial+1
      ierr=0 
!
!     Manage progress-bar
!
      ntrialcat = ntrialcat + 1
      write(Buffer,102) ntrialcat,ntrial_totali
  102 format(' Adding the missing atoms. Trial ',i5,' / ',i5)
      call scrper(Buffer,ntrialcat,ntrial_totali)
!
      call dainttocricat3a(i,jcod,xfix,xlin,ierr)
      if(ierr.lt.0)then
      go to 5000
      endif
CATTE dsogc=2.5
      dsogc=2.0
      x1(1)=xyzs(1,nfound1(i))         
      x1(2)=xyzs(2,nfound1(i))         
      x1(3)=xyzs(3,nfound1(i))         
      x2(1)=xadd(1,1)        
      x2(2)=xadd(2,1)        
      x2(3)=xadd(3,1)        
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 5000
      endif
      x1(1)=xyzs(1,nfound2(i))         
      x1(2)=xyzs(2,nfound2(i))         
      x1(3)=xyzs(3,nfound2(i))         
      call distanza(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogc)then
      ierr=-1
      go to 5000
      endif
c     xyzs(1,natsold+1)=xadd(1,1)
c     xyzs(2,natsold+1)=xadd(2,1)
c     xyzs(3,natsold+1)=xadd(3,1)
c     xyzs(1,natsold+2)=xadd(1,2)
c     xyzs(2,natsold+2)=xadd(2,2)
c     xyzs(3,natsold+2)=xadd(3,2)
c     xyzs(1,natsold+3)=xadd(1,3)
c     xyzs(2,natsold+3)=xadd(2,3)
c     xyzs(3,natsold+3)=xadd(3,3)
      nadd=0
      do 5122 iik=1,natsold
      itake(iik)=0
 5122 continue
      do 5102 iik=1,natsold
      x1(1)=xyzs(1,iik)
      x1(2)=xyzs(2,iik)
      x1(3)=xyzs(3,iik)
      x2(1)=xadd(1,2)
      x2(2)=xadd(2,2)
      x2(3)=xadd(3,2)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.0.00001)then
      itake(iik)=1
      nadd=nadd+1
      go to 5003
      endif
 5102 continue
      xyzs(1,natsold+2-nadd)=xadd(1,2)
      xyzs(2,natsold+2-nadd)=xadd(2,2)
      xyzs(3,natsold+2-nadd)=xadd(3,2)
 5003 continue
      do 5004 iik=1,natsold
      x1(1)=xyzs(1,iik)
      x1(2)=xyzs(2,iik)
      x1(3)=xyzs(3,iik)
      x2(1)=xadd(1,3)
      x2(2)=xadd(2,3)
      x2(3)=xadd(3,3)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.0.00001)then
      itake(iik)=1
      nadd=nadd+1
      go to 5005
      endif
 5004 continue
      xyzs(1,natsold+3-nadd)=xadd(1,3)
      xyzs(2,natsold+3-nadd)=xadd(2,3)
      xyzs(3,natsold+3-nadd)=xadd(3,3)
 5005 continue
      xyzs(1,natsold+1)=xadd(1,1)
      xyzs(2,natsold+1)=xadd(2,1)
      xyzs(3,natsold+1)=xadd(3,1)
      d1=dmiss(i)
      iok=0
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      else
      alfa=90.0*dtor
      endif
      kadd=0
CANGE if(i.gt.1)then
      do 841 k1=1,natsold+3-nadd
      if(itake(k1).eq.1)go to 841
      do 845 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 841
 845  continue
      do 846 k2=1,nott
      if(k1.eq.notta(k2))go to 841
 846  continue
      if(imiss(i).eq.1)then
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivtcat(xo,i,natsold,kadd,xad,k1)
      if (kadd.gt.0)then
      do 866 k3=1,kadd
      xadd(1,3+k3)=xad(1,k3)
      xadd(2,3+k3)=xad(2,k3)
      xadd(3,3+k3)=xad(3,k3)
 866  continue
      endif
      else
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      call checkequivocat(xo,i,natsold,kadd,xad,k1)
      if (kadd.gt.0)then
      do 867 k3=1,kadd
      xadd(1,3+k3)=xad(1,k3)
      xadd(2,3+k3)=xad(2,k3)
      xadd(3,3+k3)=xad(3,k3)
 867  continue
      endif
      endif
 841  continue
CANGE endif
      d1=dmiss(i)
      if(imiss(i).eq.1)then
      alfa=109.47*dtor
      kadd=min0(2,kadd)
      natsadd=5-kadd-nadd
      else
      alfa=90.0*dtor
      kadd=min0(4,kadd)
      natsadd=7-kadd-nadd
      endif
      ndiff=natsadd-(3-nadd)
      ik0=0
      ic1=2+kadd
      if(imiss(i).eq.1)then
c     xtet(1,1)=xyzs(1,natsold+2)
c     xtet(2,1)=xyzs(2,natsold+2)
c     xtet(3,1)=xyzs(3,natsold+2)
c     xtet(1,2)=xyzs(1,natsold+3)
c     xtet(2,2)=xyzs(2,natsold+3)
c     xtet(3,2)=xyzs(3,natsold+3)
      xtet(1,1)=xadd(1,2)
      xtet(2,1)=xadd(2,2)
      xtet(3,1)=xadd(3,2)
      xtet(1,2)=xadd(1,3)
      xtet(2,2)=xadd(2,3)
      xtet(3,2)=xadd(3,3)
      if(kadd.gt.0)then
      do 2222 il=1,kadd
      xtet(1,2+il)=xad(1,il)
      xtet(2,2+il)=xad(2,il)
      xtet(3,2+il)=xad(3,il)
 2222 continue
      endif
      else
c     xotta(1,1)=xyzs(1,natsold+2)
c     xotta(2,1)=xyzs(2,natsold+2)
c     xotta(3,1)=xyzs(3,natsold+2)
c     xotta(1,2)=xyzs(1,natsold+3)
c     xotta(2,2)=xyzs(2,natsold+3)
c     xotta(3,2)=xyzs(3,natsold+3)
      xotta(1,1)=xadd(1,2)
      xotta(2,1)=xadd(2,2)
      xotta(3,1)=xadd(3,2)
      xotta(1,2)=xadd(1,3)
      xotta(2,2)=xadd(2,3)
      xotta(3,2)=xadd(3,3)
      if(kadd.gt.0)then
      do 2223 il=1,kadd
      xotta(1,2+il)=xad(1,il)
      xotta(2,2+il)=xad(2,il)
      xotta(3,2+il)=xad(3,il)
 2223 continue
      endif
      endif
      iott180=0
      jk0=2-nadd
c     x1(1)=xyzs(1,natsold+jk0)
c     x1(2)=xyzs(2,natsold+jk0)
c     x1(3)=xyzs(3,natsold+jk0)
c     x2(1)=xyzs(1,natsold+1)
c     x2(2)=xyzs(2,natsold+1)
c     x2(3)=xyzs(3,natsold+1)
c     x3(1)=xyzs(1,natsold+jk0+1)
c     x3(2)=xyzs(2,natsold+jk0+1)
c     x3(3)=xyzs(3,natsold+jk0+1)
      x1(1)=xadd(1,2)
      x1(2)=xadd(2,2)
      x1(3)=xadd(3,2)
      x2(1)=xadd(1,1)
      x2(2)=xadd(2,1)
      x2(3)=xadd(3,1)
      x3(1)=xadd(1,3)
      x3(2)=xadd(2,3)
      x3(3)=xadd(3,3)
      call angolo(ggMat,x1,x2,x3,anglo)
      if(abs(anglo).gt.(pi-0.01).and.abs(anglo).lt.(pi+0.01))iott180=1
      do 861 ik=1,ndiff
      if(ik0.gt.0)then
      ik0=ik0-1
      go to 861
      endif
c     jk=ik+1
      jk=ik+1+kadd
      iok=0
 293  continue
      if(iott180.eq.1)then
c     x1(1)=xyzs(1,natsold+jk0)-xyzs(1,natsold+1)
c     x1(2)=xyzs(2,natsold+jk0)-xyzs(2,natsold+1)
c     x1(3)=xyzs(3,natsold+jk0)-xyzs(3,natsold+1)
      x1(1)=xadd(1,2)-xadd(1,1)
      x1(2)=xadd(2,2)-xadd(2,1)
      x1(3)=xadd(3,2)-xadd(3,1)
      else
c     x1(1)=xyzs(1,natsold+jk)-xyzs(1,natsold+1)
c     x1(2)=xyzs(2,natsold+jk)-xyzs(2,natsold+1)
c     x1(3)=xyzs(3,natsold+jk)-xyzs(3,natsold+1)
      x1(1)=xadd(1,jk)-xadd(1,1)
      x1(2)=xadd(2,jk)-xadd(2,1)
      x1(3)=xadd(3,jk)-xadd(3,1)
      endif
      call molt1_rot(rmz, x1, x2)
c     x1(1)=xyzs(1,natsold+jk+1)-xyzs(1,natsold+1)
c     x1(2)=xyzs(2,natsold+jk+1)-xyzs(2,natsold+1)
c     x1(3)=xyzs(3,natsold+jk+1)-xyzs(3,natsold+1)
      x1(1)=xadd(1,jk+1)-xadd(1,1)
      x1(2)=xadd(2,jk+1)-xadd(2,1)
      x1(3)=xadd(3,jk+1)-xadd(3,1)
      call molt1_rot(rmz, x1, x3)
      iarret=0
      call generat2(x2,x3,d1,alfa,x1,iok,iarret)
      if(iarret.lt.0)go to 5000
      call molt1_rot(rmiz, x1, xo)
      if(iok.eq.0)then
c     do 559 ijk=1,jk+1   
      do 559 ijk=2,jk+1   
      x1(1)=xo(1)+xyzs(1,natsold+1)
      x1(2)=xo(2)+xyzs(2,natsold+1)
      x1(3)=xo(3)+xyzs(3,natsold+1)
c     x2(1)=xyzs(1,natsold+ijk)
c     x2(2)=xyzs(2,natsold+ijk)
c     x2(3)=xyzs(3,natsold+ijk)
      x2(1)=xadd(1,ijk)
      x2(2)=xadd(2,ijk)
      x2(3)=xadd(3,ijk)
      call distanzaa(ggMat,x1,x2,dcal)
      if(dcal.lt.dsogok)then
      if(iok.eq.0)then
      iok=1
      go to  293
      endif
      endif
 559  continue
      endif
      xyzs(1,natsold+jk+2-nadd-kadd)=xo(1)+xyzs(1,natsold+1)
      xyzs(2,natsold+jk+2-nadd-kadd)=xo(2)+xyzs(2,natsold+1)
      xyzs(3,natsold+jk+2-nadd-kadd)=xo(3)+xyzs(3,natsold+1)
      xadd(1,jk+2)=xo(1)+xyzs(1,natsold+1)
      xadd(2,jk+2)=xo(2)+xyzs(2,natsold+1)
      xadd(3,jk+2)=xo(3)+xyzs(3,natsold+1)
      xo(1)=xyzs(1,natsold+jk+2-nadd-kadd)
      xo(2)=xyzs(2,natsold+jk+2-nadd-kadd)
      xo(3)=xyzs(3,natsold+jk+2-nadd-kadd)
      i1=natsold+1
      ic1=ic1+1
      if(imiss(i).eq.1)then
      xtet(1,ic1)=xyzs(1,natsold+jk+2-nadd-kadd)
      xtet(2,ic1)=xyzs(2,natsold+jk+2-nadd-kadd)
      xtet(3,ic1)=xyzs(3,natsold+jk+2-nadd-kadd)
      else
      xotta(1,ic1)=xyzs(1,natsold+jk+2-nadd-kadd)
      xotta(2,ic1)=xyzs(2,natsold+jk+2-nadd-kadd)
      xotta(3,ic1)=xyzs(3,natsold+jk+2-nadd-kadd)
      endif
      ic1sav=ic1
      if(imiss(i).eq.1.and.ic1.lt.4)then
      call checkequivtt2(xo,i,i1,ic1,ic1sav,xtet)
      xyzs(1,natsold+jk+2-nadd-kadd)=xtet(1,ic1sav)               
      xyzs(2,natsold+jk+2-nadd-kadd)=xtet(2,ic1sav)               
      xyzs(3,natsold+jk+2-nadd-kadd)=xtet(3,ic1sav)               
      xadd(1,jk+2)=xtet(1,ic1sav)
      xadd(2,jk+2)=xtet(2,ic1sav)
      xadd(3,jk+2)=xtet(3,ic1sav)
      if(ic1.gt.ic1sav.and.ic1.le.4)then
      iok=0
      do 862 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0-nadd-kadd)=xtet(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0-nadd-kadd)=xtet(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0-nadd-kadd)=xtet(3,ic1sav+iik0)               
      xadd(1,jk+2+iik0)=xtet(1,ic1sav+iik0)
      xadd(2,jk+2+iik0)=xtet(2,ic1sav+iik0)
      xadd(3,jk+2+iik0)=xtet(3,ic1sav+iik0)
      ik0=ik0+1
 862  continue
      endif
      elseif(imiss(i).eq.2.and.ic1.lt.6)then
      call checkequivoo2(xo,i,i1,ic1,ic1sav,xotta)
      xyzs(1,natsold+jk+2-nadd-kadd)=xotta(1,ic1sav)               
      xyzs(2,natsold+jk+2-nadd-kadd)=xotta(2,ic1sav)               
      xyzs(3,natsold+jk+2-nadd-kadd)=xotta(3,ic1sav)               
      xadd(1,jk+2)=xotta(1,ic1sav)
      xadd(2,jk+2)=xotta(2,ic1sav)
      xadd(3,jk+2)=xotta(3,ic1sav)
      if(ic1.gt.ic1sav.and.ic1.le.6)then
      iok=0
      do 863 iik=ic1sav+1,ic1
      iik0=iik-ic1sav
      xyzs(1,natsold+jk+2+iik0-nadd-kadd)=xotta(1,ic1sav+iik0)               
      xyzs(2,natsold+jk+2+iik0-nadd-kadd)=xotta(2,ic1sav+iik0)               
      xyzs(3,natsold+jk+2+iik0-nadd-kadd)=xotta(3,ic1sav+iik0)               
      xadd(1,jk+2+iik0)=xotta(1,ic1sav+iik0)
      xadd(2,jk+2+iik0)=xotta(2,ic1sav+iik0)
      xadd(3,jk+2+iik0)=xotta(3,ic1sav+iik0)
      ik0=ik0+1
 863  continue
      endif
      endif
 861  continue
      dsog=0.6
CAT   dsog=1.2
  910 continue
      nats=natsold+natsadd
      do 8910 ijk=natsold+1,natsold+natsadd                 
      x2(1)=xyzs(1,ijk)
      x2(2)=xyzs(2,ijk)
      x2(3)=xyzs(3,ijk)
      do 8920 ijk0=1,natsold                
      x1(1)=xyzs(1,ijk0)
      x1(2)=xyzs(2,ijk0)
      x1(3)=xyzs(3,ijk0)
c     call distanzaeq(ggMat,x1,x2,dcal)
      call distanzaeq(x1,x2,dcal)
      if(dcal.lt.dsog)then
      nats=natsold
      ierr=-1
      go to 5000
      endif
 8920 continue
 8910 continue
      ier=0
      npuntisav=npunti
c     npunti=0.9*npunti
      if(istampa.gt.0)then
      write(lo,'(/,a,i6,a)')'  **************  Z - matrix  ************'
      write(lo,'(a)')'                                                 '
      write(lo,'(a,a)')' atom nr.  type  nr.       dist          ang',
     *'          tors '
      if(ntrial.gt.2110)then
      aa=1.0
      endif
      do 800 ii=1,nzm
      if(nloc(1,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4)')
     *iloc(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),ii,nloc(1,ii)
      elseif(nloc(1,ii).eq.1.and.nloc(2,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,i4,f10.3)')
     *iloc(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),ii,nloc(1,ii),
     *xloc(1,ii)
      elseif(nloc(1,ii).eq.2.and.nloc(3,ii).eq.0)then
      write(lo,'(i4,8x,a2,i4,2(i4,f10.3))')
     *iloc(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),ii,
     *nloc(1,ii),xloc(1,ii),
     *nloc(2,ii),xloc(2,ii)
      else
      write(lo,'(i4,8x,a2,i4,3(i4,f10.3))')
     *iloc(ii),celem(iabs(nz(iloc(ii))/100))%lab(1:2),ii,
     *nloc(1,ii),xloc(1,ii),
     *nloc(2,ii),xloc(2,ii),
     *nloc(3,ii),xloc(3,ii)
      endif
 800  continue
      write(lo,'(a)')'                                                 '
      write(lo,'(a,/)')'  *********************************************'
      endif
      iloccat1=1
      nzmax=-99999999
      do 120 ii=1,nats
      if (nz(ii).ne.0) then
      nzz=iabs(nz(ii))/100
      if (nzz.gt.nzmax) nzmax=nzz
      endif
  120 continue
      do 121 il=1,nats
      if (nz(il).eq.0) go to 121
      nzz=iabs(nz(il))/100
      if (nzz.lt.nzmax)then
      zrap=float(nzmax)/float(nzz)
      bfac(il)=zrap*biso
      zrap=zrap**2
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      else
      bfac(il)=0.9*biso
      if(bfac(il).lt.0.5)bfac(il)=0.5
      if(bfac(il).gt.5.0)bfac(il)=5.0
      endif
 121  continue
      iprier=0
      call calcolaerre(chi2,iprier)
      npunti=npuntisav
c     call to_coord(1)
c     kdirect=0
c     interp=0
c     iniat = 1
c     call MakeLab(iniat,nats)
c     call to_coord(1)
c     call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
      if(chi2.lt.chimin)then
c     kdirect=0
c     interp=0
c     iniat = 1
c     call MakeLab(iniat,nats)
c     call to_coord(1)
c     call frm15e(nats,interp)
c     iconn(1)=-1
c     jab=3
c     call molplo()
CCCCC if(chi2.lt.chimin)then
      natssav=natsold+natsadd
      natsaddsav=natsadd
      kaddsav=kadd
      do 5001 jk=1,kadd
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
      xadsav(1,jk)=xad(1,jk)
      xadsav(2,jk)=xad(2,jk)
      xadsav(3,jk)=xad(3,jk)
 5001 continue
      do 5200 jk=natsold+1,natsold+natsadd
      xsavx(1,jk)=xyzs(1,jk)
      xsavx(2,jk)=xyzs(2,jk)
      xsavx(3,jk)=xyzs(3,jk)
 5200 continue
      ntrialsav=ntrial
      chimin=chi2
      endif
c     nats=natsold
 5000 continue
 4000 continue
 3000 continue
 3500 continue
 2000 continue
 1000 continue
  900 continue
 6000 continue
 5002 continue
 9999 continue
      if(iloccat1.eq.0)ier=-1
      if(ier.lt.0)return
      do 5300 k=natsold+1,natssav                
      xyzs(1,k)=xsavx(1,k)
      xyzs(2,k)=xsavx(2,k)
      xyzs(3,k)=xsavx(3,k)
 5300 continue
      if(istampa.gt.0)then
      kt=nfound1(i)
      write(lo,'(a,3f10.3)')' input cation #1',(xyzs(kp,kt),kp=1,3)
      kt=nfound2(i)
      write(lo,'(a,3f10.3)')' input cation #2',(xyzs(kp,kt),kp=1,3)
      write(lo,'(a,3f10.3)')' located cation',
     *(xyzs(kp,natsold+1),kp=1,3)
      do 5022 jk=natsold+2,natsold+natsaddsav
      write(lo,'(a,3f10.3)')' located anion',(xyzs(kp,jk),kp=1,3)
 5022 continue
      write(lo,'(/,a,f10.3,a,i7)')' Minimum fom:',chimin,
     *' trial #',ntrial
      endif
      nats=natsold+natsaddsav
      kdirect=1
      kdirectsav=3
      interp=0
      iniat = 1
      call MakeLab(iniat,nats)
      call to_coord(1)
      call frm15e(nats,interp)
      rfac=chimin
      jpol=0
      kdirectsav=0
      do inats=1,nats
        kblock(inats)=1
      enddo
!corr      iconn(1)=-1
!corr      jab=3
!corr      call molplo()
      call draw_xyzs(conn=.true.)
      nats=natsold
      nats=natssav               
      do 550 k=natsold+1,natssav             
      xo(1)=xyzs(1,k)
      xo(2)=xyzs(2,k)
      xo(3)=xyzs(3,k)
      call checkequiv(xo)
      xyzs(1,k)=xo(1)
      xyzs(2,k)=xo(2)
      xyzs(3,k)=xo(3)
 550  continue
      j1=nfound1(i)
      it(j1)=it(j1)+1
      xt(1,j1,it(j1))=xyzs(1,natsold+2)
      xt(2,j1,it(j1))=xyzs(2,natsold+2)
      xt(3,j1,it(j1))=xyzs(3,natsold+2)
      ntt(j1,it(j1))=natsold+2
      j2=nfound2(i)
      it(j2)=it(j2)+1
      xt(1,j2,it(j2))=xyzs(1,natsold+3)
      xt(2,j2,it(j2))=xyzs(2,natsold+3)
      xt(3,j2,it(j2))=xyzs(3,natsold+3)
      ntt(j2,it(j2))=natsold+3
      j3=natsold+1
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+2)
      xt(2,j3,it(j3))=xyzs(2,natsold+2)
      xt(3,j3,it(j3))=xyzs(3,natsold+2)
      ntt(j3,it(j3))=natsold+2
      it(j3)=it(j3)+1
      xt(1,j3,it(j3))=xyzs(1,natsold+3)
      xt(2,j3,it(j3))=xyzs(2,natsold+3)
      xt(3,j3,it(j3))=xyzs(3,natsold+3)
      ntt(j3,it(j3))=natsold+3
      kadd=kaddsav
      ndif=nats-natsold-3
c     do 811 il=1,ndif
c     do 811 il=1,kadd
c     it(j3)=it(j3)+1
c     xt(1,j3,it(j3))=xyzs(1,natsold+3+il)
c     xt(2,j3,it(j3))=xyzs(2,natsold+3+il)
c     xt(3,j3,it(j3))=xyzs(3,natsold+3+il)
c     xt(1,j3,it(j3))=xadd(1,il)
c     xt(2,j3,it(j3))=xadd(2,il)
c     xt(3,j3,it(j3))=xadd(3,il)
c     ntt(j3,it(j3))=natsold+3+il
c811  continue
      if(imiss(i).eq.1)then
      itet=1
      ntetra=ntetra+1
      ntetr(ntetra)=natsold+1
      dtetra(ntetra)=dmiss(i)
      dtolt(ntetra)=dtolm(i)
      atolt(ntetra)=atolm(i)
      ktetra(ntetra)=kmiss(i)
      elseif(imiss(i).eq.2)then
      iott=1
      nott=nott+1
      notta(nott)=natsold+1
      dotta1(nott)=dmiss(i)
      dtolo(nott)=dtolm(i)
      atolo(nott)=atolm(i)
      kotta(nott)=kmiss(i)
      endif
      natmis(1,i)=natsold+1
      natmis(2,i)=natsold+2
      natmis(3,i)=natsold+3
      natsold=nats
      do 9100 k1=1,nats
      do 945 k2=1,ntetra
      if(k1.eq.ntetr(k2))go to 9100
 945  continue
      do 946 k2=1,nott
      if(k1.eq.notta(k2))go to 9100
 946  continue
      xo(1)=xyzs(1,k1)
      xo(2)=xyzs(2,k1)
      xo(3)=xyzs(3,k1)
      if(ntetra.gt.0)call checkequivtcat2(xo)
      if(nott.gt.0)call checkequivocat2(xo)
 9100 continue
      return
      end
c----------------------------------------------------------------
      subroutine dainttocricat3a(icat1,jcod,xfix,xlin,ier)
      Use Polpo
      USE Atomi
      USE General
*     include 'atoms.fi'
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/toler/dtolt(500),atolt(500),dtolo(500),atolo(500)
      common/stampa/istampa
      common/ottapoly/iott,nott,kotta(500),ippo(500),
     *                 dotta1(500),notta(500)
      common/occtetra/it(500)
      common/superandom/iix,iiy,ntrial,irandom,sograndom
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common /matr/rmz(3,3),rmiz(3,3)
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      double precision thetas, phis, psis
      common /transform/ thetas,phis,psis,xortolocal(3,500),xor(3,500)
     *                  ,xorto(3,500),iplane,xorsav(3,500)
     *                  ,thetasav,phisav,psisav,scalsav,xsalva(3,500)
      common/ annealcat/ ncate,nzcat(500),iloccat(500,500),
     *xloccat(500,3,500),nloccat(500,3,500)
      common/missi/nmiss,nfound1(10),nfound2(10),imiss(10),dmiss(10)
     *           ,kmiss(10),dtolm(10),atolm(10),xadd(3,10),natmis(3,10)
     *         ,itimem
      common /derrig0/rr(3,3),rrt(3,3),rrf(3,3),rrp(3,3),derah(6,500),
     *       derbh(6,500)
      common /fastcal/ hkle(3000,4,24),fsca(9,3000)
      common/Gmatrix/ggMat(3,3)
****  common /atoms/ x(5,500),nz(500),idumx(21)
c     common /atoms/ x(5,500),nz(500),bfac(500),idumx(4001)
      common/tetrapoly/natsp,itet,ntetra,ktetra(500),ipp(500),
     *                 dtetra(500),ntetr(500)
      dimension x11(4),x1(3),x2(3),xcri(3,500),
     *xortol(3,500),xfix(3)
      dimension amat(9,9),dmat(9),INDX(9),v(3,3)
      dimension aa(3,3),w(3),bb(3,3),ww(3,3),www(3)
      dimension ilocr(4),xcr(3,4),ang(3)
      dimension xz(3,50),x3(3),x4(3),x1t(3),xzr(3,50)
      dimension wr(4,4),xortet(4,10),rrr(3,3),xlin(3)
      dimension xm(3),xo1(11),xn(11),key(10),shift(4)
c
      ier=0
      do 200 i=1,9
      dmat(i)=0.0
      do 300 j=1,9
      amat(i,j)=0.0
 300  continue
 200  continue
      nch=1
      if(jcod.eq.2)then
      xor(1,nch)=xt(1,nfound1(icat1),it(nfound1(icat1)))
      xor(2,nch)=xt(2,nfound1(icat1),it(nfound1(icat1)))
      xor(3,nch)=xt(3,nfound1(icat1),it(nfound1(icat1)))
      else
      xor(1,nch)=xt(1,nfound2(icat1),it(nfound2(icat1)))
      xor(2,nch)=xt(2,nfound2(icat1),it(nfound2(icat1)))
      xor(3,nch)=xt(3,nfound2(icat1),it(nfound2(icat1)))
      endif
      do 100 i=1,nzm
      x11(1)=0.0       
      x11(2)=0.0       
      x11(3)=0.0       
      j=iloc(i)
      if(j.le.nats)then
      x11(1)=xyzs(1,j)-xor(1,nch)
      x11(2)=xyzs(2,j)-xor(2,nch)
      x11(3)=xyzs(3,j)-xor(3,nch)
      endif
      if(i.eq.3)then
      x11(1)=xfix(1)-xor(1,nch)
      x11(2)=xfix(2)-xor(2,nch)
      x11(3)=xfix(3)-xor(3,nch)
      go to 99
      endif
      if(i.eq.5)then
      x11(1)=xlin(1)-xor(1,nch)
      x11(2)=xlin(2)-xor(2,nch)
      x11(3)=xlin(3)-xor(3,nch)
      endif
      if(i.eq.6)then
      if(jcod.eq.2)then
      x11(1)=xt(1,nfound1(icat1),it(nfound1(icat1)))-xor(1,nch)
      x11(2)=xt(2,nfound1(icat1),it(nfound1(icat1)))-xor(2,nch)
      x11(3)=xt(3,nfound1(icat1),it(nfound1(icat1)))-xor(3,nch)
      else
      x11(1)=xt(1,nfound2(icat1),it(nfound2(icat1)))-xor(1,nch)
      x11(2)=xt(2,nfound2(icat1),it(nfound2(icat1)))-xor(2,nch)
      x11(3)=xt(3,nfound2(icat1),it(nfound2(icat1)))-xor(3,nch)
      endif
      endif
 99   continue
      call molt1_rot(rmz, x11, x1)
      if(abs(x1(1)).lt.0.0001)x1(1)=0.0
      if(abs(x1(2)).lt.0.0001)x1(2)=0.0
      if(abs(x1(3)).lt.0.0001)x1(3)=0.0
      xorto(1,i)=x1(1)
      xorto(2,i)=x1(2)
      xorto(3,i)=x1(3)
 100  continue
c     a=cell(1)
c     b=cell(2)
c     c=cell(3)
c     alfa=cell(4)
c     beta=cell(5)
c     gamma=cell(6)
c     inv=0
c     call Orto_new(a, b, c, alfa, beta, gamma,inv)
c     inv=1
c     call Orto_new(a, b, c, alfa, beta, gamma,inv)
      nch=1
      il=iloc(nzm-1)
      xortol(1,nzm-1)=0.0
      xortol(2,nzm-1)=0.0
      xortol(3,nzm-1)=0.0
      xortol(1,nzm-2)=xloc(1,nzm-1)
      xortol(2,nzm-2)=0.0
      xortol(3,nzm-2)=0.0
      do 1000 k=1,nzm-3
      mmax=nzm-3
      xortol(1,k)=0.0
      xortol(2,k)=0.0
      xortol(3,k)=0.0
      do 1100 i=k,mmax
      w(1)=0.0
      w(2)=0.0
      w(3)=0.0
      j=nzm-3
      jrif=j
      fij=xloc(2,j+2)*dtor
      ppp=-1.0
      tij=ppp*(xloc(3,j+3))*dtor
      dij=xloc(1,i+1)
      aa(1,1)=-cos(fij)
      aa(1,2)=-sin(fij)
      aa(1,3)=0.0
      aa(2,1)=sin(fij)*cos(tij)
      aa(2,2)=-cos(fij)*cos(tij)
      aa(2,3)=sin(tij)
      aa(3,1)=-sin(fij)*sin(tij)
      aa(3,2)=cos(fij)*sin(tij)
      aa(3,3)=cos(tij)
      do 1200 j=nzm-4,i,-1
      fij=xloc(2,j+2)*dtor
      ppp=-1.0
      tij=ppp*(xloc(3,j+3))*dtor
      bb(1,1)=-cos(fij)
      bb(1,2)=-sin(fij)
      bb(1,3)=0.0
      bb(2,1)=sin(fij)*cos(tij)
      bb(2,2)=-cos(fij)*cos(tij)
      bb(2,3)=sin(tij)
      bb(3,1)=-sin(fij)*sin(tij)
      bb(3,2)=cos(fij)*sin(tij)
      bb(3,3)=cos(tij)
      call moltm(aa,bb,ww)
      do 1250 ik=1,3
      do 1260 jk=1,3
      aa(ik,jk)=ww(ik,jk)
 1260 continue
 1250 continue
 1200 continue
      www(1)=dij
      www(2)=0.0
      www(3)=0.0
      call moltv(aa,www,w)
      xortol(1,k)=xortol(1,k)+w(1)
      xortol(2,k)=xortol(2,k)+w(2)
      xortol(3,k)=xortol(3,k)+w(3)
 1100 continue
      xortol(1,k)=xortol(1,k)+xloc(1,nzm-1)
 1000 continue
 2500 continue
      dn=xloc(1,nzm)
      fn=(xloc(2,nzm)*dtor)-(pi/2.0)
      xortol(1,nzm)=-dn*sin(fn)      
      xortol(2,nzm)=dn*cos(fn)
      xortol(3,nzm)=0.0
      amat(1,1)=xortol(2,nzm-3)-
     *(xortol(2,nzm)*xortol(1,nzm-3)/xortol(1,nzm))
      amat(1,2)=xortol(3,nzm-3)
      amat(2,3)=xortol(2,nzm-3)-
     *(xortol(2,nzm)*xortol(1,nzm-3)/xortol(1,nzm))
      amat(2,4)=xortol(3,nzm-3)
      amat(3,5)=xortol(2,nzm-3)-
     *(xortol(2,nzm)*xortol(1,nzm-3)/xortol(1,nzm))
      amat(3,6)=xortol(3,nzm-3)
      amat(4,1)=xortol(2,nzm-4)-
     *(xortol(2,nzm)*xortol(1,nzm-4)/xortol(1,nzm))
      amat(4,2)=xortol(3,nzm-4)
      amat(5,3)=xortol(2,nzm-4)-
     *(xortol(2,nzm)*xortol(1,nzm-4)/xortol(1,nzm))
      amat(5,4)=xortol(3,nzm-4)
      amat(6,5)=xortol(2,nzm-4)-
     *(xortol(2,nzm)*xortol(1,nzm-4)/xortol(1,nzm))
      amat(6,6)=xortol(3,nzm-4)
      dmat(1)=xorto(1,nzm-3)-xortol(1,nzm-3)*xorto(1,nzm)/xortol(1,nzm)
      dmat(2)=xorto(2,nzm-3)-xortol(1,nzm-3)*xorto(2,nzm)/xortol(1,nzm)
      dmat(3)=xorto(3,nzm-3)-xortol(1,nzm-3)*xorto(3,nzm)/xortol(1,nzm)
      dmat(4)=xorto(1,nzm-4)-xortol(1,nzm-4)*xorto(1,nzm)/xortol(1,nzm)
      dmat(5)=xorto(2,nzm-4)-xortol(1,nzm-4)*xorto(2,nzm)/xortol(1,nzm)
      dmat(6)=xorto(3,nzm-4)-xortol(1,nzm-4)*xorto(3,nzm)/xortol(1,nzm)
      np=9
      n=6
      mp=1
      m=1
      ising=0
      call gaussj2(amat,n,np,dmat,m,mp,ising)
      if(ising.eq.-1)then
      ier=-1
      return
      endif
      rr(1,2)=dmat(1)
      rr(1,3)=dmat(2)
      rr(2,2)=dmat(3)
      rr(2,3)=dmat(4)
      rr(3,2)=dmat(5)
      rr(3,3)=dmat(6)
      rr(1,1)=xorto(1,nzm)/xortol(1,nzm)-
     *rr(1,2)*xortol(2,nzm)/xortol(1,nzm)
      rr(2,1)=xorto(2,nzm)/xortol(1,nzm)-
     *rr(2,2)*xortol(2,nzm)/xortol(1,nzm)
      rr(3,1)=xorto(3,nzm)/xortol(1,nzm)-
     *rr(3,2)*xortol(2,nzm)/xortol(1,nzm)
      do 700 j=1,nzm          
      i=iloc(j)
      x11(1)=xortol(1,j)
      x11(2)=xortol(2,j)
      x11(3)=xortol(3,j)
      call molt1_rot(rr, x11, x1)
      call molt1_rot(rmiz, x1, x2)
      x1(1)=x2(1)+xor(1,nch)
      x1(2)=x2(2)+xor(2,nch)
      x1(3)=x2(3)+xor(3,nch)
      xz(1,j)=x1(1)
      xz(2,j)=x1(2)
      xz(3,j)=x1(3)
 700  continue
      if(jcod.eq.1)then
      nrif=nfound2(icat1)
      elseif(jcod.eq.2)then
      nrif=nfound1(icat1)
      endif
      dd=1.8
      iyest=0
      iyeso=0
      do 111 j=1,ntetra
      if(nrif.eq.ntetr(j))then
      dd=dtetra(j)
      dd1=dtetra(j)*(1.0-dtolt(j))
      dd2=dtetra(j)*(1.0+dtolt(j))
      if(it(nrif).ge.1)iyest=1
      jrif=j
      go to 170
      endif
 111  continue
      do 101 j=1,nott
      if(nrif.eq.notta(j))then
      dd=dotta1(j)
      dd1=dotta1(j)*(1.0-dtolo(j))
      dd2=dotta1(j)*(1.0+dtolo(j))
      if(it(nrif).ge.1)iyeso=1
      jrif=j
      go to 170
      endif
 101  continue
 170  continue
      x1(1)=xz(1,1)
      x1(2)=xz(2,1)
      x1(3)=xz(3,1)
      x2(1)=xz(1,nzm)
      x2(2)=xz(2,nzm)
      x2(3)=xz(3,nzm)
      call distanza(ggMat,x1,x2,dcal)
c     if(dcal.lt.0.8*dd.or.dcal.gt.1.2*dd)then
c     if(dcal.lt.dd1.or.dcal.gt.dd2)then
CCCCCCCCCC
      if(iyest.gt.0.or.iyeso.gt.0)then
      x3(1)=xt(1,nrif,it(nrif))
      x3(2)=xt(2,nrif,it(nrif))
      x3(3)=xt(3,nrif,it(nrif))
      call angolo(ggMat,x1,x2,x3,angg)
      endif
      if(iyest.eq.1)then
      angsog1 = 109.47*(1.0-atolt(jrif))
      angsog2 = 109.47*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11=angsog1
      angsog22=angsog2
      elseif(iyeso.eq.1)then
      angsog1 = 90.00*(1.0-atolt(jrif))
      angsog2 = 90.00*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      angsog11 = 180.00*(1.0-atolt(jrif))
      angsog22 = 180.00*(1.0+atolt(jrif))
      angsog11=angsog11*dtor
      angsog22=angsog22*dtor
      elseif(iyeso.eq.0.and.iyest.eq.0)then
      angsog1=1.0
      angsog2=1.0
      angsog11=angsog1
      angsog22=angsog2
      angg=1.0
      endif
CCCCCCCCCCCC
c     if(dcal.lt.dd1.or.dcal.gt.dd2)then
      if((dcal.lt.dd1.or.dcal.gt.dd2).or
     *.((angg.lt.angsog1.or.angg.gt.angsog2)
     *.and.(angg.lt.angsog11.or.angg.gt.angsog22)))then
      nru=20
      angstep=18.0*dtor
      do 9000 jt=1,nru          
      x1(1)=xz(1,3)
      x1(2)=xz(2,3)
      x1(3)=xz(3,3)
      call molt1_rot(rmz, x1, x2)
      xortet(1,1)=x2(1)
      xortet(2,1)=x2(2)
      xortet(3,1)=x2(3)
      x1(1)=xz(1,4)
      x1(2)=xz(2,4)
      x1(3)=xz(3,4)
      call molt1_rot(rmz, x1, x2)
      xortet(1,2)=x2(1)
      xortet(2,2)=x2(2)
      xortet(3,2)=x2(3)
      kk0=2
      do 51 kl=1,2
      if(kl.eq.4.or.kl.eq.5)go to 51
      kk0=kk0+1
      x1(1)=xz(1,kl)
      x1(2)=xz(2,kl)
      x1(3)=xz(3,kl)
      call molt1_rot(rmz, x1, x2)
      xortet(1,kk0)=x2(1)
      xortet(2,kk0)=x2(2)
      xortet(3,kk0)=x2(3)
 51   continue
      xx=(xortet(1,2)-xortet(1,1))**2
      yy=(xortet(2,2)-xortet(2,1))**2
      zz=(xortet(3,2)-xortet(3,1))**2
      elle=sqrt(xx+yy+zz)
      adif=(xortet(1,2)-xortet(1,1))/elle
      bdif=(xortet(2,2)-xortet(2,1))/elle
      cdif=(xortet(3,2)-xortet(3,1))/elle
      ddif=sqrt(bdif**2+cdif**2)
      nmax=4
      do 10 ii=1,nmax
      do 20 j=1,nmax
      if(ii.le.4.and.j.le.4)wr(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtot(ii,j)=0.0
      if(ii.le.4.and.j.le.4)rtoti(ii,j)=0.0
 20   continue
 10   continue
      do ii=1,3
      x2(ii)=xortet(ii,1)
      end do
      call MatTotti(x2,adif,bdif,cdif,ddif)
      angcal=float(jt-1)*angstep
      ierr=0
      call MatTott(x2,adif,bdif,cdif,ddif,angcal)
      call molt2_rott(rtoti, rtot, wr)
        kk0=0
        do ii=1,4
          xortet(4,ii)=1
         do j=1,4
           x11(j)=xortet(j,ii)
         end do
          call molt1_rott(wr, x11, x1t)
          do j=1,3
             x11(j)=x1t(j)
          end do
          call molt1_rot(rmiz, x11, x1)
          kk0=kk0+1
          xzr(1,kk0)=x1(1)
          xzr(2,kk0)=x1(2)
          xzr(3,kk0)=x1(3)
        end do
      x1(1)=xzr(1,3)
      x1(2)=xzr(2,3)
      x1(3)=xzr(3,3)
      x2(1)=xz(1,nzm)
      x2(2)=xz(2,nzm)
      x2(3)=xz(3,nzm)
      call distanza(ggMat,x1,x2,dcal)
c     if(dcal.lt.dd1.or.dcal.gt.dd2)then
      if(dcal.gt.dd1.and.dcal.lt.dd2)then
      if(iyest.gt.0.or.iyeso.gt.0)then
      x3(1)=xt(1,nrif,it(nrif))
      x3(2)=xt(2,nrif,it(nrif))
      x3(3)=xt(3,nrif,it(nrif))
      call angolo(ggMat,x1,x2,x3,angg)
      endif
      if(iyest.eq.1)then
      angsog1 = 109.47*(1.0-atolt(jrif))
      angsog2 = 109.47*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      if(angg.gt.angsog1.and.angg.lt.angsog2)go to 9001
      elseif(iyeso.eq.1)then
      angsog1 = 90.00*(1.0-atolt(jrif))
      angsog2 = 90.00*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      if(angg.gt.angsog1.and.angg.lt.angsog2)go to 9001
      angsog1 = 180.00*(1.0-atolt(jrif))
      angsog2 = 180.00*(1.0+atolt(jrif))
      angsog1=angsog1*dtor
      angsog2=angsog2*dtor
      if(angg.gt.angsog1.and.angg.lt.angsog2)go to 9001
      elseif(iyeso.eq.0.and.iyest.eq.0)then
      go to 9001
      endif
      endif
 9000 continue
      ier=-1
      return
 9001 continue
      xadd(1,1)=xzr(1,4)
      xadd(2,1)=xzr(2,4)
      xadd(3,1)=xzr(3,4)
      if(jcod.eq.2)then
c     xadd(1,3)=xzr(1,3)
c     xadd(2,3)=xzr(2,3)
c     xadd(3,3)=xzr(3,3)
c     xadd(1,2)=xzr(1,1)
c     xadd(2,2)=xzr(2,1)
c     xadd(3,2)=xzr(3,1)
      xadd(1,2)=xzr(1,3)
      xadd(2,2)=xzr(2,3)
      xadd(3,2)=xzr(3,3)
      xadd(1,3)=xzr(1,1)
      xadd(2,3)=xzr(2,1)
      xadd(3,3)=xzr(3,1)
      else
      xadd(1,2)=xzr(1,1)
      xadd(2,2)=xzr(2,1)
      xadd(3,2)=xzr(3,1)
      xadd(1,3)=xzr(1,3)
      xadd(2,3)=xzr(2,3)
      xadd(3,3)=xzr(3,3)
      endif
      else
      xadd(1,1)=xz(1,2)
      xadd(2,1)=xz(2,2)
      xadd(3,1)=xz(3,2)
      if(jcod.eq.2)then
      xadd(1,3)=xz(1,3)
      xadd(2,3)=xz(2,3)
      xadd(3,3)=xz(3,3)
      xadd(1,2)=xz(1,1)
      xadd(2,2)=xz(2,1)
      xadd(3,2)=xz(3,1)
      else
      xadd(1,2)=xz(1,3)
      xadd(2,2)=xz(2,3)
      xadd(3,2)=xz(3,3)
      xadd(1,3)=xz(1,1)
      xadd(2,3)=xz(2,1)
      xadd(3,3)=xz(3,1)
      endif
      endif
      do 3050 i=1,3
        iser=1
        iactn=1
        khead=0
        xo1(1) = xadd(1,i)
        xo1(2) = xadd(2,i)
        xo1(3) = xadd(3,i)
        ksp=kspecb(newvet,xo1,xn,key,itype,iser,khead,iactn)
        xadd(1,i)=xn(1)
        xadd(2,i)=xn(2)
        xadd(3,i)=xn(3)
 3050 continue
      return
      end
c -----------------------------------------------------------------
      subroutine MatTott1(x1,a,b,c,d,tet)
cc
      USE General
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common/stampa/istampa
      common /mattot/rtot(4,4),rtoti(4,4),rprec(3,3)
      dimension x1(3)
cc
      tet=tet*dtor
      ctet=cos(tet)
      stet=sin(tet)
cc
      rtot(1,1) = d*ctet
      rtot(1,2) = -1./d*(a*b*ctet+c*stet)
      rtot(1,3) = 1./d*(-a*c*ctet+b*stet)
      rtot(1,4) = -(x1(1)*rtot(1,1)+x1(2)*rtot(1,2)+x1(3)*rtot(1,3))
      rtot(2,1) = d*stet
      rtot(2,2) = 1./d*(-a*b*stet+c*ctet)
      rtot(2,3) = -1./d*(a*c*stet+b*ctet)
      rtot(2,4) = -(x1(1)*rtot(2,1)+x1(2)*rtot(2,2)+x1(3)*rtot(2,3))
      rtot(3,1) = a
      rtot(3,2) = b
      rtot(3,3) = c
      rtot(3,4) = -(x1(1)*a+x1(2)*b+x1(3)*c)
      rtot(4,1) = 0.
      rtot(4,2) = 0.
      rtot(4,3) = 0.
      rtot(4,4) = 1
CC
      return
      end
c -----------------------------------------------------------------
      subroutine distanzaeq(xo,xn,dcal)
c--
      USE Symmetry
      USE general, only:cell,spacegr
      USE cgeom
      USE unit_cell
      dimension xo(3),xn(3),vet(2)
      dimension xeq(3),m(3,3),s(3),xb1(3),xb2(3)
      real, dimension(3,3) :: gm
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
      do 30 i=1,3
      xb1(i)=xo(i)
   30 xb2(i)=xn(i)
      ifin=icent+1
      nr=0
      diminimo=9999999.0
      do 50 kt=1,spacegr%ncoper
        do 50 ifi=1,ifin
          coef=vet(ifi)
          do 50 k=1,nsym
C           if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 50
            call xequi(xb1,k,coef,xeq,kt)
            !call xdist(xb2,xeq,d,s)
            call xdisteqs(xb2,xeq,gm,d,s)
            if (d.le.diminimo) diminimo=d
   50 continue
      dcal=diminimo
      return
      end
c--------------------------------------------------------------------
      subroutine intcoordd(ier)
      USE Atomi
      USE General
*     include 'atoms.fi'
****  common /atoms/ x(5,500),nz(500),idumx(21)
c     common /atoms/ x(5,500),nz(500),bfac(500),idumx(4001)
      common/anneal/nfixo,norifix,nzm,xloc(3,500),nloc(3,500)
     *    ,iloc(500),nfixc,nchain,xort(3,500),iesz(500),xl(3,2)
      common/annealsav/nzmsav,xlocsav(3,500),nlocsav(3,500),ilocsav(500)
      common/Gmatrix/ggMat(3,3)
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      dimension x1(3),x2(3),x3(3)
      dimensiOn ggstar(3,3)
c
      do 100 i=1,nzm
      xlocsav(1,i)=0.0
      xlocsav(2,i)=0.0
      xlocsav(3,i)=0.0
      if(i.gt.1)then
      k1=ilocsav(i)
      k2=ilocsav(i-1)
      x1(1)=xyzs(1,k1)
      x1(2)=xyzs(2,k1)
      x1(3)=xyzs(3,k1)
      x2(1)=xyzs(1,k2)
      x2(2)=xyzs(2,k2)
      x2(3)=xyzs(3,k2)
      call distanza(ggMat,x1,x2,dcal)
      xlocsav(1,i)=dcal
      endif
      if(i.gt.2)then
      k1=ilocsav(i)
      k2=ilocsav(i-1)
      k3=ilocsav(i-2)
      x1(1)=xyzs(1,k1)
      x1(2)=xyzs(2,k1)
      x1(3)=xyzs(3,k1)
      x2(1)=xyzs(1,k2)
      x2(2)=xyzs(2,k2)
      x2(3)=xyzs(3,k2)
      x3(1)=xyzs(1,k3)
      x3(2)=xyzs(2,k3)
      x3(3)=xyzs(3,k3)
      call angolo(ggMat,x1,x2,x3,anglo)
      anglo=anglo*rtod
      xlocsav(2,i)=anglo
      endif
      if(i.gt.3)then
      j1=ilocsav(i)
      j2=ilocsav(i-1)
      j3=ilocsav(i-2)
      j4=ilocsav(i-3)
      x1(1)=(xyzs(1,j1)-xyzs(1,j2))
      x1(2)=(xyzs(2,j1)-xyzs(2,j2))
      x1(3)=(xyzs(3,j1)-xyzs(3,j2))
      x2(1)=(xyzs(1,j2)-xyzs(1,j3))
      x2(2)=(xyzs(2,j2)-xyzs(2,j3))
      x2(3)=(xyzs(3,j2)-xyzs(3,j3))
      x3(1)=(xyzs(1,j3)-xyzs(1,j4))
      x3(2)=(xyzs(2,j3)-xyzs(2,j4))
      x3(3)=(xyzs(3,j3)-xyzs(3,j4))
      call torsion(ggMat,ggstar,x1,x2,x3,omega,vol)
      omega=omega*rtod
      xlocsav(3,i)=omega
      endif
 100  continue
      return
      end
c----------------------------------------------------------------
      subroutine inv3(a,det,v)
c
c--apparteneva al modulo seminv prima della sua sparizione
c
      USE General
c
c---- calcola l'inversa della matrice a e la
c---- memorizza in v.
c---- a deve essere una matrice  3*3 non-singolare
c---- alfa e' la matrice aggiunta
c
      integer a(3,3),v(3,3),det,alfa(3,3)
c
      alfa(1,1)=a(2,2)*a(3,3)-a(2,3)*a(3,2)
      alfa(1,2)=-1*(a(2,1)*a(3,3)-a(2,3)*a(3,1))
      alfa(1,3)=a(2,1)*a(3,2)-a(2,2)*a(3,1)
      alfa(2,1)=-1*(a(1,2)*a(3,3)-a(1,3)*a(3,2))
      alfa(2,2)=a(1,1)*a(3,3)-a(1,3)*a(3,1)
      alfa(2,3)=-1*(a(1,1)*a(3,2)-a(1,2)*a(3,1))
      alfa(3,1)=a(1,2)*a(2,3)-a(1,3)*a(2,2)
      alfa(3,2)=-1*(a(1,1)*a(2,3)-a(1,3)*a(2,1))
      alfa(3,3)=a(1,1)*a(2,2)-a(1,2)*a(2,1)
      det=a(1,1)*alfa(1,1)+a(1,2)*alfa(1,2)+a(1,3)*alfa(1,3)
      if (det.ne.0) goto 200
      do  5 i=1,3
   5  write(lo,6) (a(i,j),j=1,3)
      do 66 i=1,3
  66  write(lo,6) (alfa(i,j),j=1,3)
   6  format(5x,3i8)
 200  do 10 i=1,3
      do 10 j=1,3
   10 v(i,j)=alfa(j,i)/det
      return
      end
c------------------------------------------------------
      subroutine falsogruppo
      USE Atomi
      USE Symmetry
      USE general, only:cell,spacegr
      USE cgeom
      USE unit_cell
      common /directo/ kdirect,kdirectsav,jpol,ized,ifou
      dimension kcation(500),xb2(3),xeq(3),xo(3),xeqsav(3),vet(2),s(3)
      real, dimension(3,3) :: gm
c
      gm = matrice_metrica(cell)
      vet(1)= 1.0
      vet(2)=-1.0
      do i=1,nats
        kcation(i)=1
      enddo
      kcation(1)=2
c    
      do i=1,nats
        if(kcation(i).eq.1)then
          dtotmin=9999999.0
          ifin=icent+1
          do 10 kt=1,spacegr%ncoper
            do 10 ifi=1,ifin
              coef=vet(ifi)
              do 10 k=1,nsym
                xb2(1) = xyzs(1,i)
                xb2(2) = xyzs(2,i)
                xb2(3) = xyzs(3,i)
                call xequi(xb2,k,coef,xeq,kt)
                dtot=0.0
                do j=1,nats
                  if(kcation(j).eq.2)then
                    xo(1) = xyzs(1,j)
                    xo(2) = xyzs(2,j)
                    xo(3) = xyzs(3,j)
                    !call xdist(xo,xeq,dist,s)
                    call xdisteqs(xo,xeq,gm,dist,s)
                    xeq(1)=xo(1)+s(1)
                    xeq(2)=xo(2)+s(2)
                    xeq(3)=xo(3)+s(3)
                    dtot=dtot+dist
                  endif
                enddo
                if(dtot.lt.dtotmin)then
                  xeqsav(1)=xeq(1)
                  xeqsav(2)=xeq(2)
                  xeqsav(3)=xeq(3)
                  dtotmin=dtot
                endif
   10     continue
          kcation(i)=2
          xyzs(1,i)=xeqsav(1)
          xyzs(2,i)=xeqsav(2)
          xyzs(3,i)=xeqsav(3)
        endif
      enddo
      return
      end
